<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../config.php';
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getMIMEType($ext,$filename=null){
	if($filename){
		return '';
	}else{
		switch(strtolower($ext)){
			case 'gif':
				return 'image/gif';
			case 'jpeg':
			case 'jpg':
			case 'jpe':
				return 'image/jpeg';
			case 'png':
				return 'image/png';
			case 'tiff':
			case 'tif':
				return 'image/tiff';
			case 'bmp':
				return 'image/bmp';
			case 'wav':
				return 'audio/x-wav';
			case 'mpga':
			case 'mp2':
			case 'mp3':
				return 'audio/mpeg';
			case 'm3u':
				return 'audio/x-mpegurl';
			case 'wma':
				return 'audio/x-msaudio';
			case 'ra':
				return 'audio/x-realaudio';
			case 'css':
				return 'text/css';
			case 'html':
			case 'htm':
			case 'xhtml':
				return 'text/html';
			case 'rtf':
				return 'text/rtf';
			case 'sgml':
			case 'sgm':
				return 'text/sgml';
			case 'xml':
			case 'xsl':
				return 'text/xml';
			case 'hwp':
			case 'hwpml':
				return 'application/x-hwp';
			case 'pdf':
				return 'application/pdf';
			case 'odt':
			case 'ott':
				return 'application/vnd.oasis.opendocument.text';
			case 'ods':
			case 'ots':
				return 'application/vnd.oasis.opendocument.spreadsheet';
			case 'odp':
			case 'otp':
				return 'application/vnd.oasis.opendocument.presentation';
			case 'sxw':
			case 'stw':
				return '	application/vnd.sun.xml.writer';
			case 'sxc':
			case 'stc':
				return '	application/vnd.sun.xml.calc';
			case 'sxi':
			case 'sti':
				return '	application/vnd.sun.xml.impress';
			case 'doc':
				return 'application/vnd.ms-word';
			case 'xls':
			case 'xla':
			case 'xlt':
			case 'xlb':
				return 'application/vnd.ms-excel';
			case 'ppt':
			case 'ppa':
			case 'pot':
			case 'pps':
				return 'application/vnd.mspowerpoint';
			case 'vsd':
			case 'vss':
			case 'vsw':
				return 'application/vnd.visio';
			case 'docx':
			case 'docm':
			case 'pptx':
			case 'pptm':
			case 'xlsx':
			case 'xlsm':
				return 'application/vnd.openxmlformats';
			case 'csv':
				return 'text/comma-separated-values';
			case 'mpeg':
			case 'mpg':
			case 'mpe':
				return 'video/mpeg';
			case 'qt':
			case 'mov':
				return 'video/quicktime';
			case 'avi':
			case 'wmv':
				return 'video/x-msvideo';
			case 'bz2':
				return 'application/x-bzip2';
			case 'gz':
			case 'tgz':
				return 'application/x-gzip';
			case 'tar':
				return 'application/x-tar';
			case 'zip':
				return 'application/zip';
			case 'rar':
				return 'application/x-rar-compressed';
			case '7z':
				return 'application/x-7z-compressed';
			case 'alz':
				return 'application/x-alzip';
		}
	}
	return '';
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function api_setHint($hint){
	global $arr_hint;
	if(!$arr_hint){
		$arr_hint=array();
	}
	$arr_hint[$hint]=true;
}
function api_checkHint($hint){
	global $arr_hint;
	if($arr_hint){
		return $arr_hint[$hint];
	}
	return false;
}
function api_get_request_id($id){
	if(array_key_exists('id',$_GET)){
		return $_GET["id"];
	}
	return $id;
}
function api_get_canonical_id($id){
	$alias_file="../../.htaliases";
	$canon=api_get_request_id($id);
	if($id==""||!file_exists($alias_file)){
		return $canon;
	}
	$fd=fopen($alias_file,"r");
	if($fd==FALSE){
		return $canon;
	}
	while(!feof($fd)){
		$line=fgets($fd,1024);
		if(substr($line,0,1)=="#"){
			continue;
		}
		$match=preg_split('/( |\t|\r|\n)+/',$line);
		if($id==$match[0]){
			$canon=$match[1];
			break;
		}
	}
	fclose($fd);
	return $canon;
}
function api_login($id,$password){
	$auth=new Auth;
	if(!$auth->login($id,$password)){
		$canon_id=api_get_canonical_id($id);
		if(!$auth->login($canon_id,$password)){
			return new XMLRPCFault(1,"Authentication failed: $id($canon_id)");
		}
	}
	return false;
}
function api_utf8_substr($str,$start){
	preg_match_all("/./u",$str,$ar);
	if(func_num_args()>=3){
		$end=func_get_arg(2);
		return join("",array_slice($ar[0],$start,$end));
	}else{
		return join("",array_slice($ar[0],$start));
	}
}
function api_get_title($content){
	if(preg_match("{<title>(.+)?</title>}",$content,$match)){
		return $match[1];
	}
	$title=preg_replace("{<.*?>}","",$content);
	$title=api_utf8_substr($title,0,40);
	return $title;
}
function api_escape_content($content){
	$content=str_replace("\r",'',$content);
	return htmlspecialchars($content);
}
function api_timestamp($date8601){
	if(substr($date8601,8,1)!="T"){
		return $date8601;
	}
	return Timezone::getOffset()+mktime(substr($date8601,9,2),substr($date8601,12,2),substr($date8601,15,2),substr($date8601,4,2),substr($date8601,6,2),substr($date8601,0,4));
}
function api_dateiso8601($timestamp){
	return gmstrftime("%Y%m%dT%H:%M:%S",$timestamp);
}
function api_getCategoryIdByName($name_array){
	if($name_array==='')
		return 0;
	if(count($name_array)<=0)
		return 0;
	$category=new Category();
	$category->open(false);
	$name=$name_array[0];
	$id=0;
	while(1){
		if($category->label==$name){
			$id=$category->id;
			break;
		}
		if(!$category->shift()){
			break;
		}
	}
	$category->close();
	return $id;
}
function api_getCategoryNameById($id){
	$category=new Category();
	$category->open();
	$name=$id;
	while(1){
		if($category->id==$id){
			$name=$category->name;
			break;
		}
		if(!$category->shift()){
			break;
		}
	}
	$category->close();
	return $name;
}
function api_fix_content($content){
	$new_content="";
	if(strstr($_SERVER["HTTP_USER_AGENT"],'Zoundry')){
		$new_content=str_replace("</ul>\n","</ul>",$content);
		$new_content=str_replace("</ol>\n","</ol>",$new_content);
		$new_content=str_replace("</li>\n","</li>",$new_content);
		$new_content=str_replace("</div>\n","</div>",$new_content);
		$new_content=str_replace("</p>\n","</p>",$new_content);
	}else{
		$new_content=$content;
	}
	return $new_content;
}
function api_make_post($param,$ispublic,$postid=-1){
	$post=new Post();
	if($postid!=-1){
		if(!$post->open($postid)){
			return false;
		}
	}
	$post->content=api_fix_content($param['description']);
	$post->title=$param['title'];
	$param['categories']=array_key_exists('categories',$param)?$param['categories']:'';
	$param['dateCreated']=array_key_exists('dateCreated',$param)?$param['dateCreated']:api_dateiso8601(time());
	$param['mt_allow_comments']=array_key_exists('mt_allow_comments',$param)?$param['mt_allow_comments']:'';
	$param['mt_allow_pings']=array_key_exists('mt_allow_pings',$param)?$param['mt_allow_pings']:'';
	$param['mt_keywords']=array_key_exists('mt_keywords',$param)?$param['mt_keywords']:'';
	global $arr_hint;
	if(api_checkHint("TagsFromCategories")){
		$post->tags=array_merge($param['categories'],split(",",$param['mt_excerpt']),$param['tagwords']);
	}else{
		$post->tags=split(",",$param['mt_keywords']);
		$post->category=api_getCategoryIdByName($param['categories']);
	}
	$post->created=api_timestamp($param['dateCreated']);
	$post->modified=api_timestamp($param['dateCreated']);
	$post->acceptComment=$param['mt_allow_comments']!==0?true:false;
	$post->acceptTrackback=$param['mt_allow_pings']!==0?true:false;
	if($ispublic){
		$post->visibility="public";
		$post->published=api_timestamp($param['dateCreated']);
	}else{
		$post->visibility="private";
	}
	return $post;
}
function api_get_post($post,$type="bl"){
	$post->loadTags();
	$params=func_get_args();
	global $hostURL,$blogURL;
	return array("userid"=>"","dateCreated"=>api_dateiso8601($post->created),"datePosted"=>api_dateiso8601($post->published),"dateModified"=>api_dateiso8601($post->modified),"title"=>api_escape_content($post->title),"postid"=>$post->id,"categories"=>array(api_getCategoryNameById($post->category)),"link"=>$hostURL.$blogURL."/".$post->id,"permaLink"=>$hostURL.$blogURL."/".$post->id,"description"=>($type=="mt"?$post->content:""),"content"=>$post->content,"mt_allow_comments"=>$post->acceptComment?1:0,"mt_allow_pings"=>$post->acceptTrackback?1:0,"mt_keywords"=>join(",",$post->tags));
}
function api_addAttachment($owner,$parent,$file){
	global $database;
	$attachment=array();
	$attachment['parent']=$parent?$parent:0;
	$attachment['label']=Path::getBaseName($file['name']);
	$label=cubrid_tt_escape_string(cubrid_lessen($attachment['label'],64));
	$attachment['size']=$file['size'];
	$extension=Path::getExtension($attachment['label']);
	switch(strtolower($extension)){
		case '.exe':
		case '.php':
		case '.sh':
		case '.com':
		case '.bat':
			$extension='.xxx';
			break;
	}
	$path="../../attach/$owner";
	if(!is_dir($path)){
		mkdir($path);
		if(!is_dir($path))
			return false;
		@chmod($path,0777);
	}
	$oldFile=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Attachments WHERE owner=$owner AND parent=$parent AND label = '$label'");
	if($oldFile!==null){
		$attachment['name']=$oldFile;
	}else{
		requireComponent('Tattertools.Data.Attachment');
		$attachment['name']=rand(1000000000,9999999999).$extension;
		while(Attachment::doesExist($attachment['name']))
			$attachment['name']=rand(1000000000,9999999999).$extension;
	}
	$attachment['path']="$path/{$attachment['name']}";
	deleteAttachment($owner,-1,$attachment['name']);
	if($file['content']){
		$f=fopen($attachment['path'],"w");
		if(!$f){
			return false;
		}
		$attachment['size']=fwrite($f,$file['content']);
		fclose($f);
		$file['tmp_name']=$attachment['path'];
	}
	if($imageAttributes=@getimagesize($file['tmp_name'])){
		$attachment['mime']=$imageAttributes['mime'];
		$attachment['width']=$imageAttributes[0];
		$attachment['height']=$imageAttributes[1];
	}else{
		$attachment['mime']=getMIMEType($extension);
		$attachment['width']=0;
		$attachment['height']=0;
	}
	$attachment['mime']=cubrid_lessen($attachment['mime'],32);
	@chmod($attachment['path'],0666);
	$result=DBQuery::query("insert into {$database['prefix']}Attachments values ($owner, {$attachment['parent']}, '{$attachment['name']}', '$label', '{$attachment['mime']}', {$attachment['size']}, {$attachment['width']}, {$attachment['height']}, SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), 0,0)");
	if(!$result){
		@unlink($attachment['path']);
		return false;
	}
	return $attachment;
}
function api_update_attaches($parent,$attaches=null){
	global $database,$owner;
	if(is_null($attaches)){
		DBQuery::query("update {$database['prefix']}Attachments set parent=$parent where owner=$owner and parent=0");
	}else{
		foreach($attaches as $att){
			$att=cubrid_tt_escape_string($att);
			DBQuery::query("update {$database['prefix']}Attachments set parent=$parent where owner=$owner and parent=0 and \"name\"='".$att."'");
		}
	}
}
function api_update_attaches_with_replace($entryId){
	global $database,$owner;
	requireComponent('Eolin.PHP.Core');
	$newFiles=DBQuery::queryAll("SELECT \"name\", label FROM {$database['prefix']}Attachments WHERE owner=$owner AND parent=0");
	foreach($newFiles as $newfile){
		$newfile['label']=cubrid_tt_escape_string(cubrid_lessen($newfile['label'],64));
		$oldFile=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Attachments WHERE owner=$owner AND parent=$entryId AND label='{$newfile['label']}'");
		if(!is_null($oldFile)){
			deleteAttachment($owner,$entryId,$oldFile);
		}
	}
	api_update_attaches($entryId);
}
function api_BlogAPI(){
	global $blogApiFunctions;
	if(!array_key_exists('HTTP_RAW_POST_DATA',$GLOBALS)){
		XMLRPC::sendFault(1,'Invalid Method Call');
		exit;
	}
	if(false){
		blogger_getUsersBlogs();
		blogger_newPost();
		blogger_editPost();
		blogger_getTemplate();
		blogger_getRecentPosts();
		blogger_deletePost();
		blogger_getPost();
		metaWeblog_newPost();
		metaWeblog_getPost();
		metaWeblog_getCategories();
		metaWeblog_getRecentPosts();
		metaWeblog_editPost();
		metaWeblog_newMediaObject();
		mt_getPostCategories();
		mt_setPostCategories();
		mt_getCategoryList();
		mt_supportedMethods();
		mt_publishPost();
		mt_getRecentPostTitles();
	}
	$xml=$GLOBALS['HTTP_RAW_POST_DATA'];
	$blogApiFunctions=array("blogger.getUsersBlogs","blogger.newPost","blogger.editPost","blogger.getTemplate","blogger.getRecentPosts","blogger.deletePost","blogger.getPost","metaWeblog.newPost","metaWeblog.getPost","metaWeblog.getCategories","metaWeblog.getRecentPosts","metaWeblog.editPost","metaWeblog.newMediaObject","mt.getPostCategories","mt.setPostCategories","mt.getCategoryList","mt.supportedMethods","mt.publishPost","mt.getRecentPostTitles");
	$xmlrpc=new XMLRPC;
	foreach($blogApiFunctions as $func){
		$callback=str_replace(".","_",$func);
		$xmlrpc->registerMethod($func,$callback);
	}
	$xmlrpc->receive($xml);
}
function blogger_getUsersBlogs(){
	global $blog,$hostURL,$blogURL;
	global $owner;
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$blogs=array(array("url"=>$hostURL.$blogURL,"blogid"=>"$owner","blogName"=>$blog['title'],));
	return $blogs;
}
function blogger_newPost(){
	$params=func_get_args();
	$post=new Post();
	$post->content=$params[4];
	$post->title=htmlspecialchars(api_get_title($params[4]));
	if($params[5]){
		$post->visibility="public";
	}else{
		$post->visibility="private";
	}
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	if(!$post->add()){
		$post->close();
		return new XMLRPCFault(1,"Posting error");
	}
	RSS::refresh();
	$id="{$post->id}";
	$post->close();
	return $id;
}
function blogger_editPost(){
	$params=func_get_args();
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	$post=new Post();
	$post->title=htmlspecialchars(api_get_title($params[4]));
	$post->id=intval($params[1]);
	$post->content=htmlspecialchars($params[4]);
	if($params[5]){
		$post->visibility="public";
	}else{
		$post->visibility="private";
	}
	$ret=$post->update();
	$post->close();
	RSS::refresh();
	if($ret!=false)
		setUserSetting('LatestEditedEntry',$post->id);
	return $ret?true:false;
}
function blogger_deletePost(){
	global $owner;
	$params=func_get_args();
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	$post=new Post();
	$id=intval($params[1]);
	$ret=$post->open($id);
	$ret=$post->remove();
	deleteAttachments($owner,$id);
	return $ret?true:false;
}
function blogger_getRecentPosts(){
	$params=func_get_args();
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	$post=new Post();
	$post->open();
	$out=array();
	for($i=0;$i<$params[4];$i++){
		array_push($out,api_get_post($post,"bl"));
		if(!$post->shift()){
			break;
		}
	}
	$post->close();
	return $out;
}
function blogger_getPost(){
	$params=func_get_args();
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	$post=new Post();
	$post->open(intval($params[1]));
	$ret=api_get_post($post);
	$post->close();
	return $ret;
}
function blogger_getTemplate(){
	$params=func_get_args();
	$result=api_login($params[2],$params[3]);
	if($result){
		return $result;
	}
	$file=($params[4]=="main"?"template.main.tpl":"template.archindex.tpl");
	$template="";
	if(file_exists($file)){
		$fd=fopen($file,"r");
		while(!feof($fd)){
			$template.=fgets($fd,4096);
		}
		fclose($fd);
	}
	return htmlspecialchars($template);
}
function metaWeblog_getCategories(){
	global $hostURL,$blogURL;
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$category=new Category();
	$category->open(false);
	$cat=array();
	while($category->id){
		array_push($cat,array('htmlUrl'=>"$hostURL$blogURL/category/".$category->label,'categoryName'=>$category->label,'description'=>$category->label,'title'=>$category->label,'categoryid'=>$category->id,'isPrimary'=>true));
		if(!$category->shift()){
			break;
		}
	}
	$category->close();
	return $cat;
}
function mt_getCategoryList(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$category=new Category();
	$category->open(false);
	$cat=array();
	while(1){
		array_push($cat,array('categoryName'=>$category->label,'categoryId'=>$category->id,'isPrimary'=>true));
		if(!$category->shift()){
			break;
		}
	}
	$category->close();
	return $cat;
}
function metaWeblog_getRecentPosts(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	global $blog;
	$post=new Post();
	$post->open();
	$out=array();
	for($i=0;$post->_count>0&&$i<$params[3];$i++){
		array_push($out,api_get_post($post,"mt"));
		if(!$post->shift()){
			break;
		}
	}
	$post->close();
	return $out;
}
function metaWeblog_getPost(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=new Post();
	$post->open(intval($params[0]));
	$ret=api_get_post($post,"mt");
	$post->close();
	return $ret;
}
function metaWeblog_newPost(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=api_make_post($params[3],$params[4]);
	if($post===false){
		return new XMLRPCFault(1,"Tattertools posting error");
	}
	if(!$post->add()){
		$error=$post->error;
		$post->close();
		return new XMLRPCFault(1,"Tattertools invalid field: $error");
	}
	api_update_attaches($post->id);
	RSS::refresh();
	$id="{$post->id}";
	$post->close();
	if($id)
		setUserSetting('LatestEditedEntry',$id);
	return $id;
}
function mt_setPostCategories(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=new Post();
	if(!$post->open($params[0])){
		return new XMLRPCFault(1,"Posting error");
	}
	$category=null;
	if(is_null($params[3]))
		$params[3]=array();
	foreach($params[3] as $index=>$cat){
		if(array_key_exists('isPrimary',$cat)&&$cat['isPrimary']){
			$category=$cat['categoryId'];
		}else{
			if(is_null($category))
				$category=$cat['categoryId'];
		}
	}
	if(!is_null($category)){
		$post->category=intval($category);
		$post->update();
	}
	$post->close();
	return true;
}
function mt_getPostCategories(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=new Post();
	$post->open(intval($params[0]));
	$cat=array($post->category);
	$post->close();
	return $cat;
}
function metaWeblog_editPost(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=api_make_post($params[3],$params[4],$params[0]);
	$post->created=null;
	if(!$post){
		return new XMLRPCFault(1,"Tattertools editing error");
	}
	$ret=$post->update();
	api_update_attaches_with_replace($post->id);
	RSS::refresh();
	$post->close();
	if($ret!=false)
		setUserSetting('LatestEditedEntry',$post->id);
	return $ret?true:false;
}
function metaWeblog_newMediaObject(){
	global $owner;
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$mediaOjbect=$params[3]['bits'];
	$tmp_dir="../../attach/temp";
	if(!is_dir($tmp_dir)){
		mkdir($tmp_dir);
		if(!is_dir($tmp_dir)){
			return new XMLRPCFault(1,"Can't Create Directory $tmp_dir");
		}
		@chmod($path,0777);
	}
	$file=array('name'=>$params[3]['name'],'content'=>$params[3]['bits'],'size'=>count($params[3]['bits']));
	$attachment=api_addAttachment($owner,0,$file);
	if(!$attachment){
		return new XMLRPCFault(1,"Can't create file");
	}
	global $service;
	$attachurl=array('url'=>'http://tt_attach_path/'.$attachment['name']);
	return $attachurl;
}
function mt_supportedMethods(){
	global $blogApiFunctions;
	return $blogApiFunctions;
}
function mt_publishPost(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	$post=new Post();
	if(!$post->open(intval($params[0]))){
		return false;
	}
	return true;
}
function mt_getRecentPostTitles(){
	$params=func_get_args();
	$result=api_login($params[1],$params[2]);
	if($result){
		return $result;
	}
	global $blog;
	$post=new Post();
	$post->open();
	$out=array();
	for($i=0;$post->_count>0&&$i<$params[3];$i++){
		array_push($out,api_get_post($post,"mt"));
		if(!$post->shift()){
			break;
		}
	}
	$post->close();
	return $out;
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getAttachments($owner,$parent,$orderBy=null,$sort='ASC'){
	global $database, $cubrid_con;
	$attachments=array();
	if($result=DBQuery::query("select * from {$database['prefix']}Attachments where owner = $owner and parent = $parent ".(is_null($orderBy)?'':"ORDER BY $orderBy $sort"))){
		while($attachment=cubrid_fetch($result))
			array_push($attachments,$attachment);
		cubrid_commit($cubrid_con);
	}
	return $attachments;
}
function deleteAttachment($owner,$parent,$name){
	global $database;
	if(!Validator::filename($name))
		return false;
	$origname=$name;
	$name=cubrid_tt_escape_string($name);
	if(DBQuery::execute("delete from {$database['prefix']}Attachments where owner = $owner and \"name\" = '$name'")){
		@unlink("../../attach/$owner/$origname");
		clearRSS();
		return true;
	}
	return false;
}
function deleteAttachments($owner,$parent){
	$attachments=getAttachments($owner,$parent);
	foreach($attachments as $attachment)
		deleteAttachment($owner,$parent,$attachment['name']);
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
function clearRSS(){
	global $owner;
	@unlink("../../cache/rss/$owner.xml");
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function setUserSetting($name,$value){
	global $database,$owner;
	$name=cubrid_tt_escape_string($name);
	$value=cubrid_tt_escape_string($value);
	$cell=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '$name'");
	if ($cell===null) {
  	return DBQuery::execute("INSERT INTO {$database['prefix']}UserSettings (\"user\", \"name\", \"value\") VALUES($owner, '$name', '$value')");
  }
  else {
  	return DBQuery::execute("UPDATE {$database['prefix']}UserSettings SET \"value\"='$value' WHERE \"user\" = $owner AND \"name\" = '$name'");
  }
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../config.php')){
	header('Location: '.'../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
header('Content-Type: text/html; charset=utf-8');
requireComponent("Eolin.PHP.XMLStruct");
requireComponent("Eolin.PHP.XMLTree");
requireComponent("Eolin.PHP.XMLRPC");
requireComponent("Tattertools.Control.RSS");
requireComponent("Tattertools.Control.Auth");
requireComponent("Tattertools.Data.Post");
requireComponent("Tattertools.Data.Category");
if(getUserSetting('useBlogAPI',0)!=1){
	respondNotFoundPage();
	exit;
}
function SendRSD(){
	global $hostURL,$blogURL;
	global $owner;
	$homeurl=$hostURL.$blogURL;
	$apiurl=$homeurl."/api";
	$blogid=$owner;
	header("Content-type: text/xml",true);
	print ('<?xml version="1.0" encoding="utf-8" ?> 
<rsd xmlns="http://archipelago.phrasewise.com/rsd" version="1.0">
    <service xmlns="">
        <engineName>Tattertools</engineName> 
        <engineLink>http://www.tattertools.com/</engineLink>
        <homePageLink>'.$homeurl.'/</homePageLink>
        <apis>
        		<api name="MovableType" preferred="true" apiLink="'.$apiurl.'" blogID="'.$blogid.'" />
                <api name="MetaWeblog" preferred="false" apiLink="'.$apiurl.'" blogID="'.$blogid.'" />
                <api name="Blogger" preferred="false" apiLink="'.$apiurl.'" blogID="'.$blogid.'" />
        </apis>
    </service>
</rsd>');
}
if(substr($_SERVER["REQUEST_URI"],-8)=="/api?rsd"){
	SendRSD();
}else{
	if(strpos($_SERVER["REQUEST_URI"],"api?rnd")!==false){
		api_setHint("TagsFromCategories");
	}
	api_BlogAPI();
}?>
