<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../config.php';
function escapeCData($str){
	return str_replace(']]>',']]&gt;',$str);
}
function stripHTML($text,$allowTags=array()){
	$text=preg_replace('/<(script|style)[^>]*>.*?<\/\1>/si','',$text);
	if(count($allowTags)==0)
		$text=preg_replace('/<[\w\/!]+[^>]*>/','',$text);
	else{
		preg_match_all('/<\/?([\w!]+)[^>]*?>/s',$text,$matches);
		for($i=0;$i<count($matches[0]);$i++){
			if(!in_array(strtolower($matches[1][$i]),$allowTags))
				$text=str_replace($matches[0][$i],'',$text);
		}
	}
	$text=preg_replace('/&nbsp;?|\xc2\xa0\x20/',' ',$text);
	$text=trim(preg_replace('/\s+/',' ',$text));
	if(!empty($text))
		$text=str_replace(array('&#39;','&apos;','&quot;'),array('\'','\'','"'),$text);
	return $text;
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getAttributesFromString($str,$caseSensitive=true){
	$attributes=array();
	preg_match_all('/([^=\s]+)\s*=\s*"([^"]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)\s*=\s*\'([^\']*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)=([^\'"][^\s]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	return $attributes;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getRemoteFeed($url){
	global $service;
	$xml=fireEvent('GetRemoteFeed',null,$url);
	if(empty($xml)){
		requireComponent('Eolin.PHP.HTTPRequest');
		$request=new HTTPRequest($url);
		$request->timeout=3;
		if(!$request->send())
			return array(2,null,null);
		$xml=$request->responseText;
	}
	$feed=array('xmlurl'=>$url);
	$xmls=new XMLStruct();
	if(!$xmls->open($xml,$service['encoding'])){
		if(preg_match_all('/<link .*?rel\s*=\s*[\'"]?alternate.*?>/i',$xml,$matches)){
			foreach($matches[0] as $link){
				$attributes=getAttributesFromString($link);
				if(isset($attributes['href'])){
					$urlInfo=parse_url($url);
					$rssInfo=parse_url($attributes['href']);
					$rssURL=false;
					if(isset($rssInfo['scheme'])&&$rssInfo['scheme']=='http')
						$rssURL=$attributes['href'];
					elseif(isset($rssInfo['path'])){
						if($rssInfo['path']{0}=='/')
							$rssURL="{$urlInfo['scheme']}://{$urlInfo['host']}{$rssInfo['path']}";
						else
							$rssURL="{$urlInfo['scheme']}://{$urlInfo['host']}".(isset($urlInfo['path'])?rtrim($urlInfo['path'],'/'):'').'/'.$rssInfo['path'];
					}
					if($rssURL&&$url!=$rssURL)
						return getRemoteFeed($rssURL);
				}
			}
		}
		return array(3,null,null);
	}
	if($xmls->getAttribute('/rss','version')){
		$feed['blogurl']=$xmls->getValue('/rss/channel/link');
		$feed['title']=$xmls->getValue('/rss/channel/title');
		$feed['description']=$xmls->getValue('/rss/channel/description');
		if(Validator::language($xmls->getValue('/rss/channel/language')))
			$feed['language']=$xmls->getValue('/rss/channel/language');
		elseif(Validator::language($xmls->getValue('/rss/channel/dc:language')))
			$feed['language']=$xmls->getValue('/rss/channel/dc:language');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}elseif($xmls->getAttribute('/feed','version')){
		$feed['blogurl']=$xmls->getAttribute('/feed/link','href');
		$feed['title']=$xmls->getValue('/feed/title');
		$feed['description']=$xmls->getValue('/feed/tagline');
		if(Validator::language($xmls->getAttribute('/feed','xml:lang')))
			$feed['language']=$xmls->getAttribute('/feed','xml:lang');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}elseif($xmls->getAttribute('/rdf:RDF','xmlns')){
		if($xmls->getAttribute('/rdf:RDF/channel/link','href'))
			$feed['blogurl']=$xmls->getAttribute('/rdf:RDF/channel/link','href');
		elseif($xmls->getValue('/rdf:RDF/channel/link'))
			$feed['blogurl']=$xmls->getValue('/rdf:RDF/channel/link');
		else
			$feed['blogurl']='';
		$feed['title']=$xmls->getValue('/rdf:RDF/channel/title');
		$feed['description']=$xmls->getValue('/rdf:RDF/channel/description');
		if(Validator::language($xmls->getValue('/rdf:RDF/channel/dc:language')))
			$feed['language']=$xmls->getValue('/rdf:RDF/channel/dc:language');
		elseif(Validator::language($xmls->getAttribute('/rdf:RDF','xml:lang')))
			$feed['language']=$xmls->getAttribute('/rdf:RDF','xml:lang');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}else
		return array(3,null,null);
	$feed['xmlurl']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['xmlurl'])));
	$feed['blogurl']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['blogurl'])));
	$feed['title']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['title'])));
	$feed['description']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct(stripHTML($feed['description']))));
	$feed['language']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['language']),255));
	return array(0,$feed,$xml);
}
function saveFeedItems($feedId,$xml){
	global $database,$service;
	$xmls=new XMLStruct();
	if(!$xmls->open($xml,$service['encoding']))
		return false;
	if($xmls->getAttribute('/rss','version')){
		for($i=0;$link=$xmls->getValue("/rss/channel/item[$i]/link");$i++){
			$item=array('permalink'=>rawurldecode($link));
			if(!$item['author']=$xmls->getValue("/rss/channel/item[$i]/author"))
				$item['author']=$xmls->getValue("/rss/channel/item[$i]/dc:creator");
			$item['title']=$xmls->getValue("/rss/channel/item[$i]/title");
			if(!$item['description']=$xmls->getValue("/rss/channel/item[$i]/content:encoded"))
				$item['description']=$xmls->getValue("/rss/channel/item[$i]/description");
			$item['tags']=array();
			for($j=0;$tag=$xmls->getValue("/rss/channel/item[$i]/category[$j]");$j++)
				if(!empty($tag))
					array_push($item['tags'],$tag);
			for($j=0;$tag=$xmls->getValue("/rss/channel/item[$i]/subject[$j]");$j++)
				if(!empty($tag))
					array_push($item['tags'],$tag);
			$item['enclosures']=array();
			for($j=0;$url=$xmls->getAttribute("/rss/channel/item[$i]/enclosure[$j]",'url');$j++)
				if(!empty($url))
					array_push($item['enclosures'],$url);
			if($xmls->getValue("/rss/channel/item[$i]/pubDate"))
				$item['written']=parseDate($xmls->getValue("/rss/channel/item[$i]/pubDate"));
			elseif($xmls->getValue("/rss/channel/item[$i]/dc:date"))
				$item['written']=parseDate($xmls->getValue("/rss/channel/item[$i]/dc:date"));
			else
				$item['written']=0;
			saveFeedItem($feedId,$item);
		}
	}elseif($xmls->getAttribute('/feed','version')){
		for($i=0;$link=$xmls->getValue("/feed/entry[$i]/id");$i++){
			for($j=0;$rel=$xmls->getAttribute("/feed/entry[$i]/link[$j]",'rel');$j++){
				if($rel=='alternate'){
					$link=$xmls->getAttribute("/feed/entry[$i]/link[$j]",'href');
					break;
				}
			}
			$item=array('permalink'=>rawurldecode($link));
			$item['author']=$xmls->getValue("/feed/entry[$i]/author/name");
			$item['title']=$xmls->getValue("/feed/entry[$i]/title");
			if(!$item['description']=$xmls->getValue("/feed/entry[$i]/content"))
				$item['description']=$xmls->getValue("/feed/entry[$i]/summary");
			$item['tags']=array();
			for($j=0;$tag=$xmls->getValue("/feed/entry[$i]/dc:subject[$j]");$j++)
				if(!empty($tag))
					array_push($item['tags'],$tag);
			$item['enclosures']=array();
			for($j=0;$url=$xmls->getAttribute("/feed/entry[$i]/enclosure[$j]",'url');$j++)
				if(!empty($url))
					array_push($item['enclosures'],$url);
			$item['written']=parseDate($xmls->getValue("/feed/entry[$i]/issued"));
			saveFeedItem($feedId,$item);
		}
	}elseif($xmls->getAttribute('/rdf:RDF','xmlns')){
		for($i=0;$link=$xmls->getValue("/rdf:RDF/item[$i]/link");$i++){
			$item=array('permalink'=>rawurldecode($link));
			$item['author']=$xmls->getValue("/rdf:RDF/item[$i]/dc:creator");
			$item['title']=$xmls->getValue("/rdf:RDF/item[$i]/title");
			if(!$item['description']=$xmls->getValue("/rdf:RDF/item[$i]/content:encoded"))
				$item['description']=$xmls->getValue("/rdf:RDF/item[$i]/description");
			$item['tags']=array();
			$item['enclosures']=array();
			$item['written']=parseDate($xmls->getValue("/rdf:RDF/item[$i]/dc:date"));
			saveFeedItem($feedId,$item);
		}
	}else
		return false;
	$deadLine=0;
	$feedLife=DBQuery::queryCell("SELECT feedlife FROM {$database['prefix']}FeedSettings");
	if($feedLife>0)
		$deadLine=gmmktime()-$feedLife*86400;
	if($result=DBQuery::query("SELECT id FROM {$database['prefix']}FeedItems LEFT JOIN {$database['prefix']}FeedStarred ON id = item WHERE item IS NULL AND written < $deadLine"))
		while(list($id)=cubrid_fetch($result,CUBRID_NUM))
			DBQuery::query("DELETE FROM {$database['prefix']}FeedItems WHERE id = $id");
	if($result=DBQuery::query("SELECT owner, item FROM {$database['prefix']}FeedReads LEFT JOIN {$database['prefix']}FeedItems ON id = item WHERE id IS NULL"))
		while(list($readsOwner,$readsItem)=cubrid_fetch($result,CUBRID_NUM))
			DBQuery::query("DELETE FROM {$database['prefix']}FeedReads WHERE owner = $readsOwner AND item = $readsItem");
    DBQuery::commit();
	return true;
}
function saveFeedItem($feedId,$item){
	global $database;
	$item=fireEvent('SaveFeedItem',$item);
	$item['permalink']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($item['permalink'])));
	$item['author']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($item['author'])));
	$item['title']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($item['title'])));
	$item['description']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($item['description']),65535));
	$tagString=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct(implode(', ',$item['tags']))));
	$enclosureString=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct(implode('|',$item['enclosures']))));
	if($item['written']>gmmktime()+86400)
		return false;
	$deadLine=0;
	$feedLife=DBQuery::queryCell("SELECT feedlife FROM {$database['prefix']}FeedSettings");
	if($feedLife>0)
		$deadLine=gmmktime()-$feedLife*86400;
	if($id=DBQuery::queryCell("SELECT id FROM {$database['prefix']}FeedItems WHERE permalink='{$item['permalink']}'")&&$item['written']!=0){
		DBQuery::query("UPDATE {$database['prefix']}FeedItems SET author = '{$item['author']}', title = '{$item['title']}', description = '{$item['description']}', tags = '$tagString', enclosure = '$enclosureString', written = {$item['written']} WHERE id = $id");
	}elseif($id!=null){
		return false;
	}else{
		if($item['written']==0)
			$item['written']=gmmktime();
		if($item['written']>$deadLine)
			DBQuery::query("INSERT INTO {$database['prefix']}FeedItems VALUES(null, $feedId, '{$item['author']}', '{$item['permalink']}', '{$item['title']}', '{$item['description']}', '$tagString', '$enclosureString', {$item['written']})");
	}
	return true;
}
function updateRandomFeed(){
	global $database;
	$updateCycle=DBQuery::queryCell("SELECT updatecycle FROM {$database['prefix']}FeedSettings");
	if($updateCycle!=0){
		if($feed=DBQuery::queryRow("SELECT {$database['prefix']}Feeds.*, MOD(id, drand()) as randnum FROM {$database['prefix']}Feeds ".
                " WHERE modified < ".(gmmktime()-($updateCycle*60))." ORDER BY randnum FOR ORDERBY_NUM() = 1")){
			return array(updateFeed($feed),$feed['xmlurl']);
		}
	}
	return array(1,'No feeds to update');
}
function updateFeed($feedRow){
	global $database;
	if($feedRow['modified']>gmmktime()-300)
		return true;
	list($status,$feed,$xml)=getRemoteFeed($feedRow['xmlurl']);
	if($status>0){
		DBQuery::execute("UPDATE {$database['prefix']}Feeds SET modified = 0 WHERE xmlurl = '{$feedRow['xmlurl']}'");
		return $status;
	}else{
		DBQuery::execute("UPDATE {$database['prefix']}Feeds SET blogurl = '{$feed['blogurl']}', title = '{$feed['title']}', description = '{$feed['description']}', \"language\" = '{$feed['language']}', modified = ".gmmktime()." WHERE xmlurl = '{$feedRow['xmlurl']}'");
		return saveFeedItems($feedRow['id'],$xml)?0:1;
	}
}
function parseDate($str){
	if(preg_match('/^(\d{4})년 (\d{2})월 (\d{2})일  (\d{2}):(\d{2}):(\d{2})$/',$str,$matches))
		return parseDate("{$matches[1]}-{$matches[2]}-{$matches[3]} {$matches[4]}:{$matches[5]}:{$matches[6]}");
	if(preg_match('/^(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})$/',$str,$matches))
		return parseDate("{$matches[3]}-{$matches[1]}-{$matches[2]} {$matches[4]}:{$matches[5]}:00}");
	if(empty($str))
		return 0;
	$time=strtotime($str);
	if($time!==-1)
		return $time;
	$gmt=(substr($str,strpos($str,"GMT"))=="GMT")?9:0;
	$str=str_replace("년 ","-",$str);
	$str=str_replace("월 ","-",$str);
	$str=str_replace("일 ","",$str);
	$str=str_replace("GMT","",$str);
	$str=str_replace("KST","+0900",$str);
	if(strpos($str,"T")){
		list($date,$time)=explode("T",$str);
		list($y,$m,$d)=explode("-",$date);
		list($time)=explode("+",$time);
		@list($h,$i,$s)=explode(":",$time);
	}elseif(strpos($str,":")&&strpos($str,"-")){
		list($str)=explode(".",$str);
		list($date,$time)=explode(" ",$str);
		list($y,$m,$d)=explode("-",$date);
		if($d>1900){
			$t=$y;
			$y=$d;
			$d=$m;
			$m=$t;
		}
		@list($h,$i,$s)=explode(":",$time);
	}elseif(strpos($str,",")&&strpos($str,":")){
		list($temp,$str)=explode(",",$str);
		$str=trim(str_month_check($str));
		list($d,$m,$y,$time)=explode(" ",$str);
		list($h,$i,$s)=explode(":",$time);
	}else{
		return gmmktime();
	}
	if(!$h)
		$h="00";
	if(!$i)
		$i="00";
	if(!$s)
		$s="00";
	$h+=$gmt;
	return mktime($h,$i,$s,$m,$d,$y);
}
function str_month_check($str){
	$str=str_replace("Jan","01",$str);
	$str=str_replace("Feb","02",$str);
	$str=str_replace("Mar","03",$str);
	$str=str_replace("Apr","04",$str);
	$str=str_replace("May","05",$str);
	$str=str_replace("Jun","06",$str);
	$str=str_replace("Jul","07",$str);
	$str=str_replace("Aug","08",$str);
	$str=str_replace("Sep","09",$str);
	$str=str_replace("Oct","10",$str);
	$str=str_replace("Nov","11",$str);
	return str_replace("Dec","12",$str);
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../config.php')){
	header('Location: '.'../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function fetchConfigVal($DATA){
	$xmls=new XMLStruct();
	$outVal=array();
	if(!$xmls->open($DATA)){
		unset($xmls);
		return ;
	}
	if(is_null($xmls->selectNodes('/config/field'))){
		unset($xmls);
		return ;
	}
	foreach($xmls->selectNodes('/config/field') as $field){
		if(empty($field['.attributes']['name'])||empty($field['.attributes']['type'])){
			unset($xmls);
			return ;
		}
		$outVal[$field['.attributes']['name']]=$field['.value'];
	}
	unset($xmls);
	return ($outVal);
}
function printRespond($result,$useCDATA=true){
	header('Content-Type: text/xml; charset=utf-8');
	$xml="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
	$xml.="<response>\n";
	$xml.=printRespondValue($result,$useCDATA);
	$xml.="</response>\n";
	die($xml);
}
function printRespondValue($array,$useCDATA=true){
	$xml='';
	if(is_array($array)){
		foreach($array as $key=>$value){
			if(is_null($value))
				continue;
			elseif(is_array($value)){
				if(is_numeric($key))
					$xml.=printRespondValue($value,$useCDATA)."\n";
				else
					$xml.="<$key>".printRespondValue($value,$useCDATA)."</$key>\n";
			}else{
				if($useCDATA)
					$xml.="<$key><![CDATA[".escapeCData($value)."]]></$key>\n";
				else
					$xml.="<$key>".htmlspecialchars($value)."</$key>\n";
			}
		}
	}
	return $xml;
}
header('Content-Type: text/html; charset=utf-8');
if(false){
	fetchConfigVal();
}
list($status,$url)=updateRandomFeed();
printRespond(array('error'=>$status,'url'=>$url));?>
