<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../config.php';
function getPeriodLabel($period){
	$name=strval($period);
	switch(strlen($name)){
		case 4:
			return $name;
		case 6:
			return substr($name,0,4).'/'.substr($name,4);
		case 8:
			return substr($name,0,4).'/'.substr($name,4,2).'/'.substr($name,6).'';
	}
}
function escapeJSInAttribute($str){
	return htmlspecialchars(str_replace(array('\\','\r','\n','\''),array('\\\\','\\r','\\n','\\\''),$str));
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getArchives($owner){
	global $database, $cubrid_con;
	$archives=array();
	$visibility=doesHaveOwnership()?'':'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	$archivesOnPage=DBQuery::queryCell("SELECT archivesonpage FROM {$database['prefix']}SkinSettings WHERE owner = $owner")+0;
	$result=DBQuery::query("SELECT TO_CHAR(to_timestamp('09:00:00 AM 01/01/1970')+e.published, 'YYYYMM') period, COUNT(*) \"count\" 
		FROM {$database['prefix']}Entries e
		LEFT JOIN {$database['prefix']}Categories c ON e.category = c.id AND e.owner = c.owner
		WHERE e.owner = $owner AND e.draft = 0 $visibility AND e.category >= 0 
		GROUP BY TO_CHAR(to_timestamp('09:00:00 AM 01/01/1970')+e.published, 'YYYYMM') 
		ORDER BY period 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND $archivesOnPage");
	if($result){
		while($archive=cubrid_fetch($result))
			array_push($archives,$archive);
    cubrid_commit($cubrid_con);	
	}
	return $archives;
}
function getCategoryNameById($owner,$id){
	global $database;
	$result=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Categories WHERE owner = $owner AND id = $id");
	if(is_null($result))
		return _text('전체');
	else
		return $result;
}
function getCategories($owner){
	global $database;
	$rows=DBQuery::queryAll("SELECT * FROM {$database['prefix']}Categories WHERE owner = $owner AND id > 0 ORDER BY parent, priority");
	$categories=array();
	foreach($rows as $category){
		if($category['parent']==null){
			$category['children']=array();
			$categories[$category['id']]=$category;
		}elseif(isset($categories[$category['parent']]))
			array_push($categories[$category['parent']]['children'],$category);
	}
	return $categories;
}
function getCategoriesSkin(){
	global $database;
	global $owner,$service;
	$sql="select * from {$database['prefix']}SkinSettings where owner = $owner";
	$setting=DBQuery::queryRow($sql);
	$skin=array('name'=>"{$setting['skin']}",'url'=>$service['path']."/image/tree/{$setting['tree']}",'labelLength'=>$setting['labellengthontree'],'showValue'=>$setting['showvalueontree'],'itemColor'=>"{$setting['colorontree']}",'itemBgColor'=>"{$setting['bgcolorontree']}",'activeItemColor'=>"{$setting['activecolorontree']}",'activeItemBgColor'=>"{$setting['activebgcolorontree']}",);
	return $skin;
}
function getCategoryVisibility($owner,$id){
	global $database;
	$result=DBQuery::queryCell("SELECT visibility FROM {$database['prefix']}Categories WHERE owner = $owner AND id = $id");
	if($result==false)
		return 2;
	else
		return $result;
}
function getRecentComments($owner,$count=false,$isGuestbook=false){
	global $skinSetting,$database, $cubrid_con;
	$comments=array();
	$sql=doesHaveOwnership()?"SELECT * FROM 
			{$database['prefix']}Comments 
		WHERE 
			owner = $owner".($isGuestbook!=false?" AND entry=0":" AND entry>0")." AND isfiltered = 0 
		ORDER BY 
			written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count!=false?$count+0:$skinSetting['commentsonrecent']+0):"SELECT r.* FROM 
			{$database['prefix']}Comments r
			LEFT JOIN {$database['prefix']}Entries e ON r.owner = e.owner AND r.entry = e.id
			LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id
		WHERE 
			r.owner = $owner AND e.draft = 0 AND e.visibility >= 2 AND (c.visibility > 1 OR e.category = 0) ".($isGuestbook!=false?" AND r.entry = 0":" AND r.entry > 0")." AND isfiltered = 0 
		ORDER BY 
			r.written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND  
			".($count!=false?$count+0:$skinSetting['commentsonrecent']+0);
	if($result=DBQuery::query($sql)){
		while($comment=cubrid_fetch($result)){
			if(($comment['secret']==1)&&!doesHaveOwnership()){
				$comment['name']='';
				$comment['homepage']='';
				$comment['comment']=_text('관리자만 볼 수 있는 댓글입니다.');
			}
			array_push($comments,$comment);
		}
		cubrid_commit($cubrid_con);
	}
	return $comments;
}
function getEntriesTotalCount($owner){
	global $database;
	$visibility=doesHaveOwnership()?'':'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	return DBQuery::queryCell("SELECT COUNT(*) 
		FROM {$database['prefix']}Entries e
		LEFT JOIN {$database['prefix']}Categories c ON e.category = c.id AND e.owner = c.owner 
		WHERE e.owner = $owner AND e.draft = 0 $visibility AND e.category >= 0");
}
function getEntryWithPaging($owner,$id,$isNotice=false){
	global $database;
	global $folderURL;
	$entries=array();
	$paging=initPaging($folderURL,'/');
	$visibility=doesHaveOwnership()?'':'AND e.visibility > 0';
	$visibility.=($isNotice||doesHaveOwnership())?'':' AND (c.visibility > 1 OR e.category = 0)';
	$category=$isNotice?'e.category = -2':'e.category >= 0';
	$sql="SELECT e.*, c.label categoryLabel 
		FROM {$database['prefix']}Entries e 
		LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id 
		WHERE e.owner = $owner AND e.draft = 0 $visibility AND $category 
		ORDER BY e.published DESC";
	$result=DBQuery::query($sql);
	if(!$result)
		return array($entries,$paging);
	$paging['pages']=cubrid_num_rows($result);
	for($i=1;$entry=cubrid_fetch($result);$i++){
		if($entry['id']!=$id){
			if(array_push($paging['before'],$entry['id'])>4)
				if($i==5)
					$paging['first']=array_shift($paging['before']);
				else
					array_shift($paging['before']);
			continue;
		}
		$paging['page']=$i;
		array_push($entries,$entry);
		$paging['after']=array();
		for($i++;(count($paging['after'])<4)&&($entry=cubrid_fetch($result));$i++)
			array_push($paging['after'],$entry['id']);
		if($i<$paging['pages']){
			while($entry=cubrid_fetch($result))
				$paging['last']=$entry['id'];
		}
		if(count($paging['before'])>0)
			$paging['prev']=$paging['before'][count($paging['before'])-1];
		if(isset($paging['after'][0]))
			$paging['next']=$paging['after'][0];
		return array($entries,$paging);
	}
    DBQuery::commit();
	$paging['page']=$paging['pages']+1;
	return array($entries,$paging);
}
function initPaging($url,$prefix='?page='){
	return array('url'=>$url,'prefix'=>$prefix,'postfix'=>'','total'=>0,'pages'=>0,'page'=>0,'before'=>array(),'after'=>array());
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getRecentTrackbacks($owner,$count=false){
	global $database, $cubrid_con;
	global $skinSetting;
	$trackbacks=array();
	$sql=doesHaveOwnership()?"SELECT * 
		FROM 
			{$database['prefix']}Trackbacks 
		WHERE 
			owner = $owner AND isfiltered = 0 
		ORDER BY 
			written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count!=false?$count+0:$skinSetting['trackbacksonrecent']+0):"SELECT t.* 
		FROM 
			{$database['prefix']}Trackbacks t 
			LEFT JOIN {$database['prefix']}Entries e ON t.owner = e.owner AND t.entry = e.id
			LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id
		WHERE 
			t.owner = $owner AND e.draft = 0 AND e.visibility >= 2 AND (c.visibility > 1 OR e.category = 0) AND t.isfiltered = 0 
		ORDER BY 
			t.written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count=false?$count+0:$skinSetting['trackbacksonrecent']+0);
	if($result=DBQuery::query($sql)){
		while($trackback=cubrid_fetch($result))
			array_push($trackbacks,$trackback);
	  cubrid_commit($cubrid_con);
	}
	return $trackbacks;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
{
	$blogURL.='/m';
}
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../config.php')){
	header('Location: '.'../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
function _text($t){
	global $__outText;
	if(isset($__outText)&&isset($__outText[$t])){
		return $__outText[$t];
	}else{
		return $t;
	}
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function getCategoriesView($totalPosts,$categories,$selected,$xhtml=false){
	global $blogURL,$owner;
	$categoryCount=0;
	$categoryCountAll=0;
	$parentCategoryCount=0;
	$tree=array('id'=>0,'label'=>getCategoryNameById($owner,0),'value'=>$totalPosts,'link'=>"$blogURL/category",'children'=>array());
	foreach($categories as $category1){
		$children=array();
		if(doesHaveOwnership()||getCategoryVisibility($owner,$category1['id'])>1){
			foreach($category1['children'] as $category2){
				if(doesHaveOwnership()||getCategoryVisibility($owner,$category2['id'])>1){
					array_push($children,array('id'=>$category2['id'],'label'=>$category2['name'],'value'=>(doesHaveOwnership()?$category2['entriesinlogin']:$category2['entries']),'link'=>"$blogURL/category/".encodeURL($category2['label']),'children'=>array()));
					$categoryCount=$categoryCount+(doesHaveOwnership()?$category2['entriesinlogin']:$category2['entries']);
				}
				$categoryCountAll=$categoryCountAll+(doesHaveOwnership()?$category2['entriesinlogin']:$category2['entries']);
			}
			$parentCategoryCount=(doesHaveOwnership()?$category1['entriesinlogin']-$categoryCountAll:$category1['entries']-$categoryCountAll);
			array_push($tree['children'],array('id'=>$category1['id'],'label'=>$category1['name'],'value'=>$categoryCount+$parentCategoryCount,'link'=>"$blogURL/category/".encodeURL($category1['label']),'children'=>$children));
			$categoryCount=0;
			$categoryCountAll=0;
			$parentCategoryCount=0;
		}
	}
	ob_start();
	printTreeView($tree,$selected,false,$xhtml);
	$view=ob_get_contents();
	ob_end_clean();
	return $view;
}
function printTreeView($tree,$selected,$embedJava=false,$xhtml=false){
	global $skinSetting;
	$skin=$skinSetting;
	if($embedJava==false){
		$skin=getCategoriesSkin();
	}
	if($xhtml){
		echo '<ul>';
		$isSelected=($tree['id']===$selected)?' class="selected"':'';
		echo "<li$isSelected><a href=\"",htmlspecialchars($tree['link']),'">',htmlspecialchars($tree['label']);
		if($skin['showValue'])
			echo " <span class=\"c_cnt\">({$tree['value']})</span>";
		echo "</a>";
		if(sizeof($tree['children'])>0)
			echo '<ul>';
		foreach($tree['children'] as $child){
			$isSelected=($child['id']===$selected)?' class="selected"':'';
			echo "<li$isSelected><a href=\"",htmlspecialchars($child['link']),'">',htmlspecialchars($child['label']);
			if($skin['showValue'])
				echo " <span class=\"c_cnt\">({$child['value']})</span>";
			echo "</a>";
			if(sizeof($child['children'])>0)
				echo '<ul>';
			foreach($child['children'] as $leaf){
				$isSelected=($leaf['id']===$selected)?' class="selected"':'';
				echo "<li$isSelected><a href=\"",htmlspecialchars($leaf['link']),'">',htmlspecialchars($leaf['label']);
				if($skin['showValue'])
					echo " <span class=\"c_cnt\">({$leaf['value']})</span>";
				echo "</a></li>";
			}
			if(sizeof($child['children'])>0)
				echo '</ul>';
			echo '</li>';
		}
		if(sizeof($tree['children'])>0)
			echo "</ul>";
		echo '</li></ul>';
		return ;
	}
	$action=0;?>
<script type="text/javascript">
	//<![CDATA[
		var expanded = false;
		function expandTree() {
<?php
	foreach($tree['children'] as $level1){
		if(!empty($level1['children'])){?>
			expandFolder(<?php
			echo $level1['id'];?>, true);
<?php
		}
	}?>
		}

		function expandFolder(category, expand) {
			var oLevel1 = document.getElementById("category_" + category);
			var oImg = oLevel1.getElementsByTagName("img")[0];
			switch (expand) {
				case true:
					oImg.src = "<?php
	echo $skin['url'];?>/tab_opened.gif";
					showLayer("category_" + category + "_children");
					return true;
				case false:
					oImg.src = "<?php
	echo $skin['url'];?>/tab_closed.gif";
					hideLayer("category_" + category + "_children");
					return true;
			}
			return false;
		}

		function toggleFolder(category) {
			var oLevel1 = document.getElementById("category_" + category);
			var oImg = oLevel1.getElementsByTagName("img")[0];
			switch (oImg.src.substr(oImg.src.length - 10, 6)) {
				case "isleaf":
					return true;
				case "closed":
					oImg.src = "<?php
	echo $skin['url'];?>/tab_opened.gif";
					showLayer("category_" + category + "_children");
					expanded = true;
					return true;
				case "opened":
					oImg.src = "<?php
	echo $skin['url'];?>/tab_closed.gif";
					hideLayer("category_" + category + "_children");
					expanded = false;
					return true;
			}
			return false;
		}
		var selectedNode = 0;
		function selectNode(category) {
			try {
				var root = document.getElementById('treeComponent');
				var prevSelectedNode= root.getAttribute('currentselectednode');
				var oLevel = document.getElementById("category_" + selectedNode);
				var oChild = oLevel.getElementsByTagName("table")[0];

				oChild.style.color = "#<?php
	echo $skin['itemColor'];?>";
<?php
	if($skin['itemBgColor']!='')
		echo "				oChild.style.backgroundColor = \"#{$skin['itemBgColor']}\"";
	else
		echo "				oChild.style.backgroundColor = \"\"";?>

				root.setAttribute('currentselectednode',category);
				document.getElementById('text_'+selectedNode).style.color="#<?php
	echo $skin['itemColor'];?>";

				var oLevel = document.getElementById("category_" + category);
				var oChild = oLevel.getElementsByTagName("table")[0];
				oChild.style.color = "#<?php
	echo $skin['activeItemColor'];?>";
<?php
	if($skin['activeItemBgColor']!='')
		echo "				oChild.style.backgroundColor = \"#{$skin['activeItemBgColor']}\"";
	else
		echo "				oChild.style.backgroundColor = \"\"";?>

				document.getElementById('text_'+category).style.color="#<?php
	echo $skin['activeItemColor'];?>";

				selectedNode = category;
			} catch(e) {
				alert(e.message);
			}

		}

		function setTreeStyle(skin) {
			try {
				treeNodes = document.getElementsByName("treeNode");
				for(var i=0; i<treeNodes.length; i++) {
					if( ('category_'+selectedNode) == (treeNodes[i].getAttribute('id').value) ) {
						var oLevel = document.getElementById('category_'+i);
						var oChild = oLevel.getElementsByTagName("table")[0];
						oChild.style.color ='#'+skin['activeItemColor'];
						if (skin['activeItemBgColor'] != '' && skin['activeItemBgColor'] != undefined) {
							oChild.style.backgroundColor ='#'+skin['activeItemBgColor'];
						} else {
							oChild.style.backgroundColor ="";
						}
						alert(oChild.style.backgroundColor);
					} else{
						var oLevel = document.getElementById("category_" + i);
						var oChild = oLevel.getElementsByTagName("table")[0];
						oChild.style.color ='#'+skin['colorontree'];
						oChild.style.backgroundColor ='#'+skin['bgcolorontree'];
						var oLevel = document.getElementById('text_'+i).style.color='#'+skin['colorontree'];
						alert(document.getElementById('text_'+i).style.color);
					}
				}
			} catch(e) {
				alert(e.message);
			}
		}
	//]]>
</script>
	<?php
	if($skin['itemBgColor']==""){
		$itemBgColor='';
	}else{
		$itemBgColor='background-color: #'.$skin['itemBgColor'].';';
	}?>
	<table id="treeComponent" <?php
	echo ($embedJava==true)?'currentselectednode="'.$selected.'"':'';?> cellpadding="0" cellspacing="0" style="width: 100%;"><tr>
	<td>
		<table id="category_0" <?php
	echo ($embedJava==true)?'name="treeNode"':'';?> cellpadding="0" cellspacing="0"><tr>
			<td class="ib" style="font-size: 1px"><img src="<?php
	echo $skin['url'];?>/tab_top.gif" width="16" onclick="expandTree()" alt="" /></td>
			<td valign="top" style="font-size:9pt; padding-left:3px">
				<table onclick="<?php
	if($action==1){?> alert(3);onclick_setimp(window, this, c_ary, t_ary); <?php
	}?>" id="imp0" cellpadding="0" cellspacing="0" style="<?php
	echo $itemBgColor;?>"><tr>
					<?php
	if(empty($tree['link']))
		$link='onclick="selectNode(0)"';
	else
		$link='onclick="window.location.href=\''.escapeJSInAttribute($tree['link']).'\'"';?>
					<td class="branch3" <?php
	echo $link;?>><div id="text_0" style=" color: #<?php
	echo $skin['itemColor'];?>;"><?php
	echo htmlspecialchars($tree['label']);?> <?php
	if($skin['showValue'])
		print "<span class=\"c_cnt\">({$tree['value']})</span>";?></div></td>
				</tr></table>
			</td>
		</tr></table>

<?php
	$parentOfSelected=false;
	$i=count($tree['children']);
	foreach($tree['children'] as $row){
		$i--;
		if(empty($row['link']))
			$link='onclick="selectNode('.$row['id'].')"';
		else
			$link='onclick="window.location.href=\''.escapeJSInAttribute($row['link']).'\'"';?>
		<table <?php
		echo ($embedJava==true)?'name="treeNode"':'';?>  id="category_<?php
		echo $row['id'];?>" cellpadding="0" cellspacing="0"><tr>
			<td class="ib" style="width:39px; font-size: 1px; background-image: url('<?php
		echo $skin['url'];?>/navi_back_noactive<?php
		echo ($i?'':'_end');?>.gif')"><a class="click" onclick="toggleFolder('<?php
		echo $row['id'];?>')"><img src="<?php
		echo $skin['url'];?>/tab_<?php
		echo (count($row['children'])?'closed':'isleaf');?>.gif" width="39" alt="" /></a></td>
			<td>
				<table cellpadding="0" cellspacing="0" style="<?php
		echo $itemBgColor;?>"><tr>
					<td class="branch3" <?php
		echo $link;?>><div id="text_<?php
		echo $row['id'];?>" style="color: #<?php
		echo $skin['itemColor'];?>;"><?php
		echo htmlspecialchars(UTF8::lessenAsEm($row['label'],$skin['labelLength']));?> <?php
		if($skin['showValue'])
			print "<span class=\"c_cnt\">({$row['value']})</span>";?></div></td>
				</tr></table>
			</td>
		</tr></table>
		<div id="category_<?php
		echo $row['id'];?>_children" style="display:none">
<?php
		$j=count($row['children']);
		foreach($row['children'] as $irow){
			if($irow['id']==$selected)
				$parentOfSelected=$row['id'];
			$j--;
			if(empty($irow['link']))
				$link='onclick="selectNode('.$irow['id'].')"';
			else
				$link='onclick="window.location.href=\''.escapeJSInAttribute($irow['link']).'\'"';
			if(empty($irow['link']))
				$link='onclick="selectNode('.$irow['id'].')"';
			else
				$link='onclick="window.location.href=\''.escapeJSInAttribute($irow['link']).'\'"';?>
				<table id="category_<?php
			echo $irow['id'];?>" <?php
			echo ($embedJava==true)?'name="treeNode"':'';?> cellpadding="0" cellspacing="0"><tr>
				<td style="width:39px; font-size: 1px"><img src="<?php
			echo $skin['url'];?>/navi_back_active<?php
			echo ($i?'':'_end');?>.gif" width="17" height="18" alt="" /><img src="<?php
			echo $skin['url'];?>/tab_treed<?php
			if(!$j)
				print "_end";?>.gif" width="22" alt="" /></td>
				<td>
					<table <?php
			echo $link;?> cellpadding="0" cellspacing="0" style="<?php
			echo $itemBgColor;?>"><tr>
					<td class="branch3"><div id="text_<?php
			echo $irow['id'];?>" style="color: #<?php
			echo $skin['itemColor'];?>;"><?php
			echo htmlspecialchars(UTF8::lessenAsEm($irow['label'],$skin['labelLength']));?> <?php
			echo ($skin['showValue']?"<span class=\"c_cnt\">({$irow['value']})</span>":'');?></div></td>
					</tr></table>
				</td>
				</tr></table>
<?php
		}?>
		</div>
<?php
	}?>
	</td></tr></table>
<?php
	if(is_numeric($selected)){?>
<script type="text/javascript">
//<![CDATA[
	function execOnLoadSelect() {
<?php
		if($parentOfSelected){?>
	expandFolder(<?php
			echo $parentOfSelected;?>, true);
<?php
		}?>
		selectNode(<?php
		echo $selected;?>);
	}
	window.addEventListener("load", execOnLoadSelect, false);
//]]>
</script>
<?php
	}
}
function printMobileHtmlHeader($title=''){
	global $blogURL,$blog;
	$title=htmlspecialchars($blog['title']).' :: '.$title;?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ko">
	<head>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<title><?php
	echo $title;?></title>
	</head>
	<body>
		<div id="header">
			<h1><a href="<?php
	echo $blogURL;?>" accesskey="0"><?php
	echo htmlspecialchars($blog['title']);?></a></h1>
		</div>
		<hr />
<?php
}
function printMobileHtmlFooter(){?>
		<hr />
		<p>Powered by <a href="<?php
	echo TATTERTOOLS_HOMEPAGE;?>"><?php
	echo TATTERTOOLS_NAME;?></a></p>
	</body>
</html>
<?php
}
function printMobileNavigation($entry,$jumpToComment=true,$jumpToTrackback=true,$paging=null){
	global $suri,$blogURL;?>
<hr />
<div id="navigation">
	<ul>
		<?php
	if(isset($paging['prev'])){?>
		<li><a href="<?php
		echo $blogURL;?>/<?php
		echo $paging['prev'];?>" accesskey="1"><?php
		echo _text('이전 글 보기');?></a></li>
		<?php
	}
	if(isset($paging['next'])){?>
		<li><a href="<?php
		echo $blogURL;?>/<?php
		echo $paging['next'];?>" accesskey="2"><?php
		echo _text('다음 글 보기');?></a></li>
		<?php
	}
	if(!isset($paging)){?>	
		<li><a href="<?php
		echo $blogURL;?>/<?php
		echo $entry['id'];?>" accesskey="3"><?php
		echo _text('포스트보기');?></a></li>
		<?php
	}
	if($jumpToComment){?>
		<li><a href="<?php
		echo $blogURL;?>/comment/<?php
		echo $entry['id'];?>" accesskey="4"><?php
		echo _text('답글 보기');?> (<?php
		echo $entry['comments'];?>)</a></li>
		<?php
	}
	if($jumpToTrackback){?>
		<li><a href="<?php
		echo $blogURL;?>/trackback/<?php
		echo $entry['id'];?>" accesskey="5"><?php
		echo _text('걸린 글 보기');?> (<?php
		echo $entry['trackbacks'];?>)</a></li>
		<?php
	}
	if($suri['directive']!='/m/pannels'){?>
		<li><a href="<?php
		echo $blogURL;?>/pannels/<?php
		echo $entry['id'];?>" accesskey="6"><?php
		echo _text('다른 메뉴보기');?></a></li>
		<?php
	}?>
	</ul>
</div>
<?php
}
header('Content-Type: text/html; charset=utf-8');
list($entries,$paging)=getEntryWithPaging($owner,$suri['id']);
$entry=$entries?$entries[0]:null;
printMobileHtmlHeader(htmlspecialchars($blog['title']));?>
<div id="pannels">
	<!--
	<h2><?php
echo _t('카테고리');?></h2>
	<?php
echo getCategoriesView(getEntriesTotalCount($owner),getCategories($owner),true,true);?>
	-->
	<h2><?php
echo _text('최근에 달린 답글');?></h2>
	<?php
$comments=getRecentComments($owner);
if(count($comments)>0)
	echo '<ul>';
foreach($comments as $comment){?>
			<li><a href="<?php
	echo $blogURL;?>/comment/<?php
	echo $comment['entry'];?>"><?php
	echo htmlspecialchars($comment['comment']);?></a><br /><?php
	echo htmlspecialchars($comment['name']);?> (<?php
	echo Timestamp::format2($comment['written']);?>)</li>
		<?php
}
if(count($comments)>0)
	echo '</ul>';?>
	<h2><?php
echo _text('최근에 걸린글');?></h2>
	<?php
$trackbacks=getRecentTrackbacks($owner);
if(count($trackbacks)>0)
	echo '<ul>';
foreach($trackbacks as $trackback){?>
			<li><a href="<?php
	echo $blogURL;?>/trackback/<?php
	echo $trackback['entry'];?>"><?php
	echo htmlspecialchars($trackback['subject']);?></a><br /><?php
	echo htmlspecialchars($trackback['site']);?> (<?php
	echo Timestamp::format2($trackback['written']);?>)</li>
		<?php
}
if(count($trackbacks)>0)
	echo '</ul>';?>
	<!--
	<h2><?php
echo _text('글 보관함');?></h2>
	<ul>
	<?php
foreach(getArchives($owner) as $archive){?>
	<li><a href="<?php
	echo $blogURL;?>/archive/<?php
	echo $archive['period'];?>"><?php
	echo getPeriodLabel($archive['period']);?></a> (<?php
	echo $archive['count'];?>)</li>
	<?php
}?>
	</ul>
	-->
</div>
<?php
printMobileNavigation($entry);
printMobileHtmlFooter();?>
