<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function stripHTML($text,$allowTags=array()){
	$text=preg_replace('/<(script|style)[^>]*>.*?<\/\1>/si','',$text);
	if(count($allowTags)==0)
		$text=preg_replace('/<[\w\/!]+[^>]*>/','',$text);
	else{
		preg_match_all('/<\/?([\w!]+)[^>]*?>/s',$text,$matches);
		for($i=0;$i<count($matches[0]);$i++){
			if(!in_array(strtolower($matches[1][$i]),$allowTags))
				$text=str_replace($matches[0][$i],'',$text);
		}
	}
	$text=preg_replace('/&nbsp;?|\xc2\xa0\x20/',' ',$text);
	$text=trim(preg_replace('/\s+/',' ',$text));
	if(!empty($text))
		$text=str_replace(array('&#39;','&apos;','&quot;'),array('\'','\'','"'),$text);
	return $text;
}
function escapeCubridSearchString($str){
	return is_string($str)?str_replace('_','\_',str_replace('%','\%',cubrid_tt_escape_string($str))):$str;
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getAttributesFromString($str,$caseSensitive=true){
	$attributes=array();
	preg_match_all('/([^=\s]+)\s*=\s*"([^"]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)\s*=\s*\'([^\']*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)=([^\'"][^\s]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	return $attributes;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getAttachments($owner,$parent,$orderBy=null,$sort='ASC'){
	global $database, $cubrid_con;
	$attachments=array();
	if($result=DBQuery::query("select * from {$database['prefix']}Attachments where owner = $owner and parent = $parent ".(is_null($orderBy)?'':"ORDER BY $orderBy $sort"))){
		while($attachment=cubrid_fetch($result))
			array_push($attachments,$attachment);
		cubrid_commit($cubrid_con);
	}
	return $attachments;
}
function deleteAttachment($owner,$parent,$name){
	global $database;
	if(!Validator::filename($name))
		return false;
	$origname=$name;
	$name=cubrid_tt_escape_string($name);
	if(DBQuery::execute("delete from {$database['prefix']}Attachments where owner = $owner and \"name\" = '$name'")){
		@unlink("../../../../attach/$owner/$origname");
		clearRSS();
		return true;
	}
	return false;
}
function deleteAttachments($owner,$parent){
	$attachments=getAttachments($owner,$parent);
	foreach($attachments as $attachment)
		deleteAttachment($owner,$parent,$attachment['name']);
}
function getCommentsNotifiedWithPagingForOwner($owner,$category,$name,$ip,$search,$page,$count){
	global $database;
	if(empty($name)&&empty($ip)&&empty($search)){
		$sql="SELECT 
					c.*, 
					csiteinfo.title AS siteTitle,
					csiteinfo.\"name\" AS nickname,
					csiteinfo.url AS siteUrl,
					csiteinfo.modified AS siteModified
				FROM 
					{$database['prefix']}CommentsNotified c
				LEFT JOIN 
						{$database['prefix']}CommentsNotifiedSiteInfo csiteinfo ON c.siteid = csiteinfo.id  
				WHERE c.owner = $owner AND (c.parent is null)";
		$sql.=' ORDER BY c.modified DESC';
	}else{
		if(!empty($search)){
			$search=escapeCubridSearchString($search);
		}
		$preQuery="SELECT parent FROM {$database['prefix']}CommentsNotified WHERE owner = $owner AND parent is NOT NULL";
		if(!empty($name))
			$preQuery.=' AND \"name\" = \''.cubrid_tt_escape_string($name).'\' ';
		if(!empty($ip))
			$preQuery.=' AND ip = \''.cubrid_tt_escape_string($ip).'\' ';
		if(!empty($search)){
			$preQuery.=" AND ((\"name\" LIKE '%$search%') OR (homepage LIKE '%$search%') OR (comment LIKE '%$search%'))";
		}
		$childListTemp=array_unique(DBQuery::queryColumn($preQuery));
		$childList=array();
		foreach($childListTemp as $item)
			if(!is_null($item))
				array_push($childList,$item);
		$childListStr=(count($childList)==0)?'':('OR c.id IN ( '.implode(', ',$childList).' ) ');
		$sql="SELECT 
				c.*, 
				csiteinfo.title AS siteTitle,
				csiteinfo.\"name\" AS nickname,
				csiteinfo.url AS siteUrl,
				csiteinfo.modified AS siteModified
			FROM 
					{$database['prefix']}CommentsNotified c 
				LEFT JOIN 
					{$database['prefix']}CommentsNotifiedSiteInfo csiteinfo ON c.siteid = csiteinfo.id  
			WHERE c.owner = $owner AND (c.parent is null) ";
		if(!empty($name))
			$sql.=' AND ( c.\"name\" = \''.cubrid_tt_escape_string($name).'\') ';
		if(!empty($ip))
			$sql.=' AND ( c.ip = \''.cubrid_tt_escape_string($ip).'\') ';
		if(!empty($search)){
			$sql.=" AND ((c.\"name\" LIKE '%$search%') OR (c.homepage LIKE '%$search%') OR (c.comment LIKE '%$search%')) ";
		}
		$sql.=$childListStr.' ORDER BY c.modified DESC ';
	}
	return fetchWithPaging($sql,$page,$count);
}
function getRecentComments($owner,$count=false,$isGuestbook=false){
	global $skinSetting,$database, $cubrid_con;
	$comments=array();
	$sql=doesHaveOwnership()?"SELECT * FROM 
			{$database['prefix']}Comments 
		WHERE 
			owner = $owner".($isGuestbook!=false?" AND entry=0":" AND entry>0")." AND isfiltered = 0 
		ORDER BY 
			written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count!=false?$count+0:$skinSetting['commentsonrecent']+0):"SELECT r.* FROM 
			{$database['prefix']}Comments r
			LEFT JOIN {$database['prefix']}Entries e ON r.owner = e.owner AND r.entry = e.id
			LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id
		WHERE 
			r.owner = $owner AND e.draft = 0 AND e.visibility >= 2 AND (c.visibility > 1 OR e.category = 0) ".($isGuestbook!=false?" AND r.entry = 0":" AND r.entry > 0")." AND isfiltered = 0 
		ORDER BY 
			r.written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND  
			".($count!=false?$count+0:$skinSetting['commentsonrecent']+0);
	if($result=DBQuery::query($sql)){
		while($comment=cubrid_fetch($result)){
			if(($comment['secret']==1)&&!doesHaveOwnership()){
				$comment['name']='';
				$comment['homepage']='';
				$comment['comment']=_text('관리자만 볼 수 있는 댓글입니다.');
			}
			array_push($comments,$comment);
		}
		cubrid_commit($cubrid_con);
	}
	return $comments;
}
function getRecentGuestbook($owner,$count=false){
	return getRecentComments($owner,$count,true);
}
function getCommentCount($owner,$entryId=null){
	global $database;
	if(is_null($entryId))
		return DBQuery::queryCell("SELECT SUM(comments) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft= 0 ");
	return DBQuery::queryCell("SELECT comments FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $entryId AND draft = 0");
}
function getEntriesTotalCount($owner){
	global $database;
	$visibility=doesHaveOwnership()?'':'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	return DBQuery::queryCell("SELECT COUNT(*) 
		FROM {$database['prefix']}Entries e
		LEFT JOIN {$database['prefix']}Categories c ON e.category = c.id AND e.owner = c.owner 
		WHERE e.owner = $owner AND e.draft = 0 $visibility AND e.category >= 0");
}
function getEntry($owner,$id,$draft=false){
	global $database;
	if($id==0){
		if($draft){
			if(!$id=getDraftEntryId())
				return ;
		}else{
			if(!doesHaveOwnership())
				return ;
			deleteAttachments($owner,0);
			return array('id'=>0,'draft'=>0,'visibility'=>0,'category'=>0,'location'=>'','title'=>'','content'=>'','acceptcomment'=>1,'accepttrackback'=>1,'published'=>time(),'slogan'=>'');
		}
	}
	if($draft){
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 1");
		if(!$entry)
			return ;
		if($entry['published']==1)
			$entry['republish']=true;
		elseif($entry['published']!=0)
			$entry['appointed']=$entry['published'];
		if($id!=0)
			$entry['published']=DBQuery::queryCell("SELECT published FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0");
		return $entry;
	}else{
		$visibility=doesHaveOwnership()?'':'AND visibility > 0';
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0 $visibility");
		if(!$entry)
			return ;
		if($entry['visibility']<0)
			$entry['appointed']=$entry['published'];
		return $entry;
	}
}
function getDraftEntryId($id=0){
	global $database,$owner;
	if($id)
		return DBQuery::queryCell("SELECT id 
				FROM {$database['prefix']}Entries 
				WHERE owner = $owner AND id = $id AND draft = 1");
	else
		return DBQuery::queryCell("SELECT d.id 
				FROM {$database['prefix']}Entries d 
				LEFT JOIN {$database['prefix']}Entries e ON d.owner = e.owner AND d.id = e.id AND e.draft = 0 
				WHERE d.owner = $owner AND d.draft = 1 AND e.id IS NULL 
				ORDER BY d.id for orderby_num() = 1");
}
function fetchWithPaging($sql,$page,$count,$url=null,$prefix='?page=',$countItem=null){
	global $folderURL;
	if($url===null)
		$url=$folderURL;
	$paging=array('url'=>$url,'prefix'=>$prefix,'postfix'=>'');
	if(empty($sql))
		return array(array(),$paging);
	if(eregi('[[:space:]]{1}(FROM.*)$',$sql,$matches))
		$from=$matches[1];
	else
		return array(array(),$paging);
	$countfrom=strtoupper($from);
    if (($delpos=strpos($countfrom,"ORDER BY "))!==false) {
      $countfrom=substr($from,0,$delpos);
    }
	$paging['total']=DBQuery::queryCell("SELECT COUNT(*) $countfrom");
	if($paging['total']===null)
		return array(array(),$paging);
	if(empty($count))
		$count=1;
	$paging['pages']=intval(ceil($paging['total']/$count));
	$paging['page']=is_numeric($page)?$page:1;
	if($paging['page']>$paging['pages']){
		$paging['page']=$paging['pages'];
		if($paging['pages']>0)
			$paging['prev']=$paging['pages']-1;
	}
	if($paging['page']>1)
		$paging['prev']=$paging['page']-1;
	if($paging['page']<$paging['pages'])
		$paging['next']=$paging['page']+1;
	$offset=($paging['page']-1)*$count;
	if($offset<0)
		$offset=0;
	if($countItem!=null)
		$count=$countItem;
	$lmstr=" BETWEEN ".($offset+1)." AND ".($count+$offset);
  $sqlupr = strtoupper($sql);
  if (strpos($sqlupr,"ORDER BY") !== false) { // for orderby_num() between.. and ..
    $sql .= " for orderby_num() ".$lmstr;
  }
  else {
    if (strpos($sqlupr,"GROUP BY") !== false) { // having groupby_num() between.. and .. 
      if (($pos=strpos($sqlupr,"HAVING")) !== false) { // AND ...
        $sql = substr($sql,0,$pos+6)." groupby_num() ".$lmstr." and ".substr($sql,$pos+6);
      }
      else { // having ...
        $sql .= " having groupby_num() ".$lmstr;
      }
    }
    else { //where inst_num() between.. and .. 
      if (($pos=strpos($sqlupr,"WHERE")) !== false) { // AND ...
        $sql = substr($sql,0,$pos+5)." inst_num() ".$lmstr." and ".substr($sql,$pos+5);
      }
      else { // where ...
        $sql .= " where inst_num() ".$lmstr;
      }
    }
  }
	return array(DBQuery::queryAll("$sql"),$paging);
}
function clearRSS(){
	global $owner;
	@unlink("../../../../cache/rss/$owner.xml");
}
function getStatistics($owner){
	global $database, $cubrid_con;
	$stats=array('total'=>0,'today'=>0,'yesterday'=>0);
	$result=DBQuery::query("select visits from {$database['prefix']}BlogStatistics where owner = $owner");
	if(cubrid_num_rows($result)==1)
		list($stats['total'])=cubrid_fetch($result);
	$result=DBQuery::query("select visits from {$database['prefix']}DailyStatistics where owner = $owner and \"date\" = ".Timestamp::getDate());
	if(cubrid_num_rows($result)==1)
		list($stats['today'])=cubrid_fetch($result);
	$result=DBQuery::query("select visits from {$database['prefix']}DailyStatistics where owner = $owner and \"date\" = ".Timestamp::getDate(time()-86400));
	if(cubrid_num_rows($result)==1)
		list($stats['yesterday'])=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $stats;
}
function getRecentTrackbacks($owner,$count=false){
	global $database, $cubrid_con;
	global $skinSetting;
	$trackbacks=array();
	$sql=doesHaveOwnership()?"SELECT * 
		FROM 
			{$database['prefix']}Trackbacks 
		WHERE 
			owner = $owner AND isfiltered = 0 
		ORDER BY 
			written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count!=false?$count+0:$skinSetting['trackbacksonrecent']+0):"SELECT t.* 
		FROM 
			{$database['prefix']}Trackbacks t 
			LEFT JOIN {$database['prefix']}Entries e ON t.owner = e.owner AND t.entry = e.id
			LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id
		WHERE 
			t.owner = $owner AND e.draft = 0 AND e.visibility >= 2 AND (c.visibility > 1 OR e.category = 0) AND t.isfiltered = 0 
		ORDER BY 
			t.written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND ".($count=false?$count+0:$skinSetting['trackbacksonrecent']+0);
	if($result=DBQuery::query($sql)){
		while($trackback=cubrid_fetch($result))
			array_push($trackbacks,$trackback);
	  cubrid_commit($cubrid_con);
	}
	return $trackbacks;
}
function getTrackbackCount($owner,$entryId=null){
	global $database;
	if(is_null($entryId))
		return DBQuery::queryCell("SELECT SUM(trackbacks) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft= 0");
	return DBQuery::queryCell("SELECT trackbacks FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $entryId AND draft= 0");
}
function trashVan(){
	global $database;
	requireComponent('Eolin.PHP.Core');
	if(Timestamp::getUNIXtime()-getUserSetting('lastTrashSweep',0)>86400){
		DBQuery::execute("DELETE FROM {$database['prefix']}Comments where isfiltered < (SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970')) - 1296000 AND isfiltered > 0");
		DBQuery::execute("DELETE FROM {$database['prefix']}Trackbacks where isfiltered < (SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970')) - 1296000 AND isfiltered > 0");
		setUserSetting('lastTrashSweep',Timestamp::getUNIXtime());
	}
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function setUserSetting($name,$value){
	global $database,$owner;
	$name=cubrid_tt_escape_string($name);
	$value=cubrid_tt_escape_string($value);
	$cell=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '$name'");
	if ($cell===null) {
  	return DBQuery::execute("INSERT INTO {$database['prefix']}UserSettings (\"user\", \"name\", \"value\") VALUES($owner, '$name', '$value')");
  }
  else {
  	return DBQuery::execute("UPDATE {$database['prefix']}UserSettings SET \"value\"='$value' WHERE \"user\" = $owner AND \"name\" = '$name'");
  }
}
function getRemoteFeed($url){
	global $service;
	$xml=fireEvent('GetRemoteFeed',null,$url);
	if(empty($xml)){
		requireComponent('Eolin.PHP.HTTPRequest');
		$request=new HTTPRequest($url);
		$request->timeout=3;
		if(!$request->send())
			return array(2,null,null);
		$xml=$request->responseText;
	}
	$feed=array('xmlurl'=>$url);
	$xmls=new XMLStruct();
	if(!$xmls->open($xml,$service['encoding'])){
		if(preg_match_all('/<link .*?rel\s*=\s*[\'"]?alternate.*?>/i',$xml,$matches)){
			foreach($matches[0] as $link){
				$attributes=getAttributesFromString($link);
				if(isset($attributes['href'])){
					$urlInfo=parse_url($url);
					$rssInfo=parse_url($attributes['href']);
					$rssURL=false;
					if(isset($rssInfo['scheme'])&&$rssInfo['scheme']=='http')
						$rssURL=$attributes['href'];
					elseif(isset($rssInfo['path'])){
						if($rssInfo['path']{0}=='/')
							$rssURL="{$urlInfo['scheme']}://{$urlInfo['host']}{$rssInfo['path']}";
						else
							$rssURL="{$urlInfo['scheme']}://{$urlInfo['host']}".(isset($urlInfo['path'])?rtrim($urlInfo['path'],'/'):'').'/'.$rssInfo['path'];
					}
					if($rssURL&&$url!=$rssURL)
						return getRemoteFeed($rssURL);
				}
			}
		}
		return array(3,null,null);
	}
	if($xmls->getAttribute('/rss','version')){
		$feed['blogurl']=$xmls->getValue('/rss/channel/link');
		$feed['title']=$xmls->getValue('/rss/channel/title');
		$feed['description']=$xmls->getValue('/rss/channel/description');
		if(Validator::language($xmls->getValue('/rss/channel/language')))
			$feed['language']=$xmls->getValue('/rss/channel/language');
		elseif(Validator::language($xmls->getValue('/rss/channel/dc:language')))
			$feed['language']=$xmls->getValue('/rss/channel/dc:language');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}elseif($xmls->getAttribute('/feed','version')){
		$feed['blogurl']=$xmls->getAttribute('/feed/link','href');
		$feed['title']=$xmls->getValue('/feed/title');
		$feed['description']=$xmls->getValue('/feed/tagline');
		if(Validator::language($xmls->getAttribute('/feed','xml:lang')))
			$feed['language']=$xmls->getAttribute('/feed','xml:lang');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}elseif($xmls->getAttribute('/rdf:RDF','xmlns')){
		if($xmls->getAttribute('/rdf:RDF/channel/link','href'))
			$feed['blogurl']=$xmls->getAttribute('/rdf:RDF/channel/link','href');
		elseif($xmls->getValue('/rdf:RDF/channel/link'))
			$feed['blogurl']=$xmls->getValue('/rdf:RDF/channel/link');
		else
			$feed['blogurl']='';
		$feed['title']=$xmls->getValue('/rdf:RDF/channel/title');
		$feed['description']=$xmls->getValue('/rdf:RDF/channel/description');
		if(Validator::language($xmls->getValue('/rdf:RDF/channel/dc:language')))
			$feed['language']=$xmls->getValue('/rdf:RDF/channel/dc:language');
		elseif(Validator::language($xmls->getAttribute('/rdf:RDF','xml:lang')))
			$feed['language']=$xmls->getAttribute('/rdf:RDF','xml:lang');
		else
			$feed['language']='en-US';
		$feed['modified']=gmmktime();
	}else
		return array(3,null,null);
	$feed['xmlurl']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['xmlurl'])));
	$feed['blogurl']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['blogurl'])));
	$feed['title']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['title'])));
	$feed['description']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct(stripHTML($feed['description']))));
	$feed['language']=cubrid_tt_escape_string(cubrid_lessen(UTF8::correct($feed['language']),255));
	return array(0,$feed,$xml);
}
function parseDate($str){
	if(preg_match('/^(\d{4})년 (\d{2})월 (\d{2})일  (\d{2}):(\d{2}):(\d{2})$/',$str,$matches))
		return parseDate("{$matches[1]}-{$matches[2]}-{$matches[3]} {$matches[4]}:{$matches[5]}:{$matches[6]}");
	if(preg_match('/^(\d{2})-(\d{2})-(\d{4}) (\d{2}):(\d{2})$/',$str,$matches))
		return parseDate("{$matches[3]}-{$matches[1]}-{$matches[2]} {$matches[4]}:{$matches[5]}:00}");
	if(empty($str))
		return 0;
	$time=strtotime($str);
	if($time!==-1)
		return $time;
	$gmt=(substr($str,strpos($str,"GMT"))=="GMT")?9:0;
	$str=str_replace("년 ","-",$str);
	$str=str_replace("월 ","-",$str);
	$str=str_replace("일 ","",$str);
	$str=str_replace("GMT","",$str);
	$str=str_replace("KST","+0900",$str);
	if(strpos($str,"T")){
		list($date,$time)=explode("T",$str);
		list($y,$m,$d)=explode("-",$date);
		list($time)=explode("+",$time);
		@list($h,$i,$s)=explode(":",$time);
	}elseif(strpos($str,":")&&strpos($str,"-")){
		list($str)=explode(".",$str);
		list($date,$time)=explode(" ",$str);
		list($y,$m,$d)=explode("-",$date);
		if($d>1900){
			$t=$y;
			$y=$d;
			$d=$m;
			$m=$t;
		}
		@list($h,$i,$s)=explode(":",$time);
	}elseif(strpos($str,",")&&strpos($str,":")){
		list($temp,$str)=explode(",",$str);
		$str=trim(str_month_check($str));
		list($d,$m,$y,$time)=explode(" ",$str);
		list($h,$i,$s)=explode(":",$time);
	}else{
		return gmmktime();
	}
	if(!$h)
		$h="00";
	if(!$i)
		$i="00";
	if(!$s)
		$s="00";
	$h+=$gmt;
	return mktime($h,$i,$s,$m,$d,$y);
}
function str_month_check($str){
	$str=str_replace("Jan","01",$str);
	$str=str_replace("Feb","02",$str);
	$str=str_replace("Mar","03",$str);
	$str=str_replace("Apr","04",$str);
	$str=str_replace("May","05",$str);
	$str=str_replace("Jun","06",$str);
	$str=str_replace("Jul","07",$str);
	$str=str_replace("Aug","08",$str);
	$str=str_replace("Sep","09",$str);
	$str=str_replace("Oct","10",$str);
	$str=str_replace("Nov","11",$str);
	return str_replace("Dec","12",$str);
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
function _text($t){
	global $__outText;
	if(isset($__outText)&&isset($__outText[$t])){
		return $__outText[$t];
	}else{
		return $t;
	}
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function handleCenters($mapping){
	global $service,$pluginURL,$pluginPath,$configMappings,$configVal;
	$target='';
	include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
	if(function_exists($mapping['handler'])){
		if(!empty($configMappings[$mapping['plugin']]['config']))
			$configVal=getCurrentSetting($mapping['plugin']);
		else
			$configVal='';
		$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
		$pluginPath="../../../../plugins/{$mapping['plugin']}";
		$target=call_user_func($mapping['handler'],$target);
	}
	return $target;
}
function fetchConfigVal($DATA){
	$xmls=new XMLStruct();
	$outVal=array();
	if(!$xmls->open($DATA)){
		unset($xmls);
		return ;
	}
	if(is_null($xmls->selectNodes('/config/field'))){
		unset($xmls);
		return ;
	}
	foreach($xmls->selectNodes('/config/field') as $field){
		if(empty($field['.attributes']['name'])||empty($field['.attributes']['type'])){
			unset($xmls);
			return ;
		}
		$outVal[$field['.attributes']['name']]=$field['.value'];
	}
	unset($xmls);
	return ($outVal);
}
function respondResultPage($error){
	if($error===true)
		$error=0;
	elseif($error===false)
		$error=1;
	header('Content-Type: text/xml; charset=utf-8');
	print ("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<response>\n<error>$error</error>\n</response>");
	exit;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
if(!isset($_REQUEST['ajaxcall'])){?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
	echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
	echo htmlspecialchars($blog['title']);?> &gt; <?php
	echo _t('센터');?></title>
	<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/center.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/center.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/center.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
	echo $service['path'];?>";
			var blogurl = "<?php
	echo $blogURL;?>";
			var adminSkin = "<?php
	echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-center">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
	echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
	$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
	echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
	echo $blogURL;?>/" title="<?php
	echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
	echo $blogURL;?>/logout" title="<?php
	echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
	echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
	echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
	echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
	echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center" class="selected"><a href="<?php
	echo $blogURL;?>/owner/center/dashboard"><span><?php
	echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
	echo $blogURL;?>/owner/entry"><span class="text"><?php
	echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
	echo $blogURL;?>/owner/link"><span class="text"><?php
	echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
	echo $blogURL;?>/owner/skin"><span class="text"><?php
	echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
	echo $blogURL;?>/owner/plugin"><span class="text"><?php
	echo _t('플러그인');?></span></a></li>
						<li id="menu-setting"><a href="<?php
	echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
	echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
	echo $blogURL;?>/owner/reader"><span class="text"><?php
	echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

			<div id="layout-body">
				<h2><?php
	echo _t('서브메뉴 : 센터');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-dashboard" class="selected"><a href="<?php
	echo $blogURL;?>/owner/center/dashboard"><span class="text"><?php
	echo _t('조각보');?></span></a></li>
						<li id="sub-menu-dashboard-setting"><a href="<?php
	echo $blogURL;?>/owner/center/setting"><span class="text"><?php
	echo _t('자투리');?></span></a></li>
						<li id="sub-menu-about"><a href="<?php
	echo $blogURL;?>/owner/center/about"><span class="text"><?php
	echo _t('태터툴즈는');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
	echo getHelpURL('center/dashboard');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
	echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
	trashVan();
}
if($_SERVER['REQUEST_METHOD']=='POST'){
	if(isset($_POST['pos']))
		$_GET['pos']=$_POST['pos'];
	if(isset($_POST['rel']))
		$_GET['rel']=$_POST['rel'];
}
$layout=getUserSetting('centerLayout','');
$newlayout=array();
$addedlayout=array();
$oldcenterlayout=array();
if(count($centerMappings)==0){
	$layout='';
	setUserSetting('centerLayout','');
	unset($_GET['pos']);
	unset($_GET['rel']);
}
function findPlugin($item,$arrays){
	foreach($arrays as $key=>$data){
		if(($item['plugin']===$data['plugin'])&&($item['handler']===$data['handler']))
			return $key;
	}
	return false;
}
if((!empty($layout))&&(($oldcenterlayout=unserialize($layout))!=false)){
	$seperatorCount=0;
	foreach($oldcenterlayout as $item){
		if($item['plugin']=='TatterToolsSeperator'){
			array_push($newlayout,$item);
			$seperatorCount++;
		}elseif(($pos=findPlugin($item,$centerMappings))!==false){
			array_push($newlayout,$centerMappings[$pos]);
			unset($centerMappings[$pos]);
		}else{
			array_push($addedlayout,$item);
		}
	}
	while($seperatorCount<2){
		array_push($centerMappings,array('plugin'=>'TatterToolsSeperator'));
		$seperatorCount++;
	}
	$newlayout=array_merge($newlayout,$centerMappings);
}elseif(count($centerMappings)>0){
	unset($_GET['pos']);
	unset($_GET['rel']);
	$middlepos=(count($centerMappings)+2)/3;
	array_splice($centerMappings,$middlepos,0,array(array('plugin'=>'TatterToolsSeperator')));
	array_splice($centerMappings,$middlepos*2,0,array(array('plugin'=>'TatterToolsSeperator')));
	$newlayout=$addedlayout=$centerMappings;
}
if((isset($_GET['pos']))&&(($_GET['pos']<0)||($_GET['pos'])>=count($newlayout))){
	unset($_GET['pos']);
	unset($_GET['rel']);
}
$modified=false;
if(isset($_GET['pos'])&&is_numeric($_GET['pos'])){
	if(isset($_GET['rel'])&&is_numeric($_GET['rel'])&&(is_numeric($_GET['rel']))){
		$newpos=$_GET['pos']+$_GET['rel'];
		if($newpos<0)
			$newpos=0;
		if($newpos>=count($newlayout))
			$newpos=count($newlayout)-1;
		$item=array_splice($newlayout,$_GET['pos'],1);
		array_splice($newlayout,$newpos,0,$item);
		$modified=true;
	}
}
if((count($centerMappings)>0)||(count($addedlayout)>0)||($modified==true)){
	$saveLayout=array_values($newlayout);
	for($i=0;$i<count($saveLayout);$i++){
		unset($saveLayout[$i]['title']);
	}
	setUserSetting('centerLayout',serialize($saveLayout));
}
unset($addedlayout);
unset($layout);
unset($oldcenterlayout);
if(isset($_REQUEST['ajaxcall'])){
	respondResultPage(0);
	exit;
}
$editClass=NULL;
if(isset($_REQUEST['edit'])){
	$editClass="-edit";?>
<script src="<?php
	echo $service['path'];?>/script/dojo/dojo.js" type="text/javascript"></script>
<script src="<?php
	echo $service['path'];?>/script/dashboard.js" type="text/javascript"></script>
<?php
}
if(!file_exists('../../../../cache/CHECKUP')){?>
						<script type="text/javascript">
							//<![CDATA[
								window.addEventListener("load", checkTattertoolsVersion, false);
								function checkTattertoolsVersion() {
									if (confirm("<?php
	echo _t('버전업 체크를 위한 파일을 생성합니다. 지금 생성하시겠습니까?');?>"))
										window.location.href = "<?php
	echo $blogURL;?>/checkup";
								}
							//]]>
						</script>
<?php
}elseif(file_get_contents('../../../../cache/CHECKUP')!=TATTERTOOLS_VERSION){?>
						<script type="text/javascript">
							//<![CDATA[
								window.addEventListener("load", checkTattertoolsVersion, false);
								function checkTattertoolsVersion() {
									if (confirm("<?php
	echo _t('태터툴즈 시스템 점검이 필요합니다. 지금 점검하시겠습니까?');?>"))
										window.location.href = "<?php
	echo $blogURL;?>/checkup";
								}
							//]]>
						</script>
<?php
}
if(false){
	fetchConfigVal();
}?>	
						<form method="post" action="<?php
echo $blogURL;?>/owner/center/dashboard">
<?php
$tattertoolsDashboard=getUserSetting("tattertoolsDashboard");
if(is_null($tattertoolsDashboard)){
	setUserSetting("tattertoolsDashboard",1);
	$tattertoolsDashboard=1;
}
if($tattertoolsDashboard){
	if(!isset($_REQUEST['edit'])){
		$stats=getStatistics($owner);?>
							<div id="part-center-dashboard" class="part">
								<h2 class="caption"><span class="main-text"><?php
		echo _t('센터');?></span></h2>
								
								<div id="shortcut-collection" class="section">
									<h3><?php
		echo _t('바로가기');?></h3>
									
									<ul>
										<li><a href="<?php
		echo $blogURL;?>/owner/entry/post"><?php
		echo _t('새글 쓰기');?></a></li>
<?php
		$latestEntryId=getUserSetting('LatestEditedEntry',0);
		if($latestEntryId!==0){
			$latestEntry=getEntry($owner,$latestEntryId);
			if($latestEntry!=false){?>
										<li><a href="<?php
				echo $blogURL;?>/owner/entry/edit/<?php
				echo $latestEntry['id'];?>"><?php
				echo _f('최근글(%1) 수정',htmlspecialchars(UTF8::lessenAsEm($latestEntry['title'],10)));?></a></li>
<?php
			}
		}?>
										<li><a href="<?php
		echo $blogURL;?>/owner/skin"><?php
		echo _t('스킨 변경');?></a></li>
										<li><a href="<?php
		echo $blogURL;?>/owner/skin/setting"><?php
		echo _t('블로그 표시설정');?></a></li>
										<li><a href="<?php
		echo $blogURL;?>/owner/entry/category"><?php
		echo _t('카테고리 변경');?></a></li>
										<li><a href="<?php
		echo $blogURL;?>/owner/plugin"><?php
		echo _t('플러그인 관리');?></a></li>
										<li><a href="<?php
		echo $blogURL;?>/owner/reader"><?php
		echo _t('RSS 리더');?></a></li>
									</ul>
								</div>
								
								<div id="total-information" class="section">
									<h3><?php
		echo _t('요약');?></h3>
									
									<table>
										<tbody>
											<tr>
												<th><?php
		echo _t('오늘/어제방문자');?></th>
												<td><?php
		echo number_format($stats['today']).'/'.number_format($stats['yesterday']);?></td>
											</tr>
											<tr>
												<th><?php
		echo _t('총 방문자');?></th>
												<td><?php
		echo number_format($stats['total']);?></td>
											</tr>
											<tr>
												<th><?php
		echo _t('글 개수');?></th>
												<td><?php
		echo number_format(getEntriesTotalCount($owner));?></td>
											</tr>
											<tr>
												<th><?php
		echo _t('댓글/걸린글 개수');?></th>
												<td><?php
		echo number_format(getCommentCount($owner)).'/'.number_format(getTrackbackCount($owner));?></td>
											</tr>
										</tbody>
									</table>
								</div>
							
								<div id="tattertools-notice" class="section">
									<h3><?php
		echo _t('공지사항');?></h3>
									
<?php
		$noticeURL="http://notice.tattersite.com/";
		$noticeURLRSS=$noticeURL.(isset($blog['language'])?$blog['language']:"ko")."/rss";
		list($result,$feed,$xml)=getRemoteFeed($noticeURLRSS);
		if($result==0){
			$xmls=new XMLStruct();
			$noticeEntries=array();
			if($xmls->open($xml,$service['encoding'])){
				if($xmls->getAttribute('/rss','version')){
					for($i=0;$link=$xmls->getValue("/rss/channel/item[$i]/link");$i++){
						$item=array('permalink'=>rawurldecode($link));
						$item['title']=$xmls->getValue("/rss/channel/item[$i]/title");
						if($xmls->getValue("/rss/channel/item[$i]/pubDate"))
							$item['written']=parseDate($xmls->getValue("/rss/channel/item[$i]/pubDate"));
						elseif($xmls->getValue("/rss/channel/item[$i]/dc:date"))
							$item['written']=parseDate($xmls->getValue("/rss/channel/item[$i]/dc:date"));
						else
							$item['written']=0;
						array_push($noticeEntries,$item);
					}
				}elseif($xmls->getAttribute('/feed','version')){
					for($i=0;$link=$xmls->getValue("/feed/entry[$i]/id");$i++){
						for($j=0;$rel=$xmls->getAttribute("/feed/entry[$i]/link[$j]",'rel');$j++){
							if($rel=='alternate'){
								$link=$xmls->getAttribute("/feed/entry[$i]/link[$j]",'href');
								break;
							}
						}
						$item=array('permalink'=>rawurldecode($link));
						$item['author']=$xmls->getValue("/feed/entry[$i]/author/name");
						$item['title']=$xmls->getValue("/feed/entry[$i]/title");
						$item['written']=parseDate($xmls->getValue("/feed/entry[$i]/issued"));
						array_push($noticeEntries,$item);
					}
				}elseif($xmls->getAttribute('/rdf:RDF','xmlns')){
					for($i=0;$link=$xmls->getValue("/rdf:RDF/item[$i]/link");$i++){
						$item=array('permalink'=>rawurldecode($link));
						$item['author']=$xmls->getValue("/rdf:RDF/item[$i]/dc:creator");
						$item['title']=$xmls->getValue("/rdf:RDF/item[$i]/title");
						$item['written']=parseDate($xmls->getValue("/rdf:RDF/item[$i]/dc:date"));
						array_push($noticeEntries,$item);
					}
				}
			}
			if(count($noticeEntries)>0){
				array_splice($noticeEntries,5,count($noticeEntries)-5);?>
									<table>
										<tbody>
<?php
				foreach($noticeEntries as $item){?>
											<tr>
												<td class="title"><a href="<?php
					echo $item['permalink'];?>" onclick="return openLinkInNewWindow(this);" ><?php
					echo htmlspecialchars(UTF8::lessenAsEm($item['title'],60));?></a></td>
												<td class="date"><?php
					echo Timestamp::format2($item['written']);?></td>
											</tr>
<?php
				}?>
										</tbody>
									</table>
									
<?php
			}else{?>
									<div id="empty-notice">
										<?php
				echo _t('공지사항이 없습니다.');?>
									</div>
<?php
			}
		}else{?>
									<div id="fail-notice">
										<?php
			echo _t('공지사항을 가져올 수 없습니다. 잠시 후 다시 시도해 주십시오.');?>
									</div>
<?php
		}?>
								</div>

								<div id="myBlogInfo" class="section">
									<h3><?php
		echo _t('알림판');?></h3>
									<div id="infoPanel">
										<table class="comment">
											<caption><a href="<?php
		echo $blogURL."/owner/entry/comment";?>"><?php
		echo _t('최근 댓글');?></a></caption>
											<thead>
												<tr>
													<th scope="col"><?=_t('내용')?></th>
													<th scope="col" class="date"><?=_t('날짜')?></th>
												</tr>
											</thead>
											<tbody>
<?php
		$comments=getRecentComments($owner,5);
		foreach($comments as $comment){?>
												<tr>
													<td class="title"><a href="<?php
			echo $blogURL."/".$comment['entry']."#comment".$comment['id'];?>"><?php
			echo htmlspecialchars(UTF8::lessenAsEm($comment['comment'],25));?></a></td>
													<td class="date"><?php
			echo Timestamp::format('%m/%d',$comment['written']);?></td>
												</tr>
<?php
		}?>
											</tbody>
										</table>
										<table class="commentNotifier">
											<caption><a href="<?php
		echo $blogURL."/owner/entry/notify";?>"><?php
		echo _t('최근 댓글 알리미');?></a></caption>
											<thead>
												<tr>
													<th scope="col"><?=_t('내용')?></th>
													<th scope="col" class="date"><?=_t('날짜')?></th>
												</tr>
											</thead>
											<tbody>
<?php
		list($commentNotifies,$paging)=getCommentsNotifiedWithPagingForOwner($owner,0,null,null,null,1,5);
		foreach($commentNotifies as $comment){?>
												<tr>
													<td class="title"><?php
			echo htmlspecialchars(UTF8::lessenAsEm($comment['comment'],25));?></td>
													<td class="date"><?php
			echo Timestamp::format('%m/%d',$comment['written']);?></td>
												</tr>
<?php
		}?>
											</tbody>
										</table>
										<table class="guestbook">
											<caption><a href="<?php
		echo $blogURL."/guestbook";?>"><?php
		echo _t('최근 방명록');?></a></caption>
											<thead>
												<tr>
													<th scope="col"><?=_t('내용')?></th>
													<th scope="col" class="date"><?=_t('날짜')?></th>
												</tr>
											</thead>
											<tbody>
<?php
		$guestbooks=getRecentGuestbook($owner,5);
		foreach($guestbooks as $guestbook){?>
												<tr>
													<td class="title"><a href="<?php
			echo $blogURL."/guestbook#comment".$guestbook['id'];?>"><?php
			echo htmlspecialchars(UTF8::lessenAsEm($guestbook['comment'],25));?></a></td>
													<td class="date"><?php
			echo Timestamp::format('%m/%d',$guestbook['written']);?></td>
												</tr>
<?php
		}?>
											</tbody>
										</table>
										<table class="trackback">
											<caption><a href="<?php
		echo $blogURL."/owner/entry/trackback";?>"><?php
		echo _t('최근 트랙백');?></a></caption>
											<thead>
												<tr>
													<th scope="col"><?=_t('내용')?></th>
													<th scope="col" class="date"><?=_t('날짜')?></th>
												</tr>
											</thead>
											<tbody>
<?php
		$trackbacks=getRecentTrackbacks($owner,5);
		foreach($trackbacks as $trackback){?>
												<tr>
													<td class="title"><a href="<?php
			echo $blogURL."/".$trackback['entry']."#trackback".$trackback['id'];?>"><?php
			echo htmlspecialchars(UTF8::lessenAsEm($trackback['subject'],25));?></a></td>
													<td class="date"><?php
			echo Timestamp::format('%m/%d',$trackback['written']);?></td>
												</tr>
<?php
		}?>
											</tbody>
										</table>
									</div>

								</div>
							</div>
<?php
		unset($feed);
		unset($xmls);
		unset($noticeEntries);
	}
}?>

							<div id="part-center-quilt<?php
echo $editClass;?>" class="part">
								<h2 class="caption"><span class="main-text"><?php
echo _t('조각보를 봅니다');?></span></h2>
									
<?php
$boardbarNumber=0;
$positionCounter=0;
$secondposition=array(0,0);?>
								<div id="dojo_boardbar0" class="panel">
<?php
foreach($newlayout as $mapping){
	if($mapping['plugin']=='TatterToolsSeperator'){?>

								</div>
								<div id="dojo_boardbar<?php
		echo $boardbarNumber+1;?>" class="panel">
<?php
		$secondposition[$boardbarNumber]=$positionCounter;
		$boardbarNumber++;
	}else{?>
									<div id="<?php
		echo $mapping['plugin'];?>" class="section">
										<h3>
											<?php
		echo $mapping['title'];?> 
<?php
		if(isset($_REQUEST['edit'])){?>
				
											<a id="<?php
			echo $mapping['plugin'];?>dojoup" href="<?php
			echo $blogURL;?>/owner/center/dashboard?edit&pos=<?php
			echo $positionCounter;?>&amp;rel=-1&edit"><?php
			echo _t("위로");?></a>
											<a id="<?php
			echo $mapping['plugin'];?>dojodown" href="<?php
			echo $blogURL;?>/owner/center/dashboard?edit&pos=<?php
			echo $positionCounter;?>&amp;rel=1&edit"><?php
			echo _t("아래로");?></a>
<?php
		}?>
										</h3>
										<?php
		echo handleCenters($mapping);?>
									</div>
<?php
	}
	$positionCounter++;
}?>
								</div>
<?php
if($boardbarNumber<1){?>

								<div id="dojo_boardbar1" class="panel"></div>
<?php
	$secondposition[$boardbarNumber]=$positionCounter;
	$boardbarNumber++;
	$positionCounter++;
}
if($boardbarNumber<2){?>
								<div id="dojo_boardbar2" class="panel"></div>
<?php
	$secondposition[$boardbarNumber]=$positionCounter;
	$boardbarNumber++;
	$positionCounter++;
}
if(!isset($_REQUEST['edit'])){?>
								<div class="button-box">
									<input type="submit" class="input-button" value="<?php
	echo _t('편집');?>" onclick="window.location.href='<?php
	echo $blogURL;?>/owner/center/dashboard?edit'; return false;" />
								</div>
<?php
}else{?>
								<div class="button-box">
									<input type="button" class="input-button" value="<?php
	echo _t('돌아가기');?>" onclick="window.location.href='<?php
	echo $blogURL;?>/owner/center/dashboard'; return false;" />
								</div>
<?php
}?>
							</div>
						</form>

<?php
if(isset($_REQUEST['edit'])){?>
						<script type="text/javascript">
							//<![CDATA[
								var pan0 = new DropPanel(document.getElementById('dojo_boardbar0'), ["dashboard"]);
								document.getElementById('dojo_boardbar0').plusposition = -1;
								var pan1 = new DropPanel(document.getElementById('dojo_boardbar1'), ["dashboard"]);
								document.getElementById('dojo_boardbar1').plusposition = <?php
	echo $secondposition[0];?>;
								var pan1 = new DropPanel(document.getElementById('dojo_boardbar2'), ["dashboard"]);
								document.getElementById('dojo_boardbar2').plusposition = <?php
	echo $secondposition[1];?>;
									
<?php
	$positionCounter=0;
	foreach($newlayout as $mapping){
		if($mapping['plugin']!='TatterToolsSeperator'){?>
		document.getElementById('<?php
			echo $mapping['plugin'];?>').pos = <?php
			echo $positionCounter;?>;
		new DragPanel(document.getElementById('<?php
			echo $mapping['plugin'];?>'), ["dashboard"]);
		
		
		document.getElementById('<?php
			echo $mapping['plugin'];?>dojoup').parentNode.removeChild(document.getElementById('<?php
			echo $mapping['plugin'];?>dojoup'));
		document.getElementById('<?php
			echo $mapping['plugin'];?>dojodown').parentNode.removeChild(document.getElementById('<?php
			echo $mapping['plugin'];?>dojodown'));
<?php
		}
		$positionCounter++;
	}?>
							//]]!>
						</script>
<?php
}?>					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
