<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
$IV=array('GET'=>array('includeFileContents'=>array(array('true','false'))));
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getServiceSetting($name,$default=null){
	global $database;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function respondResultPage($error){
	if($error===true)
		$error=0;
	elseif($error===false)
		$error=1;
	header('Content-Type: text/xml; charset=utf-8');
	print ("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<response>\n<error>$error</error>\n</response>");
	exit;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
requireComponent('Eolin.PHP.OutputWriter');
requireComponent('Eolin.PHP.Base64Stream');
set_time_limit(0);
$includeFileContents=Validator::getBool(@$_GET['includeFileContents']);
$writer=new OutputWriter();
{
	if(!file_exists('../../../../cache/backup')){
		mkdir('../../../../cache/backup');
		@chmod('../../../../cache/backup',0777);
	}
	if(!is_dir('../../../../cache/backup')){
		exit;
	}
	if($writer->openFile("../../../../cache/backup/$owner.xml")){
	}else{
		exit;
	}
}
requireComponent('Tattertools.Data.BlogSetting');
requireComponent('Tattertools.Data.Category');
requireComponent('Tattertools.Data.Post');
requireComponent('Tattertools.Data.Notice');
requireComponent('Tattertools.Data.Keyword');
requireComponent('Tattertools.Data.Link');
requireComponent('Tattertools.Data.RefererLog');
requireComponent('Tattertools.Data.RefererStatistics');
requireComponent('Tattertools.Data.BlogStatistics');
requireComponent('Tattertools.Data.DailyStatistics');
requireComponent('Tattertools.Data.SkinSetting');
requireComponent('Tattertools.Data.PluginSetting');
requireComponent('Tattertools.Data.GuestComment');
requireComponent('Tattertools.Data.Filter');
requireComponent('Tattertools.Data.Feed');
requireComponent('Tattertools.Data.UserSetting');
$newlineStyle=(!is_null(getServiceSetting('newlineStyle'))?' format="'.getServiceSetting('newlineStyle').'"':'');
$writer->write('<?xml version="1.0" encoding="utf-8" ?>');
$writer->write('<blog type="tattertools/1.1" migrational="false">');
$setting=new BlogSetting();
if($setting->load()){
	$setting->escape();
	$writer->write('<setting>'.'<name>'.$setting->name.'</name>'.'<secondaryDomain>'.$setting->secondaryDomain.'</secondaryDomain>'.'<defaultDomain>'.Validator::getBit($setting->defaultDomain).'</defaultDomain>'.'<title>'.$setting->title.'</title>'.'<description>'.UTF8::correct($setting->description).'</description>'.'<banner><name>'.$setting->banner.'</name>');
	if($includeFileContents&&file_exists("../../../../attach/$owner/{$setting->banner}")){
		$writer->write('<content>');
		if(!empty($setting->banner)&&file_exists(ROOT."/attach/$owner/".$setting->banner))
			Base64Stream::encode("../../../../attach/$owner/{$setting->banner}",$writer);
		$writer->write('</content>');
	}
	$writer->write('</banner>'.'<useSlogan>'.Validator::getBit($setting->useSlogan).'</useSlogan>'.'<postsOnPage>'.$setting->postsOnPage.'</postsOnPage>'.'<postsOnList>'.$setting->postsOnList.'</postsOnList>'.'<postsOnFeed>'.$setting->postsOnFeed.'</postsOnFeed>'.'<publishWholeOnFeed>'.Validator::getBit($setting->publishWholeOnFeed).'</publishWholeOnFeed>'.'<acceptGuestComment>'.Validator::getBit($setting->acceptGuestComment).'</acceptGuestComment>'.'<acceptCommentOnGuestComment>'.Validator::getBit($setting->acceptCommentOnGuestComment).'</acceptCommentOnGuestComment>'.'<language>'.$setting->language.'</language>'.'<timezone>'.$setting->timezone.'</timezone>'.'</setting>');
	$writer->write(CRLF);
}
$category=new Category();
if($category->open()){
	do{
		if($category->id!=0){
			$category->escape();
			$writer->write('<category>'.'<name>'.$category->name.'</name>'.'<priority>'.$category->priority.'</priority>');
			if($childCategory=$category->getChildren()){
				do{
					$childCategory->escape();
					$writer->write('<category>'.'<name>'.$childCategory->name.'</name>'.'<priority>'.$childCategory->priority.'</priority>'.'</category>');
				}while($childCategory->shift());
				$childCategory->close();
			}
			$writer->write('</category>');
			$writer->write(CRLF);
		}else{
			$category->escape();
			$writer->write('<category>'.'<name>'.$category->name.'</name>'.'<priority>'.$category->priority.'</priority>');
			$writer->write('<root>1</root>');
			$writer->write('</category>');
			$writer->write(CRLF);
		}
	}while($category->shift());
	$category->close();
}
$post=new Post();
if($post->open('','*','published, id')){
	do{
		$writer->write('<post'.' slogan="'.$post->slogan.'"'.$newlineStyle.'>'.'<id>'.$post->id.'</id>'.'<visibility>'.$post->visibility.'</visibility>'.'<title>'.htmlspecialchars($post->title).'</title>'.'<content>'.htmlspecialchars(UTF8::correct($post->content)).'</content>'.'<location>'.htmlspecialchars($post->location).'</location>'.($post->password!==null?'<password>'.htmlspecialchars($post->password).'</password>':'').'<acceptComment>'.$post->acceptComment.'</acceptComment>'.'<acceptTrackback>'.$post->acceptTrackback.'</acceptTrackback>'.'<published>'.$post->published.'</published>'.'<created>'.$post->created.'</created>'.'<modified>'.$post->modified.'</modified>');
		if($post->category)
			$writer->write('<category>'.htmlspecialchars(Category::getLabel($post->category)).'</category>');
		if($post->loadTags()){
			foreach($post->tags as $tag)
				$writer->write('<tag>'.htmlspecialchars($tag).'</tag>');
		}
		$writer->write(CRLF);
		if($attachment=$post->getAttachments()){
			do{
				$writer->write('<attachment'.' mime="'.htmlspecialchars($attachment->mime).'"'.' size="'.$attachment->size.'"'.' width="'.$attachment->width.'"'.' height="'.$attachment->height.'"'.'>'.'<name>'.htmlspecialchars($attachment->name).'</name>'.'<label>'.htmlspecialchars($attachment->label).'</label>'.'<enclosure>'.($attachment->enclosure?1:0).'</enclosure>'.'<attached>'.$attachment->attached.'</attached>'.'<downloads>'.$attachment->downloads.'</downloads>');
				if($includeFileContents&&file_exists("../../../../attach/$owner/{$attachment->name}")){
					$writer->write('<content>');
					Base64Stream::encode("../../../../attach/$owner/{$attachment->name}",$writer);
					$writer->write('</content>');
				}
				$writer->write('</attachment>');
				$writer->write(CRLF);
			}while($attachment->shift());
			$attachment->close();
		}
		if($comment=$post->getComments()){
			do{
				if($comment->isFiltered==0){
					$writer->write('<comment>'.'<commenter'.' id="'.$comment->commenter.'">'.'<name>'.htmlspecialchars(UTF8::correct($comment->name)).'</name>'.'<homepage>'.htmlspecialchars(UTF8::correct($comment->homepage)).'</homepage>'.'<ip>'.$comment->ip.'</ip>'.'</commenter>'.'<content>'.htmlspecialchars($comment->content).'</content>'.'<password>'.htmlspecialchars($comment->password).'</password>'.'<secret>'.htmlspecialchars($comment->secret).'</secret>'.'<written>'.$comment->written.'</written>'.'<isFiltered>'.$comment->isFiltered.'</isFiltered>');
					$writer->write(CRLF);
					if($childComment=$comment->getChildren()){
						do{
							if($childComment->isFiltered==0){
								$writer->write('<comment>'.'<commenter'.' id="'.$childComment->commenter.'"'.'>'.'<name>'.htmlspecialchars(UTF8::correct($childComment->name)).'</name>'.'<homepage>'.htmlspecialchars(UTF8::correct($childComment->homepage)).'</homepage>'.'<ip>'.$childComment->ip.'</ip>'.'</commenter>'.'<content>'.htmlspecialchars($childComment->content).'</content>'.'<password>'.htmlspecialchars($childComment->password).'</password>'.'<secret>'.htmlspecialchars($childComment->secret).'</secret>'.'<written>'.$childComment->written.'</written>'.'<isFiltered>'.$childComment->isFiltered.'</isFiltered>'.'</comment>');
								$writer->write(CRLF);
							}
						}while($childComment->shift());
						$childComment->close();
					}
					$writer->write('</comment>');
					$writer->write(CRLF);
				}
			}while($comment->shift());
			$comment->close();
		}
		if($trackback=$post->getTrackbacks()){
			do{
				if($trackback->isFiltered==0){
					$writer->write('<trackback>'.'<url>'.htmlspecialchars(UTF8::correct($trackback->url)).'</url>'.'<site>'.htmlspecialchars(UTF8::correct($trackback->site)).'</site>'.'<title>'.htmlspecialchars(UTF8::correct($trackback->title)).'</title>'.'<excerpt>'.htmlspecialchars(UTF8::correct($trackback->excerpt)).'</excerpt>'.'<ip>'.$trackback->ip.'</ip>'.'<received>'.$trackback->received.'</received>'.'<isFiltered>'.$trackback->isFiltered.'</isFiltered>'.'</trackback>');
					$writer->write(CRLF);
				}
			}while($trackback->shift());
			$trackback->close();
		}
		if($log=$post->getTrackbackLogs()){
			$writer->write('<logs>');
			do{
				$writer->write('<trackback>'.'<url>'.htmlspecialchars(UTF8::correct($log->url)).'</url>'.'<sent>'.$log->sent.'</sent>'.'</trackback>');
				$writer->write(CRLF);
			}while($log->shift());
			$writer->write('</logs>');
			$log->close();
		}
		$writer->write('</post>');
	}while($post->shift());
	$post->close();
}
$notice=new Notice();
if($notice->open()){
	do{
		$writer->write('<notice'.$newlineStyle.'>'.'<id>'.$notice->id.'</id>'.'<visibility>'.$notice->visibility.'</visibility>'.'<title>'.htmlspecialchars(UTF8::correct($notice->title)).'</title>'.'<content formatter="'.htmlspecialchars($notice->contentFormatter).'" editor="'.htmlspecialchars($notice->contentEditor).'">'.htmlspecialchars(UTF8::correct($notice->content)).'</content>'.'<published>'.$notice->published.'</published>'.'<created>'.$notice->created.'</created>'.'<modified>'.$notice->modified.'</modified>');
		$writer->write(CRLF);
		if($attachment=$notice->getAttachments()){
			do{
				$writer->write('<attachment'.' mime="'.htmlspecialchars($attachment->mime).'"'.' size="'.$attachment->size.'"'.' width="'.$attachment->width.'"'.' height="'.$attachment->height.'"'.'>'.'<name>'.htmlspecialchars($attachment->name).'</name>'.'<label>'.htmlspecialchars($attachment->label).'</label>'.'<enclosure>'.($attachment->enclosure?1:0).'</enclosure>'.'<attached>'.$attachment->attached.'</attached>'.'<downloads>'.$attachment->downloads.'</downloads>');
				if($includeFileContents&&file_exists("../../../../attach/$owner/{$attachment->name}")){
					$writer->write('<content>');
					Base64Stream::encode("../../../../attach/$owner/{$attachment->name}",$writer);
					$writer->write('</content>');
				}
				$writer->write('</attachment>');
				$writer->write(CRLF);
			}while($attachment->shift());
			$attachment->close();
		}
		$writer->write('</notice>');
		$writer->write(CRLF);
	}while($notice->shift());
	$notice->close();
}
$keyword=new Keyword();
if($keyword->open()){
	do{
		$writer->write('<keyword'.$newlineStyle.'>'.'<id>'.$keyword->id.'</id>'.'<visibility>'.$keyword->visibility.'</visibility>'.'<name>'.htmlspecialchars(UTF8::correct($keyword->name)).'</name>'.'<description editor="'.htmlspecialchars($keyword->descriptionEditor).'" formatter="'.htmlspecialchars($keyword->descriptionFormatter).'">'.htmlspecialchars(UTF8::correct($keyword->description)).'</description>'.'<published>'.$keyword->published.'</published>'.'<created>'.$keyword->created.'</created>'.'<modified>'.$keyword->modified.'</modified>');
		$writer->write(CRLF);
		if($attachment=$keyword->getAttachments()){
			do{
				$writer->write('<attachment'.' mime="'.htmlspecialchars($attachment->mime).'"'.' size="'.$attachment->size.'"'.' width="'.$attachment->width.'"'.' height="'.$attachment->height.'"'.'>'.'<name>'.htmlspecialchars($attachment->name).'</name>'.'<label>'.htmlspecialchars($attachment->label).'</label>'.'<enclosure>'.($attachment->enclosure?1:0).'</enclosure>'.'<attached>'.$attachment->attached.'</attached>'.'<downloads>'.$attachment->downloads.'</downloads>');
				if($includeFileContents&&file_exists("../../../../attach/$owner/{$attachment->name}")){
					$writer->write('<content>');
					Base64Stream::encode("../../../../attach/$owner/{$attachment->name}",$writer);
					$writer->write('</content>');
				}
				$writer->write('</attachment>');
				$writer->write(CRLF);
			}while($attachment->shift());
			$attachment->close();
		}
		$writer->write('</keyword>');
		$writer->write(CRLF);
	}while($keyword->shift());
	$keyword->close();
}
$link=new Link();
if($link->open()){
	do{
		$writer->write('<link>'.'<url>'.htmlspecialchars(UTF8::correct($link->url)).'</url>'.'<title>'.htmlspecialchars(UTF8::correct($link->title)).'</title>'.'<feed>'.htmlspecialchars(UTF8::correct($link->feed)).'</feed>'.'<registered>'.$link->registered.'</registered>'.'</link>');
		$writer->write(CRLF);
	}while($link->shift());
	$link->close();
}
$log=new RefererLog();
if($log->open()){
	$writer->write('<logs>');
	do{
		$writer->write('<referer>'.'<url>'.htmlspecialchars(UTF8::correct($log->url)).'</url>'.'<referred>'.$log->referred.'</referred>'.'</referer>');
	}while($log->shift());
	$writer->write('</logs>');
	$log->close();
}
$statistics=new RefererStatistics();
if($statistics->open()){
	$writer->write('<statistics>');
	do{
		$writer->write('<referer>'.'<host>'.htmlspecialchars(UTF8::correct($statistics->host)).'</host>'.'<count>'.$statistics->count.'</count>'.'</referer>');
		$writer->write(CRLF);
	}while($statistics->shift());
	$writer->write('</statistics>');
	$statistics->close();
}
$statistics=new BlogStatistics();
if($statistics->load()){
	$writer->write('<statistics>'.'<visits>'.$statistics->visits.'</visits>'.'</statistics>');
	$writer->write(CRLF);
}
$statistics=new DailyStatistics();
if($statistics->open()){
	$writer->write('<statistics>');
	do{
		$writer->write('<daily>'.'<date>'.$statistics->date.'</date>'.'<visits>'.$statistics->visits.'</visits>'.'</daily>');
		$writer->write(CRLF);
	}while($statistics->shift());
	$writer->write('</statistics>');
	$statistics->close();
}
$setting=new SkinSetting();
if($setting->load()){
	$writer->write('<skin>'.'<name>'.$setting->skin.'</name>'.'<entriesOnRecent>'.$setting->entriesOnRecent.'</entriesOnRecent>'.'<commentsOnRecent>'.$setting->commentsOnRecent.'</commentsOnRecent>'.'<trackbacksOnRecent>'.$setting->trackbacksOnRecent.'</trackbacksOnRecent>'.'<commentsOnGuestbook>'.$setting->commentsOnGuestbook.'</commentsOnGuestbook>'.'<tagsOnTagbox>'.$setting->tagsOnTagbox.'</tagsOnTagbox>'.'<alignOnTagbox>'.$setting->alignOnTagbox.'</alignOnTagbox>'.'<expandComment>'.$setting->expandComment.'</expandComment>'.'<expandTrackback>'.$setting->expandTrackback.'</expandTrackback>'.'<recentNoticeLength>'.$setting->recentNoticeLength.'</recentNoticeLength>'.'<recentEntryLength>'.$setting->recentEntryLength.'</recentEntryLength>'.'<recentTrackbackLength>'.$setting->recentTrackbackLength.'</recentTrackbackLength>'.'<linkLength>'.$setting->linkLength.'</linkLength>'.'<showListOnCategory>'.$setting->showListOnCategory.'</showListOnCategory>'.'<showListOnArchive>'.$setting->showListOnArchive.'</showListOnArchive>'.'<tree>'.'<name>'.$setting->tree.'</name>'.'<color>'.$setting->colorOnTree.'</color>'.'<bgColor>'.$setting->bgColorOnTree.'</bgColor>'.'<activeColor>'.$setting->activeColorOnTree.'</activeColor>'.'<activeBgColor>'.$setting->activeBgColorOnTree.'</activeBgColor>'.'<labelLength>'.$setting->labelLengthOnTree.'</labelLength>'.'<showValue>'.$setting->showValueOnTree.'</showValue>'.'</tree>'.'</skin>');
	$writer->write(CRLF);
}
$setting=new PluginSetting();
if($setting->open()){
	do{
		$writer->write('<plugin>'.'<name>'.$setting->name.'</name>'.'<setting>'.htmlspecialchars($setting->setting).'</setting>'.'</plugin>');
		$writer->write(CRLF);
	}while($setting->shift());
	$setting->close();
}
$setting=new UserSetting();
if($setting->open()){
	do{
		$writer->write('<userSetting>'.'<name>'.$setting->name.'</name>'.'<value>'.htmlspecialchars($setting->value).'</value>'.'</userSetting>');
		$writer->write(CRLF);
	}while($setting->shift());
	$setting->close();
}
$comment=new GuestComment();
if($comment->open('parent IS NULL')){
	$writer->write('<guestbook>');
	do{
		$writer->write('<comment>'.'<commenter'.' id="'.$comment->commenter.'">'.'<name>'.htmlspecialchars(UTF8::correct($comment->name)).'</name>'.'<homepage>'.htmlspecialchars(UTF8::correct($comment->homepage)).'</homepage>'.'<ip>'.$comment->ip.'</ip>'.'</commenter>'.'<content>'.htmlspecialchars(UTF8::correct($comment->content)).'</content>'.'<password>'.htmlspecialchars($comment->password).'</password>'.'<secret>'.htmlspecialchars($comment->secret).'</secret>'.'<written>'.$comment->written.'</written>');
		$writer->write(CRLF);
		if($childComment=$comment->getChildren()){
			do{
				$writer->write('<comment>'.'<commenter'.' id="'.$childComment->commenter.'">'.'<name>'.htmlspecialchars(UTF8::correct($childComment->name)).'</name>'.'<homepage>'.htmlspecialchars(UTF8::correct($childComment->homepage)).'</homepage>'.'<ip>'.$childComment->ip.'</ip>'.'</commenter>'.'<content>'.htmlspecialchars(UTF8::correct($childComment->content)).'</content>'.'<password>'.htmlspecialchars($childComment->password).'</password>'.'<secret>'.htmlspecialchars($childComment->secret).'</secret>'.'<written>'.$childComment->written.'</written>'.'</comment>');
				$writer->write(CRLF);
			}while($childComment->shift());
			$childComment->close();
		}
		$writer->write('</comment>');
		$writer->write(CRLF);
	}while($comment->shift());
	$writer->write('</guestbook>');
	$comment->close();
}
$filter=new Filter();
if($filter->open()){
	do{
		$writer->write('<filter type="'.$filter->type.'">'.'<pattern>'.htmlspecialchars($filter->pattern).'</pattern>'.'</filter>');
		$writer->write(CRLF);
	}while($filter->shift());
	$filter->close();
}
$feed=new Feed();
if($feed->open()){
	do{
		$writer->write('<feed>'.'<group>'.htmlspecialchars($feed->getGroupName()).'</group>'.'<url>'.htmlspecialchars(UTF8::correct($feed->url)).'</url>'.'</feed>');
		$writer->write(CRLF);
	}while($feed->shift());
	$feed->close();
}
$writer->write('</blog>');
$writer->close();
{
	@chmod("../../../../cache/backup/$owner.xml",0666);
	respondResultPage(true);
}?>