<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../config.php';
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getNumericValue($value){
	$value=trim($value);
	switch(strtoupper($value{strlen($value)-1})){
		case 'G':
			$value*=1024;
		case 'M':
			$value*=1024;
		case 'K':
			$value*=1024;
	}
	return $value;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../config.php')){
	header('Location: '.'../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
$backup=null;
if(file_exists("../../../cache/backup/$owner.xml.gz"))
	$backup=filemtime("../../../cache/backup/$owner.xml.gz");
elseif(file_exists("../../../cache/backup/$owner.xml"))
	$backup=filemtime("../../../cache/backup/$owner.xml");?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
echo htmlspecialchars($blog['title']);?> &gt; <?php
echo _t('환경설정');?></title>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
echo $service['path'];?>";
			var blogurl = "<?php
echo $blogURL;?>";
			var adminSkin = "<?php
echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-setting">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
echo $blogURL;?>/" title="<?php
echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
echo $blogURL;?>/logout" title="<?php
echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
echo $blogURL;?>/owner/center/dashboard"><span><?php
echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
echo $blogURL;?>/owner/entry"><span class="text"><?php
echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
echo $blogURL;?>/owner/link"><span class="text"><?php
echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
echo $blogURL;?>/owner/skin"><span class="text"><?php
echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
echo $blogURL;?>/owner/plugin"><span class="text"><?php
echo _t('플러그인');?></span></a></li>
						<li id="menu-setting" class="selected"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
echo $blogURL;?>/owner/reader"><span class="text"><?php
echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

			<div id="layout-body">
				<h2><?php
echo _t('서브메뉴 : 환경설정');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-blog"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('기본 설정');?></span></a></li>
						<li id="sub-menu-account"><a href="<?php
echo $blogURL;?>/owner/setting/account"><span class="text"><?php
echo _t('계정 정보');?></span></a></li>
						<li id="sub-menu-filter"><a href="<?php
echo $blogURL;?>/owner/setting/filter"><span class="text"><?php
echo _t('필터');?></span></a></li>
						<li id="sub-menu-data" class="selected"><a href="<?php
echo $blogURL;?>/owner/data"><span class="text"><?php
echo _t('데이터 관리');?></span></a></li>
						<li id="sub-menu-etc"><a href="<?php
echo $blogURL;?>/owner/setting/etc"><span class="text"><?php
echo _t('기타 설정');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
echo getHelpURL('data');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
if(isset($checkFunction))
	unset($checkFunction);?>
						<script type="text/javascript">
							//<![CDATA[
								function checkForceTattertoolsVersion() {
									if (confirm("<?php
echo _t('태터툴즈 시스템 점검이 필요합니다. 지금 점검하시겠습니까?');?>"))
										window.location.href = "<?php
echo $blogURL;?>/checkup";
									else
										alert("<?php
echo _t('점검 없이 이 기능을 사용할 수 없습니다.');?>");
								}
							//]]>
						</script>
<?php
if(!file_exists('../../../cache/CHECKUP')){?>
						<script type="text/javascript">
							//<![CDATA[
								window.addEventListener("load", checkTattertoolsVersion, false);
								function checkTattertoolsVersion() {
									if (confirm("<?php
	echo _t('버전업 체크를 위한 파일을 생성합니다. 지금 생성하시겠습니까?');?>"))
										window.location.href = "<?php
	echo $blogURL;?>/checkup";
								}
							//]]>
						</script>
<?php
	$checkFunction='checkForceTattertoolsVersion();';
}elseif(file_get_contents('../../../cache/CHECKUP')!=TATTERTOOLS_VERSION){?>
						<script type="text/javascript">
							//<![CDATA[
								window.addEventListener("load", checkTattertoolsVersion, false);
								function checkTattertoolsVersion() {
									if (confirm("<?php
	echo _t('태터툴즈 시스템 점검이 필요합니다. 지금 점검하시겠습니까?');?>"))
										window.location.href = "<?php
	echo $blogURL;?>/checkup";
								}
							//]]>
						</script>
<?php
	$checkFunction='checkForceTattertoolsVersion();';
}
function forceCheckBlog($passFunction){
	global $checkFunction;
	if(!isset($checkFunction))
		return $passFunction;
	return $checkFunction;
}
if(false)
	forceCheckBlog('');?>
						<script type="text/javascript">
							//<![CDATA[
								var dialog = null;
								
								function showDialog($name) {
									if (dialog)
										dialog.style.display = "none";
									dialog = document.getElementById($name + "Dialog");
									PM.showPanel(dialog);
								}
								
								function hideDialog() {
									if (dialog) {
										dialog.style.display = "none";
										dialog = null;
									}
								}
								
								function correctData() {
									document.getElementById("correctingIndicator").style.width = "0%";
									document.getElementById("correctingDataDialogTitle").innerHTML = '<?php
echo _t('데이터를 교정하고 있습니다. 잠시만 기다려 주십시오.');?>';
									PM.showPanel("correctingDataDialog");
									document.getElementById("dataCorrector").submit();
								}

								function optimizeData() {
									document.getElementById("optimizingIndicator").style.width = "0%";
									document.getElementById("optimizingDataDialogTitle").innerHTML = '<?php
echo _t('데이터베이스를 최적화하고 있습니다. 잠시만 기다려 주십시오.');?>';
									PM.showPanel("optimizingDataDialog");
									document.getElementById("dataOptimizer").submit();
								}
								
								function backupData() {
									var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/data/backup?includeFileContents=" + document.getElementById("includeFileContents-yes").checked);
									PM.addRequest(request, "<?php
echo _t('백업을 저장하고 있습니다.');?>");
									request.onSuccess = function () {
										PM.removeRequest(this);
										PM.showMessage("<?php
echo _t('백업이 저장되었습니다.');?>", "center", "bottom");
									}
									request.onError = function () {
										PM.removeRequest(this);
										alert("<?php
echo _t('백업을 저장하지 못했습니다.');?>");
									}
									request.send();
									hideDialog();
								}
								
								function exportData() {
									window.location.href = "<?php
echo $blogURL;?>/owner/data/export?includeFileContents=" + document.getElementById("includeFileContents-yes").checked;
									hideDialog();
								}
								
								function downloadBackup() {
									window.location.href = "<?php
echo $blogURL;?>/owner/data/download";
									hideDialog();
								}
								
								function importData() {
									var dataImporter = document.getElementById("dataImporter");
									if (document.getElementById("importFromUploaded").checked) {
										if (!dataImporter.elements["backupPath"].value) {
											alert("<?php
echo _t('백업파일을 선택하십시오.');?>");
											dataImporter.elements["backupPath"].focus();
											return false;
										}
										document.getElementById("progressText").innerHTML = "<?php
echo _t('백업파일을 올리고 있습니다.');?>";
									} else if (document.getElementById("importFromWeb").checked) {
										if (!dataImporter.elements["backupURL"].value) {
											alert("<?php
echo _t('백업파일 URL을 입력하십시오.');?>");
											dataImporter.elements["backupURL"].focus();
											return false;
										}
										document.getElementById("progressText").innerHTML = "<?php
echo _t('백업파일을 가져오고 있습니다.');?>";
									} else {
										document.getElementById("progressText").innerHTML = "";
									}
									hideDialog();
									document.getElementById("progressIndicator").style.width = "0%";
									document.getElementById("progressDialogTitle").innerHTML = '<?php
echo _t('데이터를 복원하고 있습니다. 잠시만 기다려 주십시오.');?>';
									document.getElementById("progressText").innerHTML = '<?php
echo _t('백업파일을 올리고 있습니다.');?>';
									PM.showPanel("progressDialog");
									dataImporter.submit();
								}
								
								function removeData() {
									var removeAttachments = document.getElementById("removeAttachments-yes");
									var confirmativePassword = document.getElementById("confirmativePassword");
									if (confirmativePassword.value.length < 6) {
										alert("<?php
echo _t('비밀번호를 입력해 주십시오.');?>");
										confirmativePassword.focus();
										return false;
									}
									var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/data/remove");
									PM.addRequest(request, "<?php
echo _t('데이터를 삭제하고 있습니다.');?>");
									request.onSuccess = function () {
										PM.removeRequest(this);
										PM.showMessage("<?php
echo _t('데이터가 삭제되었습니다.');?>", "center", "bottom");
										confirmativePassword.value = '';
									}
									request.onError = function () {
										PM.removeRequest(this);
										alert("<?php
echo _t('비밀번호가 일치하지 않습니다.');?>");
									}
									request.send("removeAttachments=" + (removeAttachments.checked ? "1" : "0") + "&confirmativePassword=" + encodeURIComponent(confirmativePassword.value));
									hideDialog();
								}
							//]]>
						</script>
						
						<div id="part-data-correct" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('데이터를 교정합니다');?></span></h2>
							
							<div class="data-inbox main-explain-box">
								<div class="image" onclick="correctData(); return false">
									<img src="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/image/dbCorrect.gif" alt="<?php
echo _t('데이터 교정 이미지');?>" />
									<div class="title"><?php
echo _t('CORRECT');?></div>
								</div>
								<p class="explain">
									<?php
echo _t('비정상적인 데이터를 교정합니다.<br />동적인 캐쉬 데이터는 재계산하여 저장합니다.');?>
								</p>
							</div>
							
							<form id="dataCorrector" method="get" action="<?php
echo $blogURL;?>/owner/data/correct" target="blackhole"></form>
							
							<div id="correctingDataDialog" class="system-dialog" style="position: absolute; display: none; z-index: 110;">
								<h3 id="correctingDataDialogTitle"></h3>
								<div class="message-sub">
									<span id="correctingText"></span>
									<span id="correctingTextSub"></span>
								</div>
								<div id="correctingIndicator" class="progressBar" style="width: 0%; height: 18px; margin-top: 5px; background-color: #66DDFF;"></div>
							</div>
						</div>
						
						<hr class="hidden" />
<?php
if(getUserId()==1){?>
						<div id="part-data-optimize" class="part">
							<h2 class="caption"><span class="main-text"><?php
	echo _t('데이터베이스를 최적화합니다');?></span></h2>
							
							<div class="data-inbox main-explain-box">
								<div class="image" onclick="optimizeData()">
									<img src="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/image/dbOptimize.gif" alt="<?php
	echo _t('데이터베이스 최적화 이미지');?>" />
									<div class="title"><?php
	echo _t('OPTIMIZE');?></div>
								</div>
								<p class="explain">
									<?php
	echo _t('잦은 입출력으로 비효율적이 된 데이터베이스를 최적화 합니다.');?>
								</p>
							</div>
							
							<form id="dataOptimizer" method="get" action="<?php
	echo $blogURL;?>/owner/data/optimize" target="blackhole"></form>
							
							<div id="optimizingDataDialog" class="system-dialog" style="position: absolute; display: none; z-index: 110;">
								<h3 id="optimizingDataDialogTitle"></h3>
								<div class="message-sub">
									<span id="optimizingText"></span>
									<span id="optimizingTextSub"></span>
								</div>
								<div id="optimizingIndicator" class="progressBar" style="width: 0%; height: 18px; margin-top: 5px; background-color: #66DDFF;"></div>
							</div>
						</div>
						
						<hr class="hidden" />
<?php
}?>
						<div id="part-data-backup" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('데이터를 백업합니다');?></span></h2>
							
							<div class="data-inbox main-explain-box">
								<div class="image" onclick="showDialog('DBExport')">
									<img src="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/image/dbExport.gif" alt="<?php
echo _t('데이터 백업 이미지');?>" />
									<div class="title"><?php
echo _t('EXPORT');?></div>
								</div>
								<p class="explain">
									<?php
echo _t('현재의 모든 데이터를 백업파일로 보관합니다.<br />첨부파일을 포함시킬 수 있으며, 복원할 경우 자동으로 첨부파일이 처리됩니다.<br />백업파일은 서버에 저장하거나 다운받으실 수 있습니다.');?>
								</p>
							</div>
							
							<form id="DBExportDialog" class="dialog" method="get" action="<?php
echo $blogURL;?>/owner/data/backup" style="position: absolute; display: none; z-index: 100;">
								<h3><?php
echo _t('데이터 백업을 시작합니다');?></h3>
								
								<div class="message-body">
									<p class="message">
										<span><?php
echo _t('첨부파일을 포함하시겠습니까?');?></span>
									</p>
									<div class="selection">
										<div class="select-yes" title="<?php
echo _t('첨부 파일이 포함된 백업파일을 사용하여 복원할 경우, 첨부 파일의 내용은 백업파일의 내용으로 다시 작성됩니다.');?>"><input type="radio" id="includeFileContents-yes" class="radio" name="includeFileContents" value="1" /><label for="includeFileContents-yes"><span class="text"><?php
echo _t('첨부파일을 포함합니다.');?></span></label></div>
										<div class="select-no" title="<?php
echo _t('첨부 파일이 포함되지 않는 백업파일을 사용하여 복원하여도 기존 첨부 파일을 삭제하거나 훼손시키지 않습니다.');?>"><input type="radio" id="includeFileContents-no" class="radio" name="includeFileContents" value="0" checked="checked" /><label for="includeFileContents-no"><span class="text"><?php
echo _t('첨부파일을 포함하지 않습니다.');?></span></label></div>
									</div>
								</div>
								<div class="button-box">
									<a class="server-button button" href="#void" onclick="backupData()" title="<?php
echo _t('서버에 백업파일을 저장하여 복원에 사용할 수 있습니다.');?>"><span class="text"><?php
echo _t('서버에 저장');?></span></a>
									<span class="hidden">|</span>
									<a class="local-button button" href="#void" onclick="exportData()" title="<?php
echo _t('현재 상태의 데이터를 백업하여 다운로드합니다. 서버에 저장된 백업파일은 갱신되지 않습니다.');?>"><span class="text"><?php
echo _t('다운로드');?></span></a>
									<span class="hidden">|</span>
									<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
echo _t('명령을 취소하고 이 대화상자를 닫습니다.');?>"><span class="text"><?php
echo _t('취소하기');?></span></a>
	 							</div>
 							</form>
 						</div>
 						
 						<hr class="hidden" />
 						
						<div id="part-data-restore" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('데이터를 복원합니다');?></span></h2>
							
							<div class="data-inbox main-explain-box">
								<div class="image" onclick="<?php
echo forceCheckBlog("showDialog('DBImport');");?> return false">
									<img src="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/image/dbImport.gif" alt="<?php
echo _t('데이터 복원 이미지');?>" />
									<div class="title"><?php
echo _t('IMPORT');?></div>
								</div>
								<p class="explain">
									<?php
echo _t('백업파일을 읽어서 데이터를 복원합니다.<br />백업파일에 첨부파일이 포함되어 있으면 첨부파일도 자동으로 복원됩니다.<br />마이그레이션 데이터도 복원을 통해 가져올 수 있습니다.');?>
								</p>
							</div>
							<div id="DBImportDialog" class="dialog" style="position: absolute; display: none; z-index: 100;">
								<form id="dataImporter" method="post" action="<?php
echo $blogURL;?>/owner/data/import" enctype="multipart/form-data" target="blackhole">
									<h3><?php
echo _t('데이터 복원을 시작합니다');?></h3>
									
									<div class="message-body">
										<div class="explain">
											<?php
echo _f('이 계정의 업로드 허용 용량은 <em>%1</em> 바이트로 백업파일의 크기가 이를 초과하는 경우 <acronym title="File Transfer Protocol">FTP</acronym> 등으로 원하시는 사이트에 업로드하신 후 이 파일의 웹 주소를 입력해서 진행하십시오. 이 경우, 보안을 위해 복원이 끝나면 반드시 그 백업파일을 웹 상에서 지우실 것을 권장합니다.',(getNumericValue(ini_get('post_max_size'))<getNumericValue(ini_get('upload_max_filesize'))?ini_get('post_max_size'):ini_get('upload_max_filesize')));?>
										</div>
<?php
if($backup){?>
										<p class="message">
											<?php
	echo _f('서버에 <em>%1</em>에 저장된 백업파일이 있습니다.',Timestamp::format5($backup));?>
										</p>
<?php
}?>
										<div class="selection">
<?php
if($backup){?>
											<div id="select-server" title="<?php
	echo _t('데이터 백업 기능을 통해 서버에 저장해 두었던 기존 파일을 이용해 데이터베이스를 복원합니다. 데이터 파일에 대해서는 위의 정보를 참고하십시오.');?>"><input type="radio" id="importFromServer" class="radio" name="importFrom" value="server" checked="checked" onclick="if (this.checked) {hideLayer('uploadBackup'); hideLayer('remoteBackup'); document.getElementById('backupPath').disabled = true; document.getElementById('backupURL').disabled = true;}" /><label for="importFromServer"><?php
	echo _t('서버에 저장된 백업파일.');?></label></div>
<?php
}?>
											<div id="select-upload" title="<?php
echo _t('백업파일을 자신의 하드디스크로부터 직접 선택하여 데이터베이스를 복원합니다. 백업파일의 용량이 업로드 허용용량을 초과하지 않는지 주의하십시오.');?>"><input type="radio" id="importFromUploaded" class="radio" name="importFrom" value="uploaded"<?php
echo ($backup?'':' checked="checked"');?> onclick="if (this.checked) {showLayer('uploadBackup'); hideLayer('remoteBackup'); document.getElementById('backupPath').disabled = false; document.getElementById('backupURL').disabled = true;}" /><label for="importFromUploaded"><?php
echo _t('백업파일 올리기.');?></label></div>
											<div id="select-web" title="<?php
echo _t('백업파일의 크기가 업로드 허용 용량을 초과하는 경우, FTP 등을 이용하여 계정의 홈페이지에 직접 업로드한 후 이 파일의 위치를 지정하여 데이터베이스를 복원할 수 있습니다.');?>"><input type="radio" id="importFromWeb" class="radio" name="importFrom" value="web" onclick="if (this.checked) {hideLayer('uploadBackup'); showLayer('remoteBackup'); document.getElementById('backupPath').disabled = true; document.getElementById('backupURL').disabled = false;}" /><label for="importFromWeb"><?php
echo _t('웹에서 백업파일 가져오기.');?></label></div>
											<div id="select-correct" title="<?php
echo _t('백업파일에 비정상적인 글자가 포함된 경우 복원에 실패할 수 있습니다. 비정상적인 글자를 교정하여 복원이 가능하도록 합니다. 이를 사용할 경우 복원에 많은 시간이 소요될 수 있습니다.');?>"><input type="checkbox" id="correctData" class="checkbox" name="correctData" value="on" /><label for="correctData"><?php
echo _t('백업파일에 포함된 비정상적인 글자를 교정합니다.');?></label></div>
										</div>
										<div id="uploadBackup" style="display: <?php
echo ($backup?'none':'block');?>;">
											<label for="backupPath"><?php
echo _t('백업파일 경로');?></label><span class="divider"> : </span><input type="file" id="backupPath" class="input-file" name="backupPath" <?php
echo ($backup?'disabled="disabled"':'');?> />
										</div>
										<div id="remoteBackup" style="display: none;">
											<label for="backupURL"><?php
echo _t('백업파일 <acronym title="Uniform Resource Locator">URL</acronym>');?></label><span class="divider"> : </span><input type="text" id="backupURL" class="input-text" name="backupURL" value="http://" disabled="disabled" onkeydown="if (event.keyCode == 13) { importData(); return false; }" />
										</div>
									</div>
									<div class="button-box">
										<a class="restore-button button" href="#void" onclick="importData()"><span class="text"><?php
echo _t('복원하기');?></span></a>
										<span class="hidden">|</span>
										<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
echo _t('명령을 취소하고 이 대화상자를 닫습니다.');?>"><span class="text"><?php
echo _t('취소하기');?></span></a>
 									</div>
 								</form>
							</div>
							
							<div id="progressDialog" class="system-dialog" style="position: absolute; display: none; z-index: 100;">
								<h3 id="progressDialogTitle"></h3>
								<div class="message-sub">
									<p id="progressText"></p>
									<p id="progressTextSub"></p>
								</div>
								<div id="progressIndicator" class="progressBar" style="width: 10%; height: 18px; margin-top: 5px; background-color:#66DDFF;"></div>
							</div>
						</div>
						
						<hr class="hidden" />
						
						<div id="part-data-remove" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('데이터를 삭제합니다');?></span></h2>
							
							<div class="data-inbox main-explain-box">
								<div class="image" onclick="showDialog('DBRemove')">
									<img src="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/image/dbClear.gif" alt="<?php
echo _t('데이터 삭제 이미지');?>" />
									<div class="title"><?php
echo _t('REMOVE');?></div>
								</div>
								<p class="explain">
									<?php
echo _t('태터툴즈의 모든 데이터를 삭제합니다.<br />첨부파일의 삭제 여부를 선택하실 수 있습니다.<br />데이터의 복원은 백업파일로만 가능하므로 먼저 백업을 하시기 바랍니다.');?>
								</p>
							</div>
							
							<form id="DBRemoveDialog" class="dialog" method="get" action="<?php
echo $blogURL;?>/owner/data/remove" style="position: absolute; display: none; z-index: 100;">
								<h3><?php
echo _t('데이터 삭제를 시작합니다');?></h3>
								
								<div class="message-body">
<?php
if($backup){?>
									<p class="explain">
										<?php
	echo _f('서버에 <em>%1</em>에 저장된 백업파일이 있습니다. 삭제후 복원에는 이 파일을 이용하실 수 있습니다.',Timestamp::format5($backup));?><br />
									</p>
<?php
}?>
									<div class="message">
										<?php
echo _t('첨부파일을 포함하여 삭제하시겠습니까?');?>
									</div>
									<div class="selection">
										<div class="select-yes"><input type="radio" id="removeAttachments-yes" class="radio" name="removeAttachments" value="1" /><label for="removeAttachments-yes"><?php
echo _t('첨부파일을 포함합니다.');?></label></div>
										<div class="select-no"><input type="radio" id="removeAttachments-no" class="radio" name="removeAttachments" value="0" checked="checked" /><label for="removeAttachments-no"><?php
echo _t('첨부파일을 포함하지 않습니다.');?></label></div>
									</div>
									<div id="admin-password">
										<label for="confirmativePassword"><?php
echo _t('데이터를 삭제하시려면 관리자 비밀번호를 입력하십시오.');?></label>
										<input type="password" id="confirmativePassword" class="input-text" name="confirmativePassword" onkeydown="if (event.keyCode == 13) { removeData(); return false; }" />
									</div>
								</div>
								<div class="button-box">
									<a class="remove-button button" href="#void" onclick="removeData()"><span class="text"><?php
echo _t('삭제하기');?></span></a>
									<span class="hidden">|</span>
									<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
echo _t('명령을 취소하고 이 대화상자를 닫습니다.');?>"><span class="text"><?php
echo _t('취소하기');?></span></a>
								</div>
							</form>
						</div>
						
			 			<iframe id="blackhole" name="blackhole" style="display: none;"></iframe>
					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
