<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
$IV=array('POST'=>array('targets'=>array('list'),'category'=>array('int')));
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function stripHTML($text,$allowTags=array()){
	$text=preg_replace('/<(script|style)[^>]*>.*?<\/\1>/si','',$text);
	if(count($allowTags)==0)
		$text=preg_replace('/<[\w\/!]+[^>]*>/','',$text);
	else{
		preg_match_all('/<\/?([\w!]+)[^>]*?>/s',$text,$matches);
		for($i=0;$i<count($matches[0]);$i++){
			if(!in_array(strtolower($matches[1][$i]),$allowTags))
				$text=str_replace($matches[0][$i],'',$text);
		}
	}
	$text=preg_replace('/&nbsp;?|\xc2\xa0\x20/',' ',$text);
	$text=trim(preg_replace('/\s+/',' ',$text));
	if(!empty($text))
		$text=str_replace(array('&#39;','&apos;','&quot;'),array('\'','\'','"'),$text);
	return $text;
}
function decorateSrcInObejct($html){
	$count=preg_match_all('@src="(.+)"@iU',$html,$matches,PREG_PATTERN_ORDER);
	while($count>0){
		$orig=$matches[0][$count-1];
		$filename=$matches[1][$count-1];
		if(strncasecmp($filename,'http://',7)!=0){
			$html=str_replace($orig,substr($orig,0,4).'"http://'.$_SERVER['HTTP_HOST'].$filename.'"',$html);
		}
		$count--;
	}
	return $html;
}
function avoidFlashBorder($html,$tag='object'){
	$pos1=$pos2=0;
	$str=strtolower($html);
	$result='';
	while(($pos1=strpos($str,"<$tag",$pos2))!==false){
		$result.=substr($html,$pos2,$pos1-$pos2);
		$pos2=$pos1;
		while(true){
			if(($pos2=strpos($str,"</$tag>",$pos2))===false)
				return $result.'<script type="text/javascript">writeCode2("'.str_replace(array('"',"\r","\n"),array('\"','',"\\\r\n"),decorateSrcInObejct(substr($html,$pos1))).'")</script>';
			$pos2+=strlen($tag)+3;
			$chunk=substr($str,$pos1,$pos2-$pos1);
			if(substr_count($chunk,"<$tag")==substr_count($chunk,"</$tag>"))
				break;
		}
		$result.='<script type="text/javascript">writeCode2("'.str_replace(array('"',"\r","\n"),array('\"','',"\\\r\n"),decorateSrcInObejct(substr($html,$pos1,$pos2-$pos1))).'")</script>';
	}
	return $result.substr($html,$pos2);
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getFileExtension($path){
	for($i=strlen($path)-1;$i>=0;$i--){
		if($path{$i}=='.')
			return strtolower(substr($path,$i+1));
		if(($path{$i}=='/')||($path{$i}=='\\'))
			break;
	}
	return '';
}
function getAttributesFromString($str,$caseSensitive=true){
	$attributes=array();
	preg_match_all('/([^=\s]+)\s*=\s*"([^"]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)\s*=\s*\'([^\']*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	preg_match_all('/([^=\s]+)=([^\'"][^\s]*)/',$str,$matches);
	for($i=0;$i<count($matches[0]);$i++){
		if(!$caseSensitive)
			$matches[1][$i]=strtolower($matches[1][$i]);
		$attributes[$matches[1][$i]]=$matches[2][$i];
	}
	return $attributes;
}
function getContentWidth(){
	global $skinSetting,$service;
	$contentWidth=400;
	if($xml=@file_get_contents("../../../../skin/{$skinSetting['skin']}/index.xml")){
		$xmls=new XMLStruct();
		$xmls->open($xml,$service['encoding']);
		if($xmls->getValue('/skin/default/contentWidth')){
			$contentWidth=$xmls->getValue('/skin/default/contentWidth');
		}
	}
	return $contentWidth;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
function makeThumbnail($imgString,$originSrc,$paddingArray,$waterMarkArray,$useAbsolutePath){
	global $database,$owner,$blogURL,$serviceURL,$pathURL;
	if(!extension_loaded('gd')||is_null(getUserSetting("resamplingDefault"))){
		return $imgString;
	}else{
		$waterMarkOn=getUserSetting("waterMarkDefault","no");
	}
	requireComponent('Tattertools.Function.Image');
	if(!is_dir("../../../../cache/thumbnail")){
		@mkdir("../../../../cache/thumbnail");
		@chmod("../../../../cache/thumbnail",0777);
	}
	if(!is_dir("../../../../cache/thumbnail/$owner")){
		@mkdir("../../../../cache/thumbnail/$owner");
		@chmod("../../../../cache/thumbnail/$owner",0777);
	}
	$contentWidth=getContentWidth();
	if(preg_match('/class="(tt-resampling|tt-watermark)"/i',$imgString,$temp)){
		$originFileName=basename($originSrc);
		switch($temp[1]){
			case "tt-resampling":
				$resampleType="resampled";
				break;
			case "tt-watermark":
				if($waterMarkOn=='no')
					$resampleType="resampled";
				else
					$resampleType="watermarked";
				break;
		}
		if(preg_match('/width="([1-9][0-9]*)"/i',$imgString,$temp)){
			$tempWidth=$temp[1];
		}
		if(preg_match('/height="([1-9][0-9]*)"/i',$imgString,$temp)){
			$tempHeight=$temp[1];
		}
		$newTempFileName=preg_replace("/\.([[:alnum:]]+)$/i",".w{$tempWidth}-h{$tempHeight}.{$resampleType}.\\1",$originFileName);
		$tempSrc=ROOT."/cache/thumbnail/$owner/".$newTempFileName;
		$tempURL=$pathURL."/thumbnail/$owner/".$newTempFileName;
		if($useAbsolutePath==true){
			$tempURL="$serviceURL/thumbnail/$owner/$newTempFileName";
		}
		$checkResult=Image::checkExistingThumbnail($originSrc,$tempSrc,$tempWidth,$tempHeight,$paddingArray,$waterMarkArray);
		switch($checkResult){
			case 1:
				deleteFilesByRegExp("../../../../cache/thumbnail/$owner/","^".preg_replace("/\.([[:alnum:]]+)$/i","\.",$originFileName));
			case 2:
				$isSuccessful=true;
				$AttachedImage=new Image();
				$AttachedImage->imageFile=$originSrc;
				if($AttachedImage->resample($tempWidth,$tempHeight,$paddingArray)){
					if($resampleType=="watermarked"&&$waterMarkOn=="yes"){
						$waterMarkType=$AttachedImage->getImageType($waterMarkArray['path']);
						$AttachedImage->impressWaterMark($waterMarkArray['path'],$waterMarkArray['position'],$waterMarkArray['gamma']);
					}
					if($AttachedImage->createThumbnailIntoFile($tempSrc)){
						$imgString=preg_replace('/src="([^"]+)"/i','src="'.$tempURL.'"',$imgString);
						$imgString=preg_replace('/width="([^"]+)"/i','width="'.$tempWidth.'"',$imgString);
						$imgString=preg_replace('/height="([^"]+)"/i','height="'.$tempHeight.'"',$imgString);
						switch($resampleType){
							case "resampled":
								@unlink(str_replace(".resampled.",".watermarked.",$tempSrc));
								break;
							case "watermarked":
								if($waterMarkOn=="yes")
									@unlink(str_replace(".watermarked.",".resampled.",$tempSrc));
								break;
						}
						$originImageInfo=getimagesize($originSrc);
						$tempFileName=preg_replace("/\.([[:alnum:]]+)$/i",".w{$originImageInfo[0]}-h{$originImageInfo[1]}.{$resampleType}.\\1",$originFileName);
						if($resampleType=="watermarked"&&$waterMarkOn=="yes"){
							if($AttachedImage->resample($originImageInfo[0],$originImageInfo[1],NULL)){
								$AttachedImage->impressWaterMark($waterMarkArray['path'],$waterMarkArray['position'],$waterMarkArray['gamma']);
								if($AttachedImage->createThumbnailIntoFile("../../../../cache/thumbnail/$owner/$tempFileName")){
									@unlink(ROOT."/cache/thumbnail/$owner/".str_replace(".watermarked.",".resampled.",$tempFileName));
									$imgString=preg_replace('/onclick="open_img\(\'([^\']+)\'\)"/',"onclick=\"open_img('$blogURL/thumbnail/$owner/$tempFileName')\"",$imgString);
								}
							}
						}else{
							@unlink(ROOT."/cache/thumbnail/$owner/".str_replace(".resampled.",".watermarked.",$tempFileName));
						}
					}else{
						$isSuccessful=false;
					}
				}else{
					$isSuccessful=false;
				}
				if($isSuccessful==false){
					$imgString=preg_replace('/width="([^"]+)"/i','width="'.$tempWidth.'"',$imgString);
					$imgString=preg_replace('/height="([^"]+)"/i','height="'.$tempHeight.'"',$imgString);
				}
				unset($AttachedImage);
				break;
			default:
				$imgString=preg_replace('/src="([^"]+)"/i','src="'.$tempURL.'"',$imgString);
				$imgString=preg_replace('/width="([^"]+)"/i','width="'.$tempWidth.'"',$imgString);
				$imgString=preg_replace('/height="([^"]+)"/i','height="'.$tempHeight.'"',$imgString);
				$originImageInfo=getimagesize($originSrc);
				$tempFileName=preg_replace("/\.([[:alnum:]]+)$/i",".w{$originImageInfo[0]}-h{$originImageInfo[1]}.{$resampleType}.\\1",$originFileName);
				if($resampleType=="watermarked"){
					if(file_exists("../../../../cache/thumbnail/$owner/$tempFileName")){
						$imgString=preg_replace('/onclick="open_img\(\'([^\']+)\'\)"/',"onclick=\"open_img('$blogURL/thumbnail/$owner/$tempFileName')\"",$imgString);
					}elseif(file_exists(ROOT."/cache/thumbnail/$owner/".str_replace(".watermarked.",".resampled.",$tempFileName))){
						$imgString=preg_replace('/onclick="open_img\(\'([^\']+)\'\)"/',"onclick=\"open_img('$blogURL/thumbnail/$owner/".str_replace(".watermarked.",".resampled.",$tempFileName)."')\"",$imgString);
					}
				}elseif($resampleType=="resampled"&&file_exists("../../../../cache/thumbnail/$owner/$tempFileName")){
					$imgString=preg_replace('/onclick="open_img\(\'([^\']+)\'\)"/',"onclick=\"open_img('$blogURL/thumbnail/$owner/$tempFileName')\"",$imgString);
				}
				break;
		}
	}
	return $imgString;
}
function deleteFilesByRegExp($path,$regexp){
	$path=eregi("/$",$path,$temp)?$path:$path."/";
	if(!file_exists($path))
		return false;
	$handle=opendir($path);
	while($tempFile=readdir($handle)){
		if(($regexp=="*"||eregi("$regexp",$tempFile,$temp))&&($tempFile!="."&&$tempFile!="..")){
			@unlink($path.$tempFile);
		}
	}
	return true;
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getAttachments($owner,$parent,$orderBy=null,$sort='ASC'){
	global $database, $cubrid_con;
	$attachments=array();
	if($result=DBQuery::query("select * from {$database['prefix']}Attachments where owner = $owner and parent = $parent ".(is_null($orderBy)?'':"ORDER BY $orderBy $sort"))){
		while($attachment=cubrid_fetch($result))
			array_push($attachments,$attachment);
		cubrid_commit($cubrid_con);
	}
	return $attachments;
}
function getAttachmentByOnlyName($owner,$name){
	global $database;
	$name=cubrid_tt_escape_string($name);
	return DBQuery::queryRow("select * from {$database['prefix']}Attachments where owner = $owner and \"name\" = '$name'");
}
function deleteAttachment($owner,$parent,$name){
	global $database;
	if(!Validator::filename($name))
		return false;
	$origname=$name;
	$name=cubrid_tt_escape_string($name);
	if(DBQuery::execute("delete from {$database['prefix']}Attachments where owner = $owner and \"name\" = '$name'")){
		@unlink("../../../../attach/$owner/$origname");
		clearRSS();
		return true;
	}
	return false;
}
function deleteAttachments($owner,$parent){
	$attachments=getAttachments($owner,$parent);
	foreach($attachments as $attachment)
		deleteAttachment($owner,$parent,$attachment['name']);
}
function updateEntriesOfCategory($owner,$id=-1){
	global $database, $cubrid_con;
	$result=DBQuery::query("SELECT * FROM {$database['prefix']}Categories WHERE owner = $owner AND parent IS NULL");
	while($row=cubrid_fetch($result)){
		$parent=$row['id'];
		$parentName=cubrid_lessen($row['name'],127);
		$row['name']=cubrid_tt_escape_string($parentName);
		$countParent=DBQuery::queryCell("SELECT COUNT(id) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft = 0 AND visibility > 0 AND category = $parent");
		$countInLoginParent=DBQuery::queryCell("SELECT COUNT(id) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft = 0 AND category = $parent");
		$result2=DBQuery::query("SELECT * FROM {$database['prefix']}Categories WHERE owner = $owner AND parent = $parent");
		while($rowChild=cubrid_fetch($result2)){
			$label=cubrid_tt_escape_string(cubrid_lessen($parentName.'/'.$rowChild['name'],255));
			$rowChild['name']=cubrid_tt_escape_string(cubrid_lessen($rowChild['name'],127));
			$countChild=DBQuery::queryCell("SELECT COUNT(id) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft = 0 AND visibility > 0 AND category = {$rowChild['id']}");
			$countInLogInChild=DBQuery::queryCell("SELECT COUNT(id) FROM {$database['prefix']}Entries WHERE owner = $owner AND draft = 0 AND category = {$rowChild['id']}");
			DBQuery::query("UPDATE {$database['prefix']}Categories SET entries = $countChild, entriesinlogin = $countInLogInChild, \"label\" = '$label' WHERE owner = $owner AND id = {$rowChild['id']}");
			$countParent+=$countChild;
			$countInLoginParent+=$countInLogInChild;
		}
		DBQuery::query("UPDATE {$database['prefix']}Categories SET entries = $countParent, entriesinlogin = $countInLoginParent, \"label\" = '{$row['name']}' WHERE owner = $owner AND id = $parent");
	}
	cubrid_commit($cubrid_con);
	return true;
}
function getEntry($owner,$id,$draft=false){
	global $database;
	if($id==0){
		if($draft){
			if(!$id=getDraftEntryId())
				return ;
		}else{
			if(!doesHaveOwnership())
				return ;
			deleteAttachments($owner,0);
			return array('id'=>0,'draft'=>0,'visibility'=>0,'category'=>0,'location'=>'','title'=>'','content'=>'','acceptcomment'=>1,'accepttrackback'=>1,'published'=>time(),'slogan'=>'');
		}
	}
	if($draft){
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 1");
		if(!$entry)
			return ;
		if($entry['published']==1)
			$entry['republish']=true;
		elseif($entry['published']!=0)
			$entry['appointed']=$entry['published'];
		if($id!=0)
			$entry['published']=DBQuery::queryCell("SELECT published FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0");
		return $entry;
	}else{
		$visibility=doesHaveOwnership()?'':'AND visibility > 0';
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0 $visibility");
		if(!$entry)
			return ;
		if($entry['visibility']<0)
			$entry['appointed']=$entry['published'];
		return $entry;
	}
}
function getDraftEntryId($id=0){
	global $database,$owner;
	if($id)
		return DBQuery::queryCell("SELECT id 
				FROM {$database['prefix']}Entries 
				WHERE owner = $owner AND id = $id AND draft = 1");
	else
		return DBQuery::queryCell("SELECT d.id 
				FROM {$database['prefix']}Entries d 
				LEFT JOIN {$database['prefix']}Entries e ON d.owner = e.owner AND d.id = e.id AND e.draft = 0 
				WHERE d.owner = $owner AND d.draft = 1 AND e.id IS NULL 
				ORDER BY d.id for orderby_num() = 1");
}
function changeCategoryOfEntries($owner,$entries,$category){
	global $database;
	$targets=array_unique(preg_split('/,/',$entries,-1,PREG_SPLIT_NO_EMPTY));
	if(count($targets)<1||!is_numeric($category))
		return false;
	if($category==-1){
		foreach($targets as $entryId){
			$title=DBQuery::queryCell("SELECT title FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $entryId AND draft = 0");
			if(is_null($title))
				return false;
			if(DBQuery::queryExistence("SELECT id FROM {$database['prefix']}Entries WHERE owner = $owner AND id <> $entryId AND draft = 0 AND title = '$title' AND category = -1")==true)
				return false;
		}
	}
	foreach($targets as $entryId){
		$oldVisibility=DBQuery::queryCell("SELECT visibility FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $entryId AND draft = 0");
		$visibility=$oldVisibility;
		if($category<0){
			if($visibility==1)
				$visibility=0;
			if($visibility==3)
				$visibility=2;
		}
		if(($oldVisibility==3)&&($visibility!=3))
			syndicateEntry($entryId,'delete');
		DBQuery::execute("UPDATE {$database['prefix']}Entries SET category = $category , visibility = $visibility WHERE owner = $owner AND id = $entryId");
	}
	if(updateEntriesOfCategory($owner)){
		clearRSS();
		return true;
	}
	return false;
}
function syndicateEntry($id,$mode){
	global $database,$blog,$owner,$defaultURL;
	requireComponent('Eolin.PHP.Core');
	requireComponent('Eolin.PHP.XMLRPC');
	$rpc=new XMLRPC();
	$rpc->url=TATTERTOOLS_SYNC_URL;
	$summary=array('blogurl'=>$defaultURL,'syncURL'=>"$defaultURL/sync/$id");
	if($mode=='create'){
		$entry=getEntry($owner,$id);
		$summary['blogTitle']=$blog['title'];
		$summary['language']=$blog['language'];
		$summary['permalink']="$defaultURL/".($blog['useslogan']?"entry/{$entry['slogan']}":$entry['id']);
		$summary['title']=$entry['title'];
		$summary['content']=UTF8::lessenAsByte(stripHTML(getEntryContentView($owner,$entry['id'],$entry['content'])),1023,'');
		$summary['author']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");
		$summary['tags']=array();
		foreach(DBQuery::queryAll("SELECT DISTINCT \"name\" FROM {$database['prefix']}Tags, {$database['prefix']}TagRelations WHERE id = tag AND owner = $owner AND entry = $id ORDER BY name") as $tag)
			array_push($summary['tags'],$tag['name']);
		$summary['location']=$entry['location'];
		$summary['written']=Timestamp::getRFC1123($entry['published']);
	}
	if(!$rpc->call("sync.$mode",$summary))
		return false;
	if($rpc->fault)
		return false;
	return true;
}
function clearRSS(){
	global $owner;
	@unlink("../../../../cache/rss/$owner.xml");
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
function requireStrictRoute(){
	if(isset($_SERVER['HTTP_REFERER'])&&($url=parse_url($_SERVER['HTTP_REFERER']))&&($url['host']==$_SERVER['HTTP_HOST']))
		return ;
	header('HTTP/1.1 412 Precondition Failed');
	header('Content-Type: text/html');
	header("Connection: close");?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ko">
<head>
	<title><?php
	echo _t('Precondition Failed');?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>
	<h1><?php
	echo _t('Precondition Failed');?></h1>
</body>
</html>
<?php
	exit;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
function _text($t){
	global $__outText;
	if(isset($__outText)&&isset($__outText[$t])){
		return $__outText[$t];
	}else{
		return $t;
	}
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function respondResultPage($error){
	if($error===true)
		$error=0;
	elseif($error===false)
		$error=1;
	header('Content-Type: text/xml; charset=utf-8');
	print ("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<response>\n<error>$error</error>\n</response>");
	exit;
}
function getEntryContentView($owner,$id,$content,$keywords=array(),$type='Post',$useAbsolutePath=false,$bRssMode=false){
	global $service;
	$path="../../../../attach/$owner";
	$url="{$service['path']}/attach/$owner";
	$view=bindAttachments($id,$path,$url,$content,$useAbsolutePath,$bRssMode);
	$view=is_array($keywords)?bindKeywords($keywords,$view):$view;
	$view=bindTags($id,$view);
	if(!$useAbsolutePath)
		$view=avoidFlashBorder($view);
	return fireEvent('View'.$type.'Content',$view,$id);
}
function bindTags($id,$content){
	for($no=0;(($start=strpos($content,'[#M_'))!==false)&&(($end=strpos($content,'_M#]',$start+4))!==false);$no++){
		$prefix=substr($content,0,$start);
		list($more,$less,$full)=explode('|',substr($content,$start+4,$end-$start-4),3);
		if(strlen($more)==0)
			$more='more..';
		if(strlen($less)==0)
			$less='less..';
		$more2=htmlspecialchars(str_replace("\"","&quot;",str_replace("'","&#39;",$more)));
		$less2=htmlspecialchars(str_replace("\"","&quot;",str_replace("'","&#39;",$less)));
		$postfix=substr($content,$end+4);
		$content=$prefix;
		{
			$content.="<p id=\"more{$id}_$no\" class=\"moreless_fold\"><span style=\"cursor: pointer;\" onclick=\"toggleMoreLess(this, '{$id}_$no','$more2','$less2'); return false;\">$more</span></p><div id=\"content{$id}_$no\" class=\"moreless_content\" style=\"display: none;\">$full</div>";
		}
		$content.=$postfix;
	}
	return $content;
}
function bindKeywords($keywords,$content){
	if(empty($keywords))
		return $content;
	$result=preg_split('@(
		# <ns:elem or </ns:elem
		</?([A-Za-z0-9-:]+)
		# whitespaces preceding attributes
		(?:\s+
			(?:
				# quotations like ="blah"
				=\s*([\'"`]).*?\3
			|
				# =nospacehere or raw character like !
				[^>]+
			)*
		)?
		# end of element
		>
		# redundant closure need to keep num of capturing patterns to 4
		()
	|
		# TT special pattern
		\[\#\#_.*?_\#\#]
	)@x',$content,-1,PREG_SPLIT_DELIM_CAPTURE);
	$stack=array();
	$buf='';
	$i=0;
	$pattern=array();
	foreach($keywords as $keyword)
		$pattern[]=preg_quote($keyword,'/');
	$pattern='/(?<![a-zA-Z\x80-\xff])(?:'.implode('|',$pattern).')/e';
	$inUnableContexts=false;
	while(true){
		if(count($stack)<=0||(!$inUnableContexts)){
			$buf.=preg_replace($pattern,"fireEvent('BindKeyword', '\\0')",$result[$i]);
		}else{
			$buf.=$result[$i];
		}
		if(++$i>=count($result))
			break;
		if($result[$i]{0}=='<'){
			if($result[$i]{1}=='/'){
				$index=array_search(strtolower($result[$i+1]),$stack);
				if($index===false){
				}else{
					array_splice($stack,0,$index+1);
					$inUnableContexts=checkKeyWordUnBindableContext($inUnableContexts,$stack);
				}
			}else{
				$t=strlen($result[$i])-2;
				if($result[$i]{$t>=0?$t:0}!='/'&&!in_array(strtolower($result[$i+1]),array('br','hr','img','input'))){
					array_unshift($stack,strtolower($result[$i+1]));
					$inUnableContexts=checkKeyWordUnBindableContext($inUnableContexts,$stack);
				}
			}
			$buf.=$result[$i];
			$i+=4;
		}else{
			$buf.=$result[$i++];
		}
	}
	return $buf;
}
function checkKeyWordUnBindableContext($curAblale,$currentContext){
	$inUnableContexts=false;
	$inUnableContexts|=array_search('a',$currentContext)!==false;
	$inUnableContexts|=array_search('object',$currentContext)!==false;
	$inUnableContexts|=array_search('applet',$currentContext)!==false;
	$inUnableContexts|=array_search('select',$currentContext)!==false;
	$inUnableContexts|=array_search('option',$currentContext)!==false;
	$inUnableContexts|=array_search('optgroup',$currentContext)!==false;
	$inUnableContexts|=array_search('textarea',$currentContext)!==false;
	$inUnableContexts|=array_search('button',$currentContext)!==false;
	$inUnableContexts|=array_search('isindex',$currentContext)!==false;
	$inUnableContexts|=array_search('title',$currentContext)!==false;
	$inUnableContexts|=array_search('meta',$currentContext)!==false;
	$inUnableContexts|=array_search('base',$currentContext)!==false;
	$inUnableContexts|=array_search('link',$currentContext)!==false;
	$inUnableContexts|=array_search('style',$currentContext)!==false;
	$inUnableContexts|=array_search('head',$currentContext)!==false;
	$inUnableContexts|=array_search('script',$currentContext)!==false;
	$inUnableContexts|=array_search('embed',$currentContext)!==false;
	$inUnableContexts|=array_search('address',$currentContext)!==false;
	$inUnableContexts|=array_search('pre',$currentContext)!==false;
	$inUnableContexts|=array_search('param',$currentContext)!==false;
	return $inUnableContexts;
}
function bindAttachments($entryId,$folderPath,$folderURL,$content,$useAbsolutePath=false,$bRssMode=false){
	global $service,$owner,$hostURL,$blogURL;
	$view=str_replace('[##_ATTACH_PATH_##]',($useAbsolutePath?"$hostURL{$service['path']}/attach/$owner":$folderURL),$content);
	$view=str_replace('http://tt_attach_path/',($useAbsolutePath?"$hostURL{$service['path']}/attach/$owner/":($folderURL.'/')),$view);
	$count=0;
	$bWritedGalleryJS=false;
	while((($start=strpos($view,'[##_'))!==false)&&(($end=strpos($view,'_##]',$start+4))!==false)){
		$count++;
		$attributes=explode('|',substr($view,$start+4,$end-$start-4));
		$prefix='';
		$buf='';
		if($attributes[0]=='Gallery'){
			if(count($attributes)%2==1)
				array_pop($attributes);
			if(defined('__TATTERTOOLS_MOBILE__')||($bRssMode==true)){
				$images=array_slice($attributes,1,count($attributes)-2);
				for($i=0;$i<count($images);$i++){
					if(!empty($images[$i])){
						if($i%2==0)
							$buf.='<div align="center">'.getAttachmentBinder($images[$i],'',$folderPath,$folderURL,1,$useAbsolutePath,$bRssMode).'</div>';
						elseif(strlen($images[$i])>0)
							$buf.="<div align=\"center\">$images[$i]</div>";
					}
				}
			}else{
				$id="gallery$entryId$count";
				$cssId="tt-gallery-$entryId-$count";
				$items=array();
				for($i=1;$i<sizeof($attributes)-2;$i+=2)
					array_push($items,array($attributes[$i],$attributes[$i+1]));
				$galleryAttributes=getAttributesFromString($attributes[sizeof($attributes)-1]);
				if(($useAbsolutePath==true)&&($bWritedGalleryJS==false)){
					$bWritedGalleryJS=true;
					$buf.=printScript('gallery.js');
				}
				$buf.=CRLF.'<div id="'.$cssId.'" class="tt-gallery-box">'.CRLF;
				$buf.='	<script type="text/javascript">'.CRLF;
				$buf.='		//<![CDATA['.CRLF;
				$buf.="			var {$id} = new TTGallery(\"{$cssId}\");".CRLF;
				$buf.="			{$id}.prevText = \""._text('이전 이미지 보기 버튼')."\"; ".CRLF;
				$buf.="			{$id}.nextText = \""._text('다음 이미지 보기 버튼')."\"; ".CRLF;
				$buf.="			{$id}.enlargeText = \""._text('원본 크기로 보기 버튼')."\"; ".CRLF;
				$buf.="			{$id}.altText = \""._text('갤러리 이미지')."\"; ".CRLF;
				foreach($items as $item){
					$setWidth=$setHeight=0;
					if(list($width,$height)=@getimagesize("$folderPath/$item[0]")){
						$setWidth=$width;
						$setHeight=$height;
						if(isset($galleryAttributes['width'])&&$galleryAttributes['width']<$setWidth){
							$setHeight=$setHeight*$galleryAttributes['width']/$setWidth;
							$setWidth=$galleryAttributes['width'];
						}
						if(isset($galleryAttributes['height'])&&$galleryAttributes['height']<$setHeight){
							$setWidth=$setWidth*$galleryAttributes['height']/$setHeight;
							$setHeight=$galleryAttributes['height'];
						}
						$item[1]=str_replace("'",'&#39;',$item[1]);
						$buf.=$id.'.appendImage("'.($useAbsolutePath?"$hostURL{$service['path']}/attach/$owner/$item[0]":"$folderURL/$item[0]").'", "'.htmlspecialchars($item[1]).'", '.intval($setWidth).', '.intval($setHeight).");";
					}
				}
				$buf.="			{$id}.show();".CRLF;
				$buf.="		//]]>".CRLF;
				$buf.='	</script>'.CRLF;
				$buf.='	<noscript>'.CRLF;
				foreach($items as $item){
					$buf.='<div class="imageblock center" style="text-align: center; clear: both;">';
					if($useAbsolutePath)
						$buf.='		<img src="'.$hostURL.$service['path']."/attach/".$owner."/".$item[0].'" alt="'._text('사용자 삽입 이미지').'" />'.CRLF;
					else
						$buf.='		<img src="'.$folderURL."/".$item[0].'" alt="'._text('사용자 삽입 이미지').'" />'.CRLF;
					if(!empty($item[1]))
						$buf.='		<p class="cap1">'.$item[1].'</p>'.CRLF;
					$buf.='</div>';
				}
				$buf.='	</noscript>'.CRLF;
				$buf.='</div>'.CRLF;
			}
		}elseif($attributes[0]=='iMazing'){
			if(defined('__TATTERTOOLS_MOBILE__')||($bRssMode==true)){
				$images=array_slice($attributes,1,count($attributes)-3);
				for($i=0;$i<count($images);$i+=2){
					if(!empty($images[$i]))
						$buf.='<div>'.getAttachmentBinder($images[$i],'',$folderPath,$folderURL,1,$useAbsolutePath).'</div>';
				}
				$buf.=$attributes[count($attributes)-1];
			}else{
				$params=getAttributesFromString($attributes[sizeof($attributes)-2]);
				$id=$entryId.$count;
				$imgs=array_slice($attributes,1,count($attributes)-3);
				$imgStr='';
				for($i=0;$i<count($imgs);$i+=2){
					if($imgs[$i]!=''){
						$imgStr.=$service['path'].'/attach/'.$owner.'/'.$imgs[$i];
						if($i<(count($imgs)-2))
							$imgStr.='*!';
					}
				}
				if(!empty($attributes[count($attributes)-1])){
					$caption='<p class="cap1">'.$attributes[count($attributes)-1].'</p>';
				}else{
					$caption='';
				}
				$buf.='<center><img src="'.($useAbsolutePath?$hostURL:$service['path']).'/image/gallery/gallery_enlarge.gif" alt="'._text('확대').'" style="cursor:pointer" onclick="openFullScreen(\''.$service['path'].'/script/gallery/iMazing/embed.php?d='.urlencode($id).'&f='.urlencode($params['frame']).'&t='.urlencode($params['transition']).'&n='.urlencode($params['navigation']).'&si='.urlencode($params['slideshowInterval']).'&p='.urlencode($params['page']).'&a='.urlencode($params['align']).'&o='.$owner.'&i='.$imgStr.'\',\''.htmlspecialchars(str_replace("'","&#39;",$attributes[count($attributes)-1])).'\',\''.$service['path'].'\')" />';
				$buf.='<table>';
				$buf.='<tr>';
				$buf.='<td width="'.$params['width'].'" height="'.$params['height'].'">';
				$buf.='<div id="iMazingContainer'.$id.'" style="width:'.$params['width'].'px; height:'.$params['height'].'px;"></div><script type="text/javascript">iMazing'.$id.'Str = getEmbedCode(\''.$service['path'].'/script/gallery/iMazing/main.swf\',\'100%\',\'100%\',\'iMazing'.$id.'\',\'#FFFFFF\',"image='.$imgStr.'&amp;frame='.$params['frame'].'&amp;transition='.$params['transition'].'&amp;navigation='.$params['navigation'].'&amp;slideshowInterval='.$params['slideshowInterval'].'&amp;page='.$params['page'].'&amp;align='.$params['align'].'&amp;skinPath='.$service['path'].'/script/gallery/iMazing/&amp;","false"); writeCode(iMazing'.$id.'Str, "iMazingContainer'.$id.'");</script><noscript>';
				for($i=0;$i<count($imgs);$i+=2)
					$buf.='<img src="'.($useAbsolutePath?$hostURL:$service['path']).'/attach/'.$owner.'/'.$imgs[$i].'" alt="" />';
				$buf.='</noscript>';
				$buf.='</td>';
				$buf.='</tr>';
				$buf.='</table>'.$caption.'</center>';
			}
		}elseif($attributes[0]=='Jukebox'){
			{
				$params=getAttributesFromString($attributes[sizeof($attributes)-2]);
				foreach($params as $key=>$value){
					if($key=='autoPlay'){
						unset($params['autoplay']);
						$params['autoplay']=$value;
					}
				}
				if($params['visible']==1){
					$width='250px';
					$height='27px';
				}else{
					$width='0px';
					$height='0px';
				}
				$id=$entryId.$count;
				$imgs=array_slice($attributes,1,count($attributes)-3);
				$imgStr='';
				for($i=0;$i<count($imgs);$i++){
					if($imgs[$i]=='')
						continue;
					if($i%2==1){
						$imgStr.=urlencode($imgs[$i]).'_*';
						continue;
					}else{
						if($i<(count($imgs)-1))
							$imgStr.="{$service['path']}/attach/$owner/".urlencode($imgs[$i]).'*!';
					}
				}
				if(!empty($attributes[count($attributes)-1])){
					$caption='<div class="cap1" style="text-align: center">'.$attributes[count($attributes)-1].'</div>';
				}else{
					$caption='';
				}
				$buf='<center>';
				$buf.='<div id="jukeBox'.$id.'Div" style="width:'.$width.'; height:'.$height.';"><div id="jukeBoxContainer'.$id.'" style="width:'.$width.'; height:'.$height.';"></div>';
				$buf.='<script type="text/javascript">writeCode(getEmbedCode(\''.$service['path'].'/script/jukebox/flash/main.swf\',\'100%\',\'100%\',\'jukeBox'.$id.'Flash\',\'#FFFFFF\',"sounds='.$imgStr.'&amp;autoplay='.$params['autoplay'].'&amp;visible='.$params['visible'].'&amp;id='.$id.'","false"), "jukeBoxContainer'.$id.'")</script><noscript>';
				for($i=0;$i<count($imgs);$i++){
					if($i%2==0)
						$buf.='<a href="'.($useAbsolutePath?$hostURL:$service['path']).'/attach/'.$owner.'/'.$imgs[$i].'">';
					else
						$buf.=htmlspecialchars($imgs[$i]).'</a><br/>';
				}
				$buf.='</noscript>';
				$buf.='</div>'.$caption.'</center>';
			}
		}else{
			$contentWidth=getContentWidth();
			switch(count($attributes)){
				case 4:
					list($newProperty,$onclickFlag)=createNewProperty($attributes[1],$contentWidth,$attributes[2]);
					{
						if(trim($attributes[3])==''){
							$caption='';
						}else{
							$caption='<p class="cap1">'.$attributes[3].'</p>';
						}
						switch($attributes[0]){
							case '1L':
								$prefix='<div class="imageblock left" style="float: left; margin-right: 10px;">';
								break;
							case '1R':
								$prefix='<div class="imageblock right" style="float: right; margin-left: 10px;">';
								break;
							case '1C':
							default:
								$prefix='<div class="imageblock center" style="text-align: center; clear: both;">';
								break;
						}
						$buf=$prefix.getAttachmentBinder($attributes[1],$newProperty,$folderPath,$folderURL,1,$useAbsolutePath,$bRssMode,$onclickFlag).$caption.'</div>';
					}
					break;
				case 7:
					$eachImageWidth=floor(($contentWidth-5*3)/2);
					list($newProperty1,$onclickFlag1)=createNewProperty($attributes[1],$eachImageWidth,$attributes[2]);
					list($newProperty2,$onclickFlag2)=createNewProperty($attributes[4],$eachImageWidth,$attributes[5]);
					{
						$cap1=strlen(trim($attributes[3]))>0?'<p class="cap1">'.$attributes[3].'</p>':'';
						$cap2=strlen(trim($attributes[6]))>0?'<p class="cap1">'.$attributes[6].'</p>':'';
						$buf='<div class="imageblock dual" style="text-align: center;"><table cellspacing="5" cellpadding="0" border="0" style="margin: 0 auto;"><tr><td>'.getAttachmentBinder($attributes[1],$newProperty1,$folderPath,$folderURL,2,$useAbsolutePath,$bRssMode,$onclickFlag1).$cap1.'</td><td>'.getAttachmentBinder($attributes[4],$newProperty2,$folderPath,$folderURL,2,$useAbsolutePath,$bRssMode,$onclickFlag2).$cap2.'</td></tr></table></div>';
					}
					break;
				case 10:
					$eachImageWidth=floor(($contentWidth-5*4)/3);
					list($newProperty1,$onclickFlag1)=createNewProperty($attributes[1],$eachImageWidth,$attributes[2]);
					list($newProperty2,$onclickFlag2)=createNewProperty($attributes[4],$eachImageWidth,$attributes[5]);
					list($newProperty3,$onclickFlag3)=createNewProperty($attributes[7],$eachImageWidth,$attributes[8]);
					{
						$cap1=strlen(trim($attributes[3]))>0?'<p class="cap1">'.$attributes[3].'</p>':'';
						$cap2=strlen(trim($attributes[6]))>0?'<p class="cap1">'.$attributes[6].'</p>':'';
						$cap3=strlen(trim($attributes[9]))>0?'<p class="cap1">'.$attributes[9].'</p>':'';
						$buf='<div class="imageblock triple" style="text-align: center"><table cellspacing="5" cellpadding="0" border="0" style="margin: 0 auto;"><tr><td>'.getAttachmentBinder($attributes[1],$newProperty1,$folderPath,$folderURL,3,$useAbsolutePath,$bRssMode,$onclickFlag1).$cap1.'</td><td>'.getAttachmentBinder($attributes[4],$newProperty2,$folderPath,$folderURL,3,$useAbsolutePath,$bRssMode,$onclickFlag2).$cap2.'</td><td>'.getAttachmentBinder($attributes[7],$newProperty3,$folderPath,$folderURL,3,$useAbsolutePath,$bRssMode,$onclickFlag3).$cap3.'</td></tr></table></div>';
					}
					break;
			}
		}
		$view=substr($view,0,$start).$buf.substr($view,$end+4);
	}
	return $view;
}
function getAttachmentBinder($filename,$property,$folderPath,$folderURL,$imageBlocks=1,$useAbsolutePath=false,$bRssMode=false,$onclickFlag=false){
	global $database,$skinSetting,$service,$owner,$blogURL,$hostURL,$waterMarkArray,$paddingArray,$serviceURL;
	$path="$folderPath/$filename";
	if($useAbsolutePath)
		$url="$serviceURL/attach/$owner/$filename";
	else
		$url="$folderURL/$filename";
	$fileInfo=getAttachmentByOnlyName($owner,$filename);
	switch(getFileExtension($filename)){
		case 'jpg':
		case 'jpeg':
		case 'gif':
		case 'png':
		case 'bmp':
			$bPassing=false;
			{
				if(($onclickFlag==true)&&($bRssMode==false)&&($bPassing==false)){
					$imageStr='<img src="'.$url.'" '.$property.' style="cursor: pointer;" onclick="open_img(\''.$url.'\')" />';
				}else{
					$imageStr='<img src="'.$url.'" '.$property.' />';
				}
				return makeThumbnail(fireEvent('ViewAttachedImage',$imageStr,$path),$path,$paddingArray,$waterMarkArray,$useAbsolutePath);
			}
			break;
		case 'swf':
			$id=md5($url).rand(1,10000);
			if(($useAbsolutePath)&&(strncasecmp($url,'http://',7)==0))
				$url=substr($url,7);
			return "<span id=\"$id\"><script type=\"text/javascript\">writeCode(getEmbedCode('$url','300','400','$id','#FFFFFF',''), \"$id\");</script></span>";
			break;
		case 'wmv':
		case 'avi':
		case 'asf':
		case 'mpg':
		case 'mpeg':
			$id=md5($url).rand(1,10000);
			if(($useAbsolutePath)&&(strncasecmp($url,'http://',7)==0))
				$url=substr($url,7);
			return "<span id=\"$id\"><script type=\"text/javascript\">writeCode('<embed $property autostart=\"0\" src=\"$url\"></embed>', \"$id\")</script></span>";
			break;
		case 'mp3':
		case 'mp2':
		case 'wma':
		case 'wav':
		case 'mid':
		case 'midi':
			$id=md5($url).rand(1,10000);
			if(($useAbsolutePath)&&(strncasecmp($url,'http://',7)==0))
				$url=substr($url,7);
			return "<span id=\"$id\"><script type=\"text/javascript\">writeCode('<embed $property autostart=\"0\" height=\"45\" src=\"$url\"></embed>', \"$id\")</script></span>";
			break;
		case 'mov':
			$id=md5($url).rand(1,10000);
			return "<span id=\"$id\"><script type=\"text/javascript\">writeCode(".'\'<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" codebase="http://www.apple.com/qtactivex/qtplugin.cab" width="400px" height="300px"><param name="src" value="'.$url.'" /><param name="controller" value="true" /><param name="pluginspage" value="http://www.apple.com/QuickTime/download/" /><!--[if !IE]> <--><object type="video/quicktime" data="'.$url.'" width="400px" height="300px" class="mov"><param name="controller" value="true" /><param name="pluginspage" value="http://www.apple.com/QuickTime/download/" /></object><!--> <![endif]--></object>\''.", \"$id\")</script></span>";
			break;
		default:
			if(file_exists(ROOT.'/image/extension/'.getFileExtension($filename).'.gif')){
				return '<a href="'.($useAbsolutePath?$hostURL:'').$blogURL.'/attachment/'.$filename.'">'.fireEvent('ViewAttachedFileExtension','<img src="'.($useAbsolutePath?$hostURL:'').$service['path'].'/image/extension/'.getFileExtension($filename).'.gif" />').' '.htmlspecialchars($fileInfo['label']).'</a>';
			}else{
				return '<a href="'.($useAbsolutePath?$hostURL:'').$blogURL.'/attachment/'.$filename.'">'.fireEvent('ViewAttachedFileExtension','<img src="'.($useAbsolutePath?$hostURL:'').$service['path'].'/image/extension/unknown.gif" />').' '.htmlspecialchars($fileInfo['label']).'</a>';
			}
			break;
	}
}
function printScript($filename,$obfuscate=true){
	global $service,$hostURL,$blogURL;
	if(!$file=@file_get_contents("../../../../script/$filename"))
		return '';
	$file="<script type=\"text/javascript\">var servicePath=\"$hostURL{$service['path']}\"; var blogurl=\"$hostURL$blogURL/\";$file";
	if($obfuscate){
	}
	return "$file</script>";
}
function createNewProperty($filename,$imageWidth,$property){
	global $owner;
	if(!file_exists("../../../../attach/$owner/$filename"))
		return array($property,false);
	if($tempInfo=getimagesize("../../../../attach/$owner/$filename")){
		list($originWidth,$originHeight,$type,$attr)=$tempInfo;
		if($originWidth<=0||$originHeight<=0)
			return array($property,false);
	}else{
		return array($property,false);
	}
	$attributes=getAttributesFromString($property,false);
	if(array_key_exists('width',$attributes)){
		if(preg_match('/([\d.]+)(%?)/',$attributes['width'],$matches)){
			if($matches[2]=='%')
				$attributes['width']=round($originWidth*$matches[1]/100);
			else
				$attributes['width']=intval($matches[1]);
		}
	}
	if(array_key_exists('height',$attributes)){
		if(preg_match('/([\d.]+)(%?)/',$attributes['height'],$matches)){
			if($matches[2]=='%')
				$attributes['height']=round($originHeight*$matches[1]/100);
			else
				$attributes['height']=intval($matches[1]);
		}
	}
	if($attributes['width']===0||$attributes['height']===0){
		return array($property,false);
	}
	if(isset($attributes['width'])&&!isset($attributes['height'])){
		$attributes['height']=floor($originHeight*$attributes['width']/$originWidth);
	}elseif(!isset($attributes['width'])&&isset($attributes['height'])){
		$attributes['width']=floor($originWidth*$attributes['height']/$originHeight);
	}elseif(!isset($attributes['width'])&&!isset($attributes['height'])){
		$attributes['width']=$originWidth;
		$attributes['height']=$originHeight;
	}
	if($attributes['width']>$imageWidth){
		$tempWidth=$imageWidth;
		$tempHeight=floor($attributes['height']*$imageWidth/$attributes['width']);
	}else{
		$tempWidth=$attributes['width'];
		$tempHeight=$attributes['height'];
	}
	$properties=array();
	ksort($attributes);
	foreach($attributes as $key=>$value)
		array_push($properties,"$key=\"$value\"");
	$property=implode(' ',$properties);
	$onclickFlag=($originWidth>$tempWidth||$originHeight>$tempHeight);
	return array($property,$onclickFlag);
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
requireStrictRoute();
if(changeCategoryOfEntries($owner,$_POST['targets'],$_POST['category'])){
	respondResultPage(0);
}else{
	respondResultPage(1);
}?>
