<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
$IV=array('GET'=>array('draft'=>array('any','mandatory'=>false),'popupEditor'=>array('any','mandatory'=>false),'returnURL'=>array('string','mandatory'=>false)),'POST'=>array('category'=>array('int','default'=>0),'search'=>array('string','default'=>'')));
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function escapeJSInAttribute($str){
	return htmlspecialchars(str_replace(array('\\','\r','\n','\''),array('\\\\','\\r','\\n','\\\''),$str));
}
function escapeJSInCData($str){
	return preg_replace(array('/</','/>/','/\r*\n|\r/'),array('\x3C','\x3E','\\\\$0'),addslashes($str));
}
function link_cut($url,$checkURL=35){
	$leftURL=$checkURL-14;
	$rightURL=-8;
	$link=(strlen($url)>$checkURL)?substr($url,0,$leftURL).' &hellip; '.substr($url,$rightURL):$url;
	return $link;
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getSizeHumanReadable($size){
	if($size<1024)
		return "$size Bytes";
	elseif($size<1048576)
		return sprintf("%0.2f",$size/1024)." KB";
	elseif($size<1073741824)
		return sprintf("%0.2f",$size/1048576)." MB";
	else
		return sprintf("%0.2f",$size/1073741824)." GB";
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getAttachments($owner,$parent,$orderBy=null,$sort='ASC'){
	global $database, $cubrid_con;
	$attachments=array();
	if($result=DBQuery::query("select * from {$database['prefix']}Attachments where owner = $owner and parent = $parent ".(is_null($orderBy)?'':"ORDER BY $orderBy $sort"))){
		while($attachment=cubrid_fetch($result))
			array_push($attachments,$attachment);
		cubrid_commit($cubrid_con);
	}
	return $attachments;
}
function getAttachmentSize($owner=null,$parent=null){
	global $database;
	$ownerStr='';
	$parentStr='';
	if(!empty($owner))
		$ownerStr="owner = $owner ";
	if($parent==0||!empty($parent))
		$parentStr="and parent = $parent";
	return DBQuery::queryCell("select sum(\"size\") from {$database['prefix']}Attachments where $ownerStr $parentStr");
}
function getAttachmentSizeLabel($owner=null,$parent=null){
	return number_format(ceil(getAttachmentSize($owner,$parent)/1024)).' (KByte)';
}
function deleteAttachment($owner,$parent,$name){
	global $database;
	if(!Validator::filename($name))
		return false;
	$origname=$name;
	$name=cubrid_tt_escape_string($name);
	if(DBQuery::execute("delete from {$database['prefix']}Attachments where owner = $owner and \"name\" = '$name'")){
		@unlink("../../../../attach/$owner/$origname");
		clearRSS();
		return true;
	}
	return false;
}
function deleteAttachments($owner,$parent){
	$attachments=getAttachments($owner,$parent);
	foreach($attachments as $attachment)
		deleteAttachment($owner,$parent,$attachment['name']);
}
function getEnclosure($entry){
	global $database,$owner;
	if($entry<0)
		return ;
	return DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Attachments WHERE parent = $entry AND enclosure = 1 AND owner = $owner");
}
function return_bytes($val){
	$val=trim($val);
	$last=strtolower($val{strlen($val)-1});
	switch($last){
		case 'g':
			$val*=1024;
		case 'm':
			$val*=1024;
		case 'k':
			$val*=1024;
	}
	return $val;
}
function getCategoryNameById($owner,$id){
	global $database;
	$result=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Categories WHERE owner = $owner AND id = $id");
	if(is_null($result))
		return _text('전체');
	else
		return $result;
}
function getCategories($owner){
	global $database;
	$rows=DBQuery::queryAll("SELECT * FROM {$database['prefix']}Categories WHERE owner = $owner AND id > 0 ORDER BY parent, priority");
	$categories=array();
	foreach($rows as $category){
		if($category['parent']==null){
			$category['children']=array();
			$categories[$category['id']]=$category;
		}elseif(isset($categories[$category['parent']]))
			array_push($categories[$category['parent']]['children'],$category);
	}
	return $categories;
}
function getEntry($owner,$id,$draft=false){
	global $database;
	if($id==0){
		if($draft){
			if(!$id=getDraftEntryId())
				return ;
		}else{
			if(!doesHaveOwnership())
				return ;
			deleteAttachments($owner,0);
			return array('id'=>0,'draft'=>0,'visibility'=>0,'category'=>0,'location'=>'','title'=>'','content'=>'','acceptcomment'=>1,'accepttrackback'=>1,'published'=>time(),'slogan'=>'');
		}
	}
	if($draft){
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 1");
		if(!$entry)
			return ;
		if($entry['published']==1)
			$entry['republish']=true;
		elseif($entry['published']!=0)
			$entry['appointed']=$entry['published'];
		if($id!=0)
			$entry['published']=DBQuery::queryCell("SELECT published FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0");
		return $entry;
	}else{
		$visibility=doesHaveOwnership()?'':'AND visibility > 0';
		$entry=DBQuery::queryRow("SELECT * FROM {$database['prefix']}Entries WHERE owner = $owner AND id = $id AND draft = 0 $visibility");
		if(!$entry)
			return ;
		if($entry['visibility']<0)
			$entry['appointed']=$entry['published'];
		return $entry;
	}
}
function getDraftEntryId($id=0){
	global $database,$owner;
	if($id)
		return DBQuery::queryCell("SELECT id 
				FROM {$database['prefix']}Entries 
				WHERE owner = $owner AND id = $id AND draft = 1");
	else
		return DBQuery::queryCell("SELECT d.id 
				FROM {$database['prefix']}Entries d 
				LEFT JOIN {$database['prefix']}Entries e ON d.owner = e.owner AND d.id = e.id AND e.draft = 0 
				WHERE d.owner = $owner AND d.draft = 1 AND e.id IS NULL 
				ORDER BY d.id for orderby_num() = 1");
}
function clearRSS(){
	global $owner;
	@unlink("../../../../cache/rss/$owner.xml");
}
function getTags($entry){
	global $database, $cubrid_con,$owner;
	$tags=array();
	if(doesHaveOwnership())
		$result=DBQuery::query("SELECT * FROM {$database['prefix']}Tags t, 
			{$database['prefix']}TagRelations r 
			WHERE t.id = r.tag AND r.entry = $entry AND r.owner = $owner 
			ORDER BY t.name");
	else
		$result=DBQuery::query("SELECT * FROM {$database['prefix']}Tags t,
			{$database['prefix']}TagRelations r, 
			{$database['prefix']}Entries e 
			WHERE r.entry = e.id AND e.visibility > 0 AND t.id = r.tag AND r.entry = $entry AND r.owner = $owner 
			ORDER BY t.name");
	if($result){
        unset($partial_groupby);
		while($tag=cubrid_fetch($result)) {
            if ($partial_groupby[$tag[tag]]==1) continue;
            $partial_groupby[$tag[tag]]=1;
			array_push($tags,$tag); //partial GROUP BY r.tag 대치
        }
		cubrid_commit($cubrid_con);
	}
	return $tags;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
function _text($t){
	global $__outText;
	if(isset($__outText)&&isset($__outText[$t])){
		return $__outText[$t];
	}else{
		return $t;
	}
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function fetchConfigVal($DATA){
	$xmls=new XMLStruct();
	$outVal=array();
	if(!$xmls->open($DATA)){
		unset($xmls);
		return ;
	}
	if(is_null($xmls->selectNodes('/config/field'))){
		unset($xmls);
		return ;
	}
	foreach($xmls->selectNodes('/config/field') as $field){
		if(empty($field['.attributes']['name'])||empty($field['.attributes']['type'])){
			unset($xmls);
			return ;
		}
		$outVal[$field['.attributes']['name']]=$field['.value'];
	}
	unset($xmls);
	return ($outVal);
}
function respondErrorPage($message=NULL,$buttonValue=NULL,$buttonLink=NULL){
	global $service;?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ko">
<head>
	<title><?php
	echo TATTERTOOLS_NAME;?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'];?>/style/owner.css" />
</head>
<body id="body-message-page">
	<div class="message-box">
		<h1><?php
	echo TATTERTOOLS_NAME;?></h1>
		
		<div class="message"><?php
	echo $message;?></div>
		<div class="button-box">
			<input type="button" class="input-button" value="<?php
	echo !empty($buttonValue)?$buttonValue:_text('이전');?>" onclick="<?php
	echo !empty($buttonLink)?'window.location.href=\''.$buttonLink.'\'':'window.history.go(-1)';?>" />
		</div>
	</div>
</body>
</html>
<?php
	exit;
}
function printOwnerEditorScript($entryId=false){
	global $owner,$database,$skin,$hostURL,$blogURL,$service;
	$contentWidth=500;
	if($skin=DBQuery::queryCell("SELECT skin FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		if($xml=@file_get_contents("../../../../skin/$skin/index.xml")){
			$xmls=new XMLStruct();
			$xmls->open($xml,$service['encoding']);
			if($xmls->getValue('/skin/default/contentWidth')){
				$contentWidth=$xmls->getValue('/skin/default/contentWidth');
			}
		}
	}?>
<script type="text/javascript">
//<![CDATA[
	var entryId = <?php
	echo $entryId?$entryId:0;?>; 
	var skinContentWidth = <?php
	echo $contentWidth;?>;
	var s_enterURL = "<?php
	echo _t('URL을 입력하세요.');?>";
	var s_unknownFileType = "<?php
	echo _t('알 수 없는 형식의 파일명입니다.');?>";
	var s_enterObjectTag = "<?php
	echo _t('OBJECT 태그만 입력하세요.');?>";
	var s_enterCorrectObjectTag = "<?php
	echo _t('잘못된 OBJECT 태그입니다.');?>";
	var s_selectBoxArea = "<?php
	echo _t('박스로 둘러쌀 영역을 선택해주세요');?>";
	var s_selectLinkArea = "<?php
	echo _t('링크를 만들 영역을 선택해주세요');?>";

	window.addEventListener("scroll", function() { editor.setPropertyPosition(); }, false);

	function savePosition() {
		if (document.forms[0].content.createTextRange)
			document.forms[0].content.currentPos = document.selection.createRange().duplicate();
		return true;
	}
	
	function insertTag(prefix, postfix) {
		var oTextarea = document.forms[0].content;
		if(isSafari) 
			var selection = window.getSelection;
		else
			var selection = document.selection;
		
		if (selection) {			
			if (oTextarea.createTextRange && oTextarea.currentPos) {				
				oTextarea.currentPos.text = prefix + oTextarea.currentPos.text + postfix;
				oTextarea.focus();
				savePosition(oTextarea);
			}
			else
				oTextarea.value = oTextarea.value + prefix + postfix;
		}
		else if (oTextarea.selectionStart != null && oTextarea.selectionEnd != null) {
			var s1 = oTextarea.value.substring(0, oTextarea.selectionStart);
			var s2 = oTextarea.value.substring(oTextarea.selectionStart, oTextarea.selectionEnd);
			var s3 = oTextarea.value.substring(oTextarea.selectionEnd);
			oTextarea.value = s1 + prefix + s2 + postfix + s3;
		}
		else
			oTextarea.value += prefix + postfix;
			
		return true;	
	}
	
	function insertColorTag(col1) {
		hideLayer("colorPalette");
		TTCommand("Color", col1);
	}
	
	function insertMarkTag(col1) {
		hideLayer("markPalette");
		TTCommand("Mark", col1);
	}
	
	function linkImage1(align, caption) {
		var oSelect = document.forms[0].fileList;
		if (oSelect.selectedIndex < 0) {
			alert("<?php
	echo _t('파일을 선택하십시오.');?>");
			return false;
		}
		var value = oSelect.options[oSelect.selectedIndex].value.split("|");
		var result_w = new RegExp("width=['\"]?(\\d+)").exec(value[1]);
		var result_h = new RegExp("height=['\"]?(\\d+)").exec(value[1]);
		caption = (typeof caption == "undefined") ? "" : caption.replaceAll("|", "");
		if(result_w && result_h)
		{
			width = result_w[1];
			height = result_h[1];
			if(width > skinContentWidth)
			{
				height = parseInt(height * (skinContentWidth / width));
				value[1] = value[1].replace(new RegExp("width=['\"]?\\d+['\"]?", "gi"), 'width="' + skinContentWidth + '"');
				value[1] = value[1].replace(new RegExp("height=['\"]?\\d+['\"]?", "gi"), 'height="' + height + '"');
			}
		}
		if(editor.isMediaFile(value[0])) {
			getObject("propertyInsertObject_type").value = "url";
			getObject("propertyInsertObject_url").value = "<?php
	echo "$hostURL$blogURL";?>" + "/attachment/" + value[0];
			TTCommand("InsertObject");
			return;
		}
		try {
			if(editor.editMode == "WYSIWYG")
			{
				var src = editor.propertyFilePath + value[0];
				var attributes = editor.addQuot(value[1]);
				
				if(!(new RegExp("\.(jpe?g|gif|png|bmp)$", "i").test(value[0])))
				{
					src = servicePath + adminSkin + "/image/spacer.gif";
					value[1] = editor.styleUnknown;
					attributes = "";				
				}
				
				switch(align)
				{
					case "1L":
						var prefix = "<img class=\"tatterImageLeft\" src=\"" + src + "\" " + value[1] + " longdesc=\"1L|" + value[0] + "|" + attributes + "|" + caption + "\" />";
						break;
					case "1C":
						var prefix = "<img class=\"tatterImageCenter\" src=\"" + src + "\" " + value[1] + " longdesc=\"1C|" + value[0] + "|" + attributes + "|" + caption + "\" />";
						break;
					case "1R":
						var prefix = "<img class=\"tatterImageRight\" src=\"" + src + "\" " + value[1] + " longdesc=\"1R|" + value[0] + "|" + attributes + "|" + caption + "\" />";
						break;
				}
				TTCommand("Raw", prefix);
				return true;
			}
		} catch(e) { }
		insertTag('[##_' + align + '|' + value[0] + '|' + value[1] + '|' + caption + '_##]', "");
		return true;
	}
	
	function linkImage2() {
		var oSelect = document.forms[0].fileList;
		var count = 0;
		var prefix = '';
		for (var i = 0; i < oSelect.options.length; i++) {
			if (oSelect.options[i].selected == true) {
				var value = oSelect.options[i].value.split("|");
				var result_w = new RegExp("width=['\"]?(\\d+)").exec(value[1]);
				var result_h = new RegExp("height=['\"]?(\\d+)").exec(value[1]);
				if(result_w && result_h)
				{
					width = result_w[1];
					height = result_h[1];
					if(width > skinContentWidth / 2)
					{
						height = parseInt(height * (skinContentWidth / 2 / width));
						value[1] = value[1].replace(new RegExp("width=['\"]?\\d+['\"]?", "gi"), 'width="' + parseInt(skinContentWidth / 2) + '"');
						value[1] = value[1].replace(new RegExp("height=['\"]?\\d+['\"]?", "gi"), 'height="' + height + '"');
					}
				}
				prefix = prefix + '^' + value[0] + '|' + value[1] + '|';
				count ++;
			}
		}
		if (count != 2) {
			alert("<?php
	echo _t('파일 리스트에서 이미지를 2개 선택해 주십시오. (ctrl + 마우스 왼쪽 클릭)');?>");
			return false;
		}
		var imageinfo = prefix.split("^");
		try {
			if(editor.editMode == "WYSIWYG") {			
				var prefix = '<img class="tatterImageDual" src="' + servicePath + adminSkin + '/image/spacer.gif" width="200" height="100" longdesc="2C|' + editor.addQuot(imageinfo[1]) + '|' + editor.addQuot(imageinfo[2]) + '" />';
				TTCommand("Raw", prefix);
				return true;
			}
		} catch(e) { }
		insertTag('[##_2C|' + imageinfo[1] + '|' + imageinfo[2] + '_##]', '');
		return true;
	}
	
	function linkImage3() {
		var oSelect = document.forms[0].fileList;
		var count = 0;
		var prefix = '';
		for (var i = 0; i < oSelect.options.length; i++) {
			if (oSelect.options[i].selected == true) {
				var value = oSelect.options[i].value.split("|");
				var result_w = new RegExp("width=['\"]?(\\d+)").exec(value[1]);
				var result_h = new RegExp("height=['\"]?(\\d+)").exec(value[1]);
				if(result_w && result_h)
				{
					width = result_w[1];
					height = result_h[1];
					if(width > skinContentWidth / 3)
					{
						height = parseInt(height * (skinContentWidth / 3 / width));
						value[1] = value[1].replace(new RegExp("width=['\"]?\\d+['\"]?", "gi"), 'width="' + parseInt(skinContentWidth / 3) + '"');
						value[1] = value[1].replace(new RegExp("height=['\"]?\\d+['\"]?", "gi"), 'height="' + height + '"');
					}
				}
				prefix = prefix + '^' + value[0] + '|' + value[1] + '|';
				count++;
			}
		}
		if (count != 3) {
			alert("<?php
	echo _t('파일 리스트에서 이미지를 3개 선택해 주십시오. (ctrl + 마우스 왼쪽 클릭)');?>");
			return false;
		}
		var imageinfo = prefix.split("^");
		try {
			if(editor.editMode == "WYSIWYG") {
				var prefix = '<img class="tatterImageTriple" src="' + servicePath + adminSkin + '/image/spacer.gif" width="300" height="100" longdesc="3C|' + editor.addQuot(imageinfo[1]) + '|' + editor.addQuot(imageinfo[2]) + '|' + editor.addQuot(imageinfo[3]) + '" />';
				TTCommand("Raw", prefix);
				return true;
			}
		} catch(e) { }
		insertTag('[##_3C|' + imageinfo[1] + '|' + imageinfo[2] + '|' + imageinfo[3] + '_##]', '');
		return true;
	}
	
	function linkImageFree() {
		var isWYSIWYG = false;
		try {
			if(editor.editMode == "WYSIWYG")
				isWYSIWYG = true;
		} catch(e) { }		
		var oSelect = document.forms[0].fileList;
		var prefix = '';
		for (var i = 0; i < oSelect.options.length; i++) {
			if (oSelect.options[i].selected == true) {
				var value = oSelect.options[i].value.split("|");
				if(new RegExp("\\.(gif|jpe?g|png|bmp)$", "i").test(value[0])) {
					if(isWYSIWYG)
						prefix += '<img class="tatterImageFree" src="' + editor.propertyFilePath + value[0] + '" longdesc="[##_ATTACH_PATH_##]/' + value[0] + '" ' + value[1] + ' />';
					else
						prefix += '<img src="[##_ATTACH_PATH_##]/' + value[0] + '" ' + value[1] + ' />';
				}
			}
		}
		TTCommand("Raw", prefix);
		return true;
	}
	
	var iMazingProperties = new Array();
	iMazingProperties['width'] = 450;
	iMazingProperties['height'] = 350;
	iMazingProperties['frame'] = 'net_imazing_frame_none';
	iMazingProperties['transition'] = 'net_imazing_show_window_transition_alpha';
	iMazingProperties['navigation'] = 'net_imazing_show_window_navigation_simple';
	iMazingProperties['slideshowInterval'] = 10;
	iMazingProperties['page'] = 1;
	iMazingProperties['align'] = 'h';
	iMazingProperties['skinPath'] = '<?php
	echo $service['path'];?>/script/gallery/iMazing/';
	
	function viewImazing()
	{
		try
		{
			var oSelect = document.forms[0].fileList;
			if (oSelect.selectedIndex < 0) {
				alert("<?php
	echo _t('파일을 선택하십시오');?>");
				return false;
			}
			var value = oSelect.options[oSelect.selectedIndex].value.split("|");
			
			var fileList = '';
			var ignored = false;
			for (var i = 0; i<oSelect.length; i++) {
				if (!oSelect.options[i].selected) continue;
				file = (oSelect[i].value.substr(oSelect[i].value,oSelect[i].value.indexOf('|')));				
				if(new RegExp("\\.(jpe?g|gif|png)$", "gi").exec(file))
					fileList += file+'||';
				else
					ignored = true;
			}
			if(fileList == '') {
				alert("<?php
	echo _t('이미지 파일만 적용할 수 있습니다');?>");
				return false;
			}
			if(ignored)
				alert("<?php
	echo _t('iMazing 갤러리는 JPG,PNG,GIF 파일만 지원됩니다\n그 외의 형식은 목록에서 제외했습니다');?>");
			fileList = fileList.substr(0,fileList.length-1);
			var Properties = '';
			for (var name in iMazingProperties) {
				Properties += name+'='+iMazingProperties[name]+' ';
			}
			try {
				if(editor.editMode == "WYSIWYG") {
					TTCommand("Raw", '<img class="tatterImazing" src="' + servicePath + adminSkin + '/image/spacer.gif" width="400" height="300" longdesc="iMazing|' + fileList + '|' + Properties + '|" />');
					return true;
				}
			} catch(e) { }
	
			insertTag('[##_iMazing|' + fileList + '|' + Properties +'|_##]', '');
			return true;
		} catch(e) {
			return false;
		}
	}
	
	function viewGallery()
	{
		try
		{
			var oSelect = document.forms[0].fileList;
			if (oSelect.selectedIndex < 0) {
				alert("<?php
	echo _t('파일을 선택하십시오.');?>");
				return false;
			}
			var value = oSelect.options[oSelect.selectedIndex].value.split("|");
			
			var fileList = '';
			for (var i = 0; i<oSelect.length; i++) {
				if (!oSelect.options[i].selected) continue;
				file = (oSelect[i].value.substr(oSelect[i].value,oSelect[i].value.indexOf('|')));
				if(new RegExp("\\.(gif|jpe?g|png)$", "gi").exec(file))
					fileList += file+'||';
			}
			if(fileList == '') {
				alert("<?php
	echo _t('이미지 파일만 삽입 가능합니다.');?>");
				return false;
			}
			fileList = fileList.substr(0,fileList.length-1);
			try {
				if(editor.editMode == "WYSIWYG") {
					TTCommand("Raw", '<img class="tatterGallery" src="' + servicePath + adminSkin + '/image/spacer.gif" width="400" height="300" longdesc="Gallery|' + fileList + '|width=&quot;400&quot; height=&quot;300&quot;" />');
					return true;
				}
			} catch(e) { }
			insertTag('[##_Gallery|' + fileList + '|width="400" height="300"_##]', '');
			return true;
		} catch(e) {
			return false;
		}
	}	
	
	function viewJukebox()
	{
		try
		{
			var oSelect = document.forms[0].fileList;
			if (oSelect.selectedIndex < 0) {
				alert("<?php
	echo _t('파일을 선택하십시오.');?>");
				return false;
			}
			var value = oSelect.options[oSelect.selectedIndex].value.split("|");
			
			var fileList = '';
			for (var i = 0; i<oSelect.length; i++) {
				if (!oSelect.options[i].selected) continue;
				file = (oSelect[i].value.substr(oSelect[i].value,oSelect[i].value.indexOf('|')));
				if(new RegExp("\\.mp3$", "gi").exec(file))
				{
					fileList += file + "|";
					if(result = new RegExp("(.*)\\.mp3", "gi").exec(oSelect.options[i].text))
						fileList += result[1].replaceAll("|","") + "|";
					else
						fileList += "|";
				}
			}
			if(fileList == '') {
				alert("<?php
	echo _t('MP3 파일만 삽입 가능합니다.');?>");
				return false;
			}
			fileList = fileList.substr(0,fileList.length-1);
			try {
				if(editor.editMode == "WYSIWYG") {
					TTCommand("Raw", '<img class="tatterJukebox" src="' + servicePath + adminSkin + '/image/spacer.gif" width="200" height="30" longdesc="Jukebox|' + fileList + '|autoplay=0 visible=1|" />');
					return true;
				}
			} catch(e) { }
			insertTag('[##_Jukebox|' + fileList + '|autoplay=0 visible=1|_##]', '');
			return true;
		} catch(e) {
			return false;
		}
	}	
//]]>
</script>
<?php
}
function printEntryFileList($attachments,$param){
	global $owner,$service,$blogURL,$adminSkinSetting;
	if(empty($attachments)||(strpos($attachments[0]['name'],'.gif')===false&&strpos($attachments[0]['name'],'.jpg')===false&&strpos($attachments[0]['name'],'.png')===false)){
		$fileName="{$service['path']}{$adminSkinSetting['skin']}/image/spacer.gif";
	}else{
		$fileName="{$service['path']}/attach/$owner/{$attachments[0]['name']}";
	}?>
											<div id="previewSelected" style="width: 120px; height: 90px;"><span class="text"><?php
	echo _t('미리보기');?></span></div>
											
											<div id="attachManagerSelectNest">				
												<span id="attachManagerSelect">
													<select id="fileList" name="fileList" multiple="multiple" size="8" onchange="selectAttachment();">
<?php
	$initialFileListForFlash='';
	$enclosureFileName='';
	foreach($attachments as $i=>$attachment){
		if(strpos($attachment['mime'],'application')!==false){
			$class='class="MimeApplication"';
		}elseif(strpos($attachment['mime'],'audio')!==false){
			$class='class="MimeAudio"';
		}elseif(strpos($attachment['mime'],'image')!==false){
			$class='class="MimeImage"';
		}elseif(strpos($attachment['mime'],'message')!==false){
			$class='class="MimeMessage"';
		}elseif(strpos($attachment['mime'],'model')!==false){
			$class='class="MimeModel"';
		}elseif(strpos($attachment['mime'],'multipart')!==false){
			$class='class="MimeMultipart"';
		}elseif(strpos($attachment['mime'],'text')!==false){
			$class='class="MimeText"';
		}elseif(strpos($attachment['mime'],'video')!==false){
			$class='class="MimeVideo"';
		}else{
			$class='';
		}
		if(!empty($attachment['enclosure'])&&$attachment['enclosure']==1){
			$style='style="background-color:#c6a6e7; color:#000000"';
			$enclosureFileName=$attachment['name'];
		}else{
			$style='';
		}
		$value=htmlspecialchars(getAttachmentValue($attachment));
		$label=htmlspecialchars(getPrettyAttachmentLabel($attachment));
		$initialFileListForFlash.=escapeJSInAttribute($value.'(_!'.$label.'!^|');?>
		<option  <?php
		echo $style;?> value="<?php
		echo $value;?>"><?php
		echo $label;?></option>
<?php
	}?>
													</select>
												</span>
											</div>
											
											<script type="text/javascript">
												//<![CDATA[
													function addAttachment() {
														if(isIE) {
															document.frames[0].document.forms[0].action = "<?php
	echo $param['singleUploadPath'];?>";
															document.frames[0].document.forms[0].attachment.click();
														} else {
															var attachHidden = document.getElementById('attachHiddenNest');
															attachHidden.contentDocument.forms[0].action = "<?php
	echo $param['singleUploadPath'];?>";
															attachHidden.contentDocument.forms[0].attachment.click();
														}
													}
													
													function deleteAttachment() {
														var fileList = document.getElementById('fileList');		
														
														if (fileList.selectedIndex < 0) {
															alert("<?php
	echo _t('삭제할 파일을 선택해 주십시오\t');?>");
															return false;
														}
														
														try {
															
															var targetStr = '';
															deleteFileList = new Array();
															for(var i=0; i<fileList.length; i++) {
																if(fileList[i].selected) {
																	var name = fileList[i].value.split("|")[0];
																	targetStr += name+'!^|';
																	deleteFileList.push(i);
																}
															}
														} catch(e) {
															alert("<?php
	echo _t('파일을 삭제하지 못했습니다');?> ::"+e.message);
														}
												
														var request = new HTTPRequest("POST", "<?php
	echo $param['deletePath'];?>");
														request.onVerify = function () { 
															return true 
														}
												
														request.onSuccess = function() {				
															for(var i=deleteFileList.length-1; i>=0; i--) {
																fileList.remove(deleteFileList[i]);	
															}
															
															if (fileList.options.length == 0)
																document.getElementById('previewSelected').innerHTML = '';
															else {
																fileList.selectedIndex = 0;
																selectAttachment();
															}
															refreshAttachFormSize();
															refreshFileSize();
														}
														
														request.onError = function() {
															alert("<?php
	echo _t('파일을 삭제하지 못했습니다');?>");
														}
														request.send("names="+targetStr);
													}

													function selectAttachment() {
														try {
														width = document.getElementById('previewSelected').clientWidth;
														height = document.getElementById('previewSelected').clientHeight;
														var code = '';
														var fileList = document.getElementById('fileList');
														if (fileList.selectedIndex < 0)
															return false;
														var fileName = fileList.value.split("|")[0];
														
														if((new RegExp("\\.(gif|jpe?g|png)$", "gi").exec(fileName))) {
															try {
																var width = new RegExp('width="(\\d+)').exec(fileList.value);
																width = width[1];
																var height = new RegExp('height="(\\d+)').exec(fileList.value);
																height = height[1];
																if(width > 120) {
																	height = 120 / width * height;
																	width = 120;
																}
																if(height > 90) {
																	width = 90 / height * width;
																	height = 90;
																}
																document.getElementById('previewSelected').innerHTML = '<img src="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'?randseed='+Math.random()+'" width="' + parseInt(width) + '" height="' + parseInt(height) + '" alt="" style="margin-top: ' + ((90-height)/2) + 'px" onerror="this.src=\'<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/image/spacer.gif\'"/>';																
															}
															catch(e) { }
															return false;
														}
														
														if((new RegExp("\\.(mp3)$", "gi").exec(fileName))) {
															var str = getEmbedCode("<?php
	echo $service['path'];?>/script/jukebox/flash/mini.swf","100%","100%", "jukeBox0Flash","#FFFFFF", "sounds=<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/"+fileName+"&autoplay=false", "false");
															writeCode(str, 'previewSelected');
															return false;
														}
														
														if((new RegExp("\\.(swf)$", "gi").exec(fileName))) {			
															
															code = '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="100%" height="100%"><param name="movie" value="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'"/><param name="allowScriptAccess" value="sameDomain" /><param name="menu" value="false" /><param name="quality" value="high" /><param name="bgcolor" value="#FFFFFF"/>';
															code += '<!--[if !IE]> <--><object type="application/x-shockwave-flash" data="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'" width="100%" height="100%"><param name="allowScriptAccess" value="sameDomain" /><param name="menu" value="false" /><param name="quality" value="high" /><param name="bgcolor" value="#FFFFFF"/><\/object><!--> <![endif]--><\/object>';
															
															writeCode(code,'previewSelected');
															return false;
														}
														
														if((new RegExp("\\.(mov)$", "gi").exec(fileName))) {			
															code = '<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" codebase="http://www.apple.com/qtactivex/qtplugin.cab" width="'+width+'" height="'+height+'"><param name="src" value="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'"/><param name="controller" value="true"><param name="autoplay" value="false"><param name="scale" value="Aspect">';
															code += '<!--[if !IE]> <--><object type="video/quicktime" data="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'" width="'+width+'" height="'+height+'" showcontrols="true" TYPE="video/quicktime" scale="Aspect" nomenu="true"><param name="showcontrols" value="true"><param name="autoplay" value="false"><param name="scale" value="ToFit"><\/object><!--> <![endif]--><\/object>';
															writeCode(code,'previewSelected');
															return false;
														}
													
														if((new RegExp("\\.(mp2|wma|mid|midi|mpg|wav|avi|mp4)$", "gi").exec(fileName))) {
															code ='<object width="'+width+'" height="'+height+'" classid="CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95" codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701" standby="Loading for you" type="application/x-oleobject" align="middle">';		
															code +='<param name="FileName" value="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'">';
															code +='<param name="ShowStatusBar" value="False">';
															code +='<param name="DefaultFrame" value="mainFrame">';
															code +='<param name="autoplay" value="false">';
															code +='<param name="showControls" value="true">';
															code +='<embed type="application/x-mplayer2" pluginspage = "http://www.microsoft.com/Windows/MediaPlayer/" src="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'" align="middle" width="'+width+'" height="'+height+'" showControls="true" defaultframe="mainFrame" showstatusbar="false" autoplay="false"><\/embed>';
															code +='<\/object>';
															
															writeCode(code,'previewSelected');
															
															return false;
														}
														
														if((new RegExp("\\.(rm|ram)$", "gi").exec(fileName))) {		
														/*
															code = '<object classid="clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA" width="'+width+'" height="'+height+'"><param name="src" value="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'"/><param name="CONTROLS" value="imagewindow"><param name="AUTOGOTOURL" value="FALSE"><param name="CONSOLE" value="radio"><param name="AUTOSTART" value="TRUE">';
															code += '<!--[if !IE]> <--><object type="audio/x-pn-realaudio-plugin" data="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/'+fileName+'" width="'+width+'" height="'+height+'" ><param name="CONTROLS" value="imagewindow"><param name="AUTOGOTOURL" value="FALSE"><param name="CONSOLE" value="radio"><param name="AUTOSTART" value="TRUE"><\/object><!--> <![endif]--><\/object>';			
														*/
														}
														
														if (code == undefined || code == '') {
															document.getElementById('previewSelected').innerHTML = "<table width=\"100%\" height=\"100%\"><tr><td valign=\"middle\" align=\"center\"><?php
	echo _t('미리보기');?><\/td><\/tr><\/table>";
															return true;
														}
														
																
														
														return false;
														} catch (e) {
															document.getElementById('previewSelected').innerHTML = "<table width=\"100%\" height=\"100%\"><tr><td valign=\"middle\" align=\"center\"><?php
	echo _t('미리보기');?><\/td><\/tr><\/table>";	
															alert(e.message);
															return true;
														}
													}				

													function downloadAttachment() {
														try {
															var fileList = document.getElementById('fileList');
															if (fileList.selectedIndex < 0) {
																return false;
															}
															for(var i=0; fileList.length; i++) {
																if (fileList[i].selected) {
																	var fileName = fileList[i].value.split("|")[0];
																	if(STD.isIE) {
																		document.getElementById('fileDownload').innerHTML='<iframe style="display:none;" src="'+blogURL+'\/attachment\/'+fileName+'"><\/iframe>';
																		
																	} else {
																		window.location = blogURL+'/attachment/'+fileName;
																	}
																	break;
																}
															}
														} catch(e) {
															alert(e.message);
														}
													}

													function disablePageManager() {
														try {
															pageHolding = entryManager.pageHolder.isHolding;
															entryManager.pageHolder.isHolding = function () {
																return false;
															}
															STD.removeEventListener(window);					
															window.removeEventListener("beforeunload", PageMaster.prototype._onBeforeUnload, false);					
														} catch(e) {
														}
													}
													
													STD.addEventListener(window);
													window.addEventListener("load", disablePageManager, false);
													
													function enablePageManager() {
														try {
															entryManager.pageHolder.isHolding = pageHolding ;
															STD.addEventListener(window);
															window.addEventListener("beforeunload", PageMaster.prototype._onBeforeUnload, false);				
														} catch(e) {
														}	
													}
													
													function stripLabelToValue(fileLabel) {
														var pos = fileLabel.lastIndexOf('(');
														return fileLabel.substring(0,pos-1);	
													}
													
													function refreshAttachFormSize() {
														fileListObj = document.getElementById('fileList');
														fileListObj.setAttribute('size',Math.max(8,Math.min(fileListObj.length,30)));
													}
													
													function refreshAttachList() {
														var request = new HTTPRequest("POST", "<?php
	echo $param['refreshPath'];?>");
														request.onVerify = function () { 	
															return true 
														}
														request.onSuccess = function() {
															var fileListObj = document.getElementById("attachManagerSelect");
															fileListObj.innerHTML = this.getText();
															refreshAttachFormSize();
															//getUploadObj().setAttribute('width',1)
															//getUploadObj().setAttribute('height',1)
															
															if (isIE || isMoz) {
																document.getElementById('uploadBtn').style.display  = 'inline';
																document.getElementById('stopUploadBtn').style.display  = 'none';			
															} else {
																document.getElementById('uploadBtn').disabled = false;					
															}
															
															document.getElementById('uploaderNest').innerHTML = uploaderStr
															refreshFileSize();						
															setTimeout("enablePageManager()", 2000);						
														}
														request.onError = function() {}
														request.send();					
													}
													
													function uploadProgress(target,loaded, total) {
														loaded = Number(loaded);
														total = Number(total);
														var fileListObj = document.getElementById("fileList");					
														for(var i=0; i<fileListObj.length; i++) {
															if (fileListObj[i].getAttribute("value") == target) {
																fileListObj[i].innerHTML = target+" "+(Math.ceil(100*loaded/total))+"%";
																break;
															}
														}
													}
													
													function uploadComplete(target,size) {
														loaded = Number(loaded);
														total = Number(total);
														var fileListObj = document.getElementById("fileList");
														for(var i=0; i<fileListObj.length; i++) {
															if (fileListObj[i].getAttribute("value") == target) {
																fileListObj[i].innerHTML = target+" "+(Math.ceil(100*loaded/total))+"%";
																break;
															}
														}				
													}
													
													function addFileList(list) {
														var fileListObj = document.getElementById("fileList");
														var listTemp = list.split("(_!");
														var fileLabel = listTemp[0];
														var fileValue = listTemp[1];
														var fileListObj = document.getElementById("fileList");
														for(var i=0; i<fileListObj.length; i++) {
															if (stripLabelToValue(fileLabel).indexOf(fileListObj[i].getAttribute("value")) != -1) {
																var oOption = document.createElement("option");
																oOption.innerHTML= fileLabel;
																oOption.setAttribute("value",fileValue);
																fileListObj.replaceChild(oOption,fileListObj[i]);
																break;
															}
														}
													}
													
													function newLoadItem(fileValue) {
														var fileListObj = document.getElementById("fileList");
														var fileListObj = document.getElementById("fileList");
														for(var i=0; i<fileListObj.length; i++) {
															if (fileValue.indexOf(fileListObj[i].getAttribute("value")) != -1) {
																fileListObj[i].style.backgroundColor="#C8DAF3";
																break;
															}
														}	
													}
													
													function setFileList() {
														try {
															list = getUploadObj().GetVariable("/:listStr");						
														} catch(e) {
															alert(e.message);
														}
														var fileListObj = document.getElementById("fileList");										
														var listTemp = list.split("!^|");					
														for(var i=0; i<listTemp.length; i++) {						
															temp = listTemp[i].split('(_!');
															var fileName = temp[0];
															var fileSize = temp[1];
															if(fileName == undefined || fileSize == undefined) 
																continue;							
															var oOption = document.createElement("option");
															oOption.innerHTML= fileName+' ('+Math.ceil((fileSize/1024))+'KB) <?php
	echo _t('대기 중..');?>';
															oOption.setAttribute("value",fileName);
															oOption.style.backgroundColor="#A4C3F0";
															fileListObj.insertBefore(oOption,fileListObj[i]);
															if(i == 0) {
																newLoadItem(fileName);
															}
														}
														fileListObj.setAttribute('size',Math.max(8,Math.min(fileListObj.length,30)));
														getUploadObj().setAttribute('width',416);
														getUploadObj().setAttribute('height',25);
														//document.getElementById('uploadBtn').disabled=true;		
														if(isIE || isMoz) {
															document.getElementById('uploadBtn').style.display  = 'none';
															document.getElementById('stopUploadBtn').style.display  = 'inline';
														} else {
															document.getElementById('uploadBtn').disabled = true;
														}
													}
													
													function selectFileList(value) {
														selectedFiles = value.split("!^|");
														var fileListObj = document.getElementById("fileList");
														for(var i=0; i<fileListObj.length; i++) {
															for(var j=0; j<selectedFiles.length; j++) {
																if (fileListObj[i].getAttribute("value") == selectedFiles[j]) {
																	fileListObj[i].setAttribute("selected","selected");
																	selectAttachment();
																	break;
																}
																
																fileListObj[i].setAttribute("selected","");							
															}
														}
														refreshAttachFormSize();
													}
													
													function disabledDeleteBtn() {
														if(document.getElementById('fileList').length>0) {
															document.getElementById('deleteBtn').disabled = false;
														} else {
															document.getElementById('deleteBtn').disabled = true;
														}
													}
													
													function removeUploadList(list) {
														selectedFiles = list.split("!^|");
														var fileListObj = document.getElementById("fileList");
														for(var j=0; j<selectedFiles.length; j++) {
															for(var i=0; i<fileListObj.length; i++) {						
																if(selectedFiles[j] == undefined) 
																	continue;
																if (fileListObj[i].getAttribute("value") == selectedFiles[j]) {								
																	fileListObj.remove(i);
																	break;
																}
															}
														}
														refreshAttachFormSize();
													}
													
													function browser() {
														disablePageManager();
														getUploadObj().SetVariable('/:openBrowser','true');
													}
													
													function stopUpload() {
														getUploadObj().SetVariable('/:stopUpload','true');
													}
													
													function refreshFileSize() {
														try {
															var request = new HTTPRequest("POST", "<?php
	echo $param['fileSizePath'];?>");
															request.onVerify = function () {
																return true;
															}
															
															request.onSuccess = function() {
																try {
																	var result = this.getText("/response/result");
																	document.getElementById('fileSize').innerHTML = result;
																} catch(e) {
																
																}
															}
															
															request.onError = function() {
															}
															//disablePageManager();
															request.send();
															
														} catch(e) {
															alert(e.message);
														}
													}
													function getUploadObj() {
														try {		
															var result;			
															if(isIE) 
																result = document.getElementById("uploader");
															else
																result = document.getElementById("uploader2");
															if (result == null)
																return false;
															else
																return result;
														} catch(e) {
															return false;
														}
													}
													refreshAttachFormSize();
												//]]>
											</script>
											
<?php
	require_once '../../../../script/detectFlash.inc';
	$maxSize=min(return_bytes(ini_get('upload_max_filesize')),return_bytes(ini_get('post_max_size')));?>

											<div id="uploaderNest">
												<script type="text/javascript">
													//<![CDATA[
														var requiredMajorVersion = 8;
														var requiredMinorVersion = 0;
														var requiredRevision = 0;
														var jsVersion = 1.0;
														
														var hasRightVersion = DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision);
														uploaderStr = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" id="uploader"'
															+ 'width="0" height="0"'
															+ 'codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab">'
															+ '<param name="movie" value="<?php
	echo $service['path'];?>/script/uploader/uploader.swf" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" /><param name="scale" value="noScale" /><param name="wmode" value="transparent" /><param name="FlashVars" value="uploadPath=<?php
	echo $param['uploadPath'];?>&labelingPath=<?php
	echo $param['labelingPath'];?>&maxSize=<?php
	echo $maxSize;?>&sessionName=TSSESSION&sessionValue=<?php
	echo $_COOKIE['TSSESSION'];?>" />'
															+ '<embed id="uploader2" src="<?php
	echo $service['path'];?>/script/uploader/uploader.swf" flashvars="uploadPath=<?php
	echo $param['uploadPath'];?>&labelingPath=<?php
	echo $param['labelingPath'];?>&maxSize=<?php
	echo $maxSize;?>&sessionName=TSSESSION&sessionValue=<?php
	echo $_COOKIE['TSSESSION'];?>" width="1" height="1" align="middle" wmode="transparent" quality="high" bgcolor="#ffffff" scale="noScale" allowscriptaccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" /><\/embed><\/object>';
														
														if (hasRightVersion && (isMoz || isIE)) {
															if(<?php
	echo (isset($service['flashuploader'])&&$service['flashuploader']===false)?'false':'true';?>){ writeCode(uploaderStr); }
														}
													//]]>
												</script>
											</div>
<?php
}
function printEntryFileUploadButton($entryId){
	global $owner,$service;?>
										<div id="fileUploadNest" class="container">
											<script type="text/javascript">
												//<![CDATA[
													//var attachId = 0;
													function makeCrossDamainSubmit(uri,userAgent) {
														var property =new Array();
														property['ie'] = new Array();
														property['ie']['width'] = '225px';
														property['ie']['height'] = '25px';		
														
														property['moz'] = new Array();
														property['moz']['width'] = '215px';
														property['moz']['height'] = '22px';		
														
														property['etc'] = new Array();
														property['etc']['width'] = '240px';
														property['etc']['height'] = '22px';
														
																
														var str = '<iframe id="attachHiddenNest" src="' + uri + '" style="display: block; height: ' + property[userAgent]['height']+'; width: ' + property[userAgent]['width'] + ';" frameborder="no" scrolling="no"><\/iframe>';						
														document.getElementById('fileUploadNest').innerHTML = str + document.getElementById('fileUploadNest').innerHTML;
														/*if (document.getElementById('attachHiddenNest_' + (attachId - 1))) {
															document.getElementById('attachHiddenNest_' + (attachId - 1)).style.display = "none";
															document.getElementById('attachHiddenNest_' + (attachId - 1)).style.width = 0;
															document.getElementById('attachHiddenNest_' + (attachId - 1)).style.height = 0;
														}
														attachId++;*/
													}
													
													if (getUploadObj()) {
														try {
															document.write('<input type="button" id="uploadBtn" class="upload-button input-button" value="<?php
	echo _t('파일 업로드');?>" onclick="browser(); return false;" />');
															document.write('<input type="button" id="stopUploadBtn" class="stop-button input-button" value="<?php
	echo _t('업로드 중지');?>" onclick="stopUpload(); return false;" style="display: none;" />');			
														} catch(e) {
															
														}								
													} else {
														if(isIE) {
															makeCrossDamainSubmit(blogURL + "/owner/entry/attach/<?php
	echo $entryId;?>","ie");
														} else if(isMoz) {
															makeCrossDamainSubmit(blogURL + "/owner/entry/attach/<?php
	echo $entryId;?>","moz");
														} else {
															makeCrossDamainSubmit(blogURL + "/owner/entry/attach/<?php
	echo $entryId;?>","etc");
														}
													}
												//]]>
											</script>
												
											<input type="button" id="deleteBtn" class="input-button" value="<?php
	echo _t('삭제하기');?>" onclick="deleteAttachment();" />
											<div id="fileSize">
												<?php
	echo getAttachmentSizeLabel($owner,$entryId);?>
											</div>
											<div id="fileDownload" class="system-message" style="display: none;"></div>
										</div>
<?php
}
function printEntryEditorProperty($alt=NULL){
	global $service;
	$fixPosition=getUserSetting('editorPropertyPositionFix',0);?>
											<script type="text/javascript">
												//<![CDATA[
													function checkResampling(flag, type, num) {
														resampleCheckbox = document.getElementById("propertyImage" + type + "_resample" + num);
														watermarkCheckbox = document.getElementById("propertyImage" + type + "_watermark" + num);
														
														if (flag == "resample" && resampleCheckbox.checked == false && watermarkCheckbox.checked == true)
															watermarkCheckbox.checked = false;
														else if (flag == "watermark" && watermarkCheckbox.checked == true && resampleCheckbox.checked == false)
															resampleCheckbox.checked = true;
													}
												//]]>
											</script>
												
											<div id="propertyHyperLink" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyHyperLink-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyHyperLink-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('하이퍼링크');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyInsertObject_url"><?php
	echo _t('URL');?></label></dt>
														<dd><input type="text" id="propertyHyperLink_url" class="input-text" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyInsertObject_type"><?php
	echo _t('대상');?></label></dt>
														<dd>
															<select id="propertyHyperLink_target" style="width: 105px" >
																<option value="_blank"><?php
	echo _t('새창');?></option>
																<option value="_self"><?php
	echo _t('현재창');?></option>
																<option value=""><?php
	echo _t('사용 안함');?></option>
															</select>
														</dd>
													</dl>
												</div>
												<div class="button-box">
													<span class="insert-button button" onclick="TTCommand('ExcuteCreateLink')"><span class="text"><?php
	echo _t('적용하기');?></span></span>
													<span class="divider"> | </span>
													<span class="cancel-button button" onclick="TTCommand('CancelCreateLink')"><span class="text"><?php
	echo _t('취소하기');?></span></span>
												</div>
											</div>

											<div id="propertyInsertObject" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyInsertObject-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyInsertObject-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('오브젝트 삽입');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyInsertObject_type"><?php
	echo _t('유형');?></label></dt>
														<dd>
															<select id="propertyInsertObject_type" style="width: 105px" onchange="getObject('propertyInsertObject_part_url').style.display=getObject('propertyInsertObject_part_raw').style.display='none';getObject('propertyInsertObject_part_' + this.value).style.display = 'block'">
																<option value="url"><?php
	echo _t('주소입력');?></option>
																<option value="raw"><?php
	echo _t('코드 붙여넣기');?></option>
															</select>
														</dd>
													</dl>
													<dl id="propertyInsertObject_part_url" class="line">
														<dt class="property-name"><label for="propertyInsertObject_url"><?php
	echo _t('파일 주소');?></label></dt>
														<dd><input type="text" id="propertyInsertObject_url" class="input-text" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl id="propertyInsertObject_part_raw" class="line" style="display: none">
														<dt class="property-name"><label for="propertyInsertObject_chunk"><?php
	echo _t('코드');?></label></dt>
														<dd>
															<textarea id="propertyInsertObject_chunk" cols="30" rows="10"></textarea>
														</dd>
													</dl>
												</div>
												<div class="button-box">
													<span class="insert-button button" onclick="TTCommand('InsertObject')"><span class="text"><?php
	echo _t('삽입하기');?></span></span>
													<span class="divider"> | </span>
													<span class="cancel-button button" onclick="TTCommand('HideObjectBlock')"><span class="text"><?php
	echo _t('취소하기');?></span></span>
												</div>
											</div>
											
											<div id="propertyImage1" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyImage1-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyImage1-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Image');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyImage1_width1"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage1_width1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage1_alt1"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage1_alt1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage1_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage1_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage1_resample1" onclick="checkResampling('resample', 1, 1); editor.setProperty()" /> <label for="propertyImage1_resample1"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage1_watermark1" onclick="checkResampling('watermark', 1, 1); editor.setProperty()" /> <label for="propertyImage1_watermark1"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
											</div>
											
											<div id="propertyImage2" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyImage2-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyImage2-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Image');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('첫번째 이미지');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_width1"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage2_width1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_alt1"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage2_alt1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage2_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage2_resample1" onclick="checkResampling('resample', 2, 1); editor.setProperty()" /> <label for="propertyImage2_resample1"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage2_watermark1" onclick="checkResampling('watermark', 2, 1); editor.setProperty()" /> <label for="propertyImage2_watermark1"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('두번째 이미지');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_width2"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage2_width2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_alt2"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage2_alt2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage2_resample2"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage2_caption2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage2_resample2" onclick="checkResampling('resample', 2, 2); editor.setProperty()" /> <label for="propertyImage2_resample2"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage2_watermark2" onclick="checkResampling('watermark', 2, 2); editor.setProperty()" /> <label for="propertyImage2_watermark2"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
											</div>
											
											<div id="propertyImage3" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyImage3-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyImage3-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Image');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('첫번째 이미지');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_width1"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_width1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_alt1"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_alt1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage3_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage3_resample1" onclick="checkResampling('resample', 3, 1); editor.setProperty()" /> <label for="propertyImage3_resample1"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage3_watermark1" onclick="checkResampling('watermark', 3, 1); editor.setProperty()" /> <label for="propertyImage3_watermark1"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('두번째 이미지');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_width2"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_width2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_alt2"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_alt2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_caption2"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage3_caption2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage3_resample2" onclick="checkResampling('resample', 3, 2); editor.setProperty()" /> <label for="propertyImage3_resample2"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage3_watermark2" onclick="checkResampling('watermark', 3, 2); editor.setProperty()" /> <label for="propertyImage3_watermark2"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('세번째 이미지');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_width3"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_width3" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_alt3"><?php
	echo _t('대체 텍스트');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyImage3_alt3" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyImage3_caption3"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyImage3_caption3" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
<?php
	if(extension_loaded('gd')){?>
													<dl class="resample-property-box line">
														<dd>
															<input type="checkbox" id="propertyImage3_resample3" onclick="checkResampling('resample', 3, 3); editor.setProperty()" /> <label for="propertyImage3_resample3"><?php
		echo _t('이미지에 리샘플링을 적용합니다.');?></label><br />
															<input type="checkbox" id="propertyImage3_watermark3" onclick="checkResampling('watermark', 3, 3); editor.setProperty()" /> <label for="propertyImage3_watermark3"><?php
		echo _t('이미지에 워터마크를 찍습니다.');?></label>
														</dd>
													</dl>
<?php
	}?>
												</div>
											</div>
											
											<div id="propertyObject" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyObject-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyObject-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Object');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyObject_width"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject_width" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject_height"><?php
	echo _t('높이');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject_height" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject_chunk"><?php
	echo _t('코드');?></label></dt>
														<dd><textarea id="propertyObject_chunk" cols="30" rows="10" onkeyup="editor.setProperty()"></textarea></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyObject1" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyObject1-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyObject1-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Object 1');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyObject1_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject1_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject1_filename1"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject1_filename1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyObject2" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyObject2-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyObject2-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Object');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('첫번째 오브젝트');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject2_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject2_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject2_filename1"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject2_filename1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('두번째 오브젝트');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject2_caption2"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject2_caption2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject2_filename2"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject2_filename2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyObject3" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyObject3-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyObject3-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Object');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('첫번째 오브젝트');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_caption1"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject3_caption1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_filename1"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject3_filename1" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('두번째 오브젝트');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_caption2"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject3_caption2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_filename2"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject3_filename2" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('세번째 오브젝트');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_caption3"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyObject3_caption3" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyObject3_filename3"><?php
	echo _t('파일명');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyObject3_filename3" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyiMazing" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyiMazing-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyiMazing-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('iMazing');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('설정');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_width"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyiMazing_width" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_height"><?php
	echo _t('높이');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyiMazing_height" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_frame"><?php
	echo _t('테두리');?></label></dt>
														<dd>
															<select id="propertyiMazing_frame" onchange="editor.setProperty()">
																<option value="net_imazing_frame_none"><?php
	echo _t('테두리 없음');?></option>
															</select>
														</dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_tran"><?php
	echo _t('장면전환효과');?></label></dt>
														<dd>
															<select id="propertyiMazing_tran" onchange="editor.setProperty()">
																<option value="net_imazing_show_window_transition_none"><?php
	echo _t('효과없음');?></option>
																<option value="net_imazing_show_window_transition_alpha"><?php
	echo _t('투명전환');?></option>
																<option value="net_imazing_show_window_transition_contrast"><?php
	echo _t('플래쉬');?></option>
																<option value="net_imazing_show_window_transition_sliding"><?php
	echo _t('슬라이딩');?></option>
															</select>
														</dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_nav"><?php
	echo _t('내비게이션');?></label></dt>
														<dd>
															<select id="propertyiMazing_nav" onchange="editor.setProperty()">
																<option value="net_imazing_show_window_navigation_none"><?php
	echo _t('기본');?></option>
																<option value="net_imazing_show_window_navigation_simple"><?php
	echo _t('심플');?></option>
																<option value="net_imazing_show_window_navigation_sidebar"><?php
	echo _t('사이드바');?></option>
															</select>
														</dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><?php
	echo _t('슬라이드쇼 간격');?></dt>
														<dd><input type="text" class="input-text" id="propertyiMazing_sshow" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><?php
	echo _t('화면당 이미지 수');?></dt>
														<dd><input type="text" class="input-text" id="propertyiMazing_page" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_align"><?php
	echo _t('정렬방법');?></label></dt>
														<dd>
															<select id="propertyiMazing_align" onchange="editor.setProperty()">
																<option value="h"><?php
	echo _t('가로');?></option>
																<option value="v"><?php
	echo _t('세로');?></option>
															</select>
														</dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyiMazing_caption"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyiMazing_caption" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('파일');?></div>
													<dl class="file-list-line line">
														<dd>
															<select id="propertyiMazing_list" class="file-list" size="10" onchange="editor.listChanged('propertyiMazing_list')" onclick="editor.listChanged('propertyiMazing_list')"></select>
														</dd>
													</dl>
													<div class="button-box">
														<span class="up-button button" onclick="editor.moveUpFileList('propertyiMazing_list')" title="<?php
	echo _t('선택한 항목을 위로 이동합니다.');?>"><span class="text"><?php
	echo _t('위로');?></span></span>
														<span class="divider"> | </span>
														<span class="dn-button button" onclick="editor.moveDownFileList('propertyiMazing_list')" title="<?php
	echo _t('선택한 항목을 아래로 이동합니다.');?>"><span class="text"><?php
	echo _t('아래로');?></span></span>
													</div>
													<div id="propertyiMazing_preview" class="preview-box" style="display: none;"></div>
												</div>
											</div>
											
											<div id="propertyGallery" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyGallery-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyGallery-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Gallery');?></h4>
												
												<div class="group">
													<div class="title"><?php
	echo _t('설정');?></div>
													<dl class="line">
														<dt class="property-name"><label for="propertyGallery_width"><?php
	echo _t('최대너비');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyGallery_width" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyGallery_height"><?php
	echo _t('최대높이');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyGallery_height" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyGallery_caption"><?php
	echo _t('자막');?></label></dt>
														<dd><textarea class="input-text" id="propertyGallery_caption" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);"></textarea></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('파일');?></div>
													<dl class="file-list-line line">
														<dd>
															<select id="propertyGallery_list" class="file-list" size="10" onchange="editor.listChanged('propertyGallery_list')" onclick="editor.listChanged('propertyGallery_list')"></select>
														</dd>
													</dl>
													<div class="button-box">
														<span class="up-button button" onclick="editor.moveUpFileList('propertyGallery_list')" title="<?php
	echo _t('선택한 항목을 위로 이동합니다.');?>"><span class="text"><?php
	echo _t('위로');?></span></span>
														<span class="divider"> | </span>
														<span class="dn-button button" onclick="editor.moveDownFileList('propertyGallery_list')" title="<?php
	echo _t('선택한 항목을 아래로 이동합니다.');?>"><span class="text"><?php
	echo _t('아래로');?></span></span>
													</div>
													<div id="propertyGallery_preview" class="preview-box" style="display: none;"></div>
												</div>
											</div>
											
											<div id="propertyJukebox" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyJukebox-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyJukebox-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Jukebox');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyJukebox_title"><?php
	echo _t('제목');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyJukebox_title" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyJukebox_autoplay"><?php
	echo _t('자동재생');?></label></dt>
														<dd><input type="checkbox" id="propertyJukebox_autoplay" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyJukebox_visibility"><?php
	echo _t('플레이어 보이기');?></label></dt>
														<dd><input type="checkbox" id="propertyJukebox_visibility" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
												
												<div class="group">
													<div class="title"><?php
	echo _t('파일');?></div>
													<dl class="line">
														<dd>
															<select id="propertyJukebox_list" class="file-list" size="10" onchange="editor.listChanged('propertyJukebox_list')" onclick="editor.listChanged('propertyJukebox_list')"></select>
														</dd>
													</dl>
													<div class="button-box">
														<span class="up-button button" onclick="editor.moveUpFileList('propertyJukebox_list')" title="<?php
	echo _t('선택한 항목을 위로 이동합니다.');?>"><span class="text"><?php
	echo _t('위로');?></span></span>
														<span class="divider"> | </span>
														<span class="dn-button button" onclick="editor.moveDownFileList('propertyJukebox_list')" title="<?php
	echo _t('선택한 항목을 아래로 이동합니다.');?>"><span class="text"><?php
	echo _t('아래로');?></span></span>
													</div>
												</div>
											</div>
											
											<div id="propertyEmbed" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyEmbed-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyEmbed-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Embed');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyEmbed_width"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyEmbed_width" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyEmbed_height"><?php
	echo _t('높이');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyEmbed_height" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyEmbed_src"><acronym class="text" title="Uniform Resource Locator">URL</acronym></label></dt>
														<dd><input type="text" class="input-text" id="propertyEmbed_src" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyFlash" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyFlash-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyFlash-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('Embed');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyFlash_width"><?php
	echo _t('폭');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyFlash_width" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyFlash_height"><?php
	echo _t('높이');?></label></dt>
														<dd><input type="text" class="input-text" id="propertyFlash_height" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyFlash_src">URL</label></dt>
														<dd><input type="text" class="input-text" id="propertyFlash_src" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
											
											<div id="propertyMoreLess" class="entry-editor-property" style="display: none;">
												<div class="entry-editor-property-option">
													<input type="checkbox" class="checkbox" id="propertyMoreLess-fix-position" onclick="editor.setPropertyPosition(1)"<?php
	echo $fixPosition?' checked="checked"':'';?>/>
													<label for="propertyMoreLess-fix-position"><?php
	echo _t('위치 고정');?></label>
												</div>
												<h4><?php
	echo _t('More/Less');?></h4>
												
												<div class="group">
													<dl class="line">
														<dt class="property-name"><label for="propertyMoreLess_more">More Text</label></dt>
														<dd><input type="text" class="input-text" id="propertyMoreLess_more" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
													<dl class="line">
														<dt class="property-name"><label for="propertyMoreLess_less">Less Text</label></dt>
														<dd><input type="text" class="input-text" id="propertyMoreLess_less" onkeyup="editor.setProperty()" onkeypress="return preventEnter(event);" /></dd>
													</dl>
												</div>
											</div>
<?php
}
function printEntryEditorPalette(){
	global $owner,$service;?>
										<div id="editor-palette" class="container">
											<dl class="font-relatives">
												<dt class="title">
													<span class="label"><?php
	echo _t('폰트 설정');?></span>
												</dt>
												<dd class="command-box">
													<select id="fontFamilyChanger" onchange="editor.execCommand('fontname', false, this.value); this.selectedIndex=0;">
														<option class="head-option"><?php
	echo _t('글자체');?></option>
<?php
	$fontSet=explode('|',_t('fontDisplayName:fontCode:fontFamily'));
	for($i=1;$i<count($fontSet);$i++){
		$fontInfo=explode(':',$fontSet[$i]);
		if(count($fontInfo)==3)
			echo "														<option style=\"font-family: '$fontInfo[1]';\" value=\"'$fontInfo[1]', '$fontInfo[2]'\">$fontInfo[0]</option>";
	}?>
														<option style="font-family: 'Andale Mono';" value="'andale mono',times">Andale Mono</option>
														<option style="font-family: 'Arial';" value="arial,helvetica,sans-serif">Arial</option>
														<option style="font-family: 'Arial Black';" value="'arial black',avant garde">Arial Black</option>
														<option style="font-family: 'Book Antiqua';" value="'book antiqua',palatino">Book Antiqua</option>
														<option style="font-family: 'Comic Sans MS';" value="'comic sans ms',sand">Comic Sans MS</option>
														<option style="font-family: 'Courier New';" value="'courier new',courier,monospace">Courier New</option>
														<option style="font-family: 'Georgia';" value="georgia,'times new roman',times,serif">Georgia</option>
														<option style="font-family: 'Helvetica';" value="helvetica">Helvetica</option>
														<option style="font-family: 'Impact';" value="impact,chicago">Impact</option>
														<option style="font-family: 'Symbol';" value="symbol">Symbol</option>
														<option style="font-family: 'Tahoma';" value="tahoma,arial,helvetica,sans-serif">Tahoma</option>
														<option style="font-family: 'Terminal';" value="terminal,monaco">Terminal</option>
														<option style="font-family: 'Times New Roman';" value="'times new roman',times,serif">Times New Roman</option>
														<option style="font-family: 'Trebuchet MS';" value="'trebuchet ms',geneva">Trebuchet MS</option>
														<option style="font-family: 'Verdana';" value="verdana,arial,helvetica,sans-serif">Verdana</option>
														<option style="font-family: 'Webdings';" value="webdings">Webdings</option>
														<option style="font-family: 'Wingdings';" value="wingdings,'zapf dingbats'">Wingdings</option>
													</select>
													<select id="fontSizeChanger" onchange="TTCommand('FontSize', this.value); this.selectedIndex=0;">
														<option class="head-option"><?php
	echo _t('속성');?></option>
														<optgroup class="size" label="<?php
	echo _t('크기');?>">														
															<option value="1">1 (8 pt)</option>
															<option value="2">2 (10 pt)</option>
															<option value="3">3 (12 pt)</option>
															<option value="4">4 (14 pt)</option>
															<option value="5">5 (18 pt)</option>
															<option value="6">6 (24 pt)</option>
															<option value="7">7 (36 pt)</option>
														</optgroup>
														<optgroup class="header" label="<?php
	echo _t('제목');?>">
															<option value="h3">h3</option>
															<option value="h4">h4</option>
															<option value="h5">h5</option>
															<option value="h6">h6</option>
															<option value="h7">h7</option>
														</optgroup>
													</select>
												</dd>
											</dl>
											<dl class="font-style">
												<dt class="title">
													<span class="label"><?php
	echo _t('폰트 스타일');?></span>
												</dt>
												<dd class="command-box">
													<a id="indicatorBold" class="inactive-class button" href="#void" onclick="TTCommand('Bold');return false;" title="<?php
	echo _t('굵게');?>"><span class="text"><?php
	echo _t('굵게');?></span></a>
													<a id="indicatorItalic" class="inactive-class button" href="#void" onclick="TTCommand('Italic');return false;" title="<?php
	echo _t('기울임');?>"><span class="text"><?php
	echo _t('기울임');?></span></a>
													<a id="indicatorUnderline" class="inactive-class button" href="#void" onclick="TTCommand('Underline');return false;" title="<?php
	echo _t('밑줄');?>"><span class="text"><?php
	echo _t('밑줄');?></span></a>
													<a id="indicatorStrike" class="inactive-class button" href="#void" onclick="TTCommand('StrikeThrough');return false;" title="<?php
	echo _t('취소선');?>"><span class="text"><?php
	echo _t('취소선');?></span></a>
													<a id="indicatorColorPalette" class="inactive-class button" href="#void" onclick="hideLayer('markPalette'); hideLayer('textBox'); toggleLayer('colorPalette'); changeButtonStatus(this, 'colorPalette');return false;" title="<?php
	echo _t('글자색');?>"><span class="text"><?php
	echo _t('글자색');?></span></a>
													<div id="colorPalette" style="display: none;">
														<table cellspacing="0" cellpadding="0">
															<tr>
																<td><a href="#void" onclick="insertColorTag('#008000');return false;"><span class="color-008000">#008000</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#009966');return false;"><span class="color-009966">#009966</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#99CC66');return false;"><span class="color-99CC66">#99CC66</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#999966');return false;"><span class="color-999966">#999966</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#CC9900');return false;"><span class="color-CC9900">#CC9900</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#D41A01');return false;"><span class="color-D41A01">#D41A01</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FF0000');return false;"><span class="color-FF0000">#FF0000</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FF7635');return false;"><span class="color-FF7635">#FF7635</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FF9900');return false;"><span class="color-FF9900">#FF9900</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FF3399');return false;"><span class="color-FF3399">#FF3399</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#9B18C1');return false;"><span class="color-9B18C1">#9B18C1</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#993366');return false;"><span class="color-993366">#993366</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#666699');return false;"><span class="color-666699">#666699</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#0000FF');return false;"><span class="color-0000FF">#0000FF</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#177FCD');return false;"><span class="color-177FCD">#177FCD</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#006699');return false;"><span class="color-006699">#006699</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#003366');return false;"><span class="color-003366">#003366</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#333333');return false;"><span class="color-333333">#333333</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#000000');return false;"><span class="color-000000">#000000</span></a></td>			
																<td><a href="#void" onclick="insertColorTag('#8E8E8E');return false;"><span class="color-8E8E8E">#8E8E8E</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#C1C1C1');return false;"><span class="color-C1C1C1">#C1C1C1</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FFFFFF');return false;"><span class="color-FFFFFF">#FFFFFF</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FFDAED');return false;"><span class="color-FFDAED">#FFDAED</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#C9EDFF');return false;"><span class="color-C9EDFF">#C9EDFF</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#D0FF9D');return false;"><span class="color-D0FF9D">#D0FF9D</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#FAFFA9');return false;"><span class="color-FAFFA9">#FAFFA9</span></a></td>
																<td><a href="#void" onclick="insertColorTag('#E4E4E4');return false;"><span class="color-E4E4E4">#E4E4E4</span></a></td>
															</tr>
														</table>
													</div>
													<a id="indicatorMarkPalette" class="inactive-class button" href="#void" onclick="hideLayer('colorPalette');hideLayer('textBox');toggleLayer('markPalette'); changeButtonStatus(this, 'markPalette');return false;" title="<?php
	echo _t('배경색');?>"><span class="text"><?php
	echo _t('배경색');?></span></a>
													<div id="markPalette" style="display: none;">
														<table cellspacing="0" cellpadding="0">
															<tr>
																<td><a href="#void" onclick="insertMarkTag('#008000');return false;"><span class="color-008000">#008000</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#009966');return false;"><span class="color-009966">#009966</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#99CC66');return false;"><span class="color-99CC66">#99CC66</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#999966');return false;"><span class="color-999966">#999966</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#CC9900');return false;"><span class="color-CC9900">#CC9900</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#D41A01');return false;"><span class="color-D41A01">#D41A01</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FF0000');return false;"><span class="color-FF0000">#FF0000</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FF7635');return false;"><span class="color-FF7635">#FF7635</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FF9900');return false;"><span class="color-FF9900">#FF9900</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FF3399');return false;"><span class="color-FF3399">#FF3399</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#9B18C1');return false;"><span class="color-9B18C1">#9B18C1</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#993366');return false;"><span class="color-993366">#993366</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#666699');return false;"><span class="color-666699">#666699</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#0000FF');return false;"><span class="color-0000FF">#0000FF</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#177FCD');return false;"><span class="color-177FCD">#177FCD</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#006699');return false;"><span class="color-006699">#006699</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#003366');return false;"><span class="color-003366">#003366</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#333333');return false;"><span class="color-333333">#333333</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#000000');return false;"><span class="color-000000">#000000</span></a></td>			
																<td><a href="#void" onclick="insertMarkTag('#8E8E8E');return false;"><span class="color-8E8E8E">#8E8E8E</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#C1C1C1');return false;"><span class="color-C1C1C1">#C1C1C1</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FFFFFF');return false;"><span class="color-FFFFFF">#FFFFFF</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FFDAED');return false;"><span class="color-FFDAED">#FFDAED</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#C9EDFF');return false;"><span class="color-C9EDFF">#C9EDFF</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#D0FF9D');return false;"><span class="color-D0FF9D">#D0FF9D</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#FAFFA9');return false;"><span class="color-FAFFA9">#FAFFA9</span></a></td>
																<td><a href="#void" onclick="insertMarkTag('#E4E4E4');return false;"><span class="color-E4E4E4">#E4E4E4</span></a></td>
															</tr>
														</table>
													</div>
													<a id="indicatorTextBox" class="inactive-class button" href="#void" onclick="hideLayer('markPalette');hideLayer('colorPalette');toggleLayer('textBox'); changeButtonStatus(this, 'textBox');" title="<?php
	echo _t('텍스트 상자');?>"><span class="text"><?php
	echo _t('텍스트 상자');?></span></a>
													<div id="textBox" style="display: none;">
														<table cellspacing="0" cellpadding="0">
															<tr>
																<td><a href="#void" onclick="hideLayer('textBox'); TTCommand('Box', 'padding:10px; background-color:#FFDAED');"><span class="color-FFDAED">#FFDAED</span></a></td>
																<td><a href="#void" onclick="hideLayer('textBox'); TTCommand('Box', 'padding:10px; background-color:#C9EDFF');"><span class="color-C9EDFF">#C9EDFF</span></a></td>
																<td><a href="#void" onclick="hideLayer('textBox'); TTCommand('Box', 'padding:10px; background-color:#D0FF9D');"><span class="color-D0FF9D">#D0FF9D</span></a></td>
																<td><a href="#void" onclick="hideLayer('textBox'); TTCommand('Box', 'padding:10px; background-color:#FAFFA9');"><span class="color-FAFFA9">#FAFFA9</span></a></td>
																<td><a href="#void" onclick="hideLayer('textBox'); TTCommand('Box', 'padding:10px; background-color:#E4E4E4');"><span class="color-E4E4E4">#E4E4E4</span></a></td>
															</tr>
														</table>
													</div>
													<a id="indicatorRemoveFormat" class="inactive-class button" href="#void" onclick="TTCommand('RemoveFormat');return false;" title="<?php
	echo _t('효과 제거');?>"><span class="text"><?php
	echo _t('효과 제거');?></span></a>
												</dd>
											</dl>
											<dl class="paragraph">
												<dt class="title">
													<span class="label"><?php
	echo _t('문단');?></span>
												</dt>
												<dd class="command-box">
													<a id="indicatorJustifyLeft" class="inactive-class button" href="#void" onclick="TTCommand('JustifyLeft');return false;" title="<?php
	echo _t('왼쪽 정렬');?>"><span class="text"><?php
	echo _t('왼쪽 정렬');?></span></a>
													<a id="indicatorJustifyCenter" class="inactive-class button" href="#void" onclick="TTCommand('JustifyCenter');return false;" title="<?php
	echo _t('가운데 정렬');?>"><span class="text"><?php
	echo _t('가운데 정렬');?></span></a>
													<a id="indicatorJustifyRight" class="inactive-class button" href="#void" onclick="TTCommand('JustifyRight');return false;" title="<?php
	echo _t('오른쪽 정렬');?>"><span class="text"><?php
	echo _t('오른쪽 정렬');?></span></a>
													<a id="indicatorUnorderedList" class="inactive-class button" href="#void" onclick="TTCommand('InsertUnorderedList');return false;" title="<?php
	echo _t('순서없는 리스트');?>"><span class="text"><?php
	echo _t('순서없는 리스트');?></span></a>
													<a id="indicatorOrderedList" class="inactive-class button" href="#void" onclick="TTCommand('InsertOrderedList');return false;" title="<?php
	echo _t('번호 매긴 리스트');?>"><span class="text"><?php
	echo _t('번호 매긴 리스트');?></span></a>
													<a id="indicatorOutdent" class="inactive-class button" href="#void" onclick="TTCommand('Outdent');return false;" title="<?php
	echo _t('내어쓰기');?>"><span class="text"><?php
	echo _t('내어쓰기');?></span></a>
													<a id="indicatorIndent" class="inactive-class button" href="#void" onclick="TTCommand('Indent');return false;" title="<?php
	echo _t('들여쓰기');?>"><span class="text"><?php
	echo _t('들여쓰기');?></span></a>
													<a id="indicatorBlockquote" class="inactive-class button" href="#void" onclick="TTCommand('Blockquote');return false;" title="<?php
	echo _t('인용구');?>"><span class="text"><?php
	echo _t('인용구');?></span></a>
												</dd>
											</dl>
											<dl class="special">
												<dt class="title">
													<span class="label"><?php
	echo _t('기타');?></span>
												</dt>
												<dd class="command-box">
													<a id="indicatorCreateLink" class="inactive-class button" href="#void" onclick="TTCommand('CreateLink');return false;" title="<?php
	echo _t('하이퍼링크');?>"><span class="text"><?php
	echo _t('하이퍼링크');?></span></a>
													<a id="indicatorMediaBlock" class="inactive-class button" href="#void" onclick="TTCommand('ObjectBlock');return false;" title="<?php
	echo _t('미디어 삽입');?>"><span class="text"><?php
	echo _t('미디어 삽입');?></span></a>
													<a id="indicatorMoreLessBlock" class="inactive-class button" href="#void" onclick="TTCommand('MoreLessBlock');return false;" title="<?php
	echo _t('More/Less');?>"><span class="text"><?php
	echo _t('More/Less');?></span></a>
												</dd>
											</dl>
											<dl class="mode">
												<dt class="title">
													<span class="label"><?php
	echo _t('편집 환경');?></span>
												</dt>
												<dd class="command-box">
													<a id="indicatorMode" class="inactive-class button" href="#void" onclick="TTCommand('ToggleMode'); changeEditorMode();return false;" title="<?php
	echo _t('클릭하시면 HTML 편집기로 변경합니다.');?>"><span class="text"><?php
	echo _t('WYSIWYG 편집기');?></span></a>
												</dd>
											</dl>
										</div>
<?php
}
function getAttachmentValue($attachment){
	global $g_attachmentFolderPath;
	if(strpos($attachment['mime'],'image')===0){
		if(getUserSetting("waterMarkDefault")=="yes")
			$classString='class="tt-watermark" ';
		elseif(getUserSetting("resamplingDefault")=="yes")
			$classString='class="tt-resampling" ';
		else
			$classString="";
		return "{$attachment['name']}|{$classString}width=\"{$attachment['width']}\" height=\"{$attachment['height']}\" alt=\""._text('사용자 삽입 이미지')."\"";
	}else{
		return "{$attachment['name']}|";
	}
}
function getPrettyAttachmentLabel($attachment){
	if(strpos($attachment['mime'],'image')===0)
		return "{$attachment['label']} ({$attachment['width']}x{$attachment['height']} / ".getSizeHumanReadable($attachment['size']).')';
	elseif(strpos($attachment['mime'],'audio')!==0&&strpos($attachment['mime'],'video')!==0){
		if($attachment['downloads']>0)
			return "{$attachment['label']} (".getSizeHumanReadable($attachment['size']).' / '._t('다운로드').':'.$attachment['downloads'].')';
	}
	return "{$attachment['label']} (".getSizeHumanReadable($attachment['size']).')';
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
if(false){
	fetchConfigVal();
}
$isKeyword=false;
if(!isset($_GET['draft'])||(!$entry=getEntry($owner,$suri['id'],true))){
	$entry=getEntry($owner,$suri['id'],false);
	if(!$entry)
		respondErrorPage(_t('포스트 정보가 존재하지 않습니다.'));
	$isKeyword=($entry['category']==-1);
}
if(isset($_GET['popupEditor'])){?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
	echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<title><?php
	echo htmlspecialchars($blog['title']);?> &gt; <?php
	echo _t('글관리');?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/popup-editor.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/popup-editor.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/popup-editor.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
	echo $service['path'];?>";
			var blogurl = "<?php
	echo $blogURL;?>";
			var adminSkin = "<?php
	echo $adminSkinSetting['skin'];?>";
<?php
	if(file_exists(ROOT.$adminSkinSetting['editorTemplate'])){?>
			var editorCSS = "<?php
		echo $adminSkinSetting['editorTemplate'];?>";
<?php
	}else{?>
			var editorCSS = "/style/default-wysiwyg.css";
<?php
	}?>
		//]]>
	</script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/owner.js"></script>
</head>
<body<?php
	echo (empty($htmlBodyEvents)?'':$htmlBodyEvents);?>>
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
	echo _t('태터툴즈 관리 페이지');?></h1>
			</div>
			
			<hr class="hidden" />

<?php
}else{?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
	echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
	echo htmlspecialchars($blog['title']);?> &gt; <?php
	echo _t('글관리');?></title>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/editor.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/editor.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/post.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/editor.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
	echo $service['path'];?>";
			var blogurl = "<?php
	echo $blogURL;?>";
			var adminSkin = "<?php
	echo $adminSkinSetting['skin'];?>";
<?php
	if(file_exists(ROOT.$adminSkinSetting['editorTemplate'])){?>
			var editorCSS = "<?php
		echo $adminSkinSetting['editorTemplate'];?>";
<?php
	}else{?>
			var editorCSS = "/style/default-wysiwyg.css";
<?php
	}?>
		//]]>
	</script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-post">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
	echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
	$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
	echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
	echo $blogURL;?>/" title="<?php
	echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
	echo $blogURL;?>/logout" title="<?php
	echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
	echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
	echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
	echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
	echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
	echo $blogURL;?>/owner/center/dashboard"><span><?php
	echo _t('센터');?></span></a></li>
						<li id="menu-post" class="selected"><a href="<?php
	echo $blogURL;?>/owner/entry"><span class="text"><?php
	echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
	echo $blogURL;?>/owner/link"><span class="text"><?php
	echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
	echo $blogURL;?>/owner/skin"><span class="text"><?php
	echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
	echo $blogURL;?>/owner/plugin"><span class="text"><?php
	echo _t('플러그인');?></span></a></li>
						<li id="menu-setting"><a href="<?php
	echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
	echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
	echo $blogURL;?>/owner/reader"><span class="text"><?php
	echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

<?php
}
{
	if(isset($_GET['popupEditor'])){?>			<div id="layout-body">
				<h2><?php
		echo _t('팝업 윈도우 : 글수정');?></h2>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
	}else{?>			<div id="layout-body">
				<h2><?php
	echo _t('서브메뉴 : 글관리');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-add"><a href="<?php
	echo $blogURL;?>/owner/entry/post" onclick="window.location.href = '<?php
	echo $blogURL;?>/owner/entry/post'<?php
	echo (getDraftEntryId()?"+(confirm('"._t('임시 저장본을 보시겠습니까?')."') ? '?draft' : '')":'');?>; return false"><span class="text"><?php
	echo _t('글쓰기');?></span></a></li>
						<li id="sub-menu-list" class="selected"><a href="<?php
	echo $blogURL;?>/owner/entry"><span class="text"><?php
	echo _t('글 목록');?></span></a></li>
						<li id="sub-menu-thread"><a href="<?php
	echo $blogURL;?>/owner/entry/comment"><span class="text"><?php
	echo _t('댓글');?></span></a></li>
						<li id="sub-menu-notify"><a href="<?php
	echo $blogURL;?>/owner/entry/notify"><span class="text"><?php
	echo _t('댓글 알리미');?></span></a></li>
						<li id="sub-menu-trackback"><a href="<?php
	echo $blogURL;?>/owner/entry/trackback"><span class="text"><?php
	echo _t('걸린글');?></span></a></li>
						<li id="sub-menu-category"><a href="<?php
	echo $blogURL;?>/owner/entry/category"><span class="text"><?php
	echo _t('분류 관리');?></span></a></li>
						<li id="sub-menu-trash"><a href="<?php
	echo $blogURL;?>/owner/entry/trash"><span class="text"><?php
	echo _t('휴지통');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
	echo getHelpURL('entry');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
	echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
}
printOwnerEditorScript($entry['id']);
}?>
						<script type="text/javascript" src="<?php
echo $service['path'];?>/script/generaltag.js"></script>
						<script type="text/javascript" src="<?php
echo $service['path'];?>/script/locationtag.js"></script>
						<script type="text/javascript">
							//<![CDATA[
								var enclosured = "<?php
echo getEnclosure($entry['id']);?>";
								var originalPermalink = "<?php
echo htmlspecialchars($entry['slogan']);?>";
								
								window.onerror = function(errType, errURL,errLineNum) {
									window.status = "Error: " + errType +" (on line " + errLineNum + " of " + errURL + ")";
									return true;
								}
								
								function setEnclosure(value) {
									var filename = value.substring(0, value.indexOf("|"));
									
									if(document.getElementById("fileList").selectedIndex == -1) {
										alert("<?php
echo _t('파일을 선택하십시오.');?>");
										return false;
									}
									
									if(!(new RegExp("\.mp3$", "i").test(filename))) {
										alert("<?php
echo _t('MP3만 사용할 수 있습니다.');?>");
										return false;
									}
									
									try {
										if(STD.isIE) 
											var uploader = document.getElementById("uploader");
										else 
											var uploader = document.getElementById("uploader2");
									} catch(e) { }
									
									if(filename == enclosured) {
										var order = 0;
										try { uploader.SetVariable("/:enclosure", ""); } catch(e) { }
									}
									else {
										var order = 1;
										try { uploader.SetVariable("/:enclosure", filename); } catch(e) { }
									}
									
									var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/attach/enclosure/");
									request.onSuccess = function () {
										PM.removeRequest(this);
										var fileList = document.getElementById("fileList");
										fileList.selectedIndex = -1;
										for(var i=0; i<fileList.length; i++)
											fileList[i].style.backgroundColor = (order == 1 && fileList[i].value.indexOf(filename) == 0) ? "#c6a6e7" : "#fff";
										enclosured = (order == 1) ? filename : "";
									}
									
									request.onError= function () {
									PM.removeRequest(this);
										alert("<?php
echo _t('변경하지 못했습니다.');?>");
									}
									PM.addRequest(request, "<?php
echo _t('변경하고 있습니다.');?>");
									request.send("fileName=" + encodeURIComponent(filename) + "&order=" + order);
								}
								
								function EntryManager() {
									this.savedData = null;
<?php
{?>
									this.isSaved = true;

<?php
}?>

									this.entryId = <?php
echo $entry['id'];?>;

									this.pageHolder = new PageHolder(false, "<?php
echo _t('아직 저장되지 않았습니다.');?>");
									this.pageHolder.isHolding = function () {
										return (entryManager.savedData != entryManager.getData());
									}
									this.delay = false;
									this.nowsaving = false;
									this.getData = function (check) {
										if (check == undefined)
											check = false;
										var oForm = document.forms[0];
										
										var title = trim(oForm.title.value);
										var permalink = trim(oForm.permalink.value);
										if (check && (title.length == 0)) {
											alert("<?php
echo _t('제목을 입력해 주십시오.');?>");
											oForm.title.focus();
											return null;
										}
										
										var visibility = 0;
										for (var i = 0; i < oForm.visibility.length; i++) {
											if (oForm.visibility[i].checked) {
												visibility = oForm.visibility[i].value;
												break;
											}
										}

										var entrytype = 0;
										for (var i = 0; i < oForm.entrytype.length; i++) {
											if (oForm.entrytype[i].checked) {
												entrytype = oForm.entrytype[i].value;
												break;
											}
										}

										try {
											if (editor.editMode == "WYSIWYG")
												oForm.content.value = editor.html2ttml(editor.contentDocument.body.innerHTML);
										} catch(e) {
										}
										var content = trim(oForm.content.value);
										if (check && (content.length == 0)) {
											alert("<?php
echo _t('본문을 입력해 주십시오.');?>");
											return null;
										}
											
										var locationValue = "/";
										try {
											locationValue = oLocationTag.getValues();
										} catch(e) {
											locationValue = oForm.location.value;
										}
								
										var tagValue = "";
										try {
											tagValue = oTag.getValues().join(",");
										} catch (e) {
											tagValue = oForm.tag.value;
										}

										var published = 0;
										for (var i = 0; i < oForm.published.length; i++) {
											if (oForm.published[i].checked) {
												published = oForm.published[i].value;
												break;
											}
										}
										if (published == 2) {
											published = Date.parse(oForm.appointed.value);
											if (isNaN(published)) {
												if (check)
													alert("<?php
echo _t('등록 예약 시간이 올바르지 않습니다.');?>");
												return null;
											}
											published = Math.floor(published / 1000);
										}
										return (
											"visibility=" + visibility +
											"&title=" + encodeURIComponent(title) +
											"&permalink=" + encodeURIComponent(permalink) +
											"&content=" + encodeURIComponent(content) +
											"&published=" + published +
											"&category=" + ((entrytype!=0) ? entrytype : oForm.category.value) +
											"&location=" + encodeURIComponent(locationValue) +
											"&tag=" + encodeURIComponent(tagValue) +
											"&acceptcomment=" + (oForm.acceptcomment.checked ? 1 : 0) +
											"&accepttrackback=" + (oForm.accepttrackback.checked ? 1 : 0)
										);
									}
									
									this.setEnclosure = function(fileName) {
										
									}
									
									this.save = function () {
										var data = this.getData(true);
										if (data == null)
											return false;
										this.nowsaving = true;
										if(entryManager.isSaved == true) {
											var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/update/"+entryManager.entryId);
										} else {
											var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/add/");
										}

										request.message = "<?php
echo _t('저장하고 있습니다.');?>";
										request.onSuccess = function () {
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
											if(entryManager.isSaved == false) {
												entryManager.entryId = this.getText("/response/entryId");
												entryManager.isSaved = true;
											}

											PM.removeRequest(this);
											entryManager.savedData = this.content;
											if (entryManager.savedData == entryManager.getData())
												entryManager.pageHolder.release();
										}
										request.onError = function () {
											PM.removeRequest(this);
											alert("<?php
echo _t('저장하지 못했습니다.');?>");
										}
										PM.addRequest(request, "<?php
echo _t('저장하고 있습니다.');?>");
										request.send(this.getData());
									}
																		
									this.saveAndReturn = function () {
										var data = this.getData(true);
										if (data == null)
											return false;
										this.nowsaving = true;

										if(entryManager.isSaved == true) {

											var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/update/"+entryManager.entryId);
										} else {

											var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/add/");
										}

										request.message = "<?php
echo _t('저장하고 있습니다.');?>";
										request.onSuccess = function () {
											entryManager.pageHolder.isHolding = function () {
												return false;
											}
											PM.removeRequest(this);
											var returnURI = "";
											var oForm = document.forms[0];
											var changedPermalink = trim(oForm.permalink.value);
<?php
if(isset($_GET['popupEditor'])){?>
											opener.location.href = opener.location.href;
											window.close();
<?php
}elseif(isset($_GET['returnURL'])){?>
											if(originalPermalink == changedPermalink) {
												returnURI = "<?php
echo escapeJSInCData($_GET['returnURL']);?>";
											} else {
												returnURI = "<?php
echo escapeJSInCData("$blogURL/".$entry['id']);?>";
											}
											window.location = returnURI;
<?php
}else{?>
											window.location.href = "<?php
echo $blogURL;?>/owner/entry";
<?php
}?>
										}
										request.onError = function () {
											PM.removeRequest(this);
											alert("<?php
echo _t('저장하지 못했습니다.');?>");
										}
										PM.addRequest(request, "<?php
echo _t('저장하고 있습니다.');?>");
										request.send(this.getData());
									}
									this.saveAuto = function () {
										if (this.timer == null)
											this.timer = window.setTimeout("entryManager.saveDraft()", 5000);
										else
											this.delay = true;
									}
									this.saveDraft = function () {
										var data = this.getData();
										if ((data == null) || (data == this.savedData) || (this.nowsaving == true))
											return;
										this.timer = null;
										if (this.delay) {
											this.delay = false;
											this.timer = window.setTimeout("entryManager.saveDraft()", 5000);
											return;
										}

										var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/draft/"+entryManager.entryId);
										request.onSuccess = function () {
											PM.showMessage("<?php
echo _t('자동으로 임시 저장되었습니다.');?>", "center", "bottom");
											entryManager.savedData = this.content;
											entryManager.entryId = this.getText("/response/entryId");
											if (entryManager.savedData == entryManager.getData())
												entryManager.pageHolder.release();
										}
										request.send(data);
									}
									this.preview = function () {
										var data = this.getData();
										if (data == null)
											return;

										if (data == this.savedData) {
											window.open("<?php
echo $blogURL;?>/owner/entry/preview/"+entryManager.entryId, "previewEntry"+entryManager.entryId, "location=0,menubar=0,resizable=1,scrollbars=1,status=0,toolbar=0");
											return;
										}
										
										var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/entry/draft/"+entryManager.entryId);
										request.async = false;
										request.message = "<?php
echo _t('미리보기를 준비하고 있습니다.');?>";
										request.onSuccess = function () {
											entryManager.savedData = this.content;
											window.open("<?php
echo $blogURL;?>/owner/entry/preview/"+entryManager.entryId, "previewEntry"+entryManager.entryId, "location=0,menubar=0,resizable=1,scrollbars=1,status=0,toolbar=0");
										}
										request.onError = function () {
										}
										request.send(data);
									}
									this.savedData = this.getData();
								}
								var entryManager;

								function keepSessionAlive() {
									var request = new HTTPRequest("<?php
echo $blogURL;?>/owner/keep/");
									request.persistent = false;
									request.onVerify = function () {
										return true;
									}
									request.send();
								}
								window.setInterval("keepSessionAlive()", 600000);
								
								function changeEditorMode() {
									editWindow = document.getElementById("editWindow");
									var indicatorMode = document.getElementById("indicatorMode");
									
									if (editWindow.style.display == "block" || editWindow.style.display == "inline") {
										if (document.getElementById("visualEditorWindow")) {
											indicatorMode.className = indicatorMode.className.replace("inactive-class", "active-class");
											indicatorMode.innerHTML = '<span class="text"><?php
echo _t('HTML 모드');?><\/span>';
											indicatorMode.setAttribute("title", "<?php
echo _t('클릭하시면 WYSIWYG 모드로 변경합니다.');?>");
										} else {
											indicatorMode.className = indicatorMode.className.replace("inactive-class", "active-class");
											indicatorMode.innerHTML = '<span class="text"><?php
echo _t('HTML 모드');?><\/span>';
											indicatorMode.removeAttribute("title");
										}
									} else {
										indicatorMode.className = indicatorMode.className.replace("active-class", "inactive-class");
										indicatorMode.setAttribute("title", "<?php
echo _t('클릭하시면 HTML 모드로 변경합니다.');?>");
										indicatorMode.innerHTML = '<span class="text"><?php
echo _t('WYSIWYG 모드');?><\/span>';
									}
								}
								
								function changeButtonStatus(obj, palette) {
									if (!document.getElementById('indicatorColorPalette').className.match('inactive-class')) {
										document.getElementById('indicatorColorPalette').className = document.getElementById('indicatorColorPalette').className.replace('active-class', 'inactive-class');
									}
									if (!document.getElementById('indicatorMarkPalette').className.match('inactive-class')) {
										document.getElementById('indicatorMarkPalette').className = document.getElementById('indicatorMarkPalette').className.replace('active-class', 'inactive-class');
									}
									if (!document.getElementById('indicatorTextBox').className.match('inactive-class')) {
										document.getElementById('indicatorTextBox').className = document.getElementById('indicatorTextBox').className.replace('active-class', 'inactive-class');
									}
									
									if (obj != null) {
										if (document.getElementById(palette).style.display == "block") {
											obj.className = obj.className.replace('inactive-class', 'active-class');
										} else {
											if (!obj.className.match('inactive-class')) {
												obj.className = obj.className.replace('active-class', 'inactive-class');
											}
										}
									}
								}
								
								function checkCategory(type) {
									switch(type) {
										case "type_keyword":
											document.getElementById("title-line-label").innerHTML = "<?php
echo _t('키워드');?>";
											document.getElementById("category").disabled = true;
											break;
										case "type_notice":
											document.getElementById("title-line-label").innerHTML = "<?php
echo _t('제목');?>";
											document.getElementById("category").disabled = true;
											break;
										case "type_post":
											document.getElementById("title-line-label").innerHTML = "<?php
echo _t('제목');?>";
											document.getElementById("category").disabled = false;
									}
									if(type == "type_keyword") {
										var radio = document.forms[0].visibility;
										if(radio[1].checked)
											radio[0].checked = true;
										if(radio[3].checked)
											radio[2].checked = true;
										document.getElementById("permalink-line").style.display = "none";
										document.getElementById("status-protected").style.display = "none";
										document.getElementById("status-syndicated").style.display = "none";
										document.getElementById("power-line").style.display = "none";
									}
									else {
										document.getElementById("permalink-line").style.display = "";
										document.getElementById("status-protected").style.display = "";
										document.getElementById("status-syndicated").style.display = "";
										document.getElementById("power-line").style.display = "";
									}
								}
								
								function viewWhatIsEolin() {
									document.getElementById('fileList').style.visibility = 'hidden';
									dialog = document.getElementById('eolinDialog');
									PM.showPanel(dialog);
								}
								
								function closeWhatIsEolin() {
									document.getElementById('fileList').style.visibility = 'visible';
									document.getElementById('eolinDialog').style.display = 'none';
								}
							//]]>
						</script>
						
						<form id="editor-form" method="post" action="<?php
echo $blogURL;?>/owner/entry">
							<div id="part-editor" class="part">
								<h2 class="caption"><span class="main-text"><?php
{
echo _t('선택한 글을 수정합니다');
}?></span></h2>
									
								<div id="editor" class="data-inbox">
									<div id="title-section" class="section">
										<h3><?php
echo _t('머리말');?></h3>
										
										<dl id="title-line" class="line">
											<dt><label for="title" id="title-line-label"><?php
echo $isKeyword?_t('키워드'):_t('제목');?></label></dt>
											<dd>
												<input type="text" id="title" class="input-text" name="title" value="<?php
echo htmlspecialchars($entry['title']);?>" onkeypress="return preventEnter(event);" size="60" />
											</dd>
										</dl>
										<dl id="category-line" class="line">
											<dt><label for="permalink"><?php
echo _t('분류');?></label></dt>
											<dd>
												<div class="entrytype-notice"><input type="radio" id="type_notice" class="radio" name="entrytype" value="-2" onclick="checkCategory('type_notice')"<?php
echo ($entry['category']==-2?' checked="checked"':'');?> /><label for="type_notice"><?php
echo _t('공지');?></label></div>
												<div class="entrytype-keyword"><input type="radio" id="type_keyword" class="radio" name="entrytype" value="-1" onclick="checkCategory('type_keyword')"<?php
echo ($entry['category']==-1?' checked="checked"':'');?> /><label for="type_keyword"><?php
echo _t('키워드');?></label></div>
												<div class="entrytype-post">
													<input type="radio" id="type_post" class="radio" name="entrytype" value="0" onclick="checkCategory('type_post')"<?php
echo ($entry['category']>=0?' checked="checked"':'');?> /><label for="type_post"><?php
echo _t('글');?></label>
													<select id="category" name="category"<?php
if($isKeyword)
echo ' disabled="disabled"';?>>
														<option value="0"><?php
echo htmlspecialchars(getCategoryNameById($owner,0)?getCategoryNameById($owner,0):_t('전체'));?></option>
<?php
foreach(getCategories($owner) as $category){
if($category['id']!=0){?>
														<option value="<?php
echo $category['id'];?>"<?php
echo ($category['id']==$entry['category']?' selected="selected"':'');?>><?php
echo ($category['visibility']>1?'':_t('(비공개)')).htmlspecialchars($category['name']);?></option>
<?php
}
foreach($category['children'] as $child){
if($category['id']!=0){?>
														<option value="<?php
	echo $child['id'];?>"<?php
	echo ($child['id']==$entry['category']?' selected="selected"':'');?>>&nbsp;― <?php
	echo ($category['visibility']>1?'':_t('(비공개)')).htmlspecialchars($child['name']);?></option>
<?php
}
}
}?>
													</select>
												</div>
											</dd>
										</dl>
									</div>
									
									<div id="textarea-section" class="section">
										<h3><?php
echo _t('본문');?></h3>
											
<?php
printEntryEditorPalette();?>
										<div id="editor-textbox" class="container">
											<textarea id="editWindow" name="content" cols="80" rows="20" onselect="savePosition(); editorChanged()" onclick="savePosition();editorChanged()" onkeyup="savePosition();editorChanged()"><?php
echo htmlspecialchars($entry['content']);?></textarea>
											<script type="text/javascript" src="<?php
echo $service['path'];?>/script/editor2.js"></script>
											<script type="text/javascript">
												//<![CDATA[
													var editor = new TTEditor();
													editor.initialize(document.getElementById("editWindow"), "<?php
echo $service['path'];?>/attach/<?php
echo $owner;?>/", "<?php
echo getUserSetting('editorMode',1)==1?'WYSIWYG':'TEXTAREA';?>", "<?php
echo true?'BR':'P';?>");
												//]]>
											</script>
										</div>
										<div id="status-container" class="container"><span id="pathStr"><?php
echo _t('path');?></span><span class="divider"> : </span><span id="pathContent"></span></div>
<?php
$view=fireEvent('AddPostEditorToolbox','');
if(!empty($view)){?>
										<div id="toolbox-container" class="container"><?php
echo $view;?></div>
<?php
}?>
									</div>
									
									<hr class="hidden" />
									
									<div id="property-section" class="section">
										<h3><?php
echo _t('속성 상자');?></h3>
										
										<div id="property-container" class="container">
<?php
printEntryEditorProperty();?>
										</div>
									</div>

									<hr class="hidden" />
									
									<div id="taglocal-section" class="section">
										<h3><?php
echo _t('태그 &amp; 위치');?></h3>
												
										<div id="tag-location-container" class="container">
											<dl id="tag-line">
												<dt><span class="label"><?php
echo _t('태그');?></span></dt>
												<dd id="tag"></dd>
											</dl>
											
											<dl id="location-line">
												<dt><span class="label"><?php
echo _t('지역');?></span></dt>
												<dd id="location"></dd>
											</dl>
											
											<script type="text/javascript">
												//<![CDATA[
													try {
														var oLocationTag = new LocationTag(document.getElementById("location"), "<?php
echo $blog['language'];?>", <?php
echo isset($service['disableEolinSuggestion'])&&$service['disableEolinSuggestion']?'true':'false';?>);
														oLocationTag.setInputClassName("input-text");
														oLocationTag.setValue("<?php
echo addslashes($entry['location']);?>");	
													} catch (e) {
														document.getElementById("location").innerHTML = '<input type="text" class="input-text" name="location" value="<?php
echo addslashes($entry['location']);?>" /><br /><?php
echo _t('지역태그 스크립트를 사용할 수 없습니다. 슬래시(/)로 구분된 지역을 직접 입력해 주십시오.(예: /대한민국/서울/강남역)');?>';
														// TODO : 이부분(스크립트를 실행할 수 없는 환경일 때)은 직접 입력보다는 0.96 스타일의 팝업이 좋을 듯
													}
													
													try {
														var oTag = new Tag(document.getElementById("tag"), "<?php
echo $blog['language'];?>", <?php
echo isset($service['disableEolinSuggestion'])&&$service['disableEolinSuggestion']?'true':'false';?>);
														oTag.setInputClassName("input-text");
<?php
$tags=array();
{
foreach(getTags($entry['id']) as $tag){
array_push($tags,$tag['name']);
echo 'oTag.setValue("'.addslashes($tag['name']).'");';
}
}?>
													} catch(e) {
														document.getElementById("tag").innerHTML = '<input type="text" class="input-text" name="tag" value="<?php
echo addslashes(str_replace('"','&quot;',implode(', ',$tags)));?>" /><br /><?php
echo _t('태그 입력 스크립트를 사용할 수 없습니다. 콤마(,)로 구분된 태그를 직접 입력해 주십시오.(예: 태터툴즈, BLOG, 테스트)');?>';
													}
												//]]>
											</script> 
										</div>

										<hr class="hidden" />
										
<?php
if(isset($_GET['popupEditor'])){?>
										<div class="button-box two-button-box">
											<input type="button" value="<?php
echo _t('미리보기');?>" class="preview-button input-button" onclick="entryManager.preview();return false;" />
											<span class="hidden">|</span>
											<input type="submit" value="<?php
echo _t('지금저장');?>" class="save-button input-button" onclick="entryManager.save();return false;" />
											<span class="hidden">|</span>
											<input type="submit" value="<?php
echo _t('완료하기');?>" class="save-and-return-button input-button" onclick="entryManager.saveAndReturn();return false;" />									
										</div>
<?php
}else{?>
										<div class="button-box three-button-box">
											<input type="button" value="<?php
echo _t('미리보기');?>" class="preview-button input-button" onclick="entryManager.preview();return false;" />
											<span class="hidden">|</span>
							    	  	 	<input type="submit" value="<?php
echo _t('지금저장');?>" class="save-button input-button" onclick="entryManager.save();return false;" />
											<span class="hidden">|</span>
							       			<input type="submit" value="<?php
echo _t('완료하기');?>" class="save-and-return-button input-button" onclick="entryManager.saveAndReturn();return false;" />
											<span class="hidden">|</span>
											<input type="submit" value="<?php
echo _t('목록으로');?>" class="list-button input-button" onclick="window.location.href='<?php
echo $blogURL;?>/owner/entry'" />
										</div>
<?php
}?>
									</div>							
									<hr class="hidden" />
									
									<div id="upload-section" class="section">
										<h3><?php
echo _t('업로드');?></h3>
										
										<div id="attachment-container" class="container">
<?php
$param=array('uploadPath'=>"$blogURL/owner/entry/attachmulti/{$entry['id']}",'singleUploadPath'=>"$blogURL/owner/entry/attach/{$entry['id']}",'deletePath'=>"$blogURL/owner/entry/detach/multi/".($entry['id']?$entry['id']:'0'),'labelingPath'=>"$blogURL/owner/entry/attachmulti/list/{$entry['id']}",'refreshPath'=>"$blogURL/owner/entry/attachmulti/refresh/".($entry['id']?$entry['id']:'0'),'fileSizePath'=>"$blogURL/owner/entry/size?parent={$entry['id']}");
printEntryFileList(getAttachments($owner,$entry['id'],'label'),$param);?>
										</div>
										
										<div id="insert-container" class="container">
											<a class="image-left" href="#void" onclick="linkImage1('1L');return false;" title="<?php
echo _t('선택한 파일을 글의 왼쪽에 정렬합니다.');?>"><span class="text"><?php
echo _t('왼쪽 정렬');?></span></a>
											<a class="image-center" href="#void" onclick="linkImage1('1C');return false;" title="<?php
echo _t('선택한 파일을 글의 중앙에 정렬합니다.');?>"><span class="text"><?php
echo _t('중앙 정렬');?></span></a>
											<a class="image-right" href="#void" onclick="linkImage1('1R');return false;" title="<?php
echo _t('선택한 파일을 글의 오른쪽에 정렬합니다.');?>"><span class="text"><?php
echo _t('오른쪽 정렬');?></span></a>
											<a class="image-2center" href="#void" onclick="linkImage2();return false;" title="<?php
echo _t('선택한 두개의 파일을 글의 중앙에 정렬합니다.');?>"><span class="text"><?php
echo _t('중앙 정렬(2 이미지)');?></span></a>
											<a class="image-3center" href="#void" onclick="linkImage3();return false;" title="<?php
echo _t('선택한 세개의 파일을 글의 중앙에 정렬합니다.');?>"><span class="text"><?php
echo _t('중앙 정렬(3 이미지)');?></span></a>
											<a class="image-free" href="#void" onclick="linkImageFree();return false;" title="<?php
echo _t('선택한 파일을 글에 삽입합니다. 문단의 모양에 영향을 주지 않습니다.');?>"><span class="text"><?php
echo _t('파일 삽입');?></span></a>
											<a class="image-imazing" href="#void" onclick="viewImazing();return false;" title="<?php
echo _t('이메이징(플래쉬 갤러리)을 삽입합니다.');?>"><span class="text"><?php
echo _t('이메이징(플래쉬 갤러리) 삽입');?></span></a>
											<a class="image-sequence" href="#void" onclick="viewGallery();return false;" title="<?php
echo _t('이미지 갤러리를 삽입합니다.');?>"><span class="text"><?php
echo _t('갤러리 삽입');?></span></a>
											<a class="image-mp3" href="#void" onclick="viewJukebox();return false;" title="<?php
echo _t('쥬크박스를 삽입합니다.');?>"><span class="text"><?php
echo _t('쥬크박스 삽입');?></span></a>
											<a class="image-podcast" href="#void" onclick="setEnclosure(document.getElementById('fileList').value);return false;" title="<?php
echo _t('팟캐스트로 지정합니다.');?>"><span class="text"><?php
echo _t('팟캐스트 지정');?></span></a>
										</div>
<?php
printEntryFileUploadButton($entry['id']);?>
									</div>

									<hr class="hidden" />
									
									<div id="power-section" class="section">
										<div id="power-container" class="container">
											<dl id="permalink-line" class="line"<?php
if($isKeyword)
echo _t('style="display: none"');?>>
												<dt><label for="permalink"><?php
echo _t('절대 주소');?></label></dt>
												<dd>
													<samp><?php
echo _f('%1/entry/',link_cut(getBlogURL()));?></samp><input type="text" id="permalink" class="input-text" name="permalink" onkeypress="return preventEnter(event);" value="<?php
echo htmlspecialchars($entry['slogan']);?>" />
													<p>* <?php
echo _t('입력하지 않으면 글의 제목이 절대 주소가 됩니다.');?></p>
												</dd>
											</dl>
											<dl id="date-line" class="line">
												<dt><span class="label"><?php
echo _t('등록일자');?></span></dt>
												<dd>
<?php
{?>
													<div class="publish-nochange"><input type="radio" id="publishedNoChange" class="radio" name="published" value="0" <?php
echo (!isset($entry['republish'])&&!isset($entry['appointed'])?'checked="checked"':'');?> /><label for="publishedNoChange"><?php
echo _t('유지');?> (<?php
echo Timestamp::format5($entry['published']);?>)</label></div>
													<div class="publish-update"><input type="radio" id="publishedUpdate" class="radio" name="published" value="1" <?php
echo (isset($entry['republish'])?'checked="checked"':'');?> /><label for="publishedUpdate"><?php
echo _t('갱신');?></label></div>
<?php
}?>
													<div class="publish-preserve">
														<input type="radio" id="publishedPreserve" class="radio" name="published" value="2" <?php
echo (isset($entry['appointed'])?'checked="checked"':'');?> /><label for="publishedPreserve" onclick="document.getElementById('appointed').select()"><?php
echo _t('예약');?></label>
														<input type="text" id="appointed" class="input-text" name="appointed" value="<?php
echo Timestamp::format5(isset($entry['appointed'])?$entry['appointed']:$entry['published']);?>" onfocus="document.forms[0].published[document.forms[0].published.length - 1].checked = true" onkeypress="return preventEnter(event);" />
													</div>
												</dd>
											</dl>
<?php
$countResult=DBQuery::queryExistence("SELECT id FROM {$database['prefix']}Entries WHERE owner = {$owner} AND visibility = 3");?>
											<dl id="status-line" class="line">
												<dt><span class="label"><?php
echo _t('공개여부');?></span></dt>
												<dd>
													<div id="status-private" class="status-private"><input type="radio" id="visibility_private" class="radio" name="visibility" value="0"<?php
echo (abs($entry['visibility'])==0?' checked="checked"':'');?> /><label for="visibility_private"><?php
echo _t('비공개');?></label></div>
													<div id="status-protected" class="status-protected"<?php
if($isKeyword)
echo _t('style="display: none"');?>><input type="radio" id="visibility_protected" class="radio" name="visibility" value="1"<?php
echo (abs($entry['visibility'])==1?' checked="checked"':'');?> /><label for="visibility_protected"><?php
echo _t('보호');?></label></div>
													<div id="status-public" class="status-public"><input type="radio" id="visibility_public" class="radio" name="visibility" value="2"<?php
echo (abs($entry['visibility'])==2?' checked="checked"':'');?> /><label for="visibility_public"><?php
echo _t('공개');?></label></div>
													<div id="status-syndicated" class="status-syndicated"<?php
if($isKeyword)
echo _t('style="display: none"');?>><input type="radio" id="visibility_syndicated" class="radio" name="visibility" value="3"<?php
echo $countResult==false?' onclick="viewWhatIsEolin()"':NULL;
echo (abs($entry['visibility'])==3?' checked="checked"':'');?> /><label for="visibility_syndicated"><?php
echo _t('발행');?><?php
echo $countResult==true?' (<a href="#void" onclick="viewWhatIsEolin();return false;">'._t('설명').'</a>)':NULL;?></label></div>
												</dd>
											</dl>
												
											<dl id="power-line" class="line"<?php
if($isKeyword)
echo _t('style="display: none"');?>>
												<dt><span class="label"><?php
echo _t('권한');?></span></dt>
												<dd>
													<div class="comment-yes"><input type="checkbox" id="acceptcomment" class="checkbox" name="acceptcomment"<?php
echo ($entry['acceptcomment']?' checked="checked"':'');?> /><label for="acceptcomment"><span class="text"><?php
echo _t('댓글 작성을 허용합니다.');?></span></label></div>
												  	<div class="trackback-yes"><input type="checkbox" id="accepttrackback" class="checkbox" name="accepttrackback"<?php
echo ($entry['accepttrackback']?' checked="checked"':'');?> /><label for="accepttrackback"><span class="text"><?php
echo _t('글을 걸 수 있게 합니다.');?></span></label></div>
												</dd>
											</dl>
										</div>
									</div>
<?php
if(isset($_GET['popupEditor'])){?>
									<div class="button-box two-button-box">
										<input type="button" value="<?php
echo _t('미리보기');?>" class="preview-button input-button" onclick="entryManager.preview();return false;" />
										<span class="hidden">|</span>
										<input type="submit" value="<?php
echo _t('완료하기');?>" class="save-and-return-button input-button" onclick="entryManager.saveAndReturn();return false;" />									
										</div>
<?php
}else{?>
									<div class="button-box three-button-box">
										<input type="button" value="<?php
echo _t('미리보기');?>" class="preview-button input-button" onclick="entryManager.preview();return false;" />
										<span class="hidden">|</span>
						       			<input type="submit" value="<?php
echo _t('완료하기');?>" class="save-and-return-button input-button" onclick="entryManager.saveAndReturn();return false;" />
										<span class="hidden">|</span>
										<input type="submit" value="<?php
echo _t('목록으로');?>" class="list-button input-button" onclick="window.location.href='<?php
echo $blogURL;?>/owner/entry'" />
									</div>
<?php
}?>
								</div>
								
								<input type="hidden" name="categoryAtHome" value="<?php
echo (isset($_POST['category'])?$_POST['category']:'0');?>" />
								<input type="hidden" name="page" value="<?php
echo $suri['page'];?>" />
								<input type="hidden" name="withSearch" value="<?php
echo (empty($_POST['search'])?'':'on');?>" />
								<input type="hidden" name="search" value="<?php
echo (isset($_POST['search'])?htmlspecialchars($_POST['search']):'');?>" />
							</div>
						</form>
						
						<div id="eolinDialog" class="dialog" style="position: absolute; display: none; z-index: 100;">
							<div class="temp-box">
								<h4><?php
echo _t('이올린이란?');?></h4>
								
								<p class="message">
									<?php
echo _t('이올린은 태터툴즈와 태터툴즈 기반의 블로그에서 "발행"을 통해 보내진 글들을 다양한 방법으로 만날 수 있는 태터툴즈 블로거들의 열린 공간입니다.');?>
								</p>
								
								<h4><?php
echo _t('발행 방법');?></h4>
								
								<p class="message">
									<em><?php
echo _t('태터툴즈 글목록에서 발행버튼을 누르거나 글쓰기시 공개범위를 "발행"으로 체크하면 됩니다.');?></em>
									<?php
echo _t('발행을 통해 이올린으로 보내진 게시물들의 저작권을 포함한 일체에 관한 권리는 별도의 의사표시가 없는 한 각 회원에게 있습니다. 이올린에서는 발행된 게시물을 블로거의 동의 없이 상업적으로 이용하지 않습니다. 다만 비영리적 목적인 경우는 이용이 가능하며, 또한 이올린 서비스 내의 게재권, 사용권을 갖습니다.');?>
								</p>
							
								<div class="button-box">
									<button id="eolin-button" class="eolin-button input-button" onclick="window.open('http://www.eolin.com');" title="<?php
echo _t('이올린으로 연결합니다.');?>"><span class="text"><?php
echo _t('이올린 방문');?></span></button>
									<button id="close-button" class="close-button input-button" onclick="closeWhatIsEolin();" title="<?php
echo _t('이 대화상자를 닫습니다.');?>"><span class="text"><?php
echo _t('닫기');?></span></button>
					 			</div>
					 		</div>
				 		</div>
				 		
						<script type="text/javascript">
							//<![CDATA[
								entryManager = new EntryManager();
							//]]>
						</script> 
<?php
if(isset($_GET['popupEditor'])){?>					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
			}
		//]]>
	</script>
</body>
</html>
<?php
}else{?>					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
<?php
}?>
