<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../config.php';
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function setUserSetting($name,$value){
	global $database,$owner;
	$name=cubrid_tt_escape_string($name);
	$value=cubrid_tt_escape_string($value);
	$cell=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '$name'");
	if ($cell===null) {
  	return DBQuery::execute("INSERT INTO {$database['prefix']}UserSettings (\"user\", \"name\", \"value\") VALUES($owner, '$name', '$value')");
  }
  else {
  	return DBQuery::execute("UPDATE {$database['prefix']}UserSettings SET \"value\"='$value' WHERE \"user\" = $owner AND \"name\" = '$name'");
  }
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../config.php')){
	header('Location: '.'../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
{?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
	echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
	echo htmlspecialchars($blog['title']);?> &gt; <?php
	echo _t('플러그인');?></title>
	<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/plugin.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/plugin.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" href="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/plugin.ie7.css" />
	<![endif]-->
<?php
	$plugin=isset($_GET['name'])?$_GET['name']:'';
	$pluginDir=strtok($plugin,'/');
	$adminSkinDir=getUserSetting("adminSkin","default");
	if(file_exists("../../../plugins/$pluginDir/plugin-main.css")){?>
	<link rel="stylesheet" type="text/css" href="<?php
		echo $service['path'];?>/plugins/<?php
		echo $pluginDir;?>/plugin-main.css" />
<?php
	}
	if(file_exists("../../../plugins/$pluginDir/plugin-main.ie.css")){?>
	<!--[if lte IE 6]>
	<link rel="stylesheet" type="text/css" href="<?php
		echo $service['path'];?>/plugins/<?php
		echo $pluginDir;?>/plugin-main.ie.css" />
	<![endif]-->
<?php
	}
	if(file_exists("../../../plugins/$pluginDir/plugin-main.ie7.css")){?>
	<!--[if IE 7]>
	<link rel="stylesheet" type="text/css" href="<?php
		echo $service['path'];?>/plugins/<?php
		echo $pluginDir;?>/plugin-main.ie7.css" />
	<![endif]-->
<?php
	}?>
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
	echo $service['path'];?>";
			var blogurl = "<?php
	echo $blogURL;?>";
			var adminSkin = "<?php
	echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
	echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-plugin">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
	echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
	$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
	echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
	echo $blogURL;?>/" title="<?php
	echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
	echo $blogURL;?>/logout" title="<?php
	echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
	echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
	echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
	echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
	echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
	echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
	echo $blogURL;?>/owner/center/dashboard"><span><?php
	echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
	echo $blogURL;?>/owner/entry"><span class="text"><?php
	echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
	echo $blogURL;?>/owner/link"><span class="text"><?php
	echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
	echo $blogURL;?>/owner/skin"><span class="text"><?php
	echo _t('스킨');?></span></a></li>
						<li id="menu-plugin" class="selected"><a href="<?php
	echo $blogURL;?>/owner/plugin"><span class="text"><?php
	echo _t('플러그인');?></span></a></li>
						<li id="menu-setting"><a href="<?php
	echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
	echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
	echo $blogURL;?>/owner/reader"><span class="text"><?php
	echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

			<div id="layout-body">
				<h2><?php
	echo _t('서브메뉴 : 플러그인');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-plugin"<?php
	echo ((!isset($_GET['name']))?' class="selected"':'');?>><a href="<?php
	echo $blogURL;?>/owner/plugin"><span class="text"><?php
	echo _t('플러그인 목록');?></span></a></li>
<?php
	foreach($adminMenuMappings as $path=>$adminMenuitem){
		$selected=(isset($_GET['name'])&&($_GET['name']==$path))?' class="selected"':'';?>
						<li <?php
		echo $selected;?>><a href="<?php
		echo $blogURL;?>/owner/plugin/adminMenu?name=<?php
		echo $path;?>"><span class="text"><?php
		echo $adminMenuitem['title'];?></span></a></li>
	<?php
	}?>
						<li id="sub-menu-plugin-tablesetting"><a href="<?php
	echo $blogURL;?>/owner/plugin/tableSetting"><span class="text"><?php
	echo _t('플러그인 데이터 관리');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
	echo getHelpURL('plugin');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
	echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
}
if(empty($_POST['sortType'])){
	$sortType=getUserSetting("pluginListSortType","ascend");
	$_POST['sortType']=$sortType;
}
setUserSetting("pluginListSortType",$_POST['sortType']);
if(empty($_POST['scopeType'])){
	$scopeType=getUserSetting("pluginListScopeType","all");
	$_POST['scopeType']=$scopeType;
}
{
	setUserSetting("pluginListScopeType",$_POST['scopeType']);
}
if(empty($_POST['listedPluginStatus'])){
	$listType=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = 'listedPluginStatus'");
	$_POST['listedPluginStatus']=($listType==false)?array("activated","deactivated"):explode("|",$listType);
}elseif(is_array($_POST['listedPluginStatus'])){
	sort($_POST['listedPluginStatus']);
	if($_POST['listedPluginStatus']!=array("activated")&&$_POST['listedPluginStatus']!=array("deactivated")&&$_POST['listedPluginStatus']!=array("activated","deactivated")){
		$_POST['listedPluginStatus']=array("activated","deactivated");
	}
}else{
	$_POST['listedPluginStatus']=array("activated","deactivated");
}
if(!DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = 'listedPluginStatus'")){
	DBQuery::execute("INSERT INTO {$database['prefix']}UserSettings (\"user\", \"name\", \"value\") VALUES ($owner, 'listedPluginStatus', '".implode("|",$_POST['listedPluginStatus'])."')");
}else{
	DBQuery::execute("UPDATE {$database['prefix']}UserSettings SET \"value\" = '".implode("|",$_POST['listedPluginStatus'])."' WHERE \"user\" = $owner AND \"name\" = 'listedPluginStatus'");
}?>
						<script type="text/javascript">
							//<![CDATA[
								function togglePlugin(plugin, num, width, height, scope) {
									tempStr = document.getElementById("plugin" + num + "Link").innerHTML;
									
									if (!tempStr.match('<?php
echo _t('사용중');?>')) {
										var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/plugin/activate");
										request.onSuccess = function() {												
											document.getElementById("plugin" + num + "Link").className = 'active-class';
											
											document.getElementById("plugin" + num + "Link").innerHTML = '<span class="text"><?php
echo _t('사용중');?><\/span>';
											document.getElementById("plugin" + num + "Link").setAttribute('title', '<?php
echo _t('이 플러그인은 사용중입니다. 클릭하시면 사용을 중지합니다.');?>');
											
											objTR = getParentByTagName("TR", document.getElementById("plugin" + num + "Link"));
											objTR.className = objTR.className.replace('inactive', 'active');
											
											if (objTR.cells[5].innerHTML.match('<?php
echo _t('설정');?>')) {
												objTR.cells[5].innerHTML = '<a href="#void" id="config_' + num +'" class="config-enabled-icon bullet" onclick="getCurrentSetting(\'' + plugin + '\',\'Y\',\''+width+'\',\''+height+'\')"><?php
echo _t('설정');?><\/a>';
											}
											tempStr = document.getElementById("plugin" + num + "Scope").innerHTML;
											if (tempStr.match('<?php
echo _t('관리자');?>'))
											{
												changeList();
											}
										}
										request.onError = function() {
											alert("<?php
echo _t('플러그인을 활성화하는데 실패했습니다.');?>");
										}
										request.send("name=" + plugin + "&scope=" + scope);
									} else {
										var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/plugin/deactivate");
										request.onSuccess = function() {
											document.getElementById("plugin" + num + "Link").className = 'inactive-class';
											
											document.getElementById("plugin" + num + "Link").innerHTML = '<span class="text"><?php
echo _t('미사용');?><\/span>';
											document.getElementById("plugin" + num + "Link").setAttribute('title', '<?php
echo _t('이 플러그인은 사용중지 상태입니다. 클릭하시면 사용을 시작합니다.');?>');
											
											objTR = getParentByTagName("TR", document.getElementById("plugin" + num + "Link"));
											objTR.className = objTR.className.replace('active', 'inactive');
											
											if (objTR.cells[5].innerHTML.match('<?php
echo _t('설정');?>')) {
												objTR.cells[5].innerHTML = '<span class="config-disabled-icon bullet"><?php
echo _t('설정');?><\/span>';
											}
											tempStr = document.getElementById("plugin" + num + "Scope").innerHTML;
											if (tempStr.match('<?php
echo _t('관리자');?>'))
											{
												changeList();
											}
										}
										request.onError = function() {
											alert("<?php
echo _t('플러그인을 비활성화하는데 실패했습니다.');?>");
										}
										request.send("name=" + plugin + "&scope=" + scope);
									}
								}
								
<?php
{?>
								function changeList() {
									document.getElementById("part-plugin-list").submit();
								}
<?php
}?>
								
								window.addEventListener("load", execLoadFunction, false);
								
								function execLoadFunction() {
									removeItselfById('submit-button-box');
								}
								
								var currentSetting='';
								function getCurrentSetting( plugin, setYN, width, height){
									if( "N" == setYN ) return ;
									if( '' != currentSetting ) currentSetting.close();
									window.open('<?php
echo $blogURL;?>/owner/plugin/currentSetting/?Name='+plugin,'CurrentSetting', 'width='+width+', height='+height+', scrollbars=1, status=0, resizable=1');	
									return;
								}								
							//]]>
						</script>
						
						<form id="<?php
echo 'part-plugin-list';?>" class="part" method="post" action="<?php
echo $blogURL."/owner/plugin";?>">
							<h2 class="caption"><span class="main-text"><?php
echo _t('설치된 플러그인입니다');?></span></h2>
							
							<div class="main-explain-box">
								<p class="explain"><?php
echo _t('플러그인은 태터툴즈의 기능을 확장합니다. 이 곳에서 설치된 플러그인의 사용 여부를 결정할 수 있습니다.');?></p>
							</div>
							
							<fieldset id="plugin-display-box">
								<legend><?php
echo _t('표시될 플러그인 설정');?></legend>

<?php
{?>
								<dl id="scope-line" class="line">
									<dt><?php
	echo _t('종류');?></dt>
									<dd>
										<input type="radio" class="radio" id="global-scope" name="scopeType" value="all" onclick="changeList()"<?php
	echo $_POST['scopeType']=="all"?' checked="checked"':'';?> /><label id="global-scope-label" for="global-scope"<?php
	echo $_POST['scopeType']=="all"?' class="selected"':'';?>><?php
	echo _t('전체');?></label>
										<input type="radio" class="radio" id="common-scope" name="scopeType" value="global" onclick="changeList()"<?php
	echo $_POST['scopeType']=="global"?' checked="checked"':'';?> /><label id="common-scope-label" for="common-scope"<?php
	echo $_POST['scopeType']=="global"?' class="selected"':'';?>><?php
	echo _t('일반');?></label>
										<input type="radio" class="radio" id="blog-scope" name="scopeType" value="blog" onclick="changeList()"<?php
	echo $_POST['scopeType']=="blog"?' checked="checked"':'';?> /><label id="blog-scope-label" for="blog-scope"<?php
	echo $_POST['scopeType']=="blog"?' class="selected"':'';?>><?php
	echo _t('블로그');?></label>
										<input type="radio" class="radio" id="sidebar-scope" name="scopeType" value="sidebar" onclick="changeList()"<?php
	echo $_POST['scopeType']=="sidebar"?' checked="checked"':'';?> /><label id="sidebar-scope-label" for="sidebar-scope"<?php
	echo $_POST['scopeType']=="sidebar"?' class="selected"':'';?>><?php
	echo _t('사이드바');?></label>
										<input type="radio" class="radio" id="admin-scope" name="scopeType" value="admin" onclick="changeList()"<?php
	echo $_POST['scopeType']=="admin"?' checked="checked"':'';?> /><label id="admin-scope-label" for="admin-scope"<?php
	echo $_POST['scopeType']=="admin"?' class="selected"':'';?>><?php
	echo _t('관리자');?></label>
										<input type="radio" class="radio" id="none-scope" name="scopeType" value="none" onclick="changeList()"<?php
	echo $_POST['scopeType']=="none"?' checked="checked"':'';?> /><label id="none-scope-label" for="none-scope"<?php
	echo $_POST['scopeType']=="none"?' class="selected"':'';?>><?php
	echo _t('분류 없음');?></label>
									</dd>
								</dl>
<?php
}?>
								<dl id="sorting-line" class="line">
									<dt><?php
echo _t('정렬');?></dt>
									<dd>
										<input type="radio" class="radio" id="ascend-sorting" name="sortType" value="ascend" onclick="changeList()"<?php
echo $_POST['sortType']=="ascend"?' checked="checked"':'';?> /><label for="ascend-sorting"><?php
echo _t('오름차순');?></label>
										<input type="radio" class="radio" id="descend-sorting" name="sortType" value="descend" onclick="changeList()"<?php
echo $_POST['sortType']=="descend"?' checked="checked"':'';?> /><label for="descend-sorting"><?php
echo _t('내림차순');?></label>
									</dd>
								</dl>
								<dl id="activate-status-line" class="line">
									<dt><?php
echo _t('상태');?></dt>
									<dd>
										<input type="checkbox" class="checkbox" id="activated-plugin" name="listedPluginStatus[]" value="activated" onclick="changeList()"<?php
echo in_array("activated",$_POST['listedPluginStatus'])?' checked="checked"':'';?> /><label for="activated-plugin"><?php
echo _t('사용중인 플러그인');?></label>
										<input type="checkbox" class="checkbox" id="deactivated-plugin" name="listedPluginStatus[]" value="deactivated" onclick="changeList()"<?php
echo in_array("deactivated",$_POST['listedPluginStatus'])?' checked="checked"':'';?> /><label for="deactivated-plugin"><?php
echo _t('사용하지 않는 플러그인');?></label>
									</dd>
								</dl>
								
								<div id="submit-button-box" class="button-box">
									<input type="submit" value="<?php
echo _t('플러그인 목록 갱신');?>" />
								</div>
							</fieldset>
							
							<table class="data-inbox" cellspacing="0" cellpadding="0">
								<thead>
									<tr>
										<th class="title"><span class="text"><?php
echo _t('제목');?></span></th>
										<th class="version"><span class="text"><?php
echo _t('버전');?></span></th>
										<th class="scope"><span class="text"><?php
echo _t('종류');?></span></th>
										<th class="explain"><span class="text"><?php
echo _t('설명');?></span></th>
										<th class="maker"><span class="text"><?php
echo _t('만든이');?></span></th>
										<th class="config"><span class="text"><?php
echo _t('설정');?></span></th>
										<th class="status"><span class="text"><?php
echo _t('상태');?></span></th>
									</tr>
								</thead>
								<tbody>
<?php
$plugins=array();
$pluginAttrs=array();
$dir=dir('../../../plugins/');
while($plugin=$dir->read()){
	if(!ereg('^[[:alnum:] _-]+$',$plugin))
		continue;
	if(!is_dir(ROOT.'/plugins/'.$plugin))
		continue;
	if(!file_exists("../../../plugins/$plugin/index.xml"))
		continue;
	$xmls=new XMLStruct();
	if(!$xmls->open(file_get_contents("../../../plugins/$plugin/index.xml"))){
		continue;
	}else{
		$pluginDir=trim($plugin);
		$pluginAttrs[$pluginDir]=array("link"=>$xmls->getValue('/plugin/link[lang()]'),"title"=>htmlspecialchars($xmls->getValue('/plugin/title[lang()]')),"version"=>htmlspecialchars($xmls->getValue('/plugin/version[lang()]')),"description"=>htmlspecialchars($xmls->getValue('/plugin/description[lang()]')),"authorLink"=>$xmls->getAttribute('/plugin/author[lang()]','link'),"author"=>htmlspecialchars($xmls->getValue('/plugin/author[lang()]')),"scope"=>array(),"config"=>$xmls->doesExist('/plugin/binding/config'),"width"=>$xmls->getAttribute('/plugin/binding/config/window','width'),"height"=>$xmls->getAttribute('/plugin/binding/config/window','height'));
		if($xmls->doesExist('/plugin/binding/adminMenu'))
			array_push($pluginAttrs[$pluginDir]['scope'],'admin');
		if($xmls->doesExist('/plugin/binding/tag'))
			array_push($pluginAttrs[$pluginDir]['scope'],'blog');
		if($xmls->doesExist('/plugin/binding/center'))
			array_push($pluginAttrs[$pluginDir]['scope'],'dashboard');
		if($xmls->doesExist('/plugin/binding/listener'))
			array_push($pluginAttrs[$pluginDir]['scope'],'global');
		if($xmls->doesExist('/plugin/binding/sidebar'))
			array_push($pluginAttrs[$pluginDir]['scope'],'sidebar');
		$plugins[$pluginDir]=$pluginAttrs[$pluginDir]['title'];
	}
}
if($_POST['sortType']=="ascend"){
	asort($plugins);
}else{
	arsort($plugins);
}
$arrayKeys=array_keys($plugins);
$rowCount=0;
for($i=0;$i<count($arrayKeys);$i++){
	$pluginDir=$arrayKeys[$i];
	$link=$pluginAttrs[$pluginDir]['link'];
	$title=$pluginAttrs[$pluginDir]['title'];
	$version=$pluginAttrs[$pluginDir]['version'];
	$description=$pluginAttrs[$pluginDir]['description'];
	$authorLink=$pluginAttrs[$pluginDir]['authorLink'];
	$author=$pluginAttrs[$pluginDir]['author'];
	$scope=$pluginAttrs[$pluginDir]['scope'];
	$config=$pluginAttrs[$pluginDir]['config']?'Y':'N';
	$width=$pluginAttrs[$pluginDir]['width']?$pluginAttrs[$pluginDir]['width']:500;
	$height=$pluginAttrs[$pluginDir]['height']?$pluginAttrs[$pluginDir]['height']:400;
	$active=in_array($pluginDir,$activePlugins);
	if(count($scope)==0)
		$scope=array('none');
	if($_POST['scopeType']!='all')
		if(!in_array($_POST['scopeType'],$scope))
			continue;
	{
		if(in_array('dashboard',$scope)&&(count($scope)==1)){
			continue;
		}
	}
	if($active==true&&!in_array("activated",$_POST['listedPluginStatus']))
		continue;
	elseif($active==false&&!in_array("deactivated",$_POST['listedPluginStatus']))
		continue;
	$className=($rowCount%2)==1?'even-line':'odd-line';
	$className.=($i==sizeof($plugins)-1)?' last-line':'';
	$className.=$active?' active-class':' inactive-class';?>
									<tr class="<?php
	echo $className;?>" onmouseover="rolloverClass(this, 'over')" onmouseout="rolloverClass(this, 'out')">
										<td class="title"><?php
	echo ($link?'<a href="'.htmlspecialchars($link).'">'.$title.'</a>':$title);?></td>
										<td class="version"><?php
	echo $version;?></td>
										<td id="plugin<?php
	echo $i;?>Scope" class="scope">
<?php
	echo str_repeat("\t",11);
	for($j=0;$j<count($scope);$j++){
		if($j!=0){
			echo ', ';
		}
		switch($scope[$j]){
			case 'global':
				echo _t('일반');
				break;
			case 'blog':
				echo _t('블로그');
				break;
			case 'admin':
				echo _t('관리자');
				break;
			case 'sidebar':
				echo _t('사이드바');
				break;
			case 'dashboard':
				echo _t('자투리');
				break;
			default:
				echo _t('미지정');
				break;
		}
	}
	echo CRLF;?>
										</td>
										<td class="explain"><?php
	echo $description;?></td>
										<td class="maker"><?php
	echo ($authorLink?'<a href="'.htmlspecialchars($authorLink).'">'.$author.'</a>':$author);?></td>
										<td class="config">
<?php
	if($config=='Y'){
		if($active){?>
											<a href="#void" id="config_<?php
			echo $i;?>" class="config-enabled-icon bullet" onclick="getCurrentSetting('<?php
			echo $pluginDir;?>','<?php
			echo $config;?>','<?php
			echo $width;?>','<?php
			echo $height;?>')"><?php
			echo _t('설정');?></a>
<?php
		}else{?>
											<span class="config-disabled-icon bullet"><?php
			echo _t('설정');?></span>
<?php
		}
	}else{?>
											<span class="config-none-icon bullet"><?php
		echo _t('없음');?></span>
<?php
	}?>
										</td>
										<td class="status">
<?php
	if($active){?>
											<a id="plugin<?php
		echo $i;?>Link" class="active-class" href="#void" onclick="togglePlugin('<?php
		echo $pluginDir;?>',<?php
		echo $i;?>,'<?php
		echo $width;?>','<?php
		echo $height;?>', '<?php
		echo $scope;?>')" title="<?php
		echo _t('이 플러그인은 사용중입니다. 클릭하시면 사용을 중지합니다.');?>"><span class="text"><?php
		echo _t('사용중');?></span></a>
<?php
	}else{?>
											<a id="plugin<?php
		echo $i;?>Link" class="inactive-class" href="#void" onclick="togglePlugin('<?php
		echo $pluginDir;?>',<?php
		echo $i;?>,'<?php
		echo $width;?>','<?php
		echo $height;?>', '<?php
		echo $scope;?>')" title="<?php
		echo _t('이 플러그인은 사용중지 상태입니다. 클릭하시면 사용을 시작합니다.');?>"><span class="text"><?php
		echo _t('미사용');?></span></a>
<?php
	}?>
										</td>
									</tr>
<?php
	$rowCount++;
}?>
								</tbody>
							</table>

							<div id="data-description">
								<dl class="title-description">
									<dt><?php
echo _t('제목');?></dt>
									<dd><?php
echo _t('manifest 에서 정의한 플러그인 이름');?></dd>
								</dl>
								<dl class="version-description">	
									<dt><?php
echo _t('버전');?></dt>
									<dd><?php
echo _t('플러그인 버전');?></dd>
								</dl>
								<dl class="kind-description">	
									<dt><?php
echo _t('종류');?></dt>
									<dd><?php
echo _t('플러그인의 기능별 분류');?></dd>
								</dl>
								<dl class="explain-description">	
									<dt><?php
echo _t('설명');?></dt>
									<dd><?php
echo _t('작성자의 설명');?></dd>
								</dl>
								<dl class="author-description">	
									<dt><?php
echo _t('작성자');?></dt>
									<dd><?php
echo _t('해당 플러그인의 제작,수정,배포의 권한을 가진 사람 또는 단체');?></dd>
								</dl>
								<dl class="setting-description">	
									<dt><?php
echo _t('설정');?></dt>
									<dd><?php
echo _t('설정이 있는경우 각 항목을 클릭하여 설정창을 불러올 수 있습니다.');?></dd>
								</dl>
								<dl class="status-description">	
									<dt><?php
echo _t('상태');?></dt>
									<dd><?php
echo _t('상태 항목을 클릭하면 플러그인을 활성화/비활성화 할 수 있습니다.');?></dd>
								</dl>
							</div>	
						</form>
						
						<div id="part-plugin-more" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('플러그인을 구하려면');?></span></h2>
							
<?php
$linkString='<a href="http://plugin.tattertools.com/" onclick="window.open(this.href); return false;" title="'._t('플러그인 업로드 게시판으로 연결합니다.').'">'._t('플러그인 업로드 게시판').'</a>';
$tempString=_f('태터툴즈 홈페이지의 %1을 방문하시면 다양한 플러그인을 다운로드 하실 수 있습니다. 일반적으로 플러그인 파일을 태터툴즈의 plugin 디렉토리로 업로드하면 설치가 완료됩니다. 업로드가 완료된 플러그인은 이 메뉴에서 사용중으로 전환하여 사용을 시작합니다. 추천 플러그인에 대한 정보는 <a href="http://blog.tattertools.com/plugin" onclick="window.open(this.href); return false;">태터앤 프렌즈의 플러그인 리뷰</a>를 참고하십시오.',$linkString);?>
							<div class="main-explain-box">
								<p class="explain"><?php
echo $tempString;?></p>
							</div>
						</div>
					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
