<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../..');
$IV=array('GET'=>array('forceRefresh'=>array('any','mandatory'=>false)));
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../config.php';
function escapeJSInAttribute($str){
	return htmlspecialchars(str_replace(array('\\','\r','\n','\''),array('\\\\','\\r','\\n','\\\''),$str));
}
function filterJavaScript($str,$removeScript=true){
	if($removeScript){
		preg_match_all('/<.*?>/s',$str,$matches);
		foreach($matches[0] as $tag){
			$strippedTag=$tag;
			preg_match_all('/\s+on\w+?\s*?=\s*?("|\').*?\1/s',$strippedTag,$subMatches);
			foreach($subMatches[0] as $attribute)
				$strippedTag=str_replace($attribute,'',$strippedTag);
			preg_match_all('/\s+on\w+?\s*?=\s*?[^\s>]*/s',$tag,$subMatches);
			foreach($subMatches[0] as $attribute)
				$strippedTag=str_replace($attribute,'',$strippedTag);
			$str=str_replace($tag,$strippedTag,$str);
		}
		$str=preg_replace('/<\/?iframe.*?>/si','',$str);
		$str=preg_replace('/<script.*?<\/script>/si','',$str);
		$str=preg_replace('/<object.*?type=["\']?text\/x-scriptlet["\']?.*?>(.*?<\/object>)?/si','',$str);
		$str=preg_replace('/j\s*?a\s*?v\s*?a\s*?s\s*?c\s*?r\s*?i\s*?p\s*?t\s*?:/si','',$str);
	}else
		$str=str_replace('<script','<script defer="defer"',$str);
	return $str;
}
function escapeCubridSearchString($str){
	return is_string($str)?str_replace('_','\_',str_replace('%','\%',cubrid_tt_escape_string($str))):$str;
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getReaderSetting($owner){
	global $database;
	return DBQuery::queryRow("SELECT * FROM {$database['prefix']}FeedSettings WHERE owner = $owner");
}
function getFeedGroups($owner,$starredOnly=false,$searchKeyword=null){
	global $database;
	$searchKeyword=escapeCubridSearchString($searchKeyword);
	if($starredOnly!==false){
		$condition="AND s.item IS NOT NULL";
	}elseif($searchKeyword!==null){
		$condition="AND (i.title LIKE '%{$searchKeyword}%' OR i.description LIKE '%{$searchKeyword}%')";
	}else{
		$condition='';
	}
	$sql="SELECT
					g.id, g.title
				FROM
					{$database['prefix']}FeedGroups g
				LEFT JOIN
					{$database['prefix']}FeedGroupRelations r
				ON
					r.owner = $owner AND
					r.owner = g.owner AND
					g.id = r.groupId
				LEFT JOIN
					{$database['prefix']}FeedItems i
				ON
					r.feed = i.feed
				LEFT JOIN
					{$database['prefix']}FeedStarred s
				ON
					s.owner = $owner AND
					i.id = s.item
				WHERE
					g.owner = $owner
					$condition
                GROUP BY g.id, g.title
				ORDER BY g.title";
	return DBQuery::queryAll($sql);
}
function getFeeds($owner,$group=0,$starredOnly=false,$searchKeyword=null){
	global $database;
	$searchKeyword=escapeCubridSearchString($searchKeyword);
	if($starredOnly!==false){
		$condition="AND s.item IS NOT NULL";
	}elseif($searchKeyword!==null){
		$condition="AND (i.title LIKE '%{$searchKeyword}%' OR i.description LIKE '%{$searchKeyword}%')";
	}else{
		$condition='';
	}
	$condition.=($group==0)?'':" AND g.id = $group";
	$sql="SELECT
					f.id, f.xmlurl, f.blogurl, f.title, f.description, f.modified
				FROM
					{$database['prefix']}FeedGroups g,
					{$database['prefix']}FeedGroupRelations r,
					{$database['prefix']}Feeds f
				LEFT JOIN
					{$database['prefix']}FeedItems i
				ON
					f.id = i.feed
				LEFT JOIN
					{$database['prefix']}FeedStarred s
				ON
					s.owner = $owner AND
					i.id = s.item
				WHERE
					r.owner = $owner AND
					r.owner = g.owner AND
					g.id = r.groupId AND
					r.feed = f.id
					$condition
				ORDER BY f.title";
	return DBQuery::queryFilterAll($sql,'id');
}
function getFeedEntriesTotalCount($owner,$group=0,$feed=0,$unreadOnly=false,$starredOnly=false,$searchKeyword=null){
	global $database;
	$searchKeyword=escapeCubridSearchString($searchKeyword);
	if($starredOnly!==false){
		$condition='AND s.item IS NOT NULL';
	}elseif($searchKeyword!==null){
		$condition="AND (i.title LIKE '%{$searchKeyword}%' OR i.description LIKE '%{$searchKeyword}%')";
	}else{
		$condition='';
	}
	$condition.=($group==0)?'':" AND g.id = $group";
	$condition.=($feed==0)?'':" AND f.id = $feed";
	$condition.=($unreadOnly==false)?'':' AND rd.item IS NULL';
	$sql="SELECT
					COUNT(i.id)
				FROM
					{$database['prefix']}FeedGroups g,
					{$database['prefix']}FeedGroupRelations r,
					{$database['prefix']}Feeds f
				LEFT JOIN
					{$database['prefix']}FeedItems i
				ON
					f.id = i.feed
				LEFT JOIN					
					{$database['prefix']}FeedStarred s
				ON
					s.owner = $owner AND
					i.id = s.item
				LEFT JOIN					
					{$database['prefix']}FeedReads rd
				ON
					rd.owner = $owner AND
					i.id = rd.item
				WHERE
					r.owner = $owner AND
					r.owner = g.owner AND
					g.id = r.groupId AND
					r.feed = f.id
					$condition";
	return DBQuery::queryCell($sql);
}
function getFeedEntries($owner,$group=0,$feed=0,$unreadOnly=false,$starredOnly=false,$searchKeyword=null,$offset=0){
	global $database;
	$searchKeyword=escapeCubridSearchString($searchKeyword);
	if($starredOnly!==false){
		$condition='AND s.item IS NOT NULL';
	}elseif($searchKeyword!==null){
		$condition="AND (i.title LIKE '%{$searchKeyword}%' OR i.description LIKE '%{$searchKeyword}%')";
	}else{
		$condition='';
	}
	$condition.=($group==0)?'':" AND g.id = $group";
	$condition.=($feed==0)?'':" AND f.id = $feed";
	$condition.=($unreadOnly==false)?'':' AND rd.item IS NULL';
	$sql="SELECT
					s.item, i.id, i.title entry_title, i.enclosure, f.title blog_title, i.written, i.tags, i.author, rd.item wasread
				FROM
					{$database['prefix']}FeedGroups g,
					{$database['prefix']}FeedGroupRelations r,
					{$database['prefix']}Feeds f,
					{$database['prefix']}FeedItems i
				LEFT JOIN					
					{$database['prefix']}FeedStarred s
				ON
					s.owner = $owner AND
					i.id = s.item
				LEFT JOIN					
					{$database['prefix']}FeedReads rd
				ON
					rd.owner = $owner AND
					i.id = rd.item
				WHERE
					r.owner = $owner AND
					r.owner = g.owner AND
					g.id = r.groupId AND
					r.feed = f.id AND
					f.id = i.feed
					$condition
				ORDER BY i.written DESC, i.id DESC";
	$sql.=" FOR ORDERBY_NUM() BETWEEN ".($offset+1)." AND ".($offset+($offset==0?100:min($offset,400)));
	return DBQuery::queryFilterAll($sql,'id');
}
function getFeedEntry($owner,$group=0,$feed=0,$entry=0,$unreadOnly=false,$starredOnly=false,$searchKeyword=null,$position='current',$markAsRead='read'){
	global $database;
	$setting=getReaderSetting($owner);
	$searchKeyword=escapeCubridSearchString($searchKeyword);
	if($entry==0||$position!='current'){
		if($starredOnly!==false){
			$condition='AND s.item IS NOT NULL';
		}elseif($searchKeyword!==null){
			$condition="AND (i.title LIKE '%{$searchKeyword}%' OR i.description LIKE '%{$searchKeyword}%')";
		}else{
			$condition='';
		}
		$condition.=($group==0)?'':" AND g.id = $group";
		$condition.=($feed==0)?'':" AND f.id = $feed";
		$sql="SELECT
						i.id, i.title entry_title, i.description, f.title blog_title, i.author, i.written, i.tags, i.permalink, rd.item wasread, f.\"language\", enclosure
					FROM
						{$database['prefix']}FeedGroups g,
						{$database['prefix']}FeedGroupRelations r,
						{$database['prefix']}Feeds f,
						{$database['prefix']}FeedItems i
					LEFT JOIN					
						{$database['prefix']}FeedStarred s
					ON
						s.owner = $owner AND
						i.id = s.item
					LEFT JOIN					
						{$database['prefix']}FeedReads rd
					ON
						rd.owner = $owner AND
						i.id = rd.item
					WHERE
						r.owner = $owner AND
						r.owner = g.owner AND
						g.id = r.groupId AND
						r.feed = f.id AND
						f.id = i.feed
						$condition
					ORDER BY i.written DESC, i.id DESC";
		if($position=='current'){
			if($row=DBQuery::queryRow("$sql FOR ORDERBY_NUM() = 1 ")){
				$row['description']=adjustRelativePathImage($row['description'],$row['permalink']);
				$row['description']=filterJavaScript($row['description'],($setting['allowscript']==1?false:true));
			}
			return $row;
		}else{
			$result=DBQuery::query($sql);
			$prevRow=null;
            unset($partial_groupby);
			while($row=cubrid_fetch($result)){
                if ($partial_groupby[$row['id']]==1) continue;
                $partial_groupby[$row['id']]=1;
				if($row['id']==$entry){
					if($position=='before'){
						while($row=cubrid_fetch($result)){
							if($unreadOnly==false||!$row['wasread'])
								break;
						}
						if($markAsRead=='read') {
                            if (DBQuery::queryCount("SELECT item FROM {$database['prefix']}FeedReads WHERE owner = $owner AND item = {$row['id']}")<=0)
                                DBQuery::execute("INSERT INTO {$database['prefix']}FeedReads VALUES($owner, {$row['id']})");
                        }
						if($row){
							$row['description']=adjustRelativePathImage($row['description'],$row['permalink']);
							$row['description']=filterJavaScript($row['description'],($setting['allowscript']==1?false:true));
						}
                        DBQuery::commit();
						return $row;
					}elseif($position=='after'){
						if($markAsRead=='read') {
                            if (DBQuery::queryCount("SELECT item FROM {$database['prefix']}FeedReads WHERE owner = $owner AND item = {$prevRow['id']}")<=0)
                                DBQuery::execute("INSERT INTO {$database['prefix']}FeedReads VALUES($owner, {$prevRow['id']})");
                        }
						if($prevRow){
							$prevRow['description']=adjustRelativePathImage($prevRow['description'],$row['permalink']);
							$prevRow['description']=filterJavaScript($prevRow['description'],($setting['allowscript']==1?false:true));
						}
                        DBQuery::commit();
						return $prevRow;
					}
				}
				if($unreadOnly==false||!$row['wasread'])
					$prevRow=$row;
			}
			return ;
		}
	}else{
        if (DBQuery::queryCount("SELECT item FROM {$database['prefix']}FeedReads WHERE owner = $owner AND item = $entry")<=0)
           DBQuery::execute("INSERT INTO {$database['prefix']}FeedReads VALUES($owner, $entry)");
		$sql="SELECT
						i.id, i.title entry_title, i.description, f.title blog_title, i.author, i.written, i.tags, i.permalink, f.\"language\", enclosure
					FROM
						{$database['prefix']}FeedGroups g,
						{$database['prefix']}FeedGroupRelations r,
						{$database['prefix']}Feeds f,
						{$database['prefix']}FeedItems i
					WHERE
						r.owner = $owner AND
						r.owner = g.owner AND
						r.feed = f.id AND
						r.groupId = g.id AND
						i.id = $entry AND
						f.id = i.feed";
		if($row=DBQuery::queryRow($sql)){
			$row['description']=adjustRelativePathImage($row['description'],$row['permalink']);
			$row['description']=filterJavaScript($row['description'],($setting['allowscript']==1?false:true));
		}
		return $row;
	}
}
function adjustRelativePathImage($str,$permalink){
	$link=parse_url($permalink);
	if(empty($link['scheme']))
		return $str;
	$port=(empty($link['port'])||$link['port']==80)?'':":{$link['port']}";
	$urls=array();
	preg_match_all('/<img[^>]+?src=("|\')?(.*?)("|\')/si',$str,$matches);
	foreach($matches[2] as $src)
		array_push($urls,$src);
	foreach($urls as $url){
		if($url&&!preg_match('/^(http:|ftp:)/i',$url)){
			$newSrc=($url{0}=='/')?$url:"/$url";
			$str=str_replace($url,"{$link['scheme']}://{$link['host']}$port$newSrc",$str);
		}
	}
	return $str;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../config.php')){
	header('Location: '.'../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
function printFeedGroups($owner,$selectedGroup=0,$starredOnly=false,$searchKeyword=null){
	global $service;?>
													<div id="groupAdder">
														<div class="title"><span class="text"><?php
	echo _t('그룹 등록하기');?></span></div>
														<div class="button-box">
															<input type="text" id="newGroupTitle" class="input-text" value="<?php
	echo _t('그룹을 추가하세요.');?>" onfocus="if(this.value == '<?php
	echo _t('그룹을 추가하세요.');?>') this.value = ''" onblur="if(this.value == '') this.value = '<?php
	echo _t('그룹을 추가하세요.');?>'" onkeydown="if(event.keyCode==13) Reader.addGroup(this.value)" />
															<a class="add-button button" href="#void" onclick="Reader.addGroup(document.getElementById('newGroupTitle').value)"><span class="text"><?php
	echo _t('추가');?></span></a>
														</div>
													</div>

													<ul id="groupList">
<?php
	$count=0;
	foreach(getFeedGroups($owner,$starredOnly,$searchKeyword) as $group){
		if($group['id']==0)
			$group['title']=_t('전체보기');
		$className=($count%2)==1?'even-line':'odd-line';
		$className.=($selectedGroup==$group['id'])?' active-class':' inactive-class';?>
														<li id="groupList<?php
		echo $group['id'];?>" class="<?php
		echo $className;?>" onmouseover="rolloverClass(this, 'over')" onmouseout="rolloverClass(this, 'out')">
															<div class="title">
																<a href="#void" onclick="Reader.selectGroup(this, <?php
		echo $group['id'];?>)"><?php
		echo htmlspecialchars($group['title']);?></a>
															</div>
<?php
		if($group['id']){?>

															<div class="button-box">
																<a class="edit-button button" href="#void" onclick="Reader.editGroup(<?php
			echo $group['id'];?>, '<?php
			echo escapeJSInAttribute($group['title']);?>'); return false;" title="<?php
			echo _t('이 그룹 정보를 수정합니다.');?>"><span class="text"><?php
			echo _t('수정');?></span></a>
															</div>
<?php
		}?>
														</li>
<?php
		$count++;
	}?>
													</ul>

													<div id="groupEditor" style="display: none;">
														<div class="title"><span><?php
	echo _t('그룹 수정하기');?></span></div>
														<div class="input-box">
															<div class="input-field">
																<input type="text" id="changeGroupTitle" class="input-text" name="changeGroupTitle" />
															</div>
															<div class="button-box">
																<input type="button" class="delete-button input-button" value="<?php
	echo _t('삭제');?>" onclick="Reader.deleteGroup(); return false;" />
																<span class="divider">|</span>
																<input type="submit" class="edit-button input-button" value="<?php
	echo _t('저장');?>" onclick="Reader.editGroupExecute(); return false;" />
																<span class="divider">|</span>
																<input type="button" class="cancel-button input-button" value="<?php
	echo _t('취소');?>" onclick="Reader.cancelEditGroup(); return false;" />
															</div>
														</div>
													</div>
<?php
}
function printFeeds($owner,$group=0,$starredOnly=false,$searchKeyword=null){
	global $service;?>
													<div id="feedAdder">
														<div class="title"><span><?php
	echo _t('피드 등록하기');?></span></div>
														<div class="button-box">
															<input type="text" id="newFeedURL" class="input-text" name="newFeedURL" value="<?php
	echo _t('피드 주소를 입력하세요.');?>" onfocus="if(this.value == '<?php
	echo _t('피드 주소를 입력하세요.');?>') this.value = ''" onblur="if(this.value == '') this.value = '<?php
	echo _t('피드 주소를 입력하세요.');?>'" onkeydown="if(event.keyCode==13) Reader.addFeed(this.value)" />
															<a class="add-button button" href="#void" onclick="Reader.addFeed(document.getElementById('newFeedURL').value)"><span class="text"><?php
	echo _t('추가');?></span></a>
															<?php
	echo fireEvent('AddFeedURLToolbox','');?>
														</div>
													</div>

													<ul id="feedList">
<?php
	$count=0;
	foreach(getFeeds($owner,$group,$starredOnly,$searchKeyword) as $feed){
		if($feed['modified']>time()-86400)
			$status='Update';
		elseif($feed['modified']==0)
			$status='Failure';
		else
			$status='UpdateNo';
		$className=($count%2)==1?'even-line':'odd-line';?>
														<li class="<?php
		echo $className;?> inactive-class" onmouseover="rolloverClass(this, 'over')" onmouseout="rolloverClass(this, 'out')" onclick="Reader.selectFeed(this, <?php
		echo $feed['id'];?>)">
															<div class="title"><?php
		echo $feed['blogurl']?'<a href="'.htmlspecialchars($feed['blogurl']).'" onclick="window.open(this.href); event.cancelBubble=true; return false;" title="'._t('이 피드의 원본 사이트를 새 창으로 엽니다.').'">':'';?><?php
		echo htmlspecialchars($feed['title']);?><?php
		echo $feed['blogurl']?"</a>\n":'';?></div>
															<div class="description"><?php
		echo $feed['description']?'<span class="divider"> | </span>':'&nbsp;';?><?php
		echo htmlspecialchars($feed['description']);?></div>
															<div class="button-box">
																<a id="iconFeedStatus<?php
		echo $feed['id'];?>" class="update-button button" onclick="Reader.updateFeed(<?php
		echo $feed['id'];?>, '<?php
		echo _t('피드를 갱신 했습니다.');?>'); event.cancelBubble=true; return false;" title="<?php
		echo _t('이 피드를 갱신 합니다.');?>"><span class="text"><?php
		echo _t('피드 갱신');?></span></a>
																<span class="divider">|</span>
																<a class="edit-button button" href="#void" onclick="Reader.editFeed(<?php
		echo $feed['id'];?>, '<?php
		echo escapeJSInAttribute($feed['xmlurl']);?>')" title="<?php
		echo _t('이 피드 정보를 수정합니다.');?>"><span class="text"><?php
		echo _t('수정');?></span></a>
															</div>
														</li>
<?php
		$count++;
	}?>
													</ul>

													<div id="feedEditor" style="display: none;">
														<div class="title"><span class="text"><?php
	echo _t('피드 수정하기');?></span></div>
														<div class="input-box">
															<div class="input-field">
																<select id="changeFeedGroup">
<?php
	foreach(getFeedGroups($owner) as $group){
		if($group['id']==0)
			$group['title']=_t('그룹 없음');?>
																	<option value="<?php
		echo $group['id'];?>"><?php
		echo htmlspecialchars($group['title']);?></option>
<?php
	}?>
																</select>
																<input type="text" id="changeFeedURL" class="text-readonly-input" readonly="readonly" />
															</div>
															<div class="button-box">
																<input type="button" class="delete-button input-button" value="<?php
	echo _t('삭제');?>" onclick="Reader.deleteFeed(); return false;" />
																<span class="divider">|</span>
																<input type="submit" class="edit-button input-button" value="<?php
	echo _t('저장');?>" onclick="Reader.editFeedExecute(); return false;" />
																<span class="divider">|</span>
																<input type="button" class="cancel-button input-button" value="<?php
	echo _t('취소');?>" onclick="Reader.cancelEditFeed(); return false;" />
															</div>
														</div>
													</div>
<?php
}
function printFeedEntries($owner,$group=0,$feed=0,$unreadOnly=false,$starredOnly=false,$searchKeyword=null){
	global $service;?>
												<script type="text/javascript">
													//<![CDATA[
														var scrapedPostText = "<?php
	echo _t('스크랩 포스트');?>";
														var disscrapedPostText = "<?php
	echo _t('미스크랩 포스트');?>";
													//]]>
												</script>

												<table cellpadding="0" cellspacing="0">
													<tbody>
<?php
	$count=0;
	foreach(getFeedEntries($owner,$group,$feed,$unreadOnly,$starredOnly,$searchKeyword) as $entry){
		if($count==0)
			$firstEntryId=$entry['id'];
		$className=$entry['wasread']?'read':'unread';
		$className.=($count%2)==1?' even-line':' odd-line';
		$className.=($count==0)?' active-class':' inactive-class';
		$podcast=$entry['enclosure']?'<span class="podcast-icon bullet" title="'._t('팟캐스트 포스트입니다.').'"><span class="text">'._t('팟캐스트').'</span></span>':'';?>
														<tr id="entryTitleList<?php
		echo $entry['id'];?>" class="<?php
		echo $className;?>" onmouseover="rolloverClass(this, 'over')" onmouseout="rolloverClass(this, 'out')" onclick="Reader.selectEntry(<?php
		echo $entry['id'];?>)">
															<td>
																<div class="icons">
<?php
		if($entry['item']){?>
																	<span id="star<?php
			echo $entry['id'];?>" class="scrap-on-icon bullet" title="<?php
			echo _t('이 포스트를 스크랩 해제합니다.');?>" onclick="Reader.toggleStarred(<?php
			echo $entry['id'];?>)"><span class="text"><?php
			echo _t('스크랩 포스트');?></span></span>
<?php
		}else{?>
																	<span id="star<?php
			echo $entry['id'];?>" class="scrap-off-icon bullet" title="<?php
			echo _t('이 포스트를 스크랩합니다.');?>" onclick="Reader.toggleStarred(<?php
			echo $entry['id'];?>)"><span class="text"><?php
			echo _t('미스크랩 포스트');?></span></span>
<?php
		}?>
																	<?php
		echo $podcast;?>
																</div>
																<div class="content">
																	<div class="title"><span class="text"><?php
		echo htmlspecialchars($entry['entry_title']);?></span></div>
																	<div class="blog"><?php
		echo htmlspecialchars($entry['blog_title']);?></div>
																</div>
															</td>
														</tr>
<?php
		$count++;
	}?>
													</tbody>
												</table>

												<div id="additionalFeedContainer"></div>
												<div id="feedLoadingIndicator" class="system-message" style="display: none;">
													<?php
	echo _t('피드를 읽어오고 있습니다.');?>
												</div>

												<script type="text/javascript">
													//<![CDATA[
														Reader.setShownEntries(<?php
	echo $count;?>);
														Reader.setTotalEntries(<?php
	echo getFeedEntriesTotalCount($owner,$group,$feed,$unreadOnly,$starredOnly,$searchKeyword);?>);
<?php
	if(isset($firstEntryId)){?>
														Reader.selectedEntryObject = document.getElementById("entryTitleList<?php
		echo $firstEntryId;?>").parentNode;
<?php
	}?>
													//]]>
												</script>
<?php
	return $count;
}
function printFeedEntry($owner,$group=0,$feed=0,$entry=0,$unreadOnly=false,$starredOnly=false,$searchKeyword=null,$position='current'){
	global $service;
	if(!$entry=getFeedEntry($owner,$group,$feed,$entry,$unreadOnly,$starredOnly,$searchKeyword,$position)){
		$entry=array('id'=>0,'author'=>'Tattertools','blog_title'=>'Tattertools Reader','permalink'=>'#','entry_title'=>_t('포스트가 없습니다.'),'language'=>'en-US','description'=>'<div style="height: 369px"></div>','tags'=>'','enclosure'=>'','written'=>time());
	}?>
												<div id="entryHead">
													<div class="title"><a href="<?php
	echo htmlspecialchars($entry['permalink']);?>" onclick="window.open(this.href); return false;"><?php
	echo htmlspecialchars($entry['entry_title']);?></a></div>
													<div class="writing-info"><span class="by">by </span><span class="name"><?php
	echo htmlspecialchars($entry['author']?eregi_replace("^\\((.+)\\)$","\\1",$entry['author']):$entry['blog_title']);?></span><span class="divider"> : </span><span class="date"><?php
	echo date('Y-m-d H:i:s',$entry['written']);?></span></div>
													<div class="open"><a id="entryPermalink" href="<?php
	echo htmlspecialchars($entry['permalink']);?>" onclick="window.open(this.href); return false;" title="<?php
	echo _t('이 포스트를 새 창으로 엽니다.');?>"><span class="text"><?php
	echo _t('새 창으로');?></span></a></div>
												</div>

												<div id="entryBody" xml:lang="<?php
	echo htmlspecialchars($entry['language']);?>">
<?php
	if($entry['enclosure']){
		if(preg_match('/\.mp3$/i',$entry['enclosure'])){?>
													<p><span class="podcast-icon bullet"><span class="text"><?php
			echo _t('팟캐스트');?></span></span><a href="<?php
			echo htmlspecialchars($entry['enclosure']);?>"><?php
			echo htmlspecialchars($entry['enclosure']);?></a></p>
<?php
		}else{?>
													<p><span class="podcast-icon bullet"><span class="text"><?php
			echo _t('팟캐스트');?></span></span><a href="<?php
			echo htmlspecialchars($entry['enclosure']);?>"><?php
			echo htmlspecialchars($entry['enclosure']);?></a></p>
<?php
		}
	}?>
													<?php
	echo $entry['description'];?>
												</div>

												<script type="text/javascript">
													//<![CDATA[
														Reader.selectedEntry = <?php
	echo escapeJSInAttribute($entry['id']);?>;
														Reader.setBlogTitle("<?php
	echo escapeJSInAttribute($entry['blog_title']);?>");
														Reader.doPostProcessingOnEntry();
													//]]>
												</script>

												<div id="entryFoot">
<?php
	if($entry['tags']){?>
													<div id="entryTag">
														<span class="title"><?php
		echo htmlspecialchars(_t('태그'));?></span><span class="divider"> : </span><span class="tags"><?php
		echo htmlspecialchars($entry['tags']);?></span>
													</div>
<?php
	}?>
													<div class="button-box">
														<a class="non-read-button button" href="#void" onclick="Reader.markAsUnread(<?php
	echo $entry['id'];?>)"><span class="text"><?php
	echo _t('안 읽은 글로 표시');?></span></a>
													</div>
												</div>
<?php
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
echo htmlspecialchars($blog['title']);?> &gt; <?php
echo _t('리더');?></title>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/reader.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/reader-html.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/reader.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/reader.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
echo $service['path'];?>";
			var blogurl = "<?php
echo $blogURL;?>";
			var adminSkin = "<?php
echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-reader">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
echo $blogURL;?>/" title="<?php
echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
echo $blogURL;?>/logout" title="<?php
echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
echo $blogURL;?>/owner/center/dashboard"><span><?php
echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
echo $blogURL;?>/owner/entry"><span class="text"><?php
echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
echo $blogURL;?>/owner/link"><span class="text"><?php
echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
echo $blogURL;?>/owner/skin"><span class="text"><?php
echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
echo $blogURL;?>/owner/plugin"><span class="text"><?php
echo _t('플러그인');?></span></a></li>
						<li id="menu-setting"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('환경설정');?></span></a></li>
						<li id="menu-reader" class="selected"><a href="<?php
echo $blogURL;?>/owner/reader"><span class="text"><?php
echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

<?php
$setting=getReaderSetting($owner);?>
			<script type="text/javascript">
				//<![CDATA[
					var s_unknownError = "<?php
echo _t('알 수 없는 에러입니다.');?>";
					var s_notFoundPrevPost = "<?php
echo _t('이전 포스트가 없습니다.');?>";
					var s_notFoundNextPost = "<?php
echo _t('다음 포스트가 없습니다.');?>";
					var s_groupAdded = "<?php
echo _t('그룹이 추가됐습니다.');?>";
					var s_enterFeedName = "<?php
echo _t('피드 이름을 입력하세요.');?>";
					var s_groupExists = "<?php
echo _t('이미 존재하는 그룹 이름입니다.');?>";
					var s_addingGroup = "<?php
echo _t('그룹을 추가하고 있습니다.');?>";
					var s_groupModified = "<?php
echo _t('그룹이 수정됐습니다.');?>";
					var s_enterGroupName = "<?php
echo _t('그룹 이름을 입력하세요.');?>";
					var s_editingGroup = "<?php
echo _t('그룹을 수정하고 있습니다.');?>";
					var s_confirmDelete = "<?php
echo _t('삭제하시겠습니까?');?>";
					var s_groupRemoved = "<?php
echo _t('그룹이 삭제됐습니다.');?>";
					var s_groupNotFound = "<?php
echo _t('없는 그룹입니다.');?>";
					var s_removingGroup = "<?php
echo _t('그룹을 삭제하고 있습니다.');?>";
					var s_feedAdded = "<?php
echo _t('피드가 추가됐습니다.');?>";
					var s_feedExists = "<?php
echo _t('이미 존재하는 피드 주소입니다.');?>";
					var s_conNotConnect = "<?php
echo _t('입력하신 URL에 접속할 수 없습니다.');?>";
					var s_feedBroken = "<?php
echo _t('올바른 피드가 아닙니다.');?>";
					var s_requestFeed = "<?php
echo _t('피드를 가져오고 있습니다.');?>";
					var s_feedModified = "<?php
echo _t('피드가 수정됐습니다.');?>";
					var s_editingFeed = "<?php
echo _t('피드를 수정하고 있습니다.');?>";
					var s_feedRemoved = "<?php
echo _t('피드가 삭제됐습니다.');?>";
					var s_removingFeed = "<?php
echo _t('피드를 삭제하고 있습니다.');?>";
					var s_saved = "<?php
echo _t('저장되었습니다.');?>";
					var s_markedAsUnread = "<?php
echo _t('읽지 않은 상태로 변경됐습니다.');?>";
					var s_loadingList = "<?php
echo _t('글 목록을 불러오고 있습니다.');?>";
					var s_opmlImportComplete = "<?php
echo _t('OPML 파일을 가져왔습니다.');?>";
					var s_opmlUploadCompleteMulti = "<?php
echo _t('개의 피드를 가져왔습니다.\n피드를 업데이트 해 주십시오.');?>";
					var s_opmlUploadCompleteSingle = "<?php
echo _t('하나의 피드를 가져왔습니다.\n피드를 업데이트 해 주십시오.');?>";
					var s_xmlBroken = "<?php
echo _t('올바른 XML 파일이 아닙니다.');?>";
					var s_opmlBroken = "<?php
echo _t('올바른 OPML 파일이 아닙니다.');?>";
					var s_loadingOPML = "<?php
echo _t('OPML 파일을 가져오고 있습니다.');?>";
				//]]>
			</script>
			<script type="text/javascript" src="<?php
echo $service['path'];?>/script/reader.js"></script>
			<script type="text/javascript">
				//<![CDATA[
					var Reader = new TTReader();
					TTReader.feedUpdating = "<?php
echo _t('피드 업데이트 중');?>";
					TTReader.feedFailure = "<?php
echo _t('잘못된 피드');?>";
					TTReader.feedUpdate = "<?php
echo _t('피드 업데이트');?>";
					Reader.isPannelCollapsed = <?php
echo getUserSetting('readerPannelVisibility',1)==1?'false':'true';?>;
					STD.addEventListener(document);
					document.addEventListener("mouseup", Reader.finishResizing, false);
					STD.addEventListener(window);
					window.addEventListener("scroll", function() { Reader.setListPosition(); }, false);
<?php
if($setting['loadimage']==2){?>
					Reader.optionForceLoadImage = true;
<?php
}
if($setting['newwindow']==2){?>
					Reader.optionForceNewWindow = true;
<?php
}?>
					var pannelLabel = "<?php
echo _t('피드 리스트');?>";
					var configureLabel = "<?php
echo _t('설정');?>";
				//]]>
			</script>
			
			<iframe id="hiddenFrame" name="hiddenFrame" src="about:blank" width="1" height="1" style="display: none;"></iframe>
			
			<div id="layout-body">
				<h2><?php
echo _t('리더 서브메뉴');?></h2>
				
				<div id="reader-menu-box">
					<ul id="reader-menu">
						<li id="all-read"><a href="<?php
echo $blogURL.'/owner/reader';?>"><span class="text"><?php
echo _t('전체 보기');?></span></a></li>
						<li id="scrap"><span id="starredOnlyIndicator" class="scrap-off-icon bullet"><span class="text"></span></span><a href="#void" onclick="Reader.showStarredOnly(); return false;"><span class="text"><?php
echo _t('스크랩한 글 보기');?></span></a></li>
						<li id="setting" class="configureText"><a id="settingLabel" href="#void" onclick="Reader.toggleConfigure(); return false;"><span class="text"><?php
echo _t('설정');?></span></a></li>
						<li id="feed-update"><a href="#void" onclick="Reader.updateAllFeeds(); return false;"><span class="text"><?php
echo _t('모든 피드 새로고침');?><span id="progress"></span></span></a></li>
						<li id="search">
							<input type="text" id="keyword" class="input-text" onkeydown="if(event.keyCode==13) Reader.showSearch()" />
							<input type="submit" class="search-button input-button" value="<?php
echo _t('검색');?>" onclick="Reader.showSearch(); return false;" />
						</li>
						<li id="sub-menu-helper"><a href="<?php
echo getHelpURL('reader');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
						<div id="pannel" style="display: <?php
echo getUserSetting('readerPannelVisibility',1)==1?'block':'none';?>;">
							<div id="groupsAndFeeds" class="part">
								<h2 class="caption"><span class="main-text"><?php
echo _t('피드 목록');?></span></h2>
								
								<div class="data-inbox">
									<div id="group-section" class="section">
										<h3><?php
echo _t('피드 그룹');?></h3>
										
										<div id="groupBox" class="container" style="height: <?php
echo getUserSetting('readerPannelHeight',150);?>px;">
<?php
printFeedGroups($owner);?>
										</div>
									</div>
									
									<hr class="hidden" />
									
									<div id="feed-section" class="section">
										<h3><?php
echo _t('현재 그룹 내의 피드 목록');?></h3>
									
										<div id="feedBox" class="section" style="height: <?php
echo getUserSetting('readerPannelHeight',150);?>px;">
<?php
printFeeds($owner);?>
										</div>
									</div>
								</div>
							</div>
							
							<hr class="hidden" />
							
							<div id="configure" class="part" style="display: none;">
								<h2 class="caption"><span class="main-text"><?php
echo _t('설정');?></span></h2>
								
								<div class="data-inbox">
									<form id="reader-section" class="section" method="post" action="<?php
echo $blogURL;?>/owner/reader/config/save/" target="hiddenFrame">
<?php
if(getUserId()==1){?>
										<fieldset class="container">
											<legend class="title"><?php
	echo _t('리더 환경을 설정합니다');?></legend>
											
											<dl id="update-line" class="line">
												<dt><label for="updatecycle"><?php
	echo _t('업데이트 주기');?></label></dt>
												<dd>
													<select id="updatecycle" name="updatecycle">
														<option value="0"<?php
	echo $setting['updatecycle']==0?' selected="selected"':'';?>><?php
	echo _t('수집하지 않음');?></option>
														<option value="60"<?php
	echo $setting['updatecycle']==60?' selected="selected"':'';?>>1<?php
	echo _t('시간');?></option>
														<option value="120"<?php
	echo $setting['updatecycle']==120?' selected="selected"':'';?>>2<?php
	echo _t('시간');?></option>
														<option value="240"<?php
	echo $setting['updatecycle']==240?' selected="selected"':'';?>>4<?php
	echo _t('시간');?></option>
														<option value="480"<?php
	echo $setting['updatecycle']==480?' selected="selected"':'';?>>8<?php
	echo _t('시간');?></option>
														<option value="960"<?php
	echo $setting['updatecycle']==960?' selected="selected"':'';?>>16<?php
	echo _t('시간');?></option>
													</select>
												</dd>
											</dl>
											<dl id="period-line" class="line">
												<dt><label for="feedlife"><?php
	echo _t('수집한 글의 보존기간');?></label></dt>
												<dd>
													<select id="feedlife" name="feedlife">
														<option value="10"<?php
	echo $setting['feedlife']==10?' selected="selected"':'';?>>10<?php
	echo _t('일');?></option>
														<option value="20"<?php
	echo $setting['feedlife']==20?' selected="selected"':'';?>>20<?php
	echo _t('일');?></option>
														<option value="30"<?php
	echo $setting['feedlife']==30?' selected="selected"':'';?>>30<?php
	echo _t('일');?></option>
														<option value="45"<?php
	echo $setting['feedlife']==45?' selected="selected"':'';?>>45<?php
	echo _t('일');?></option>
														<option value="60"<?php
	echo $setting['feedlife']==60?' selected="selected"':'';?>>60<?php
	echo _t('일');?></option>
														<option value="90"<?php
	echo $setting['feedlife']==90?' selected="selected"':'';?>>90<?php
	echo _t('일');?></option>
														<option value="0"<?php
	echo $setting['feedlife']==0?' selected="selected"':'';?>><?php
	echo _t('계속보관');?></option>
													</select>
												</dd>
											</dl>
<?php
}?>
											<dl id="image-line" class="line">
												<dt><span class="label"><?php
echo _t('링크가 차단된 이미지');?></span></dt>
												<dd>
													<div class="image-get-yes"><input type="radio" id="loadImage2" class="radio" name="loadimage" value="2"<?php
echo $setting['loadimage']==2?' checked="checked"':'';?> /><label for="loadImage2"><?php
echo _t('강제로 읽어오기');?></label></div>
													<div class="image-get-no"><input type="radio" id="loadImage1" class="radio" name="loadimage" value="1"<?php
echo $setting['loadimage']==1?' checked="checked"':'';?> /><label for="loadImage1"><?php
echo _t('그대로 두기');?></label></div>
												</dd>
											</dl>
											<dl id="javascript-line" class="line">
												<dt><span class="label"><?php
echo _t('자바스크립트 허용');?></span></dt>
												<dd>
													<div class="javascript-yes"><input type="radio" id="allowScript1" class="radio" name="allowscript" value="1"<?php
echo $setting['allowscript']==1?' checked="checked"':'';?> /><label for="allowScript1"><?php
echo _t('허용');?></label></div>
													<div class="javascript-no"><input type="radio" id="allowScript2" class="radio" name="allowscript" value="2"<?php
echo $setting['allowscript']==2?' checked="checked"':'';?> /><label for="allowScript2"><?php
echo _t('거부');?></label></div>
													<em><?php
echo _t('허용 시 문제가 발생할 수 있습니다.');?></em>
												</dd>
											</dl>
											<dl id="link-line" class="line">
												<dt><span class="label"><?php
echo _t('링크');?></span></dt>
												<dd>
													<div class="window-self"><input type="radio" id="newWindow1" class="radio" name="newwindow" value="1"<?php
echo $setting['newwindow']==1?' checked="checked"':'';?> /><label for="newWindow1"><?php
echo _t('기본값');?></label></div>
													<div class="window-blank"><input type="radio" id="newWindow2" class="radio" name="newwindow" value="2"<?php
echo $setting['newwindow']==2?' checked="checked"':'';?> /><label for="newWindow2"><?php
echo _t('새 창으로');?></label></div>
												</dd>
											</dl>
										</fieldset>
										
										<div class="button-box">
											<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="Reader.saveSetting(); return false;" />
										</div>
									</form>
									
									<form id="opml-section" class="section" method="post" action="<?php
echo $blogURL;?>/owner/reader/opml/import/file/" enctype="multipart/form-data" target="hiddenFrame">
										<fieldset class="container">
											<legend class="title"><?php
echo _t('OPML 관리');?></legend>
											
											<dl id="get-line" class="line">
												<dt><span class="label"><?php
echo _t('가져오기');?></span></dt>
												<dd>
													<div id="get-upload"><input type="radio" id="opmlMethod1" class="radio" name="opmlMethod" value="1" checked="checked" onclick="document.getElementById('opmlUpload').style.display='block';document.getElementById('opmlRequest').style.display='none';" /><label for="opmlMethod1"><span class="text"><?php
echo _t('파일 업로드');?></span></label></div>
													<div id="get-url"><input type="radio" id="opmlMethod2" class="radio" name="opmlMethod" value="2" onclick="document.getElementById('opmlUpload').style.display='none';document.getElementById('opmlRequest').style.display='block';" /><label for="opmlMethod2"><span class="text"><?php
echo _t('<acronym title="Uniform Resource Locator">URL</acronym> 입력');?></span></label></div>
												</dd>
											</dl>
											<dl id="opmlUpload" class="line">
												<dt><label for="opmlUploadValue"><?php
echo _t('<acronym title="Outline Processor Markup Language">OPML</acronym> 업로드');?></label></dt>
												<dd><input type="file" id="opmlUploadValue" class="input-file" name="opmlFile" /></dd>
											</dl>
											<dl id="opmlRequest" class="line" style="display: none;">
												<dt><label for="opmlRequestValue"><?php
echo _t('URL로 읽어오기');?></label></dt>
												<dd><input type="text" id="opmlRequestValue" class="input-text" /></dd>
											</dl>
										</fieldset>
										
										<div class="button-box two-button-box">
											<input type="submit" class="import-button input-button" value="<?php
echo _t('가져오기');?>" onclick="if(document.getElementById('opml-section').opmlMethod[0].checked) Reader.importOPMLUpload(); else Reader.importOPMLURL(); return false;" />
											<span class="hidden">|</span>
											<input type="submit" class="export-button input-button" value="<?php
echo _t('내보내기');?>" onclick="Reader.exportOPML(); return false;" />
										</div>
									</form>
								</div>
							</div>
						</div>
						
						<hr class="hidden" />
							
						<div id="toggleBar" onmousedown="Reader.startResizing(event)">
							<script type="text/javascript">
								//<![CDATA[
									var show_str = '<?php
echo _t('패널 보기');?>';
									var hide_str = '<?php
echo _t('패널 가리기');?>';
									
									document.write('<a id="toggleButton" class="pannel-<?php
echo getUserSetting('readerPannelVisibility',1)==1?'show':'hide';?>" href="#void" onclick="Reader.togglePannel(event)">');
									document.write('<span class="text"><?php
echo getUserSetting('readerPannelVisibility',1)==1?_t('패널 가리기'):_t('패널 보기');?><\/span>');
									document.write('<\/a>');
								//]]>
							</script>
						</div>
						
						<hr class="hidden" />
						
						<div id="scrollPoint">
							<div id="post-information" class="part">
								<h2 class="caption"><span class="main-text"><?php
echo _t('글 목록');?></span></h2>
								
								<div id="post-list" class="data-inbox">
									<div class="title">
										<a id="totalList" href="<?php
echo $blogURL;?>/owner/reader" title="<?php
echo _t('글 목록을 전부 출력합니다.');?>"><span class="text"><?php
echo _t('전체 목록');?></span></a><span class="count">(<span id="entriesShown">0</span>/<span id="entriesTotal">0</span>)</span>
										<span class="hidden">|</span>
										<a id="iconMoreEntries" href="#void" onclick="Reader.listScroll(1); return false;" title="<?php
echo _t('지나간 글 정보를 더 읽어옵니다.');?>"><span class="text"><?php
echo _t('더 읽어오기');?></span></a>
									</div>
									
									<div id="listup" class="section" onscroll="Reader.listScroll(0)">
<?php
printFeedEntries($owner);?>
									</div>
									
									<div class="button-box">
										<a class="hide-button button" href="#void" onclick="Reader.showUnreadOnly(); return false;"><span class="text"><?php
echo _t('읽은 글 감추기');?></span></a>
										<span class="divider">-</span>
										<a class="shortcut-button button" href="#void" onclick="document.getElementById('shortcuts').style.display = document.getElementById('shortcuts').style.display=='none' ? 'block' : 'none'"><span class="text"><?php
echo _t('단축키보기');?></span></a>
									</div>
									
									<div id="shortcuts" style="display: none;">
										<h3 class="title"><?php
echo _t('단축키');?></h3>
										
										<ul>
											<li><kbd>A</kbd>, <kbd>H</kbd> - <?php
echo _t('이전 글');?></li>
											<li><kbd>S</kbd>, <kbd>L</kbd> - <?php
echo _t('다음 글');?></li>
											<li><kbd>D</kbd> - <?php
echo _t('새 창으로');?></li>
											<li><kbd>F</kbd> - <?php
echo _t('안 읽은 글만보기');?></li>
											<li><kbd>G</kbd> - <?php
echo _t('스크랩된 글 보기');?></li>
											<li><kbd>Q</kbd> - <?php
echo _t('블로그 화면으로');?></li>
											<li><kbd>W</kbd> - <?php
echo _t('현재글 스크랩');?></li>
											<li><kbd>R</kbd> - <?php
echo _t('리더 첫화면으로');?></li>
											<li><kbd>T</kbd> - <?php
echo _t('글 수집하기');?></li>
											<li><kbd>J</kbd> - <?php
echo _t('위로 스크롤');?></li>
											<li class="last-shortcut"><kbd>K</kbd> - <?php
echo _t('아래로 스크롤');?></li>
										</ul>
									</div>
								</div>
							</div>
							
							<hr class="hidden" />
							
							<div id="content-information" class="part">
								<h2 class="caption"><span class="main-text"><?php
echo _t('글 내용');?></span></h2>
								
								<div id="post-content" class="data-inbox">
									<div class="title">
										<span id="blogTitle"></span>
										<span class="divider"> | </span>
										<span class="move"><a class="prev-button button" href="#void" onclick="Reader.prevEntry()"><span class="text"><?php
echo _t('이전');?></span></a><span class="divider"> : </span><a class="next-button button" href="#void" onclick="Reader.nextEntry()"><span class="text"><?php
echo _t('다음');?></span></a></span>
									</div>
									
									<div id="floatingList" class="section">
										<div id="entry">
<?php
printFeedEntry($owner);?>
										</div>
									</div>
								</div>
							</div>
						</div>
<?php
if(isset($_GET['forceRefresh'])){?>
						<script type="text/javascript">
							//<![CDATA[
								Reader.updateAllFeeds();
							//]]>
						</script>
<?php
}?>					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
{?>
					case 65: //A
					case 72: //H
						Reader.prevEntry();
						break;
					case 83: //S
					case 76: //L
						Reader.nextEntry();
						break;
					case 68: //D
						Reader.openEntryInNewWindow();
						break;
					case 70: //F
						Reader.showUnreadOnly();
						break;
					case 71: //G
						Reader.showStarredOnly();
						break;
					case 84: //T
						Reader.updateAllFeeds();
						break;
					case 87: //W
						Reader.toggleStarred();
						break;
					case 74: //J
						window.scrollBy(0, 100);
						break;
					case 75: //K
						window.scrollBy(0, -100);
						break;				
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
