<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function escapeJSInCData($str){
	return preg_replace(array('/</','/>/','/\r*\n|\r/'),array('\x3C','\x3E','\\\\$0'),addslashes($str));
}
function link_cut($url,$checkURL=35){
	$leftURL=$checkURL-14;
	$rightURL=-8;
	$link=(strlen($url)>$checkURL)?substr($url,0,$leftURL).' &hellip; '.substr($url,$rightURL):$url;
	return $link;
}
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getArrayValue($array,$key){
	return $array[$key];
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getBlogURLRule($domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	switch($type){
		case 'domain':
			return array('http://',".$domain$path");
		case 'path':
			return array("http://$domain$path/",'');
		case 'single':
		default:
			return array("http://$domain$path",'');
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
echo htmlspecialchars($blog['title']);?> &gt; <?php
echo _t('환경설정');?></title>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/setting.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
echo $service['path'];?>";
			var blogurl = "<?php
echo $blogURL;?>";
			var adminSkin = "<?php
echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-setting">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
echo $blogURL;?>/" title="<?php
echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
echo $blogURL;?>/logout" title="<?php
echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
echo $blogURL;?>/owner/center/dashboard"><span><?php
echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
echo $blogURL;?>/owner/entry"><span class="text"><?php
echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
echo $blogURL;?>/owner/link"><span class="text"><?php
echo _t('링크');?></span></a></li>
						<li id="menu-skin"><a href="<?php
echo $blogURL;?>/owner/skin"><span class="text"><?php
echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
echo $blogURL;?>/owner/plugin"><span class="text"><?php
echo _t('플러그인');?></span></a></li>
						<li id="menu-setting" class="selected"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
echo $blogURL;?>/owner/reader"><span class="text"><?php
echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

			<div id="layout-body">
				<h2><?php
echo _t('서브메뉴 : 환경설정');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-blog" class="selected"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('기본 설정');?></span></a></li>
						<li id="sub-menu-account"><a href="<?php
echo $blogURL;?>/owner/setting/account"><span class="text"><?php
echo _t('계정 정보');?></span></a></li>
						<li id="sub-menu-filter"><a href="<?php
echo $blogURL;?>/owner/setting/filter"><span class="text"><?php
echo _t('필터');?></span></a></li>
						<li id="sub-menu-data"><a href="<?php
echo $blogURL;?>/owner/data"><span class="text"><?php
echo _t('데이터 관리');?></span></a></li>
						<li id="sub-menu-etc"><a href="<?php
echo $blogURL;?>/owner/setting/etc"><span class="text"><?php
echo _t('기타 설정');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
echo getHelpURL('setting/blog');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">

						<script type="text/javascript">
							//<![CDATA[
								var title = "<?php
echo escapeJSInCData($blog['title']);?>";
								var description = "<?php
echo escapeJSInCData(trim($blog['description']));?>";
								
								function setBlog() {
									if (document.getElementById('common-form').title.value != title) {
										var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/blog/title?title=" + encodeURIComponent(document.getElementById('common-form').title.value));
										request.onSuccess = function() {
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
											title = document.getElementById('common-form').title.value;
										}
										request.onError = function() {
											alert("<?php
echo _t('블로그 제목을 변경하지 못했습니다.');?>");
										}
										request.send();
									}
									if (document.getElementById('common-form').description.value != description) {
										var request = new HTTPRequest("POST", "<?php
echo $blogURL;?>/owner/setting/blog/description/");
										request.onSuccess = function() {
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
											description = document.getElementById('common-form').description.value;
										}
										request.onError = function() {
											alert("<?php
echo _t('블로그 설명을 변경하지 못했습니다.');?>");
										}
										request.send("description=" + encodeURIComponent(document.getElementById('common-form').description.value));
									}
								}
<?php
if($service['type']!='single'){
	if($service['type']=='domain'){?>
								var primaryDomain = "<?php
		echo escapeJSInCData($blog['name']);?>";
								var secondarydomain = "<?php
		echo escapeJSInCData($blog['secondarydomain']);?>";
								var defaultdomain = <?php
		echo escapeJSInCData($blog['defaultdomain']);?>;

								var newPrimaryDomain = primaryDomain;
								var newSecondaryDomain = secondaryDomain;
								var newDefaultDomain = defaultDomain;
<?php
	}elseif($service['type']=='path'){?>
								var pathDomain = "<?php
		echo escapeJSInCData($blog['name']);?>";
								var newPathDomain = pathDomain;
<?php
	}?>
								function setDomains() {
<?php
	if($service['type']=='domain'){?>
									if ((document.getElementById('multi-form').primaryDomain.value != primaryDomain) && (!checkBlogName(document.getElementById('multi-form').primaryDomain.value))) {
										alert("<?php
		echo _t('1차 블로그 주소가 올바르지 않습니다.');?>");
										document.getElementById('multi-form').primaryDomain.focus();
										return;
									}
									if ((document.getElementById('multi-form').secondarydomain.value != secondaryDomain) && (document.getElementById('multi-form').secondarydomain.value.trim() != "") &&  (!checkDomainName(document.getElementById('multi-form').secondarydomain.value))) {
										alert("<?php
		echo _t('2차 블로그 주소가 올바르지 않습니다.');?>");
										document.forms[0].secondarydomain.focus();
										return;
									}
<?php
	}elseif($service['type']=='path'){?>
									if ((document.getElementById('multi-form').pathDomain.value != pathDomain) && (!checkBlogName(document.getElementById('multi-form').pathDomain.value))) {
										alert("<?php
		echo _t('블로그 주소가 올바르지 않습니다.');?>");
										document.getElementById('multi-form').pathDomain.focus();
										return;
									}
<?php
	}?>
									var location = null;
<?php
	if($service['type']=='domain'){?>
									newPrimaryDomain = document.getElementById('multi-form').primaryDomain.value;
									newSecondaryDomain = document.getElementById('multi-form').secondarydomain.value;
									newDefaultDomain = document.getElementById('multi-form').defaultDomain[defaultdomain].checked ? 0 : 1;
								
									if(primaryDomain != newPrimaryDomain || secondarydomain != newSecondaryDomain || defaultdomain != newDefaultDomain) {
										var request = new HTTPRequest("POST", "<?php
		echo $blogURL;?>/owner/setting/domain/set/");
										request.onSuccess = function() {
											PM.showMessage("<?php
		echo _t('저장되었습니다');?>", "center", "bottom");
											if(newDefaultDomain == 0 && newPrimaryDomain != primaryDomain) {
												alert("<?php
		echo _t('변경된 1차 블로그 주소로 이동합니다');?>");
												window.location.href = "http://" + newPrimaryDomain + ".<?php
		echo $service['domain'];?><?php
		echo $blogURL;?>/owner/setting/blog";
											}
											else if(newDefaultDomain == 1 && newSecondaryDomain != secondaryDomain) {
												alert("<?php
		echo _t('변경된 2차 블로그 주소로 이동합니다');?>");
												window.location.href = "http://" + newSecondaryDomain + "<?php
		echo $blogURL;?>/owner/setting/blog";
											}
											primaryDomain = newPrimaryDomain;
											secondarydomain = newSecondaryDomain;
											defaultdomain = newDefaultDomain;
										}
										request.onError = function() {
											var msg = '';
											switch(parseInt(this.getText("/response/error"))) {
												case 1:
													msg = "<?php
		echo _t('기본 블로그 도메인을 변경하지 못했습니다');?>";
													break;
												case 2:
													msg = "<?php
		echo _t('1차 블로그 도메인을 변경하지 못했습니다');?>";						
													switch(parseInt(this.getText("/response/msg"))) {
														case 1:
															msg += "\n\n<?php
		echo _t('올바르지 않은 블로그 주소입니다');?>";
															break;
														case 2:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
														case 3:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
													}						
													break;
												case 3:
													msg = "<?php
		echo _t('2차 블로그 주소를 변경하지 못했습니다');?>";
													switch(parseInt(this.getText("/response/msg"))) {
														case 1:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
														case 2:
															msg += "\n\n<?php
		echo _t('올바르지 않은 블로그 주소입니다');?>";
															break;
													}						
													break;
												case 4:
													msg = "<?php
		echo _t('2차 블로그 주소가 비어있어서 기본 블로그 주소로 설정할 수 없습니다');?>";
													document.forms[0].defaultDomain[0].checked = true;
													break;
												default:
													msg = "<?php
		echo _t('알 수 없는 에러가 발생했습니다');?>";
											}
											alert(msg);
										}
										request.send("defaultdomain=" + newDefaultDomain + "&primaryDomain=" + encodeURIComponent(newPrimaryDomain) + "&secondarydomain=" + encodeURIComponent(newSecondaryDomain));
									}
<?php
	}elseif($service['type']=='path'){?>
									newPathDomain = document.getElementById('multi-form').pathDomain.value;
									if(pathDomain != newPathDomain) {
										var request = new HTTPRequest("POST", "<?php
		echo $blogURL;?>/owner/setting/domain/set/");
										request.onSuccess = function() {
											PM.showMessage("<?php
		echo _t('저장되었습니다');?>", "center", "bottom");
											alert("<?php
		echo _t('변경된 블로그 주소로 이동합니다');?>");
											window.location.href = "http://<?php
		echo $service['domain'];?><?php
		echo $service['path'];?>/" + newPathDomain + "/owner/setting/blog";
											pathDomain = newPathDomain;
										}
										request.onError = function() {
											var msg = '';
											switch(parseInt(this.getText("/response/error"))) {
												case 1:
													msg = "<?php
		echo _t('블로그 주소를 변경하지 못했습니다');?>";
													break;
												case 2:
													msg = "<?php
		echo _t('1차 블로그 도메인을 변경하지 못했습니다');?>";						
													switch(parseInt(this.getText("/response/msg"))) {
														case 1:
															msg += "\n\n<?php
		echo _t('올바르지 않은 블로그 주소입니다');?>";
															break;
														case 2:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
														case 3:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
													}						
													break;
												case 3:
													msg = "<?php
		echo _t('2차 블로그 주소를 변경하지 못했습니다');?>";
													switch(parseInt(this.getText("/response/msg"))) {
														case 1:
															msg += "\n\n<?php
		echo _t('이미 사용중인 블로그 주소입니다');?>";
															break;
														case 2:
															msg += "\n\n<?php
		echo _t('올바르지 않은 블로그 주소입니다');?>";
															break;
													}						
													break;
												default:
													msg = "<?php
		echo _t('알 수 없는 에러가 발생했습니다');?>";
											}
											alert(msg);
										}
										request.send("defaultdomain=0&primaryDomain=" + encodeURIComponent(newPathDomain) + "&secondarydomain=");
									}

<?php
	}?>
									if (location) {
										alert("<?php
	echo _t('변경된 기본 블로그 도메인으로 이동합니다.');?>");
										window.location.href = location;
									}
								}
<?php
}?>
								
								function setIcons() {
									document.getElementById('icons-form').submit();
								}
								
								var useslogan = "<?php
echo $blog['useslogan']+0;?>";
								var publisheolinsynconrss = "<?php
echo $blog['publisheolinsynconrss'];?>";
								var entriesonrss = "<?php
echo $blog['entriesonrss'];?>";
								var publishwholeonrss = "<?php
echo $blog['publishwholeonrss'];?>";
								var allowCommentGuestbook = <?php
echo $blog['allowwritedoublecommentonguestbook']+0;?>;
								//var allowWriteGuestbook = <?php
echo $blog['allowwriteonguestbook'];?>;
								function setRSS() {
									if (document.getElementById('rss-form').useSlogan[useslogan].checked == true) {
										if (document.getElementById('rss-form').useslogan.value != useSlogan) {
											var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/blog/slogan/" + (document.getElementById('rss-form').useSlogan[0].checked ? 1 : 0));
											request.onSuccess = function() {
												useslogan = document.getElementById('rss-form').useSlogan[0].checked ? 1 : 0;
												PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
											}
											request.onError = function() {
												alert("<?php
echo _t('글 주소 표기법을 변경할 수 없습니다.');?>");
											}
											request.send();
										}
									}
									
									var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/blog/publishRSS/" + (document.getElementById('rss-form').publishEolinSyncOnRSS[0].checked ? 1 : 0));
									request.onSuccess = function() {
										publisheolinsynconrss = document.getElementById('rss-form').publishEolinSyncOnRSS[0].checked ? 1 : 0;
										PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
									}
									request.onError = function() {
										alert("<?php
echo _t('RSS 공개 정도를 변경할 수 없습니다.');?>");
									}
									request.send();
									
									if (document.getElementById('rss-form').entriesonrss.value != entriesOnRSS) {
										var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/rss/entries/" + document.getElementById('rss-form').entriesonrss.value);
										request.onSuccess = function() {
											entriesonrss = document.getElementById('rss-form').entriesonrss.value;
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
										}
										request.onError = function() {
											alert("<?php
echo _t('RSS 글 개수를 변경하지 못했습니다.');?>");
										}
										request.send();
									}
									
									if (document.getElementById('rss-form').publishwholeonrss.value != publishWholeOnRSS) {
										var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/rss/whole/" + document.getElementById('rss-form').publishwholeonrss.value);
										request.onSuccess = function() {
											publishwholeonrss = document.getElementById('rss-form').publishwholeonrss.value;
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
										}
										request.onError = function() {
											alert("<?php
echo _t('RSS 공개 범위를 변경하지 못했습니다.');?>");
										}
										request.send();
									}
									
									isAllowCommentGuestbook = document.getElementById('allowCommentGuestbook').checked ? 1 : 0;
									//isAllowWriteGuestbook = document.getElementById('allowWriteGuestbook').checked ? 1 : 0;
									if ( isAllowCommentGuestbook != allowCommentGuestbook) {
										var request = new HTTPRequest("GET", "<?php
echo $blogURL;?>/owner/setting/blog/guestbook/?comment="+isAllowCommentGuestbook+"&write=1");
										request.onSuccess = function() {
											allowCommentGuestbook = isAllowCommentGuestbook;
											PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
										}
										request.onError = function() {
											alert("<?php
echo _t('실패했습니다.');?>");
										}
										request.send();
									}
								}
								
							//]]>
						</script>
						
						<div id="part-setting-basic" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('블로그 기본 정보를 설정합니다');?></span></h2>
							
							<div class="data-inbox">
								<form id="common-form" class="section" method="post" action="<?php
echo $blogURL;?>/owner/setting/blog/title">
									<fieldset class="container">
										<legend><?php
echo _t('블로그 정보');?></legend>
										
										<dl id="blog-title-line" class="line">
											<dt><label for="title"><?php
echo _t('블로그 제목');?></label></dt>
											<dd><input type="text" id="title" class="input-text" name="title" value="<?php
echo htmlspecialchars($blog['title']);?>" /></dd>
										</dl>
										<dl id="blog-description-line" class="line">
											<dt><label for="description"><?php
echo _t('블로그 설명');?></label></dt>
											<dd><textarea id="description" name="description" cols="15" rows="5"><?php
echo htmlspecialchars($blog['description']);?></textarea></dd>
										</dl>
									</fieldset>
									<div class="button-box">
										<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="setBlog(); return false;" />
									</div>
								</form>
<?php
$urlRule=getBlogURLRule();
if($service['type']!='single'){?>
								<form id="multi-form" class="section" method="post" action="<?php
	echo $blogURL;?>/owner/setting/blog/domain">
									<fieldset class="container">
										<legend><?php
	echo _t('블로그 주소');?></legend>
									
<?php
	if($service['type']=='domain'){?>
										<dl id="first-blog-address-line" class="line">
											<dt><label for="primaryDomain"><?php
		echo _t('1차 블로그 주소');?></label></dt>
											<dd>
												<input type="radio" class="radio" name="defaultdomain" <?php
		echo ($blog['defaultdomain']?'':'checked="checked"');?> title="<?php
		echo _t('기본 도메인');?>" /> http://<input type="text" id="primaryDomain" class="input-text" name="primaryDomain" value="<?php
		echo htmlspecialchars($blog['name']);?>" /><?php
		echo $urlRule[1];?>
											</dd>
										</dl>
										<dl id="second-blog-address-line" class="line">
											<dt><label for="secondarydomain"><?php
		echo _t('2차 블로그 주소');?></label></dt>
											<dd>
												<input type="radio" class="radio" name="defaultdomain" <?php
		echo ($blog['defaultdomain']?'checked="checked"':'');?>title="<?php
		echo _t('기본 도메인');?>" /> http://<input type="text" id="secondarydomain" class="input-text" name="secondarydomain" value="<?php
		echo htmlspecialchars($blog['secondarydomain']);?>" /><?php
		echo $blogURL;?>
											</dd>
										</dl>
<?php
	}else{?>
										<dl id="blog-address-line" class="line">
											<dt><label for="pathDomain"><?php
		echo _t('블로그 주소');?></label></dt>
											<dd><?php
		echo $urlRule[0];?><input type="text" id="pathDomain" class="input-text" name="pathDomain" value="<?php
		echo htmlspecialchars($blog['name']);?>" /></dd>
										</dl>
<?php
	}?>
									</fieldset>
									<div class="button-box">
										<input type="submit" class="save-button input-button" value="<?php
	echo _t('저장하기');?>" onclick="setDomains(); return false;" />
									</div>
								</form>
<?php
}?>
							</div>
						</div>
						
						<hr class="hidden" />
						
						<div id="part-setting-profile" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('특징을 설정합니다');?></span></h2>
							
							<form id="icons-form" class="data-inbox" method="post" action="<?php
echo $blogURL;?>/owner/setting/blog/icons" enctype="multipart/form-data">
								<div id="icons-upload-section" class="section">
									<fieldset class="container">
										<legend><?php
echo _t('블로그 로고 및 파비콘');?></legend>
										
										<dl id="blog-picture-line" class="line">
											<dt><span class="label"><?php
echo _t('로고 그림');?></span></dt>
											<dd>
<?php
if(!empty($blog['logo'])&&file_exists("../../../../attach/$owner/{$blog['logo']}")){
	$logoInfo=@getimagesize("../../../../attach/$owner/{$blog['logo']}");
	if($logoInfo[0]>150){?>
												<a href="<?php
		echo $service['path'];?>/attach/<?php
		echo $owner;?>/<?php
		echo $blog['logo'];?>" onclick="window.open(this.href); return false;"><img src="<?php
		echo $service['path'];?>/attach/<?php
		echo $owner;?>/<?php
		echo $blog['logo'];?>" width="150" border="1" alt="<?php
		echo _t('사용자 로고');?>" /></a>
<?php
	}else{?>
												<img src="<?php
		echo $service['path'];?>/attach/<?php
		echo $owner;?>/<?php
		echo $blog['logo'];?>" border="1" alt="<?php
		echo _t('사용자 로고');?>" />
<?php
	}
}?>

												<input type="file" class="input-file" name="logo" />
												<div class="init-box"><input type="checkbox" class="checkbox" id="deleteLogo" name="deleteLogo" value="yes"<?php
echo empty($blog['logo'])?' disabled="disabled"':'';?> /><label for="deleteLogo"><?php
echo _t('로고를 초기화합니다.');?></label></div>
											</dd>
										</dl>
										<dl id="favicon-line" class="line">
											<dt><span class="label"><?php
echo _t('파비콘');?></span></dt>
											<dd>
<?php
if(file_exists("../../../../attach/$owner/favicon.ico")&&!eregi(' MSIE',$_SERVER['HTTP_USER_AGENT'],$temp)){?>
												<img src="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/favicon.ico" border="1" alt="<?php
	echo _t('파비콘');?>" />
<?php
}elseif(file_exists("../../../../attach/$owner/favicon.ico")&&eregi(' MSIE',$_SERVER['HTTP_USER_AGENT'],$temp)){?>
												<a id="favicon-preview" href="<?php
	echo $service['path'];?>/attach/<?php
	echo $owner;?>/favicon.ico"><?php
	echo _t('미리 보기');?></a>
<?php
}?>
												<input type="file" class="input-file" name="favicon" />
												<div class="init-box"><input type="checkbox" class="checkbox" id="deleteFavicon" name="deleteFavicon" value="yes"<?php
echo file_exists("../../../../attach/$owner/favicon.ico")?'':' disabled="disabled"';?> /><label for="deleteFavicon"><?php
echo _t('파비콘을 초기화합니다.');?></label></div>
												<p><?php
echo _t('파비콘은 웹 브라우저의 즐겨찾기나 주소 입력줄에 보이는 그림입니다.');?></p>
											</dd>
										</dl>
									</fieldset>
								</div>
								
								<div id="blogicon-section" class="section">
									<fieldset class="container">
										<legend><?php
echo _t('블로그 아이콘');?></legend>
										
										<dl id="blogicon-line" class="line">
											<dt><span class="label"><?php
echo _t('블로그 아이콘');?></span></dt>
											<dd>
<?php
if(file_exists("../../../../attach/$owner/index.gif")){
	$blogIconInfo=getimagesize("../../../../attach/$owner/index.gif");
	if($blogIconInfo!=false){?>
												<img src="<?php
		echo $service['path'];?>/attach/<?php
		echo $owner;?>/index.gif"<?php
		echo ($blogIconInfo[0]>48)?' width="48"':'';?> border="1" alt="<?php
		echo _t('블로그 아이콘');?>" />
<?php
	}
}?>
												<input type="file" class="input-file" name="blogIcon" />
												<div class="init-box"><input type="checkbox" class="checkbox" id="deleteBlogIcon" name="deleteBlogIcon" value="yes"<?php
echo file_exists("../../../../attach/$owner/index.gif")?'':' disabled="disabled"';?> /><label for="deleteBlogIcon"><?php
echo _t('블로그 아이콘을 초기화합니다.');?></label></div>
												<p><?php
echo _t('블로그 아이콘은 댓글과 방명록에서 사용됩니다. 크기는 16×16 이상, 48×48 이하까지 지원합니다.');?></p>
											</dd>
										</dl>
									</fieldset>
								</div>
								
								<div class="button-box">
									<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="setIcons(); return false;" />
								</div>
							</form>
						</div>
						
						<hr class="hidden" />
						<div id="part-setting-rss" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('블로그 공개 정책을 설정합니다');?></span></h2>
							
							<form id="rss-form" class="data-inbox" method="post" action="<?php
echo $blogURL;?>/owner/setting/blog">
								<div id="rss-section" class="section">
									<fieldset class="container">
										<legend><?php
echo _t('RSS 설정');?></legend>
										
										<dl id="open-type-line" class="line">
											<dt><span class="label"><?php
echo _t('공개 정도');?></span></dt>
											<dd>
												<input type="radio" id="publishEolinSyncOnRSS1" class="radio" name="publisheolinsynconrss"<?php
echo ($blog['publisheolinsynconrss']?' checked="checked"':'');?> /><label for="publishEolinSyncOnRSS1"><span class="text"><?php
echo _t('공개된 모든 글을 <acronym title="Rich Site Summary">RSS</acronym>로 내보냅니다.');?></span></label><br />
												<input type="radio" id="publishEolinSyncOnRSS0" class="radio" name="publisheolinsynconrss"<?php
echo ($blog['publisheolinsynconrss']?'':'checked="checked"');?> /><label for="publishEolinSyncOnRSS0"><span class="text"><?php
echo _t('이올린에 발행된 글만을 RSS로 내보냅니다.');?></span></label>
											</dd>

										</dl>
										<dl id="post-count-line" class="line">
											<dt><span class="label"><?php
echo _t('글 개수');?></span></dt>
											<dd>
												<?php
echo getArrayValue(explode('%1',_t('RSS 파일의 블로그 글은 최신 %1개로 갱신됩니다.')),0);?>
												<select id="entriesonrss" name="entriesonrss">
<?php
for($i=5;$i<=30;$i+=5){?>
													<option value="<?php
	echo $i;?>"<?php
	echo ($i==$blog['entriesonrss']?' selected="selected"':'');?>><?php
	echo $i;?></option>
<?php
}?>
												</select><?php
echo getArrayValue(explode('%1',_t('RSS 파일의 블로그 글은 최신 %1개로 갱신됩니다.')),1);?>
											</dd>
										</dl>
										<dl id="open-range-line" class="line">
											<dt><span class="label"><?php
echo _t('공개 범위');?></span></dt>
											<dd><?php
echo getArrayValue(explode('%1',_t('RSS 파일의 글 본문은 %1를 원칙으로 합니다.')),0);?>
												<select id="publishwholeonrss" name="publishwholeonrss">
													<option value="1"<?php
echo ($blog['publishwholeonrss']?' selected="selected"':'');?>><?php
echo _t('전체공개');?></option>
													<option value="0"<?php
echo ($blog['publishwholeonrss']?'':' selected="selected"');?>><?php
echo _t('부분공개');?></option>
												</select><?php
echo getArrayValue(explode('%1',_t('RSS 파일의 글 본문은 %1를 원칙으로 합니다.')),1);?>
											</dd>

										</dl>
									</fieldset>
								</div>
								<div id="etc-section" class="section">
									<fieldset class="container">
										<legend><?php
echo _t('기타');?></legend>
										
										<dl id="post-address-line" class="line">
											<dt><span class="label"><?php
echo _t('글 주소');?></span></dt>
											<dd>
												<input type="radio" id="useSlogan1" class="radio" name="useslogan"<?php
echo ($blog['useslogan']?' checked="checked"':'');?> /><label for="useSlogan1"><span class="text"><?php
echo _t('문자를 사용합니다.');?> <samp><?php
echo _f('(예: %1/entry/태터툴즈로-오신-것을-환영합니다)',link_cut(getBlogURL()));?></samp></span></label><br />
												<input type="radio" id="useSlogan0" class="radio" name="useslogan"<?php
echo ($blog['useslogan']?'':' checked="checked"');?> /><label for="useSlogan0"><span class="text"><?php
echo _t('숫자를 사용합니다.');?> <samp><?php
echo _f('(예: %1/123)',link_cut(getBlogURL()));?></samp></span></label>
											</dd>
										</dl>
										<dl id="guestbook-authority-line" class="line">
											<dt><label for="allowCommentGuestbook"><?php
echo _t('방명록 사용 권한');?></label></dt>
											<dd>
												<!--input type="checkbox" id="allowWriteGuestbook" class="checkbox" value=""<?php
echo $blog['allowwriteonguestbook']=='1'?' checked="checked"':"";?> /><label for="allowWriteGuestbook"><?php
echo _t('손님이 글쓰기 허용');?></label-->
												<input type="checkbox" id="allowCommentGuestbook" class="checkbox" value=""<?php
echo $blog['allowwritedoublecommentonguestbook']=='1'?' checked="checked"':"";?> /><label for="allowCommentGuestbook"><?php
echo _t('손님이 댓글을 쓰는 것을 허용합니다.');?></label>
											</dd>
										</dl>
									</fieldset>
									<div class="button-box">
										<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="setRSS(); return false;" />
									</div>
								</div>
							</form>
						</div>
<?php
if(isset($_GET['message'])){
	$msg=escapeJSInCData($_GET['message']);?>
	<script> window.onload = function() { PM.showMessage("<?php
	echo $msg;?>", "center", "bottom"); } </script>
<?php
}?>					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
