<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
?>
<?php
define('ROOT','../../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.1.3 : Transition');
define('TATTERTOOLS_COPYRIGHT','Copyright &copy; 2004-2007. Needlworks / Tatter Network Foundation. All rights reserved. Licensed under the GPL.');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://ping.eolin.com/');
define('CRLF',"\r\n");
define('TAB',"	");
$database['server']='localhost';
$database['database']='';
$database['port']=33000;
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='ko';
$service['timezone']='Asia/Seoul';
$service['encoding']='EUC-KR';
$service['umask']=0;
$service['skin']='tistory';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
if(isset($IV)){
	if(!Validator::validate($IV)){
		header('HTTP/1.1 404 Not Found');
		exit;
	}
}
$basicIV=array('SCRIPT_NAME'=>array('string'),'REQUEST_URI'=>array('string'),'REDIRECT_URL'=>array('string','mandatory'=>false));
Validator::validateArray($_SERVER,$basicIV);
include_once '../../../../config.php';
function doesExistTable($tablename){
  global $cubrid_con;
  
  $cub_qry="SELECT count(*) FROM db_class WHERE class_name = '$tablename'";
  if (!($result = cubrid_execute($cubrid_con, $cub_qry )))
    return false;
  if (!($row = cubrid_fetch($result)))
    return false;
  if ($row[0]>0)
    return true;
	return false;
}
function getWaterMarkPosition(){
	$waterMarkPosition=getUserSetting("waterMarkPosition","left=10|bottom=10");
	list($horizontalPos,$verticalPos)=explode("|",$waterMarkPosition);
	$horizontalPos=explode("=",$horizontalPos);
	$verticalPos=explode("=",$verticalPos);
	if($horizontalPos[0]=="left"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1];
		}else{
			$horizontalValue="left";
		}
	}elseif($horizontalPos[0]=="center"){
		$horizontalValue="center";
	}elseif($horizontalPos[0]=="right"){
		if($horizontalPos[1]>0){
			$horizontalValue=$horizontalPos[1]-$horizontalPos[1]*2;
		}else{
			$horizontalValue="right";
		}
	}
	if($verticalPos[0]=="top"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1];
		}else{
			$verticalValue="top";
		}
	}elseif($verticalPos[0]=="middle"){
		$verticalValue="middle";
	}elseif($verticalPos[0]=="bottom"){
		if($verticalPos[1]>0){
			$verticalValue=$verticalPos[1]-$verticalPos[1]*2;
		}else{
			$verticalValue="bottom";
		}
	}
	return "$horizontalValue $verticalValue";
}
function getWaterMarkGamma(){
	return 100;
}
function getThumbnailPadding(){
	$thumbnailPadding=getUserSetting("thumbnailPadding",false);
	if($thumbnailPadding==false){
		return array("top"=>0,"right"=>0,"bottom"=>0,"left"=>0);
	}else{
		$tempArray=explode("|",$thumbnailPadding);
		return array("top"=>intval($tempArray[0]),"right"=>intval($tempArray[1]),"bottom"=>intval($tempArray[2]),"left"=>intval($tempArray[3]));
	}
}
function getThumbnailPaddingColor(){
	return getUserSetting("thumbnailPaddingColor","FFFFFF");
}
$cubrid_con = @cubrid_connect($database['server'], $database['port'], $database['database'], 
                              $database['username'], $database['password']);

$database['utf8']=true;
function cubrid_lessen($str,$length=255,$tail='..'){
	return UTF8::lessen($str,$length,$tail);
}
function cubrid_tt_escape_string($string,$link=null){
  $cutlen=14000;
  $clen=strlen($string);
  if ($clen<=$cutlen)
    return eregi_replace(chr(39), chr(39).chr(39),$string);
  else {
    $wrk="";
    $off=0;
    while($off<$clen) {
      $wlen=$clen-$off;
      if ($wlen>$cutlen) $wlen=$cutlen;
      if ($off>0) $wrk .= "' + '";
      $wrk .= eregi_replace(chr(39), chr(39).chr(39), substr($string, $off, $wlen));
      $off += $wlen;
    }
    return $wrk;
  }
}
function getOwner($name){
	global $database;
	return DBQuery::queryCell("select owner from {$database['prefix']}BlogSettings where \"name\" = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return DBQuery::queryCell("SELECT owner FROM {$database['prefix']}BlogSettings WHERE secondarydomain = '$domain' OR  secondarydomain = '".(substr($domain,0,4)=='www.'?substr($domain,4):'www.'.$domain)."'");
}
function getBlogSetting($owner){
	global $database, $cubrid_con;
	if($result=DBQuery::query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		$ret=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		return $ret;
	}
	return false;
}
function getSkinSetting($owner){
	global $database, $service, $cubrid_con;
	if($result=DBQuery::query("SELECT * FROM {$database['prefix']}SkinSettings WHERE owner = $owner")){
		$retval=cubrid_fetch($result);
		cubrid_commit($cubrid_con);
		if($retval!=FALSE){
			if(!Validator::directory($retval['skin'])&&($retval['skin']!="customize/$owner")){
				$retval['skin']=$service['skin'];
			}
			return $retval;
		}
	}
	$retval=array('owner'=>$owner,'skin'=>$service['skin'],'entriesonrecent'=>5,'commentsonrecent'=>5,'commentsonguestbook'=>5,'tagsontagbox'=>30,'tagboxalign'=>3,'trackbacksonrecent'=>5,'expandcomment'=>1,'expandtrackback'=>1,'recentnoticelength'=>25,'recententrylength'=>30,'recentcommentlength'=>30,'recenttrackbacklength'=>30,'linklength'=>30,'showlistoncategory'=>1,'showlistonarchive'=>1,'tree'=>'base','colorontree'=>'000000','bgcolorontree'=>'','activecolorontree'=>'FFFFFF','activebgcolorontree'=>'00ADEF','labellengthontree'=>27,'showvalueontree'=>1);
	return $retval;
}
function getDefaultURL($uid){
	global $database,$service;
	$blog=DBQuery::queryRow("SELECT \"name\", secondarydomain, defaultdomain FROM {$database['prefix']}BlogSettings WHERE owner = $uid");
	switch($service['type']){
		case 'domain':
			if($blog['defaultdomain']&&$blog['secondarydomain'])
				return ('http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
			else
				return ('http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
		case 'path':
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'].'/'.$blog['name']);
		case 'single':
		default:
			return ('http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path']);
	}
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function getHelpURL($path){
	return 'http://help.tattertools.com/ko/Menu/'.$path;
}
function getCategories($owner){
	global $database;
	$rows=DBQuery::queryAll("SELECT * FROM {$database['prefix']}Categories WHERE owner = $owner AND id > 0 ORDER BY parent, priority");
	$categories=array();
	foreach($rows as $category){
		if($category['parent']==null){
			$category['children']=array();
			$categories[$category['id']]=$category;
		}elseif(isset($categories[$category['parent']]))
			array_push($categories[$category['parent']]['children'],$category);
	}
	return $categories;
}
function getUserSetting($name,$default=null){
	global $database,$owner;
	$value=DBQuery::queryCell("SELECT \"value\" FROM {$database['prefix']}UserSettings WHERE \"user\" = $owner AND \"name\" = '".cubrid_tt_escape_string($name)."'");
	return ($value===null)?$default:$value;
}
function getCurrentSetting($name){
	global $database,$owner,$activePlugins, $cubrid_con;
	if(!in_array($name,$activePlugins))
		return false;
	$name=cubrid_tt_escape_string($name);
	$result=DBQuery::query("SELECT settings FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$name'");
	if(false===$result)
		return false;
	$out=cubrid_fetch($result);
	cubrid_commit($cubrid_con);
	return $out['settings'];
}
function treatPluginTable($plugin,$name,$fields,$keys,$version){
	global $database;
	if(doesExistTable($database['prefix'].$name)){
		$keyname='Database_'.$name;
		$value=$plugin;
		$query="SELECT \"value\" FROM {$database['prefix']}ServiceSettings WHERE \"name\"='{$keyname}'";
		$result=DBQuery::queryCell($query);
		if(is_null($result)){
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings SET \"name\"='$keyname', \"value\" ='$value'");
		}else{
			$keyname=cubrid_tt_escape_string(cubrid_lessen($keyname,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			$values=explode('/',$result,2);
			if(strcmp($plugin,$values[0])!=0){
				return false;
			}elseif(strcmp($version,$values[1])!=0){
				DBQuery::execute("UPDATE {$database['prefix']}ServiceSettings SET \"value\" ='$value' WHERE \"name\"='$keyname'");
				$eventName='UpdateDB_'.$name;
				fireEvent($eventName,$values[1]);
			}
		}
		return true;
	}else{
		$query="CREATE TABLE {$database['prefix']}{$name} (owner INT DEFAULT 0 NOT NULL";
		$isaiExists=false;
		$index='';
        $serialqry='';
		foreach($fields as $field){
            $att_type=strtolower($field['attribute']);
			if($att_type=='int'||$att_type=='mediumint'){
				if($field['autoincrement']==1&&!$isaiExists){
					$serialqry="CREATE SERIAL {$database['prefix']}{$name}"."_seq START WITH 1";
					$isaiExists=true;
					if(!in_array($field['name'],$keys))
						$index="CREATE UNIQUE INDEX SERIAL_idx on {$database['prefix']}{$name} ( {$field['name']} ); ";
				}
			}
			$isNull=($field['isnull']==0)?' NOT NULL ':' NULL ';
            switch( $att_type )
        	{
        		case 'bit' :
        		case 'smallint' :
        		case 'tinyint' :
        			$typename = "SMALLINT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'mediumint' ;
        		case 'int' ;
        			$typename = "INT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'bigint' ;
        			$typename = "NUMERIC" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'float' :
        			$typename = "FLOAT" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'double' ;
        		case 'double precision' :
        			$typename = "DOUBLE PRECISION" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'decimal' :
        		case 'dec' :
        			$typename = "DECIMAL({$field['length']})" ;
        			$typetype = "numeric" ;
        			break ;
        		case 'date' :
        			$typename = "DATE" ;
        			$typetype = "date" ;
        			break ;
        		case 'time' :
        			$typename = "TIME" ;
        			$typetype = "time" ;
        			break ;
        		case 'timestamp' :
        		case 'datetime' :
        			$typename = "TIMESTAMP" ;
        			$typetype = "timestamp" ;
        			break ;
        		case 'year' :
        			$typename = "VARCHAR(4)" ;
        			$typetype = "string" ;
        			break ;
        		case 'char' :
        			$typename = "CHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'varchar' :
        			$typename = "VARCHAR({$field['length']})" ;
        			$typetype = "string" ;
        			break ;
        		case 'tinytext' :
        			$typename = "VARCHAR(256)" ;
        			$typetype = "string" ;
        			break ;
        		case 'text' :
        			$typename = "VARCHAR(65535)" ;
        			$typetype = "string" ;
        			break ;
        		case 'longtext' :
        		case 'mediumtext' :
        			$typename = "STRING" ;
        			$typetype = "string" ;
        			break ;
        	} // end of switch()
            $deli=($typetype=="string") ? "'" : "";
			$defaultValue=is_null($field['default'])?'':" DEFAULT $deli".cubrid_tt_escape_string($field['default'])."$deli ";
			
			$sentence=",".$field['name']." ".$typename.$isNull.$defaultValue;
			$query.=$sentence;
		}
		array_unshift($keys,'owner');
		$query.=")";
		if(($rst=DBQuery::query($query))){
            if ($serialqry!='') $rst=DBQuery::query($serialqry);
            if ($rst && $index!='') $rst=DBQuery::query($index);
            if ($rst && count($keys)>0) $rst=DBQuery::query("CREATE UNIQUE INDEX PRIMARY_idx on {$database['prefix']}{$name} (".implode(',',$keys).")");
        }
		if($rst){
			$keyname=cubrid_tt_escape_string(cubrid_lessen('Database_'.$name,32));
			$value=cubrid_tt_escape_string(cubrid_lessen($plugin.'/'.$version,255));
			DBQuery::execute("INSERT INTO {$database['prefix']}ServiceSettings (\"name\", \"value\") values('$keyname', '$value')");
			return true;
		}else {
            DBQuery::rollback();
			return false;
        }
	}
	return true;
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			if($owner===null)
				$owner=1;
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
if(!isset($serviceURL))
	$serviceURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$service['path'];
switch($service['type']){
	case 'domain':
		$pathURL=$service['path'];
		if($blog['defaultdomain']&&$blog['secondarydomain']){
			$defaultURL='http://'.$blog['secondarydomain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==$blog['secondarydomain'])
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}else{
			$defaultURL='http://'.$blog['name'].'.'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
			if($_SERVER['HTTP_HOST']==($blog['name'].'.'.$service['domain']))
				$baseURL=$service['path'];
			else
				$baseURL=$defaultURL;
		}
		break;
	case 'path':
		$pathURL=$service['path'].'/'.$blog['name'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'].'/'.$blog['name'];
		else
			$baseURL=$defaultURL;
		break;
	case 'single':
	default:
		$pathURL=$service['path'];
		$defaultURL='http://'.$service['domain'].(isset($service['port'])?':'.$service['port']:'').$pathURL;
		if($_SERVER['HTTP_HOST']==$service['domain'])
			$baseURL=$service['path'];
		else
			$baseURL=$defaultURL;
		break;
}
$hostURL='http://'.$_SERVER['HTTP_HOST'].(isset($service['port'])?':'.$service['port']:'');
$blogURL=$pathURL;
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
$adminSkinSetting=array();
$adminSkinSetting['skin']="/style/admin/".getUserSetting("adminSkin","default");
if(file_exists("../../../../skin/{$skinSetting['skin']}/wysiwyg.css"))
	$adminSkinSetting['editorTemplate']="/skin/{$skinSetting['skin']}/wysiwyg.css";
else
	$adminSkinSetting['editorTemplate']="/style/default-wysiwyg.css";
if(file_exists("../../../../attach/$owner/watermark.gif")){
	$waterMarkPath="../../../../attach/$owner/watermark.gif";
}else{
	$waterMarkPath=NULL;
}
$waterMarkArray=array();
$waterMarkArray['path']=$waterMarkPath;
$waterMarkArray['position']=getWaterMarkPosition();
$waterMarkArray['gamma']=getWaterMarkGamma();
$paddingArray=array();
$padding=getThumbnailPadding();
$paddingArray['top']=$padding['top'];
$paddingArray['right']=$padding['right'];
$paddingArray['bottom']=$padding['bottom'];
$paddingArray['left']=$padding['left'];
$paddingArray['bgColor']=getThumbnailPaddingColor();
unset($padding);
unset($waterMarkPath);
if(!file_exists('../../../../config.php')){
	header('Location: '.'../../../../setup.php');
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database, $cubrid_con,$service;
	if($result=sessionQuery("SELECT \"data\" FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (SYS_TIMESTAMP - {$service['timeout']})")){
		if($session=cubrid_fetch($result))
			return $session['data'];
		cubrid_commit($cubrid_con);
	}
	return '';
}
function writeSession($id,$data){
	global $database, $cubrid_con;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=cubrid_tt_escape_string($data);
	$server=cubrid_tt_escape_string($_SERVER['HTTP_HOST']);
	$request=cubrid_tt_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?cubrid_tt_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=cubrid_execute($cubrid_con,"UPDATE {$database['prefix']}Sessions SET userid = $userid, \"data\" = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970') WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(cubrid_affected_rows($result)==1)) {
	  cubrid_commit($cubrid_con);
		return true;
	}
	return false;
}
function destroySession($id,$setCookie=false){
	global $database, $cubrid_con;
	if(!isset($_SESSION['userid']))
		return ;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	cubrid_commit($cubrid_con);
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database, $cubrid_con,$service;
	@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}Sessions WHERE updated < (SYS_TIMESTAMP - {$service['timeout']})");
	$result=@sessionQuery("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=cubrid_fetch($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@cubrid_execute($cubrid_con,"DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
		cubrid_commit($cubrid_con);
	}
	return true;
}
function getAnonymousSession(){
	global $database, $cubrid_con;
	$result=sessionQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=cubrid_fetch($result))) {
 		cubrid_commit($cubrid_con);
		return $id;
	}
	cubrid_commit($cubrid_con);
	return false;
}
function newAnonymousSession(){
	global $database, $cubrid_con;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		$rst=cubrid_execute($cubrid_con,"INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'), SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
		if(cubrid_affected_rows($rst)>0) {
  		cubrid_commit($cubrid_con);
			return $id;
		}
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database, $cubrid_con;
	$result=cubrid_execute($cubrid_con,"select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(cubrid_num_rows($result)==1)) {
		cubrid_commit($cubrid_con);
  	return true;
	}
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
function sessionQuery($sql){
	global $database, $cubrid_con,$sessionDBRepair;
	$result=cubrid_execute($cubrid_con, $sql);
	if($result===false){
		if(!isset($sessionDBRepair)){
		  // CUBRID repair table 없음.
			$sessionDBRepair=true;
		}
	}
	return $result;
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL'])){
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}else{
		if(String::endsWith($_SERVER['HTTP_HOST'],'.'.$service['domain']))
			header("Location: $blogURL/login?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
		else
			header('Location: '.getBlogURL().'/login?requestURI='.rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	$user['name']=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = {$user['id']}");
	$user['homepage']=getDefaultURL($user['id']);
}else{
	$user=null;
}
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
if(!isset($blog['bloglanguage'])){
	$blog['bloglanguage']=$service['language'];
}
if(is_file($__locale['directory'].'/'.$blog['bloglanguage'].".php")){
	$__outText=getOutLanguage($__locale['directory'].'/'.$blog['bloglanguage'].".php");
}
function getOutLanguage($languageFile){
	include ($languageFile);
	return $__text;
}
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
$sidebarMappings=array();
$centerMappings=array();
$storageMappings=array();
$storageKeymappings=array();
$adminMenuMappings=array();
$adminHandlerMappings=array();
$configMappings=array();
$baseConfigPost=$service['path'].'/owner/setting/plugins/currentSetting';
$configPost='';
$configVal='';
$typeSchema=null;
if(!empty($owner)){
	$activePlugins=DBQuery::queryColumn("SELECT \"name\" FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			$version='';
			if($xmls->doesExist('/plugin/version')){
				$version=$xmls->getValue('/plugin/version');
			}
			if($xmls->doesExist('/plugin/storage')){
				foreach($xmls->selectNodes('/plugin/storage/table') as $table){
					$storageMappings=array();
					$storageKeymappings=array();
					if(empty($table['name'][0]['.value']))
						continue;
					$tableName=htmlspecialchars($table['name'][0]['.value']);
					if(!empty($table['fields'][0]['field'])){
						foreach($table['fields'][0]['field'] as $field){
							if(!isset($field['name']))
								continue;
							$fieldName=$field['name'][0]['.value'];
							if(!isset($field['attribute']))
								continue;
							$fieldAttribute=$field['attribute'][0]['.value'];
							$fieldLength=isset($field['length'])?$field['length'][0]['.value']:-1;
							$fieldIsNull=isset($field['isnull'])?$field['isnull'][0]['.value']:1;
							$fieldDefault=isset($field['default'])?$field['default'][0]['.value']:null;
							$fieldAutoIncrement=isset($field['autoincrement'])?$field['autoincrement'][0]['.value']:0;
							array_push($storageMappings,array('name'=>$fieldName,'attribute'=>$fieldAttribute,'length'=>$fieldLength,'isnull'=>$fieldIsNull,'default'=>$fieldDefault,'autoincrement'=>$fieldAutoIncrement));
						}
					}
					if(!empty($table['key'][0]['.value'])){
						foreach($table['key'] as $key){
							array_push($storageKeymappings,$key['.value']);
						}
					}
					treatPluginTable($plugin,$tableName,$storageMappings,$storageKeymappings,$version);
					unset($tableName);
					unset($storageMappings);
					unset($storageKeymappings);
				}
			}
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
			if($xmls->doesExist('/plugin/binding/center')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/center') as $center){
					if(!empty($center['.attributes']['handler'])){
						array_push($centerMappings,array('plugin'=>$plugin,'handler'=>$center['.attributes']['handler'],'title'=>$title));
					}
				}
				unset($title);
				unset($center);
			}
			if($xmls->doesExist('/plugin/binding/sidebar')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				foreach($xmls->selectNodes('/plugin/binding/sidebar') as $sidebar){
					if(!empty($sidebar['.attributes']['handler'])){
						$parameters=array();
						if(isset($sidebar['params'])&&isset($sidebar['params'][0])&&isset($sidebar['params'][0]['param'])){
							foreach($sidebar['params'][0]['param'] as $param){
								$parameter=array('name'=>$param['name'][0]['.value'],'type'=>$param['type'][0]['.value'],'title'=>XMLStruct::getValueByLocale($param['title']));
								array_push($parameters,$parameter);
							}
						}
						array_push($sidebarMappings,array('plugin'=>$plugin,'title'=>$sidebar['.attributes']['title'],'display'=>$title,'handler'=>$sidebar['.attributes']['handler'],'parameters'=>$parameters));
					}
				}
				unset($sidebar);
			}
			if($xmls->doesExist('/plugin/binding/config')){
				$config=$xmls->selectNode('/plugin/binding/config');
				if(!empty($config['.attributes']['dataValHandler']))
					$configMappings[$plugin]=array('config'=>'ok','dataValHandler'=>$config['.attributes']['dataValHandler']);
				else
					$configMappings[$plugin]=array('config'=>'ok');
			}
			if($xmls->doesExist('/plugin/binding/adminMenu')){
				$title=htmlspecialchars($xmls->getValue('/plugin/title[lang()]'));
				if($xmls->doesExist('/plugin/binding/adminMenu/viewMethods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/viewMethods/method') as $adminViewMenu){
						$menutitle=htmlspecialchars(XMLStruct::getValueByLocale($adminViewMenu['title']));
						if(empty($menutitle))
							continue;
						$menuposition=empty($adminViewMenu['position'][0]['.value'])?'menu-plugin':$adminViewMenu['position'][0]['.value'];
						$menuhelpurl=empty($adminViewMenu['helpurl'][0]['.value'])?'':$adminViewMenu['helpurl'][0]['.value'];
						if(!isset($adminViewMenu['handler'][0]['.value']))
							continue;
						$viewhandler=htmlspecialchars($adminViewMenu['handler'][0]['.value']);
						if(empty($viewhandler))
							continue;
						$params=array();
						if(isset($adminViewMenu['params'][0]['param'])){
							foreach($adminViewMenu['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($params,array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminMenuMappings[$plugin.'/'.$viewhandler]=array('plugin'=>$plugin,'title'=>$menutitle,'position'=>$menuposition,'handler'=>$viewhandler,'params'=>$params,'helpurl'=>$menuhelpurl);
					}
				}
				unset($menutitle);
				unset($viewhandler);
				unset($adminViewMenu);
				unset($params);
				if($xmls->doesExist('/plugin/binding/adminMenu/methods')){
					foreach($xmls->selectNodes('/plugin/binding/adminMenu/methods/method') as $adminMethods){
						$method=array();
						$method['plugin']=$plugin;
						if(!isset($adminMethods['handler'][0]['.value']))
							continue;
						$method['handler']=$adminMethods['handler'][0]['.value'];
						$method['params']=array();
						if(isset($adminMethods['params'][0]['param'])){
							foreach($adminMethods['params'][0]['param'] as $methodParam){
								if(!isset($methodParam['name'][0]['.value'])||!isset($methodParam['type'][0]['.value']))
									continue;
								array_push($method['params'],array('name'=>$methodParam['name'][0]['.value'],'type'=>$methodParam['type'][0]['.value'],'mandatory'=>@$methodParam['mandatory'][0]['.value'],'default'=>@$methodParam['default'][0]['.value']));
							}
						}
						$adminHandlerMappings[$plugin.'/'.$method['handler']]=$method;
					}
				}
				unset($method);
				unset($methodParam);
				unset($adminMethods);
			}
		}else{
			$plugin=cubrid_tt_escape_string($plugin);
			DBQuery::query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND \"name\" = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
function fireEvent($event,$target=null,$mother=null,$condition=true){
	global $service,$eventMappings,$pluginURL,$pluginPath,$configMappings,$configVal;
	if(!$condition)
		return $target;
	if(!isset($eventMappings[$event]))
		return $target;
	foreach($eventMappings[$event] as $mapping){
		include_once ("../../../../plugins/{$mapping['plugin']}/index.php");
		if(function_exists($mapping['listener'])){
			if(!empty($configMappings[$mapping['plugin']]['config']))
				$configVal=getCurrentSetting($mapping['plugin']);
			else
				$configVal=null;
			$pluginURL="{$service['path']}/plugins/{$mapping['plugin']}";
			$pluginPath="../../../../plugins/{$mapping['plugin']}";
			$target=call_user_func($mapping['listener'],$target,$mother);
		}
	}
	return $target;
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php
echo (isset($blog['language'])?$blog['language']:"ko");?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php
echo htmlspecialchars($blog['title']);?> &gt; <?php
echo _t('스킨관리');?></title>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/skin.css" />
	<!--[if lte IE 6]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/skin.ie.css" />
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/basic.ie7.css" />
		<link rel="stylesheet" type="text/css" media="screen" href="<?php
echo $service['path'].$adminSkinSetting['skin'];?>/skin.ie7.css" />
	<![endif]-->
	<script type="text/javascript">
		//<![CDATA[
			var servicePath = "<?php
echo $service['path'];?>";
			var blogurl = "<?php
echo $blogURL;?>";
			var adminSkin = "<?php
echo $adminSkinSetting['skin'];?>";
		//]]>
	</script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/byTattertools.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/EAF2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/common2.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/gallery.js"></script>
	<script type="text/javascript" src="<?php
echo $service['path'];?>/script/owner.js"></script>
</head>
<body id="body-skin">
	<div id="temp-wrap">
		<div id="all-wrap">
			<div id="layout-header">
				<h1><?php
echo _t('태터툴즈 관리 페이지');?></h1>
				
				<div id="main-description-box">
					<ul id="main-description">
<?php
$writer=DBQuery::queryCell("SELECT \"name\" FROM {$database['prefix']}Users WHERE userid = $owner");?>
						<li id="description-blogger"><span class="text"><?php
echo _f('환영합니다. <em>%1</em>님.',htmlspecialchars($writer));?></span></li>
						<li id="description-blog"><a href="<?php
echo $blogURL;?>/" title="<?php
echo _t('블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('블로그로 이동');?></span></a></li>
						<li id="description-logout"><a href="<?php
echo $blogURL;?>/logout" title="<?php
echo _t('로그아웃하고 블로그 메인으로 이동합니다.');?>"><span class="text"><?php
echo _t('로그아웃');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<h2><?php
echo _t('메인메뉴');?></h2>
				
				<div id="main-menu-box">
					<ul id="main-menu">
						<li id="menu-tattertools"><a href="<?php
echo TATTERTOOLS_HOMEPAGE;?>" onclick="window.open(this.href); return false;" title="<?php
echo _t('태터툴즈 홈페이지로 이동합니다.');?>"><span class="text"><?php
echo _t('태터툴즈 홈페이지');?></span></a></li>
						<li id="menu-center"><a href="<?php
echo $blogURL;?>/owner/center/dashboard"><span><?php
echo _t('센터');?></span></a></li>
						<li id="menu-post"><a href="<?php
echo $blogURL;?>/owner/entry"><span class="text"><?php
echo _t('글');?></span></a></li>
						<li id="menu-link"><a href="<?php
echo $blogURL;?>/owner/link"><span class="text"><?php
echo _t('링크');?></span></a></li>
						<li id="menu-skin" class="selected"><a href="<?php
echo $blogURL;?>/owner/skin"><span class="text"><?php
echo _t('스킨');?></span></a></li>
						<li id="menu-plugin"><a href="<?php
echo $blogURL;?>/owner/plugin"><span class="text"><?php
echo _t('플러그인');?></span></a></li>
						<li id="menu-setting"><a href="<?php
echo $blogURL;?>/owner/setting/blog"><span class="text"><?php
echo _t('환경설정');?></span></a></li>
						<li id="menu-reader"><a href="<?php
echo $blogURL;?>/owner/reader"><span class="text"><?php
echo _t('리더');?></span></a></li>
					</ul>
				</div>
			</div>
			
			<hr class="hidden" />

			<div id="layout-body">
				<h2><?php
echo _t('서브메뉴 : 스킨관리');?></h2>
				
				<div id="sub-menu-box">
					<ul id="sub-menu">
						<li id="sub-menu-list"><a href="<?php
echo $blogURL;?>/owner/skin"><span class="text"><?php
echo _t('스킨 선택');?></span></a></li>
						<li id="sub-menu-edit"><a href="<?php
echo $blogURL;?>/owner/skin/edit"><span class="text"><?php
echo _t('스킨 편집');?></span></a></li>
						<li id="sub-menu-option" class="selected"><a href="<?php
echo $blogURL;?>/owner/skin/setting"><span class="text"><?php
echo _t('출력 설정');?></span></a></li>
						<li id="sub-menu-sidebar"><a href="<?php
echo $blogURL;?>/owner/skin/sidebar"><span class="text"><?php
echo _t('사이드바');?></span></a></li>
						<li id="sub-menu-helper"><a href="<?php
echo getHelpURL('skin/setting');?>" onclick="window.open(this.href); return false;"><span class="text"><?php
echo _t('도우미');?></span></a></li>
					</ul>
				</div>
				
				<hr class="hidden" />
				
				<div id="pseudo-box">
					<div id="data-outbox">
<?php
$categories=getCategories($owner);
$selected=0;?>
						<script type="text/javascript">
							//<![CDATA[
								function getValueById(id) {
									return document.getElementById(id).value;
								}
								
								function setSkin() {
									if(document.getElementById('showListOnCategoryTitles').checked) 
										showlistoncategory = 2;
									else if(document.getElementById('showListOnCategoryContents').checked) 
										showlistoncategory = 0;
									else if(document.getElementById('showListOnCategorySome').checked) 
										showlistoncategory = 3;
									else 
										showlistoncategory = 1;
									
									if(document.getElementById('showListOnArchiveTitles').checked) 
										showlistonarchive = 2;
									else if(document.getElementById('showListOnArchiveContents').checked) 
										showlistonarchive = 0;
									else if(document.getElementById('showListOnArchiveSome').checked) 
										showlistonarchive = 3;
									else 
										showlistonarchive = 1;

									if(document.getElementById('showListOnTagTitles').checked) 
										showlistontag = 2;
									else if(document.getElementById('showListOnTagContents').checked) 
										showlistontag = 0;
									else if(document.getElementById('showListOnTagSome').checked) 
										showlistontag = 3;
									else 
										showlistontag = 1;

									if(document.getElementById('showListOnSearchTitles').checked) 
										showlistonsearch = 2;
									else 
										showlistonsearch = 1;
									
									if(document.getElementById('expandcomment').checked) 
										expandcomment = 1;
									else 
										expandcomment = 0;
									
									if(document.getElementById('expandtrackback').checked) 
										expandtrackback = 1;
									else 
										expandtrackback = 0;

									if(document.getElementById('useRelTag').checked)
										useRelTag = 1;
									else 
										useRelTag = 0;
									
									var tagboxalign = 1;
									if (document.getElementById('tagboxAlignUsed')	.checked) {
										tagboxalign = 1;
									} else if(document.getElementById('tagboxAlignName').checked) {
										tagboxalign = 2;
									} else {
										tagboxalign = 3;
									}
									
									param  = '';
									param += 'entriesonpage='+getValueById('entriesonpage') +'&';
									param += 'entriesonlist='+getValueById('entriesonlist') +'&';
									param += 'entriesonrecent='+getValueById('entriesonrecent') +'&';
									param += 'commentsonrecent='+getValueById('commentsonrecent') +'&';
									param += 'commentsonguestbook='+getValueById('commentsonguestbook') +'&';
									param += 'archivesonpage='+getValueById('archivesonpage') +'&';
									param += 'tagboxalign='+tagboxAlign +'&';
									param += 'tagsontagbox='+getValueById('tagsontagbox') +'&';
									param += 'trackbacksonrecent='+getValueById('trackbacksonrecent') +'&';
									param += 'showlistoncategory='+showListOnCategory +'&';
									param += 'showlistonarchive='+showListOnArchive +'&';
									param += 'showlistontag='+showListOnTag +'&';
									param += 'showlistonsearch='+showListOnSearch +'&';
									param += 'expandcomment='+expandComment +'&';				
									param += 'expandtrackback='+expandTrackback +'&';
									param += 'recentnoticelength='+getValueById('recentnoticelength') +'&';
									param += 'recententrylength='+getValueById('recententrylength') +'&';
									param += 'recentcommentlength='+getValueById('recentcommentlength') +'&';
									param += 'recenttrackbacklength='+getValueById('recenttrackbacklength') +'&';				
									param += 'linklength='+getValueById('linklength') +'&';
									param += 'useRelTag='+ useRelTag +'&';
									var request = new HTTPRequest("POST", '<?php
echo $blogURL;?>/owner/skin/setting/skin/');
									request.onSuccess = function() {
										PM.showMessage("<?php
echo _t('저장되었습니다.');?>", "center", "bottom");
									}
									request.onError = function() {
										PM.showMessage("<?php
echo _t('저장하지 못했습니다.');?>", "center", "bottom");
									}
									request.send(param);
								}
										
								function changeTreeStyle() {	
									var param = '';
									param += 'name='+document.getElementById('tree').value+'&';
									param += 'url=<?php
echo $service['path'];?>/image/tree/'+document.getElementById('tree').value+'&';
									param += 'showValue='+(document.getElementById('showValue').checked ? 1:0)+'&';
									param += 'itemColor='+document.getElementById('colorontree').value+'&';
									param += 'itemBgColor='+document.getElementById('bgcolorontree').value+'&';
									param += 'activeItemColor='+document.getElementById('activecolorontree').value+'&';
									param += 'activeItemBgColor='+document.getElementById('activebgcolorontree').value+'&';
									param += 'labelLength='+document.getElementById('labellengthontree').value+'&';
									
									document.getElementById('treePreview').src="<?php
echo $blogURL;?>/owner/skin/setting/tree/preview/?"+param;
								}
							//]]>
						</script>
						
						<div id="part-skin-setting" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('스킨 출력에 따른 여러 값들을 변경합니다');?></span></h2>
							
							<div class="data-inbox">
								<form id="skinSetting" class="section" method="post" action="<?php
echo $blogURL;?>/owner/skin/setting/skin" enctype="application/x-www-form-urlencoded">
									<fieldset id="per-page-container" class="container">
										<legend><?php
echo _t('출력 숫자 조절');?></legend>
<?php
ob_start();?>

												<select id="entriesonpage" name="entriesonpage">
<?php
for($i=1;$i<=30;$i++){
	if($i==$blog['entriesonpage'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="post-per-count-line" class="line">
											<dt><span class="label"><?php
echo _t('한 쪽당 글 수');?></span></dt>
											<dd><?php
echo _f('블로그 글을 한 쪽당 %1개 보여줍니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="entriesonlist" name="entriesonlist">
<?php
for($i=1;$i<=30;$i++){
	if($i==$blog['entriesonlist'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="post-per-count-line" class="line">
											<dt><span class="label"><?php
echo _t('목록 한 쪽당 글 수');?></span></dt>
											<dd><?php
echo _f('글목록을 한 쪽당 %1개 보여줍니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="entriesonrecent" name="entriesonrecent">
<?php
for($i=1;$i<=30;$i++){
	if($i==$skinSetting['entriesonrecent'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-post-line" class="line">
											<dt><span class="label"><?php
echo _t('출력될 최근 글 수');?></span></dt>
											<dd><?php
echo _f('최근에 쓴 글을 %1개 보여줍니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="commentsonrecent" name="commentsonrecent">
<?php
for($i=1;$i<=30;$i++){
	if($i==$skinSetting['commentsonrecent'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-comment-line" class="line">
											<dt><span class="label"><?php
echo _t('출력될 최근 댓글 수');?></span></dt>
											<dd><?php
echo _f('최근에 달린 댓글을 %1개 보여줍니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="trackbacksonrecent" name="trackbacksonrecent">
<?php
for($i=1;$i<=30;$i++){
	if($i==$skinSetting['trackbacksonrecent'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-trackback-line" class="line">
											<dt><span class="label"><?php
echo _t('출력될 최근 걸린글 수');?></span></dt>
											<dd><?php
echo _f('최근 걸린글을 %1개 보여줍니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="archivesonpage" name="archivesonpage">
<?php
for($i=1;$i<36;$i++){
	if($i==$skinSetting['archivesonpage'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}
for($i=36;$i<=120;$i=$i+12){
	if($i==$skinSetting['archivesonpage'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-archive-line" class="line">
											<dt><span class="label"><?php
echo _t('출력될 저장소 수');?></span></dt>
											<dd><?php
echo _f('저장소에 글 목록을 %1달치만큼 보여줍니다.',$arg);?></dd>

										</dl>
									</fieldset>
									
									<fieldset id="click-container" class="container">
										<legend><?php
echo _t('클릭 설정');?></legend>
										<dl id="category-click-line" class="line">
											<dt><span class="label"><?php
echo _t('분류 선택 시');?></span></dt>
											<dd>
												<input type="radio" id="showListOnCategoryTitles" class="radio" name="showlistoncategory" value="titles"<?php
echo ($skinSetting['showlistoncategory']==2)?' checked="checked"':'';?> /> <label for="showListOnCategoryTitles"><?php
echo _t('글 목록을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnCategoryContents" class="radio" name="showlistoncategory" value="contents"<?php
echo ($skinSetting['showlistoncategory']==0)?' checked="checked"':'';?> /> <label for="showListOnCategoryContents"><?php
echo _t('글 내용을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnCategorySome" class="radio" name="showlistoncategory" value="some"<?php
echo ($skinSetting['showlistoncategory']==3)?' checked="checked"':'';?> /> <label for="showListOnCategorySome"><?php
echo _t('목록과 한 쪽당 글 수 만큼 글을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnCategoryAll" class="radio" name="showlistoncategory" value="all"<?php
echo ($skinSetting['showlistoncategory']==1)?' checked="checked"':'';?> /> <label for="showListOnCategoryAll"><?php
echo _t('목록과 함께 해당되는 모든 글을 표시합니다.');?></label>
											</dd>
										</dl>
										<dl id="archive-click-line" class="line">
											<dt><span class="label"><?php
echo _t('저장소 선택 시');?></span></dt>
											<dd>
												<input type="radio" id="showListOnArchiveTitles" class="radio" name="showlistonarchive" value="titles"<?php
echo ($skinSetting['showlistonarchive']==2)?' checked="checked"':'';?> /> <label for="showListOnArchiveTitles"><?php
echo _t('글 목록을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnArchiveContents" class="radio" name="showlistonarchive" value="contents"<?php
echo ($skinSetting['showlistonarchive']==0)?' checked="checked"':'';?> /> <label for="showListOnArchiveContents"><?php
echo _t('글 내용을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnArchiveSome" class="radio" name="showlistonarchive" value="some"<?php
echo ($skinSetting['showlistonarchive']==3)?' checked="checked"':'';?> /> <label for="showListOnArchiveSome"><?php
echo _t('목록과 한 쪽당 글 수 만큼 글을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnArchiveAll" class="radio" name="showlistonarchive" value="all"<?php
echo ($skinSetting['showlistonarchive']==1)?' checked="checked"':'';?> /> <label for="showListOnArchiveAll"><?php
echo _t('목록과 함께 해당되는 모든 글을 표시합니다.');?></label>
											</dd>
										</dl>
										<dl id="tag-click-line" class="line">
											<dt><span class="label"><?php
echo _t('태그 선택 시');?></span></dt>
											<dd>
												<input type="radio" id="showListOnTagTitles" class="radio" name="showlistontag" value="titles"<?php
echo ($skinSetting['showlistontag']==2)?' checked="checked"':'';?> /> <label for="showListOnTagTitles"><?php
echo _t('글 목록을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnTagContents" class="radio" name="showlistontag" value="contents"<?php
echo ($skinSetting['showlistontag']==0)?' checked="checked"':'';?> /> <label for="showListOnTagContents"><?php
echo _t('글 내용을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnTagSome" class="radio" name="showlistontag" value="some"<?php
echo ($skinSetting['showlistontag']==3)?' checked="checked"':'';?> /> <label for="showListOnTagSome"><?php
echo _t('목록과 한 쪽당 글 수 만큼 글을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnTagAll" class="radio" name="showlistontag" value="all"<?php
echo ($skinSetting['showlistontag']==1)?' checked="checked"':'';?> /> <label for="showListOnTagAll"><?php
echo _t('목록과 함께 해당되는 모든 글을 표시합니다.');?></label>
											</dd>
										</dl>
										<dl id="search-click-line" class="line">
											<dt><span class="label"><?php
echo _t('검색 시');?></span></dt>
											<dd>
												<input type="radio" id="showListOnSearchTitles" class="radio" name="showlistonsearch" value="titles"<?php
echo ($skinSetting['showlistonsearch']==2)?' checked="checked"':'';?> /> <label for="showListOnSearchTitles"><?php
echo _t('글 목록을 표시합니다.');?></label><br />
												<input type="radio" id="showListOnSearchAll" class="radio" name="showlistonsearch" value="all"<?php
echo ($skinSetting['showlistonsearch']==1)?' checked="checked"':'';?> /> <label for="showListOnSearchAll"><?php
echo _t('목록과 함께 해당되는 모든 글을 표시합니다.');?></label>
											</dd>
										</dl>
										<dl id="post-click-line" class="line">
											<dt><span class="label"><?php
echo _t('글을 표시할 때');?></span></dt>
											<dd>
												<input type="checkbox" id="expandcomment" class="checkbox" name="expandcomment"<?php
echo $skinSetting['expandcomment']?' checked="checked"':'';?> /><label for="expandcomment"><?php
echo _t('댓글을 기본으로 펼칩니다.');?></label><br />
												<input type="checkbox" id="expandtrackback" class="checkbox" name="expandtrackback"<?php
echo $skinSetting['expandtrackback']?' checked="checked"':'';?> /><label for="expandtrackback"><?php
echo _t('걸린글을 기본으로 펼칩니다.');?></label>
											</dd>
										</dl>
									</fieldset>
									
									<fieldset id="length-container" class="container">
										<legend><?php
echo _t('문자열 길이 조절');?></legend>
<?php
ob_start();?>

												<select id="recentnoticelength" name="recentnoticelength">
<?php
for($i=3;$i<50;$i++){
	if($i==$skinSetting['recentnoticelength'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}
for($i=50;$i<1000;$i=$i+50){
	if($i==$skinSetting['recentnoticelength']){
		$checked=' selected="selected"';
	}elseif(($i<$skinSetting['recentnoticelength'])&&(($i+50)>$skinSetting['recentnoticelength'])){
		$checked=' selected="selected"';?>
													<option value="<?php
		echo $skinSetting['recentnoticelength'];?>" <?php
		echo $checked;?>><?php
		echo $skinSetting['recentnoticelength'];?></option>
<?php
	}else{
		$checked='';
	}?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>


												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-notice-length-line" class="line">
											<dt><span class="label"><?php
echo _t('최근 공지 길이');?></span></dt>
											<dd><?php
echo _f('최근 공지를 %1 글자로 표시합니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="recententrylength" name="recententrylength">
<?php
for($i=3;$i<50;$i++){
	if($i==$skinSetting['recententrylength'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}
for($i=50;$i<1000;$i=$i+50){
	if($i==$skinSetting['recententrylength']){
		$checked=' selected="selected"';
	}elseif(($i<$skinSetting['recententrylength'])&&(($i+50)>$skinSetting['recententrylength'])){
		$checked=' selected="selected"';?>
													<option value="<?php
		echo $skinSetting['recententrylength'];?>" <?php
		echo $checked;?>><?php
		echo $skinSetting['recententrylength'];?></option>
<?php
	}else{
		$checked='';
	}?>

													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-post-length-line" class="line">
											<dt><span class="label"><?php
echo _t('최근 글 길이');?></span></dt>
											<dd><?php
echo _f('최근 글을 %1 글자로 표시합니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="recentcommentlength" name="recentcommentlength">
<?php
for($i=3;$i<50;$i++){
	if($i==$skinSetting['recentcommentlength'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}
for($i=50;$i<1000;$i=$i+50){
	if($i==$skinSetting['recentcommentlength']){
		$checked=' selected="selected"';
	}elseif(($i<$skinSetting['recentcommentlength'])&&(($i+50)>$skinSetting['recentcommentlength'])){
		$checked=' selected="selected"';?>
													<option value="<?php
		echo $skinSetting['recentcommentlength'];?>" <?php
		echo $checked;?>><?php
		echo $skinSetting['recentcommentlength'];?></option>
<?php
	}else{
		$checked='';
	}?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-comment-length-line" class="line">
											<dt><span class="label"><?php
echo _t('최근 댓글 길이');?></span></dt>
											<dd><?php
echo _f('최근 댓글을 %1 글자로 표시합니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="recenttrackbacklength" name="recenttrackbacklength">
<?php
for($i=3;$i<50;$i++){
	if($i==$skinSetting['recenttrackbacklength'])
		$checked=' selected="selected"';
	else
		$checked='';?>
														<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}
for($i=50;$i<1000;$i=$i+50){
	if($i==$skinSetting['recenttrackbacklength']){
		$checked=' selected="selected"';
	}elseif(($i<$skinSetting['recenttrackbacklength'])&&(($i+50)>$skinSetting['recenttrackbacklength'])){
		$checked=' selected="selected"';?>
														<option value="<?php
		echo $skinSetting['recenttrackbacklength'];?>" <?php
		echo $checked;?>><?php
		echo $skinSetting['recenttrackbacklength'];?></option>
<?php
	}else{
		$checked='';
	}?>
														<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-trackback-length-line" class="line">
											<dt><span class="label"><?php
echo _t('최근 걸린글 길이');?></span></dt>
											<dd><?php
echo _f('최근 걸린글을 %1 글자로 표시합니다.',$arg);?></dd>
										</dl>
<?php
ob_start();?>

												<select id="linklength" name="linklength">
<?php
for($i=3;$i<=80;$i++){
	if($i==$skinSetting['linklength'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="recent-link-length-line" class="line">
											<dt><span class="label"><?php
echo _t('링크 길이');?></span></dt>
											<dd><?php
echo _f('링크를 %1 글자로 표시합니다.',$arg);?></dd>
										</dl>
									</fieldset>
									
									<fieldset id="tag-setting-container" class="container">
										<legend><?php
echo _t('태그 조절');?></legend>
										
										<dl id="tag-align-line" class="line">
											<dt><span class="label"><?php
echo _t('태그의 정렬방법을');?></span></dt>
											<dd>
												<input type="radio" id="tagboxAlignUsed" class="radio" name="tagboxalign" value="1" <?php
echo ($skinSetting['tagboxalign']==1?'checked = "checked"':'');?> /><label for="tagboxAlignUsed"><?php
echo _t('인기도순으로 표시합니다.');?></label><br />
												<input type="radio" id="tagboxAlignName" class="radio" name="tagboxalign" value="2" <?php
echo ($skinSetting['tagboxalign']==2?'checked = "checked"':'');?> /><label for="tagboxAlignName"><?php
echo _t('이름순으로 표시합니다.');?></label><br />
												<input type="radio" id="tagboxAlignRandom" class="radio" name="tagboxalign" value="3" <?php
echo ($skinSetting['tagboxalign']==3?'checked = "checked"':'');?> /><label for="tagboxAlignRandom"><?php
echo _t('임의로 표시합니다.');?></label>
											</dd>
										</dl>
<?php
ob_start();?>

												<select id="tagsontagbox" name="tagsontagbox">
<?php
for($i=10;$i<=200;$i+=10){
	if($i==$skinSetting['tagsontagbox'])
		$checked=' selected="selected"';
	else
		$checked='';?>
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
													<option value="-1" <?php
echo $skinSetting['tagsontagbox']==-1?'selected = "selected"':'';?>><?php
echo _t('전체');?></option>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl id="tag-count-line" class="line">
											<dt><span class="label"><?php
echo _t('태그상자의 태그 수');?></span></dt>
											<dd><?php
echo _f('태그상자의 태그를 %1개 표시합니다.',$arg);?></dd>
										</dl>
										<dl id="tag-rel-line" class="line">
											<dt><span class="label"><?php
echo _t('태그 연관성 명시');?></span></dt>
											<dd>
												<input type="checkbox" id="useRelTag" class="checkbox" name="useRelTag"<?php
echo getUserSetting('useRelTag',1)?' checked="checked"':'';?> /><label for="useRelTag"><?php
echo _t('검색엔진이 태그를 따로 인식할 수 있도록 글의 태그에 rel=tag 를 표시합니다. 태그 상자에는 적용되지 않습니다.');?></label>
											</dd>
										</dl>
									</fieldset>
									
									<fieldset id="guestbook-setting-container" class="container">
										<legend><?php
echo _t('방명록 관련 조절');?></legend>
<?php
ob_start();?>

												<select id="commentsonguestbook" name="commentsonguestbook">
<?php
for($i=1;$i<=30;$i++){
	if($i==$skinSetting['commentsonguestbook'])
		$checked=' selected="selected"';
	else
		$checked='';?>						
													<option value="<?php
	echo $i;?>" <?php
	echo $checked;?>><?php
	echo $i;?></option>
<?php
}?>
												</select>
<?php
$arg=ob_get_contents();
ob_end_clean();?>
										<dl class="line">
											<dt><span class="label"><?php
echo _t('쪽 당 방명록 수');?></span></dt>
											<dd><?php
echo _f('방명록 한 쪽 당 %1개 글을 표시합니다.',$arg);?></dd>
										</dl>
									</fieldset>
								
									<div class="button-box">
										<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="setSkin(); return false;" />
									</div>
								</form>
							</div>
						</div>
						
						<hr class="hidden" />
						
						<div id="part-skin-tree" class="part">
							<h2 class="caption"><span class="main-text"><?php
echo _t('스킨에 맞춘 분류의 출력을 변경합니다');?></span></h2>
							
							<form id="setSkinForm" method="post" action="<?php
echo $blogURL;?>/owner/skin/setting/tree" enctype="application/x-www-form-urlencoded">
								<div class="data-inbox">
									<div id="tree-preview-box">
										<div class="title"><?php
echo _t('미리보기');?></div>
										<iframe id="treePreview" src="<?php
echo $blogURL;?>/owner/skin/setting/tree/preview" width="300" height="300" frameborder="0" style="overflow: visible;"></iframe>
									</div>
									
									<div class="section">
										<fieldset id="property-box" class="container">
											<legend><?php
echo _t('트리 속성');?></legend>
											
											<dl id="tree-skin-line" class="line">
												<dt><span class="label"><?php
echo _t('분류 스킨 선택');?></span></dt>
												<dd>
													<select name="tree" onchange="changeTreeStyle()">
<?php
$skinPath='../../../../image/tree';
if($dh=opendir($skinPath)){
	while(($file=readdir($dh))!==false){
		if($file=='.'||$file=='..')
			continue;
		if((!file_exists($skinPath.'/'.$file.'/tab_top.gif')))
			continue;
		if($skinSetting['tree']==$file)
			echo "<option value=\"$file\" selected=\"selected\">$file</option>";
		else
			echo "<option value=\"$file\">$file</option>";
	}
	closedir($dh);
}?>
													</select>
												</dd>
											</dl>
											<dl id="selected-color-line" class="line">
												<dt><label for="activecolorontree"><?php
echo _t('선택된 글자색');?></label></dt>
												<dd><input type="text" id="activecolorontree" class="input-text" name="activecolorontree" value="<?php
echo $skinSetting['activecolorontree'];?>" size="7" maxlength="6" onchange="changeTreeStyle()" /></dd>
											</dl>
											<dl id="selected-bgcolor-line" class="line">
												<dt><label for="activebgcolorontree"><?php
echo _t('선택된 배경색');?></label></dt>
												<dd><input type="text" id="activebgcolorontree" class="input-text" name="activebgcolorontree" value="<?php
echo $skinSetting['activebgcolorontree'];?>" size="7" maxlength="6" onchange="changeTreeStyle()" /></dd>
											</dl>
											<dl id="unselected-color-line" class="line">
												<dt><label for="colorontree"><?php
echo _t('선택되지 않은 글자색');?></label></dt>
												<dd><input type="text" id="colorontree" class="input-text" name="colorontree" value="<?php
echo $skinSetting['colorontree'];?>" size="7" maxlength="6" onchange="changeTreeStyle()" /></dd>
											</dl>
											<dl id="unselected-bgcolor-line" class="line">
												<dt><label for="bgcolorontree"><?php
echo _t('선택되지 않은 배경색');?></label></dt>
												<dd><input type="text" id="bgcolorontree" class="input-text" name="bgcolorontree" value="<?php
echo $skinSetting['bgcolorontree'];?>" size="7" maxlength="6" onchange="changeTreeStyle()" /></dd>
											</dl>
											<dl id="label-length-line" class="line">
												<dt><label for="labellengthontree"><?php
echo _t('분류 길이');?></label></dt>
												<dd><?php
echo _f('분류를 %1 글자로 표시합니다.','<input type="text" id="labellengthontree" class="input-text" name="labellengthontree" value="'.$skinSetting['labellengthontree'].'" size="3" maxlength="6" onchange="changeTreeStyle()" />');?></dd>
											</dl>
											<dl id="count-display-line" class="line">
												<dt><label for="showValue"><?php
echo _t('글 수 출력');?></label></dt>
												<dd><input type="checkbox" class="checkbox" id="showValue" name="showvalueontree" onclick="changeTreeStyle()" <?php
echo $skinSetting['showvalueontree']?'checked="checked"':'';?> /><label for="showValue"><?php
echo _t('각 분류의 글 수를 표시합니다.');?></label></dd>
											</dl>
										</fieldset>
									
										<div class="button-box">
											<input type="submit" class="save-button input-button" value="<?php
echo _t('저장하기');?>" onclick="document.getElementById('setSkinForm').submit()" />
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			
			<hr class="hidden" />
			
			<div id="layout-footer">
				<div id="copyright"><span class="text"><?php
echo TATTERTOOLS_COPYRIGHT;?></span></div>
				<div id="version"><span class="text"><?php
echo TATTERTOOLS_NAME;?> <?php
echo TATTERTOOLS_VERSION;?></span></div>
			</div>
		</div>
	</div>
	
	<script type="text/javascript">
		//<![CDATA[
			document.onkeydown = function(oEvent) {
				if(isIE) {
					oEvent = event;
				}

				if (oEvent.altKey || oEvent.ctrlKey)
					return;
				if(isIE) {
					var nodeName = oEvent.srcElement.nodeName
				} else {
					var nodeName = oEvent.target.nodeName
				}
				switch (nodeName) {
					case "INPUT":
					case "SELECT":
					case "TEXTAREA":
						return;
				}
				switch (oEvent.keyCode) {
<?php
{?>
					case 81: //Q
						try { window.location = "<?php
	echo $blogURL;?>/"; } catch(e) { };
						break;
					case 82: //R
						try { window.location = "<?php
	echo $blogURL;?>/owner/reader"; } catch(e) { };
						break;
<?php
}
if(isset($paging['prev'])){?>
					case 65: //A
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['prev']}{$paging['postfix']}";?>";
						break;
<?php
}
if(isset($paging['next'])){?>
					case 83: //S
						window.location = "<?php
	echo "{$paging['url']}{$paging['prefix']}{$paging['next']}{$paging['postfix']}";?>";
						break;
<?php
}?>
					default:
				}
			}
		//]]>
	</script>
</body>
</html>
