<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
class BlogStatistics {
	function BlogStatistics() {
		$this->reset();
	}

	function reset() {
		$this->error =
		$this->visits =
			null;
	}
	
	function load() {
		global $database, $cubrid_con, $owner;
		$this->reset();
		if ($result = cubrid_execute($cubrid_con,"SELECT visits FROM {$database['prefix']}BlogStatistics WHERE owner = $owner")) {
			if ($row = cubrid_fetch($result)) {
				foreach ($row as $name => $value) {
					if ($name == 'owner')
						continue;
					$this->$name = $value;
				}
				cubrid_commit($cubrid_con);
				return true;
			}
			cubrid_commit($cubrid_con);
		}
		return false;
	}
	
	function add() {
		if (!isset($this->visits))
			$this->visits = 1;
		
		if (!$query = $this->_buildQuery())
			return false;

		if ($query->doesExist()) {
			$query->setAttribute('visits', "visits + {$this->visits}");
			if (!$query->update())
				return $this->_error('update');
		} else if (!$query->insert()) {
			return $this->_error('insert');
		}
		return true;
	}
	
	function update() {
		if (!isset($this->visits))
			$this->visits = 1;
		
		if (!$query = $this->_buildQuery())
			return false;

		if ($query->doesExist()) {
			if (!$query->update())
				return $this->_error('update');
		} else if (!$query->insert()) {
			return $this->_error('insert');
		}
		return true;
	}

	/*@static@*/
	function compile($host) {
		$instance = new BlogStatistics();
		$instance->host = $host;
		$instance->visits = 1;
		return $instance->update();
	}
	
	function _buildQuery() {
		global $database, $owner;
		$query = new TableQuery($database['prefix'] . 'BlogStatistics');
		$query->setQualifier('owner', $owner);
		if (isset($this->visits)) {
			if (!Validator::number($this->visits, 0))
				return $this->_error('visits');
			$query->setAttribute('visits', $this->visits);
		}
		return $query;
	}

	function _error($error) {
		$this->error = $error;
		return false;
	}
}
?>