<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
class ServiceSetting {
	function ServiceSetting() {
		$this->reset();
	}

	function reset() {
		$this->error =
		$this->name =
		$this->value =
			null;
	}

	function open($name = '', $fields = '*', $sort = 'name') {
		global $cubrid_con, $database;
		if (!empty($name))
			$name = 'AND name = \'' . $name . '\'';
		if (!empty($sort))
			$sort = 'ORDER BY ' . $sort;
		$this->close();
		$this->_result = cubrid_execute($cubrid_con,"SELECT $fields FROM {$database['prefix']}ServiceSettings WHERE 1 $name $sort");
		if ($this->_result)
			$this->_count = cubrid_num_rows($this->_result);
		return $this->shift();
	}
	
	function close() {
		if (isset($this->_result)) {
			cubrid_close_request($this->_result);
			unset($this->_result);
		}
		$this->_count = 0;
		$this->reset();
	}
	
	function shift() {
	  global $cubrid_con;
	  
		$this->reset();
		if ($this->_result && ($row = cubrid_fetch($this->_result))) {
			foreach ($row as $name => $value) {
				switch ($name) {
					case 'value':
						$name = 'value';
						break;
				}
				$this->$name = $value;
			}
			return true;
		}
		return false;
	}

	function set() {
		if (!$query = $this->_buildQuery())
			return false;
		return $query->replace();
	}
	
	function update() {
		if (!$query = $this->_buildQuery())
			return false;
		if (!$query->getAttributeCount())
			return $this->_error('nothing');
		return $query->update();
	}
	
	function getCount() {
		return (isset($this->_count) ? $this->_count : 0);
	}

	function _buildQuery() {
		global $database;
		$query = new TableQuery($database['prefix'] . 'ServiceSettings');
		$query->setQualifier('name', cubrid_lessen($this->name, 32), false);
		if (isset($this->value))
			$query->setAttribute('value', cubrid_lessen($this->value, 255), true);
		return $query;
	}

	function _error($error) {
		$this->error = $error;
		return false;
	}
}
?>