<?php
/// Copyright (c) 2004-2007, Tatter & Company / Tatter & Friends.
/// All rights reserved. Licensed under the GPL.
/// See the GNU General Public License for more details. (/doc/LICENSE, /doc/COPYRIGHT)
class Statistics {
	function getStatistics($owner) {
		global $cubrid_con, $database;
		$stats = array('total' => 0, 'today' => 0, 'yesterday' => 0);
		$result = cubrid_execute($cubrid_con,"select visits from {$database['prefix']}BlogStatistics where owner = $owner");
		if (cubrid_num_rows($result) == 1)
			list($stats['total']) = cubrid_fetch($result);
		$result = cubrid_execute($cubrid_con,"select visits from {$database['prefix']}DailyStatistics where owner = $owner and \"date\" = " . Timestamp::getDate());
		if (cubrid_num_rows($result) == 1)
			list($stats['today']) = cubrid_fetch($result);
		$result = cubrid_execute($cubrid_con,"select visits from {$database['prefix']}DailyStatistics where owner = $owner and \"date\" = " . Timestamp::getDate(time() - 86400));
		if (cubrid_num_rows($result) == 1)
			list($stats['yesterday']) = cubrid_fetch($result);
	  cubrid_commit($cubrid_con);
		return $stats;
	}

	function getDailyStatistics($period) {
		global $database, $owner;
		return DBQuery::queryAll("SELECT \"date\", visits FROM {$database['prefix']}DailyStatistics WHERE owner = $owner AND LEFT(\"date\", 6) = $period ORDER BY \"date\" DESC");
	}
	
	function getWeeklyStatistics() {
		global $database, $owner;
		$now_day = date('Ymd', strtotime("now"));
		$old_day = date('Ymd', strtotime("-1 week"));
		return DBQuery::queryAll("SELECT \"date\", visits FROM {$database['prefix']}DailyStatistics WHERE owner = $owner AND  \"date\" BETWEEN $old_day AND $now_day ORDER BY \"date\" DESC");
	}

	function getMonthlyStatistics($owner) {
		global $cubrid_con, $database;
		$statistics = array();
		if ($result = cubrid_execute($cubrid_con,"select left(\"date\", 6) \"date\", sum(visits) visits from {$database['prefix']}DailyStatistics where owner = $owner group by left(\"date\", 6) order by \"date\" desc")) {
			while ($record = cubrid_fetch($result))
				array_push($statistics, $record);
		  cubrid_commit($cubrid_con);
		}
		return $statistics;
	}

	function getRefererStatistics($owner) {
		global $cubrid_con, $database;
		$statistics = array();
		if ($result = cubrid_execute($cubrid_con,"select \"host\", \"count\" from {$database['prefix']}RefererStatistics where owner = $owner order by \"count\" desc for orderby_num() between 1 and 20")) {
			while ($record = cubrid_fetch($result))
				array_push($statistics, $record);
			cubrid_commit($cubrid_con);
		}
		return $statistics;
	}

	function getRefererLogsWithPage($page, $count) {  
		global $database, $owner;
		return Statistics::fetchWithPaging("SELECT \"host\", url, referred FROM {$database['prefix']}RefererLogs WHERE owner = $owner ORDER BY referred DESC", $page, $count);  
	}  

	function getRefererLogs() {
		global $database, $owner;
		return DBQuery::queryAll("SELECT \"host\", url, referred FROM {$database['prefix']}RefererLogs WHERE owner = $owner ORDER BY referred DESC for orderby_num() between 1 and 1500");
	}

	function updateVisitorStatistics($owner) {
		global $database, $cubrid_con, $blogURL;
		if (!fireEvent('UpdatingVisitorStatistics', true))
			return;
		if (doesHaveOwnership())
			return;
		$id = session_id();
		$result = cubrid_execute($cubrid_con,"select blog from {$database['prefix']}SessionVisits where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and blog = $owner");
		if ($result && (cubrid_num_rows($result) > 0))
			return;
		if (($rst=cubrid_execute($cubrid_con,"insert into {$database['prefix']}SessionVisits values('$id', '{$_SERVER['REMOTE_ADDR']}', $owner)")) && (cubrid_affected_rows($rst) > 0)) {
			$rst=cubrid_execute($cubrid_con,"update {$database['prefix']}BlogStatistics set visits = visits + 1 where owner = $owner");
			if (cubrid_affected_rows($rst) == 0) {
				if (!($rst=cubrid_execute($cubrid_con,"update {$database['prefix']}BlogStatistics set visits = visits + 1 where owner = $owner")) || (cubrid_affected_rows($rst) == 0))
					cubrid_execute($cubrid_con,"insert into {$database['prefix']}BlogStatistics values($owner, 1)");
			}
			$period = Timestamp::getDate();
			$rst=cubrid_execute($cubrid_con,"update {$database['prefix']}DailyStatistics set visits = visits + 1 where owner = $owner and \"date\" = $period");
			if (cubrid_affected_rows($rst) == 0) {
				if (!($rst=cubrid_execute($cubrid_con,"insert into {$database['prefix']}DailyStatistics values($owner, $period, 1)")) || (cubrid_affected_rows($rst) == 0))
					cubrid_execute($cubrid_con,"update {$database['prefix']}DailyStatistics set visits = visits + 1 where owner = $owner and \"date\" = $period");
			}
			cubrid_commit($cubrid_con);
			if (!empty($_SERVER['HTTP_REFERER'])) {
				$referer = parse_url($_SERVER['HTTP_REFERER']);
				if (!empty($referer['host']) && (($referer['host'] != $_SERVER['HTTP_HOST']) || (strncmp($referer['path'], $blogURL, strlen($blogURL)) != 0))) {
					requireComponent('Tattertools.Data.Filter');
					if (Filter::isFiltered('ip', $_SERVER['REMOTE_ADDR']) || Filter::isFiltered('url', $_SERVER['HTTP_REFERER']))
						return;
					if (!fireEvent('AddingRefererLog', true, array('host' => $referer['host'], 'url' => $_SERVER['HTTP_REFERER'])))
						return;
					$host = cubrid_tt_escape_string(cubrid_lessen($referer['host'], 64));
					$url = cubrid_tt_escape_string(cubrid_lessen($_SERVER['HTTP_REFERER'], 255));
					cubrid_execute($cubrid_con,"insert into {$database['prefix']}RefererLogs values($owner, '$host', '$url', SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970'))");
					cubrid_execute($cubrid_con,"delete from {$database['prefix']}RefererLogs where referred < (SYS_TIMESTAMP - to_timestamp('09:00:00 AM 01/01/1970')) - 604800");
					if (!($rst=cubrid_execute($cubrid_con,"update {$database['prefix']}RefererStatistics set \"count\" = \"count\" + 1 where owner = $owner and \"host\" = '$host'")) || (cubrid_affected_rows($rst) == 0))
						cubrid_execute($cubrid_con,"insert into {$database['prefix']}RefererStatistics values($owner, '$host', 1)");
				}
				cubrid_commit($cubrid_con);
			}
		}
	}

	function setTotalStatistics($owner) {
		global $cubrid_con, $database;
		DBQuery::execute("DELETE FROM {$database['prefix']}DailyStatistics WHERE owner = $owner");
		$prevCount = DBQuery::queryCell("SELECT visits FROM {$database['prefix']}BlogStatistics WHERE owner = $owner");
		if ((!is_null($prevCount)) && ($prevCount == 0))
			return true;
		$rst=cubrid_execute($cubrid_con,"update {$database['prefix']}BlogStatistics set visits = 0 where owner = $owner");
		if (cubrid_affected_rows($rst) == 0)
			cubrid_execute($cubrid_con,"insert into {$database['prefix']}BlogStatistics values($owner, 0)");
		if (cubrid_affected_rows($rst)) {
		  cubrid_commit($cubrid_con);
		  return true;
		}
		else return false;
	}
	
	function fetchWithPaging($sql, $page, $count, $url = null, $prefix = '?page=') {
		global $folderURL;
		requireComponent('Eolin.PHP.Core');
		if ($url === null)
			$url = $folderURL;
		$paging = array('url' => $url, 'prefix' => $prefix, 'postfix' => '');
		if (empty($sql))
			return array(array(), $paging);
		if (eregi('[[:space:]]{1}(FROM.*)$', $sql, $matches))
			$from = $matches[1];
		else
			return array(array(), $paging);
		$paging['total'] = DBQuery::queryCell("SELECT COUNT(*) $from");
		if ($paging['total'] === null)
			return array(array(), $paging);
		$paging['pages'] = intval(ceil($paging['total'] / $count));
		$paging['page'] = is_numeric($page) ? $page : 1;
		if ($paging['page'] > $paging['pages']) {
			$paging['page'] = $paging['pages'];
			if ($paging['pages'] > 0)
				$paging['prev'] = $paging['pages'] - 1;
			//return array(array(), $paging);
		}
		if ($paging['page'] > 1)
			$paging['prev'] = $paging['page'] - 1;
		if ($paging['page'] < $paging['pages'])
			$paging['next'] = $paging['page'] + 1;
		$offset = ($paging['page'] - 1) * $count;
		$lmstr=" BETWEEN ".($offset+1)." AND ".($count+$offset);
  $sqlupr = strtoupper($sql);
  if (strpos($sqlupr,"ORDER BY") !== false) { // for orderby_num() between.. and ..
    $sql .= " for orderby_num() ".$lmstr;
  }
  else {
    if (strpos($sqlupr,"GROUP BY") !== false) { // having groupby_num() between.. and .. 
      if (($pos=strpos($sqlupr,"HAVING")) !== false) { // AND ...
        $sql = substr($sql,0,$pos+6)." groupby_num() ".$lmstr." and ".substr($sql,$pos+6);
      }
      else { // having ...
        $sql .= " having groupby_num() ".$lmstr;
      }
    }
    else { //where inst_num() between.. and .. 
      if (($pos=strpos($sqlupr,"WHERE")) !== false) { // AND ...
        $sql = substr($sql,0,$pos+5)." inst_num() ".$lmstr." and ".substr($sql,$pos+5);
      }
      else { // where ...
        $sql .= " where inst_num() ".$lmstr;
      }
    }
  }
	return array(DBQuery::queryAll("$sql"),$paging);
	}
}
?>
