<?php
/* Recent Trackbacks plugin for Tattertools 1.1
   ----------------------------------
   Version 1.0
   Tatter and Friends development team.

   Creator          : NANI
   Maintainer       : Peris, inureyes, graphittie

   Created at       : 2006.10.10
   Last modified at : 2007.3.15

 This plugin shows recent trackback on 'quilt'.
 For the detail, visit http://forum.tattertools.com/ko


 General Public License
 http://www.gnu.org/licenses/gpl.html

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

*/

// lib/model/trackback.php : 46 line
function _getRecentTrackbacks($owner) {
	global $database;
	global $skinSetting;
	$trackbacks = array();
	$sql = doesHaveOwnership() ? "SELECT * 
		FROM 
			{$database['prefix']}Trackbacks 
		WHERE 
			owner = $owner AND isfiltered = 0 
		ORDER BY 
			written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND 
			{$skinSetting['trackbacksonrecent']}" : 
		"SELECT t.* 
		FROM 
			{$database['prefix']}Trackbacks t 
			LEFT JOIN {$database['prefix']}Entries e ON t.owner = e.owner AND t.entry = e.id
			LEFT JOIN {$database['prefix']}Categories c ON e.owner = c.owner AND e.category = c.id
		WHERE 
			t.owner = $owner AND e.draft = 0 AND e.visibility >= 2 AND (c.visibility > 1 OR e.category = 0) AND t.isfiltered = 0 
		ORDER BY 
			t.written 
		DESC FOR ORDERBY_NUM() BETWEEN 1 AND 
			{$skinSetting['trackbacksonrecent']}";
	if ($result = DBQuery::query($sql)) {
		while ($trackback = cubrid_fetch($result))
			array_push($trackbacks, $trackback);
        DBQuery::commit();
	}
	return $trackbacks;
}

function CT_RecentTB_Default($target) {
	global $owner;
	requireComponent("Eolin.PHP.Core");
	requireComponent("Tattertools.Function.misc");
	
	$target .= '<ul>';
	$trackbacks = _getRecentTrackbacks($owner);
	foreach ($trackbacks as $trackback) {
		$target .= '<li>';
		$target .= '<span style="color: #9E7C54;">'.Timestamp::format2($trackback['written']).'</span>';
		$target .= '<a href="'.$blogURL.'/'.$trackback['entry'].'#trackback'.$trackback['id'].'">';
		$target .= htmlspecialchars(UTF8::lessenAsEm($trackback['subject'],30));
		$target .= '</a> - ';
		$target .= '<cite style="color: #777; font-style: normal;">';
		$target .= htmlspecialchars(UTF8::lessenAsEm($trackback['site'], 10));
		$target .= '</cite>';
		$target .= '</li>';
	}
	$target .= '</ul>';

	return $target;
}
?>
